<?php
# --------------------------------------------------------------------------
# file: nws-all-zones-inc.php
# created from NWS data files:
# from: https://www.weather.gov/gis/Counties "c_05mr24.zip" file: "c_05mr24.dbf"
# from: https://www.weather.gov/gis/ZoneCounty file: "bp05mr24.dbx"
#
# with data combined to produce an array of ssZnnn, ssCnnn Forecast and County
# centroid lat/long, names
#
# Version 1.00 - 13-May-2019 - initial release for Leaflet/OpenStreetMaps nws-alerts
# Version 1.01 - 08-Nov-2019 - NWS updates (October, 2019) for zones
# Version 1.02 - 15-Jun-2023 - NWS updates (March, 2023) for zones
# Version 1.03 - 19-Sep-2023 - NWS updates (September, 2023) for zones
# Version 1.04 - 05-Mar-2024 - NWS updates (March 5, 2024) for zones
#
# Note: there are no settings to do in this file. It is included and used
#  in nws-alerts-details-inc to set the map center lat/long.
#
# (created by make-zone-arrays.php on Tue, 13 Feb 2024 14:24:00 +0000 UTC)
# --------------------------------------------------------------------------
 
$loclatlon = array( // Lookup for lat/lon for Forecast and County NWS Zones
 'AKC013' => '55.4039|-161.8631|Aleutians East||',
 'AKC016' => '52.8883|-111.2564|Aleutians West||',
 'AKC020' => '61.1501|-149.1067|Anchorage||',
 'AKC050' => '60.9210|-159.7733|Bethel||',
 'AKC060' => '58.7423|-156.7013|Bristol Bay||',
 'AKC063' => '60.7357|-145.7950|Chugach||',
 'AKC066' => '61.8844|-143.9685|Copper River||',
 'AKC068' => '63.6739|-150.0083|Denali||',
 'AKC070' => '59.8021|-158.2119|Dillingham||',
 'AKC090' => '64.8084|-146.5630|Fairbanks North Star||',
 'AKC100' => '59.1221|-135.5049|Haines||',
 'AKC105' => '58.2897|-135.6402|Hoonah-Angoon||',
 'AKC110' => '58.4593|-134.1755|Juneau||',
 'AKC122' => '60.2619|-151.5667|Kenai Peninsula||',
 'AKC130' => '55.5947|-130.9268|Ketchikan Gateway||',
 'AKC150' => '57.6777|-153.8060|Kodiak Island||',
 'AKC158' => '62.1552|-163.3711|Kusilvak||',
 'AKC164' => '58.6478|-156.1834|Lake and Peninsula||',
 'AKC170' => '62.3163|-149.5706|Matanuska-Susitna||',
 'AKC180' => '64.9107|-164.0308|Nome||',
 'AKC185' => '69.3094|-153.4534|North Slope||',
 'AKC188' => '67.0626|-159.7085|Northwest Arctic||',
 'AKC195' => '57.1338|-132.9279|Petersburg Borough||',
 'AKC198' => '55.8039|-133.0048|Prince of Wales-Hyder||',
 'AKC220' => '57.2356|-135.3008|Sitka||',
 'AKC230' => '59.5604|-135.3381|Skagway||',
 'AKC240' => '63.8771|-143.2062|Southeast Fairbanks||',
 'AKC275' => '56.3337|-132.0073|Wrangell||',
 'AKC282' => '59.8958|-140.3904|Yakutat||',
 'AKC290' => '65.5096|-151.3893|Yukon-Koyukuk||',
 'AKZ102' => '61.2292|-149.3466|Anchorage |Anchorage|02020',
 'AKZ103' => '61.0377|-148.7761|East Turnagain Arm |Anchorage|02020',
 'AKZ112' => '61.6518|-149.2037|Matanuska Valley |Matanuska-Susitna|02170',
 'AKZ121' => '60.3254|-150.709|Western Kenai Peninsula|Kenai Peninsula|02122',
 'AKZ126' => '60.3278|-149.0357|Western Prince William Sound |Kenai Peninsula|02122	60.3278|-149.0357|Western Prince William Sound |Chugach|02063',
 'AKZ132' => '61.11|-146.3052|Northeast Prince William Sound |Chugach|02063',
 'AKZ135' => '60.5285|-144.9344|Southeast Prince William Sound|Chugach|02063',
 'AKZ142' => '61.9431|-144.7751|Copper River Basin |Matanuska-Susitna|02170	61.9431|-144.7751|Copper River Basin |Copper River|02066	61.9431|-144.7751|Copper River Basin |Chugach|02063',
 'AKZ145' => '62.0904|-150.7335|Susitna Valley|Bethel|02050	62.0904|-150.7335|Susitna Valley|Kenai Peninsula|02122	62.0904|-150.7335|Susitna Valley|Matanuska-Susitna|02170',
 'AKZ152' => '61.4395|-156.4803|Lower Kuskokwim Valley|Bethel|02050	61.4395|-156.4803|Lower Kuskokwim Valley|Dillingham|02070	61.4395|-156.4803|Lower Kuskokwim Valley|Kenai Peninsula|02122	61.4395|-156.4803|Lower Kuskokwim Valley|Lake and Peninsula|02164	61.4395|-156.4803|Lower Kuskokwim Valley|Matanuska-Susitna|02170',
 'AKZ155' => '60.6404|-162.6305|Kuskokwim Delta|Bethel|02050',
 'AKZ161' => '59.2984|-157.2451|Bristol Bay|Bethel|02050	59.2984|-157.2451|Bristol Bay|Bristol Bay|02060	59.2984|-157.2451|Bristol Bay|Dillingham|02070	59.2984|-157.2451|Bristol Bay|Kenai Peninsula|02122	59.2984|-157.2451|Bristol Bay|Kodiak Island|02150	59.2984|-157.2451|Bristol Bay|Lake and Peninsula|02164',
 'AKZ171' => '58.2911|-154.1629|Kodiak Island|Kenai Peninsula|02122	58.2911|-154.1629|Kodiak Island|Kodiak Island|02150	58.2911|-154.1629|Kodiak Island|Lake and Peninsula|02164',
 'AKZ181' => '55.6116|-161.2034|Alaska Peninsula|Aleutians East|02013	55.6096|-161.2034|Alaska Peninsula|Lake and Peninsula|02164',
 'AKZ185' => '53.5983|-167.2049|Eastern Aleutians|Aleutians West|02016',
 'AKZ187' => '52.0613|-175.0715|Central Aleutians|Aleutians West|02016',
 'AKZ191' => '52.3658|175.5393|Western Aleutians|Aleutians West|02016',
 'AKZ195' => '56.9092|-169.979|Pribilof Islands|Aleutians West|02016',
 'AKZ317' => '59.9007|-140.4|City and Borough of Yakutat|Yakutat|02282',
 'AKZ318' => '59.5634|-135.3363|Municipality of Skagway|Skagway|02230',
 'AKZ319' => '59.1231|-135.5029|Haines Borough and Klukwan|Haines|02100',
 'AKZ320' => '58.7919|-136.374|Glacier Bay|Hoonah-Angoon|02105',
 'AKZ321' => '58.0322|-135.5308|Eastern Chichagof Island|Hoonah-Angoon|02105',
 'AKZ322' => '58.3895|-136.9144|Cape Fairweather to Lisianski Strait|Hoonah-Angoon|02105',
 'AKZ323' => '57.2368|-135.3018|City and Borough of Sitka|Sitka|02220',
 'AKZ324' => '57.7037|-134.0857|Admiralty Island|Hoonah-Angoon|02105',
 'AKZ325' => '58.4584|-134.1787|City and Borough of Juneau|Juneau|02110',
 'AKZ326' => '57.1338|-132.9279|Petersburg Borough|Petersburg Borough|02195',
 'AKZ327' => '56.6439|-133.8989|Western Kupreanof and Kuiu Island|Prince of Wales-Hyder|02198',
 'AKZ328' => '55.5002|-132.8808|Prince of Wales Island|Prince of Wales-Hyder|02198',
 'AKZ329' => '56.3326|-132.0115|City and Borough of Wrangell|Wrangell|02275',
 'AKZ330' => '55.597|-130.9302|Ketchikan Gateway Borough|Ketchikan|02130',
 'AKZ331' => '55.9569|-130.1734|City of Hyder|Prince of Wales-Hyder|02198',
 'AKZ332' => '55.1277|-131.4853|Annette Island|Prince of Wales-Hyder|02198',
 'AKZ801' => '69.0125|-164.1064|Western Arctic Coast|North Slope|02185',
 'AKZ802' => '70.3019|-159.508|Northwest Arctic Coast|North Slope|02185',
 'AKZ803' => '70.6873|-155.3712|Northern Arctic Coast|North Slope|02185',
 'AKZ804' => '70.2069|-149.5617|Central Beaufort Sea Coast|North Slope|02185',
 'AKZ805' => '69.8543|-144.0064|Eastern Beaufort Sea Coast|North Slope|02185',
 'AKZ806' => '69.4448|-157.04|Western Arctic Plains|North Slope|02185',
 'AKZ807' => '68.4515|-159.5118|Howard Pass and the Delong Mountains|North Slope|02185',
 'AKZ808' => '69.3952|-150.0441|Central Arctic Plains|North Slope|02185',
 'AKZ809' => '68.4522|-151.0083|Central Brooks Range|North Slope|02185',
 'AKZ810' => '68.9538|-144.9059|Romanzof Mountains|North Slope|02185',
 'AKZ811' => '67.8471|-144.9201|South Slopes of the Eastern Brooks Range|Yukon-Koyukuk|02290',
 'AKZ812' => '67.5646|-151.9607|South Slopes of the Central Brooks Range|Yukon-Koyukuk|02290',
 'AKZ813' => '67.6243|-157.2881|South Slopes of the Western Brooks Range|Northwest Arctic|02188',
 'AKZ814' => '67.6896|-161.9337|Noatak Valley|Northwest Arctic|02188',
 'AKZ815' => '67.6038|-164.1586|Kivalina and Red Dog Dock|Northwest Arctic|02188',
 'AKZ816' => '66.7012|-160.5806|Lower Kobuk Valley|Northwest Arctic|02188',
 'AKZ817' => '66.5619|-161.7133|Baldwin Peninsula|Northwest Arctic|02188',
 'AKZ818' => '65.865|-161.6971|Northern Seward Peninsula|Northwest Arctic|02188',
 'AKZ819' => '66.775|-157.3858|Upper Kobuk Valleys|Northwest Arctic|02188',
 'AKZ820' => '66.117|-165.867|Shishmaref|Nome|02180',
 'AKZ821' => '65.4254|-166.6301|Bering Strait Coast|Nome|02180',
 'AKZ822' => '64.6146|-164.4871|Southern Seward Peninsula Coast|Nome|02180',
 'AKZ823' => '65.2674|-163.7888|Interior Seward Peninsula|Nome|02180',
 'AKZ824' => '64.2108|-160.884|Eastern Norton Sound and Nulato Hills|Nome|02180',
 'AKZ825' => '62.1513|-164.2464|Yukon Delta Coast|Kusilvak|02158',
 'AKZ826' => '62.1612|-162.0465|Lower Yukon River|Kusilvak|02158',
 'AKZ827' => '63.3895|-170.3421|St. Lawrence Island|Nome|02180',
 'AKZ828' => '65.6681|-156.8481|Lower Koyukuk Valley|Yukon-Koyukuk|02290',
 'AKZ829' => '64.4694|-156.776|Middle Yukon Valley|Yukon-Koyukuk|02290',
 'AKZ830' => '63.0674|-158.329|Lower Yukon and Innoko Valleys|Yukon-Koyukuk|02290',
 'AKZ831' => '66.3527|-152.8907|Upper Koyukuk Valley|Yukon-Koyukuk|02290',
 'AKZ832' => '66.3044|-150.2855|Dalton Highway Summits|Yukon-Koyukuk|02290',
 'AKZ833' => '66.5038|-144.6111|Yukon Flats|Yukon-Koyukuk|02290',
 'AKZ834' => '65.4537|-146.8278|White Mountains and High Terrain South of the Yukon River|Yukon-Koyukuk|02290',
 'AKZ835' => '64.351|-142.5474|Fortymile Country|Southeast Fairbanks|02240',
 'AKZ836' => '63.0016|-142.528|Upper Tanana Valley|Southeast Fairbanks|02240',
 'AKZ837' => '64.0671|-145.6603|Delta Junction|Southeast Fairbanks|02240',
 'AKZ838' => '64.8329|-145.4109|Upper Chena River Valley|Fairbanks North Star|02090',
 'AKZ839' => '64.4858|-147.58|Tanana Flats|Fairbanks North Star|02090',
 'AKZ840' => '64.5731|-146.8032|Eielson Air Force Base and Salcha|Fairbanks North Star|02090',
 'AKZ841' => '64.8226|-148.4043|Goldstream Valley and Nenana Hills|Fairbanks North Star|02090',
 'AKZ842' => '65.1455|-147.4888|Chatanika River Valley|Fairbanks North Star|02090',
 'AKZ843' => '64.915|-146.8659|Two Rivers|Fairbanks North Star|02090',
 'AKZ844' => '64.8465|-147.68|Fairbanks Metro Area|Fairbanks North Star|02090',
 'AKZ845' => '64.5373|-148.7871|Nenana|Yukon-Koyukuk|02290',
 'AKZ846' => '64.7511|-151.8283|Central Interior|Yukon-Koyukuk|02290',
 'AKZ847' => '63.8161|-150.0994|Northern Denali Borough|Denali|02068',
 'AKZ848' => '63.3248|-149.7848|Southern Denali Borough|Denali|02068',
 'AKZ849' => '63.7236|-145.7753|Eastern Alaska Range North of Trims Camp|Southeast Fairbanks|02240',
 'AKZ850' => '63.3137|-145.1121|Eastern Alaska Range South of Trims Camp|Southeast Fairbanks|02240',
 'AKZ851' => '62.5083|-153.8608|North Slopes of the Western Alaska Range|Yukon-Koyukuk|02290',
 'AKZ852' => '62.8537|-155.2228|Upper Kuskokwim Valley|Yukon-Koyukuk|02290',
 'ALC001' => '32.5349|-86.6428|Autauga||',
 'ALC003' => '30.7278|-87.7171|Baldwin||',
 'ALC005' => '31.8696|-85.3932|Barbour||',
 'ALC007' => '32.9986|-87.1264|Bibb||',
 'ALC009' => '33.9809|-86.5674|Blount||',
 'ALC011' => '32.1005|-85.7161|Bullock||',
 'ALC013' => '31.7524|-86.6803|Butler||',
 'ALC015' => '33.7714|-85.8261|Calhoun||',
 'ALC017' => '32.9144|-85.3920|Chambers||',
 'ALC019' => '34.1760|-85.6038|Cherokee||',
 'ALC021' => '32.8479|-86.7188|Chilton||',
 'ALC023' => '32.0192|-88.2628|Choctaw||',
 'ALC025' => '31.6709|-87.8309|Clarke||',
 'ALC027' => '33.2691|-85.8605|Clay||',
 'ALC029' => '33.6745|-85.5188|Cleburne||',
 'ALC031' => '31.4026|-85.9882|Coffee||',
 'ALC033' => '34.7004|-87.8049|Colbert||',
 'ALC035' => '31.4293|-86.9936|Conecuh||',
 'ALC037' => '32.9362|-86.2476|Coosa||',
 'ALC039' => '31.2485|-86.4512|Covington||',
 'ALC041' => '31.7315|-86.3136|Crenshaw||',
 'ALC043' => '34.1320|-86.8676|Cullman||',
 'ALC045' => '31.4318|-85.6110|Dale||',
 'ALC047' => '32.3258|-87.1065|Dallas||',
 'ALC049' => '34.4598|-85.8041|DeKalb||',
 'ALC051' => '32.5966|-86.1492|Elmore||',
 'ALC053' => '31.1262|-87.1616|Escambia||',
 'ALC055' => '34.0453|-86.0348|Etowah||',
 'ALC057' => '33.7212|-87.7388|Fayette||',
 'ALC059' => '34.4417|-87.8438|Franklin||',
 'ALC061' => '31.0950|-85.8390|Geneva||',
 'ALC063' => '32.8531|-87.9522|Greene||',
 'ALC065' => '32.7627|-87.6291|Hale||',
 'ALC067' => '31.5147|-85.2414|Henry||',
 'ALC069' => '31.1532|-85.3025|Houston||',
 'ALC071' => '34.7794|-85.9993|Jackson||',
 'ALC073' => '33.5543|-86.8965|Jefferson||',
 'ALC075' => '33.7792|-88.0969|Lamar||',
 'ALC077' => '34.9015|-87.6543|Lauderdale||',
 'ALC079' => '34.5220|-87.3110|Lawrence||',
 'ALC081' => '32.6012|-85.3556|Lee||',
 'ALC083' => '34.8101|-86.9813|Limestone||',
 'ALC085' => '32.1548|-86.6501|Lowndes||',
 'ALC087' => '32.3860|-85.6926|Macon||',
 'ALC089' => '34.7631|-86.5502|Madison||',
 'ALC091' => '32.2476|-87.7895|Marengo||',
 'ALC093' => '34.1366|-87.8871|Marion||',
 'ALC095' => '34.3669|-86.3066|Marshall||',
 'ALC097' => '30.7943|-88.2018|Mobile||',
 'ALC099' => '31.5706|-87.3658|Monroe||',
 'ALC101' => '32.2202|-86.2076|Montgomery||',
 'ALC103' => '34.4535|-86.8529|Morgan||',
 'ALC105' => '32.6385|-87.2942|Perry||',
 'ALC107' => '33.2809|-88.0887|Pickens||',
 'ALC109' => '31.8024|-85.9409|Pike||',
 'ALC111' => '33.2938|-85.4591|Randolph||',
 'ALC113' => '32.2884|-85.1849|Russell||',
 'ALC115' => '33.7157|-86.3147|St. Clair||',
 'ALC117' => '33.2643|-86.6607|Shelby||',
 'ALC119' => '32.5910|-88.1988|Sumter||',
 'ALC121' => '33.3800|-86.1659|Talladega||',
 'ALC123' => '32.8624|-85.7975|Tallapoosa||',
 'ALC125' => '33.2896|-87.5250|Tuscaloosa||',
 'ALC127' => '33.8034|-87.2973|Walker||',
 'ALC129' => '31.4077|-88.2071|Washington||',
 'ALC131' => '31.9892|-87.3082|Wilcox||',
 'ALC133' => '34.1492|-87.3737|Winston||',
 'ALZ001' => '34.9015|-87.6544|Lauderdale|Lauderdale|01077',
 'ALZ002' => '34.7005|-87.8049|Colbert|Colbert|01033',
 'ALZ003' => '34.4417|-87.8438|Franklin|Franklin|01059',
 'ALZ004' => '34.522|-87.311|Lawrence|Lawrence|01079',
 'ALZ005' => '34.8101|-86.9813|Limestone|Limestone|01083',
 'ALZ006' => '34.7631|-86.5502|Madison|Madison|01089',
 'ALZ007' => '34.4535|-86.8529|Morgan|Morgan|01103',
 'ALZ008' => '34.3669|-86.3066|Marshall|Marshall|01095',
 'ALZ009' => '34.7794|-85.9993|Jackson|Jackson|01071',
 'ALZ010' => '34.4598|-85.8041|DefireKalb|DeKalb|01049',
 'ALZ011' => '34.1366|-87.8871|Marion|Marion|01093',
 'ALZ012' => '33.7792|-88.0969|Lamar|Lamar|01075',
 'ALZ013' => '33.7212|-87.7389|Fayette|Fayette|01057',
 'ALZ014' => '34.1492|-87.3737|Winston|Winston|01133',
 'ALZ015' => '33.8034|-87.2973|Walker|Walker|01127',
 'ALZ016' => '34.132|-86.8676|Cullman|Cullman|01043',
 'ALZ017' => '33.9809|-86.5674|Blount|Blount|01009',
 'ALZ018' => '34.0453|-86.0348|Etowah|Etowah|01055',
 'ALZ019' => '33.7714|-85.8261|Calhoun|Calhoun|01015',
 'ALZ020' => '34.176|-85.6038|Cherokee|Cherokee|01019',
 'ALZ021' => '33.6745|-85.5188|Cleburne|Cleburne|01029',
 'ALZ022' => '33.2809|-88.0887|Pickens|Pickens|01107',
 'ALZ023' => '33.2895|-87.525|Tuscaloosa|Tuscaloosa|01125',
 'ALZ024' => '33.5543|-86.8965|Jefferson|Jefferson|01073',
 'ALZ025' => '33.2643|-86.6607|Shelby|Shelby|01117',
 'ALZ026' => '33.7157|-86.3147|St. Clair|St. Clair|01115',
 'ALZ027' => '33.38|-86.1659|Talladega|Talladega|01121',
 'ALZ028' => '33.2691|-85.8605|Clay|Clay|01027',
 'ALZ029' => '33.2938|-85.4591|Randolph|Randolph|01111',
 'ALZ030' => '32.591|-88.1988|Sumter|Sumter|01119',
 'ALZ031' => '32.8531|-87.9522|Greene|Greene|01063',
 'ALZ032' => '32.7627|-87.6291|Hale|Hale|01065',
 'ALZ033' => '32.6385|-87.2942|Perry|Perry|01105',
 'ALZ034' => '32.9986|-87.1264|Bibb|Bibb|01007',
 'ALZ035' => '32.8479|-86.7188|Chilton|Chilton|01021',
 'ALZ036' => '32.9362|-86.2476|Coosa|Coosa|01037',
 'ALZ037' => '32.8624|-85.7975|Tallapoosa|Tallapoosa|01123',
 'ALZ038' => '32.9144|-85.392|Chambers|Chambers|01017',
 'ALZ039' => '32.2476|-87.7895|Marengo|Marengo|01091',
 'ALZ040' => '32.3258|-87.1065|Dallas|Dallas|01047',
 'ALZ041' => '32.5349|-86.6428|Autauga|Autauga|01001',
 'ALZ042' => '32.1547|-86.6501|Lowndes|Lowndes|01085',
 'ALZ043' => '32.5966|-86.1492|Elmore|Elmore|01051',
 'ALZ044' => '32.2202|-86.2076|Montgomery|Montgomery|01101',
 'ALZ045' => '32.386|-85.6926|Macon|Macon|01087',
 'ALZ046' => '32.1005|-85.7161|Bullock|Bullock|01011',
 'ALZ047' => '32.6012|-85.3556|Lee|Lee|01081',
 'ALZ048' => '32.2884|-85.1849|Russell|Russell|01113',
 'ALZ049' => '31.8024|-85.9409|Pike|Pike|01109',
 'ALZ050' => '31.8696|-85.3932|Barbour|Barbour|01005',
 'ALZ051' => '32.0192|-88.2628|Choctaw|Choctaw|01023',
 'ALZ052' => '31.4077|-88.2071|Washington|Washington|01129',
 'ALZ053' => '31.6709|-87.8309|Clarke|Clarke|01025',
 'ALZ054' => '31.9892|-87.3082|Wilcox|Wilcox|01131',
 'ALZ055' => '31.5706|-87.3658|Monroe|Monroe|01099',
 'ALZ056' => '31.4293|-86.9936|Conecuh|Conecuh|01035',
 'ALZ057' => '31.7524|-86.6803|Butler|Butler|01013',
 'ALZ058' => '31.7315|-86.3136|Crenshaw|Crenshaw|01041',
 'ALZ059' => '31.1262|-87.1616|Escambia|Escambia|01053',
 'ALZ060' => '31.2485|-86.4512|Covington|Covington|01039',
 'ALZ065' => '31.4026|-85.9882|Coffee|Coffee|01031',
 'ALZ066' => '31.4318|-85.611|Dale|Dale|01045',
 'ALZ067' => '31.5147|-85.2414|Henry|Henry|01067',
 'ALZ068' => '31.095|-85.839|Geneva|Geneva|01061',
 'ALZ069' => '31.1532|-85.3025|Houston|Houston|01069',
 'ALZ261' => '30.9237|-88.185|Mobile Inland|Mobile|01097',
 'ALZ262' => '30.494|-87.6699|Baldwin Inland|Baldwin|01003',
 'ALZ263' => '30.5283|-88.2363|Mobile Central|Mobile|01097',
 'ALZ264' => '30.9471|-87.7615|Baldwin Central|Baldwin|01003',
 'ALZ265' => '30.5283|-88.2363|Mobile Coastal|Mobile|01097',
 'ALZ266' => '30.494|-87.6699|Baldwin Coastal|Baldwin|01003',
 'ARC001' => '34.2908|-91.3749|Arkansas||',
 'ARC003' => '33.1912|-91.7679|Ashley||',
 'ARC005' => '36.2872|-92.3370|Baxter||',
 'ARC007' => '36.3392|-94.2573|Benton||',
 'ARC009' => '36.3086|-93.0915|Boone||',
 'ARC011' => '33.4659|-92.1623|Bradley||',
 'ARC013' => '33.5580|-92.5031|Calhoun||',
 'ARC015' => '36.3410|-93.5382|Carroll||',
 'ARC017' => '33.2672|-91.2940|Chicot||',
 'ARC019' => '34.0510|-93.1764|Clark||',
 'ARC021' => '36.3685|-90.4173|Clay||',
 'ARC023' => '35.5381|-92.0267|Cleburne||',
 'ARC025' => '33.8983|-92.1852|Cleveland||',
 'ARC027' => '33.2143|-93.2274|Columbia||',
 'ARC029' => '35.2622|-92.7014|Conway||',
 'ARC031' => '35.8308|-90.6328|Craighead||',
 'ARC033' => '35.5889|-94.2430|Crawford||',
 'ARC035' => '35.2079|-90.3089|Crittenden||',
 'ARC037' => '35.2958|-90.7713|Cross||',
 'ARC039' => '33.9698|-92.6545|Dallas||',
 'ARC041' => '33.8333|-91.2540|Desha||',
 'ARC043' => '33.5895|-91.7200|Drew||',
 'ARC045' => '35.1470|-92.3320|Faulkner||',
 'ARC047' => '35.5123|-93.8906|Franklin||',
 'ARC049' => '36.3817|-91.8183|Fulton||',
 'ARC051' => '34.5767|-93.1504|Garland||',
 'ARC053' => '34.2900|-92.4236|Grant||',
 'ARC055' => '36.1177|-90.5591|Greene||',
 'ARC057' => '33.7354|-93.6684|Hempstead||',
 'ARC059' => '34.3177|-92.9460|Hot Spring||',
 'ARC061' => '34.0887|-93.9935|Howard||',
 'ARC063' => '35.7415|-91.5698|Independence||',
 'ARC065' => '36.0949|-91.9134|Izard||',
 'ARC067' => '35.5994|-91.2146|Jackson||',
 'ARC069' => '34.2688|-91.9315|Jefferson||',
 'ARC071' => '35.5701|-93.4599|Johnson||',
 'ARC073' => '33.2408|-93.6073|Lafayette||',
 'ARC075' => '36.0413|-91.1071|Lawrence||',
 'ARC077' => '34.7807|-90.7820|Lee||',
 'ARC079' => '33.9575|-91.7333|Lincoln||',
 'ARC081' => '33.7005|-94.2343|Little River||',
 'ARC083' => '35.2153|-93.7163|Logan||',
 'ARC085' => '34.7542|-91.8887|Lonoke||',
 'ARC087' => '36.0110|-93.7246|Madison||',
 'ARC089' => '36.2684|-92.6842|Marion||',
 'ARC091' => '33.3124|-93.8918|Miller||',
 'ARC093' => '35.7639|-90.0540|Mississippi||',
 'ARC095' => '34.6778|-91.2038|Monroe||',
 'ARC097' => '34.5388|-93.6595|Montgomery||',
 'ARC099' => '33.6640|-93.3072|Nevada||',
 'ARC101' => '35.9200|-93.2179|Newton||',
 'ARC103' => '33.5933|-92.8820|Ouachita||',
 'ARC105' => '34.9474|-92.9315|Perry||',
 'ARC107' => '34.4283|-90.8480|Phillips||',
 'ARC109' => '34.1636|-93.6564|Pike||',
 'ARC111' => '35.5740|-90.6629|Poinsett||',
 'ARC113' => '34.4858|-94.2281|Polk||',
 'ARC115' => '35.4476|-93.0342|Pope||',
 'ARC117' => '34.8297|-91.5528|Prairie||',
 'ARC119' => '34.7699|-92.3117|Pulaski||',
 'ARC121' => '36.3415|-91.0278|Randolph||',
 'ARC123' => '35.0220|-90.7478|St. Francis||',
 'ARC125' => '34.6466|-92.6766|Saline||',
 'ARC127' => '34.8608|-94.0633|Scott||',
 'ARC129' => '35.9109|-92.6995|Searcy||',
 'ARC131' => '35.1993|-94.2740|Sebastian||',
 'ARC133' => '33.9973|-94.2412|Sevier||',
 'ARC135' => '36.1611|-91.4799|Sharp||',
 'ARC137' => '35.8599|-92.1567|Stone||',
 'ARC139' => '33.1713|-92.5973|Union||',
 'ARC141' => '35.5807|-92.5157|Van Buren||',
 'ARC143' => '35.9800|-94.2147|Washington||',
 'ARC145' => '35.2563|-91.7457|White||',
 'ARC147' => '35.1863|-91.2432|Woodruff||',
 'ARC149' => '35.0026|-93.4113|Yell||',
 'ARZ001' => '36.3392|-94.2573|Benton|Benton|05007',
 'ARZ002' => '36.341|-93.5382|Carroll|Carroll|05015',
 'ARZ004' => '36.2684|-92.6842|Marion|Marion|05089',
 'ARZ005' => '36.2872|-92.337|Baxter|Baxter|05005',
 'ARZ006' => '36.3817|-91.8183|Fulton|Fulton|05049',
 'ARZ007' => '36.1611|-91.4799|Sharp|Sharp|05135',
 'ARZ008' => '36.3415|-91.0278|Randolph|Randolph|05121',
 'ARZ009' => '36.3685|-90.4173|Clay|Clay|05021',
 'ARZ010' => '35.98|-94.2147|Washington|Washington|05143',
 'ARZ011' => '36.011|-93.7246|Madison|Madison|05087',
 'ARZ014' => '35.8599|-92.1567|Stone|Stone|05137',
 'ARZ015' => '36.0949|-91.9134|Izard|Izard|05065',
 'ARZ016' => '35.7415|-91.5698|Independence|Independence|05063',
 'ARZ017' => '36.0413|-91.1071|Lawrence|Lawrence|05075',
 'ARZ018' => '36.1177|-90.5591|Greene|Greene|05055',
 'ARZ019' => '35.5889|-94.243|Crawford|Crawford|05033',
 'ARZ020' => '35.5123|-93.8906|Franklin|Franklin|05047',
 'ARZ024' => '35.5381|-92.0267|Cleburne|Cleburne|05023',
 'ARZ025' => '35.5994|-91.2146|Jackson|Jackson|05067',
 'ARZ026' => '35.8308|-90.6328|Craighead|Craighead|05031',
 'ARZ027' => '35.574|-90.6629|Poinsett|Poinsett|05111',
 'ARZ028' => '35.7639|-90.054|Mississippi|Mississippi|05093',
 'ARZ029' => '35.1993|-94.274|Sebastian|Sebastian|05131',
 'ARZ031' => '35.2622|-92.7014|Conway|Conway|05029',
 'ARZ032' => '35.147|-92.3321|Faulkner|Faulkner|05045',
 'ARZ033' => '35.2563|-91.7457|White|White|05145',
 'ARZ034' => '35.1863|-91.2431|Woodruff|Woodruff|05147',
 'ARZ035' => '35.2958|-90.7713|Cross|Cross|05037',
 'ARZ036' => '35.2079|-90.3089|Crittenden|Crittenden|05035',
 'ARZ039' => '34.9474|-92.9315|Perry|Perry|05105',
 'ARZ042' => '34.5767|-93.1504|Garland|Garland|05051',
 'ARZ043' => '34.6466|-92.6766|Saline|Saline|05125',
 'ARZ044' => '34.7699|-92.3118|Pulaski|Pulaski|05119',
 'ARZ045' => '34.7542|-91.8887|Lonoke|Lonoke|05085',
 'ARZ046' => '34.8297|-91.5528|Prairie|Prairie|05117',
 'ARZ047' => '34.6778|-91.2038|Monroe|Monroe|05095',
 'ARZ048' => '35.022|-90.7478|St. Francis|St. Francis|05123',
 'ARZ049' => '34.7806|-90.782|Lee|Lee|05077',
 'ARZ050' => '33.9973|-94.2412|Sevier|Sevier|05133',
 'ARZ051' => '34.0887|-93.9934|Howard|Howard|05061',
 'ARZ052' => '34.1636|-93.6564|Pike|Pike|05109',
 'ARZ053' => '34.051|-93.1764|Clark|Clark|05019',
 'ARZ054' => '34.3177|-92.946|Hot Spring|Hot Spring|05059',
 'ARZ055' => '34.29|-92.4236|Grant|Grant|05053',
 'ARZ056' => '34.2688|-91.9315|Jefferson|Jefferson|05069',
 'ARZ057' => '34.2908|-91.3749|Arkansas|Arkansas|05001',
 'ARZ058' => '34.4283|-90.848|Phillips|Phillips|05107',
 'ARZ059' => '33.7005|-94.2343|Little River|Little River|05081',
 'ARZ060' => '33.7354|-93.6684|Hempstead|Hempstead|05057',
 'ARZ061' => '33.6641|-93.3072|Nevada|Nevada|05099',
 'ARZ062' => '33.9698|-92.6545|Dallas|Dallas|05039',
 'ARZ063' => '33.8984|-92.1852|Cleveland|Cleveland|05025',
 'ARZ064' => '33.9575|-91.7333|Lincoln|Lincoln|05079',
 'ARZ065' => '33.8333|-91.254|Desha|Desha|05041',
 'ARZ066' => '33.5933|-92.882|Ouachita|Ouachita|05103',
 'ARZ067' => '33.558|-92.5031|Calhoun|Calhoun|05013',
 'ARZ068' => '33.4659|-92.1622|Bradley|Bradley|05011',
 'ARZ069' => '33.5895|-91.72|Drew|Drew|05043',
 'ARZ070' => '33.3124|-93.8918|Miller|Miller|05091',
 'ARZ071' => '33.2408|-93.6073|Lafayette|Lafayette|05073',
 'ARZ072' => '33.2143|-93.2273|Columbia|Columbia|05027',
 'ARZ073' => '33.1713|-92.5973|Union|Union|05139',
 'ARZ074' => '33.1912|-91.7679|Ashley|Ashley|05003',
 'ARZ075' => '33.2672|-91.294|Chicot|Chicot|05017',
 'ARZ103' => '36.3217|-93.0755|Boone County Except Southwest|Boone|05009',
 'ARZ112' => '35.8956|-93.2439|Newton County Higher Elevations|Newton|05101',
 'ARZ113' => '35.9775|-92.7213|Searcy County Lower Elevations|Searcy|05129',
 'ARZ121' => '35.4736|-93.4744|Southern Johnson County|Johnson|05071',
 'ARZ122' => '35.3423|-93.0596|Southern Pope County|Pope|05115',
 'ARZ123' => '35.5067|-92.4247|Southeast Van Buren County|Van Buren|05141',
 'ARZ130' => '35.2523|-93.7455|Western and Northern Logan County|Logan|05083',
 'ARZ137' => '34.9845|-94.0579|Northern Scott County|Scott|05127',
 'ARZ138' => '35.1143|-93.5043|Northwest Yell County|Yell|05149',
 'ARZ140' => '34.4133|-94.3073|Polk County Lower Elevations|Polk|05113',
 'ARZ141' => '34.5241|-93.6079|Central and Eastern Montgomery County|Montgomery|05097',
 'ARZ203' => '36.1834|-93.2439|Boone County Higher Elevations|Boone|05009',
 'ARZ212' => '36.0553|-93.0733|Newton County Lower Elevations|Newton|05101',
 'ARZ213' => '36.0493|-92.8685|Northwest Searcy County Higher Elevations|Searcy|05129',
 'ARZ221' => '35.6552|-93.4471|Johnson County Higher Elevations|Johnson|05071',
 'ARZ222' => '35.607|-92.9956|Pope County Higher Elevations|Pope|05115',
 'ARZ223' => '35.6487|-92.5994|Van Buren County Higher Elevations|Van Buren|05141',
 'ARZ230' => '35.1586|-93.6717|Southern and Eastern Logan County|Logan|05083',
 'ARZ237' => '34.8189|-94.0651|Central and Southern Scott County|Scott|05127',
 'ARZ238' => '34.9695|-93.3837|Yell Excluding Northwest|Yell|05149',
 'ARZ240' => '34.6452|-94.2329|Northern Polk County Higher Elevations|Polk|05113',
 'ARZ241' => '34.6914|-93.6775|Northern Montgomery County Higher Elevations|Montgomery|05097',
 'ARZ313' => '35.8697|-92.6677|Eastern, Central, and Southern Searcy County Higher Elevations|Searcy|05129',
 'ARZ340' => '34.4489|-94.1274|Southeast Polk County Higher Elevations|Polk|05113',
 'ARZ341' => '34.4197|-93.8217|Southwest Montgomery County Higher Elevations|Montgomery|05097',
 'ASC010' => '-14.2763|-170.6596|Eastern||',
 'ASC020' => '-14.2219|-169.5060|Manu\'a||',
 'ASC030' => '-14.5453|-168.1560|Rose Atoll||',
 'ASC040' => '-11.0548|-171.0802|Swains Island||',
 'ASC050' => '-14.3241|-170.7691|Western||',
 'ASZ001' => '-14.3055|-170.717|Tutuila and Aunuu|Eastern|60010	-14.3055|-170.717|Tutuila and Aunuu|Western|60050',
 'ASZ002' => '-14.227|-169.5053|Manua|Manu\'a|60020',
 'ASZ003' => '-11.0844|-171.046|Swains Island|Swains Island|60040',
 'ASZ004' => '-14.5453|-168.156|Rose Atoll|Rose Atoll|60030',
 'AZC001' => '35.3957|-109.4888|Apache||',
 'AZC003' => '31.8796|-109.7511|Cochise||',
 'AZC005' => '35.8387|-111.7705|Coconino||',
 'AZC007' => '33.7997|-110.8117|Gila||',
 'AZC009' => '32.9327|-109.8874|Graham||',
 'AZC011' => '33.2153|-109.2401|Greenlee||',
 'AZC012' => '33.7292|-113.9813|La Paz||',
 'AZC013' => '33.3488|-112.4912|Maricopa||',
 'AZC015' => '35.7044|-113.7582|Mohave||',
 'AZC017' => '35.3996|-110.3214|Navajo||',
 'AZC019' => '32.0974|-111.7899|Pima||',
 'AZC021' => '32.9043|-111.3447|Pinal||',
 'AZC023' => '31.5260|-110.8466|Santa Cruz||',
 'AZC025' => '34.5999|-112.5538|Yavapai||',
 'AZC027' => '32.7694|-113.9056|Yuma||',
 'AZZ001' => '36.5921|-113.3317|Northwest Plateau|Mohave|04015',
 'AZZ002' => '34.6762|-114.3492|Lake Havasu and Fort Mohave|Mohave|04015',
 'AZZ003' => '35.1839|-113.848|Northwest Deserts|Mohave|04015',
 'AZZ004' => '36.6514|-112.2018|Kaibab Plateau|Coconino|04005',
 'AZZ005' => '36.7777|-111.6681|Marble and Glen Canyons|Coconino|04005',
 'AZZ006' => '36.184|-112.3184|Grand Canyon Country|Coconino|04005',
 'AZZ007' => '35.7341|-112.5569|Coconino Plateau|Coconino|04005',
 'AZZ008' => '34.8361|-112.6554|Yavapai County  Mountains|Yavapai|04025',
 'AZZ009' => '36.4046|-110.9711|Northeast Plateaus and Mesas Hwy 264 Northward|Apache|04001	36.4046|-110.9711|Northeast Plateaus and Mesas Hwy 264 Northward|Coconino|04005	36.4046|-110.9711|Northeast Plateaus and Mesas Hwy 264 Northward|Navajo|04017',
 'AZZ010' => '36.5404|-109.7068|Chinle Valley|Apache|04001	36.5404|-109.7068|Chinle Valley|Navajo|04017',
 'AZZ011' => '35.8693|-109.2344|Chuska Mountains and Defiance Plateau|Apache|04001',
 'AZZ012' => '35.4788|-111.1876|Little Colorado River Valley in Coconino County|Coconino|04005	35.4788|-111.1876|Little Colorado River Valley in Coconino County|Navajo|04017',
 'AZZ013' => '34.844|-110.3128|Little Colorado River Valley in Navajo County|Navajo|04017',
 'AZZ014' => '34.5768|-109.4198|Little Colorado River Valley in Apache County|Apache|04001',
 'AZZ015' => '35.2296|-111.7689|Western Mogollon Rim|Coconino|04005',
 'AZZ016' => '34.4418|-110.8122|Eastern Mogollon Rim|Coconino|04005	34.4418|-110.8122|Eastern Mogollon Rim|Navajo|04017',
 'AZZ017' => '33.9272|-109.6483|White Mountains|Apache|04001	33.9272|-109.6483|White Mountains|Navajo|04017',
 'AZZ018' => '34.0401|-110.9225|Northern Gila County|Gila|04007',
 'AZZ036' => '35.8011|-114.3194|Lake Mead National Recreation Area|Mohave|04015',
 'AZZ037' => '34.4302|-112.5126|Yavapai County Valleys and Basins|Yavapai|04025',
 'AZZ038' => '34.9117|-111.8796|Oak Creek and Sycamore Canyons|Coconino|04005	34.9117|-111.8796|Oak Creek and Sycamore Canyons|Yavapai|04025',
 'AZZ039' => '36.355|-110.243|Black Mesa Area|Apache|04001	36.355|-110.243|Black Mesa Area|Coconino|04005	36.355|-110.243|Black Mesa Area|Navajo|04017',
 'AZZ040' => '35.4889|-110.1825|Northeast Plateaus and Mesas South of Hwy 264|Apache|04001	35.4889|-110.1825|Northeast Plateaus and Mesas South of Hwy 264|Coconino|04005	35.4889|-110.1825|Northeast Plateaus and Mesas South of Hwy 264|Navajo|04017',
 'AZZ501' => '32.2167|-112.9766|Western Pima County Including Ajo/Organ Pipe Cactus National Monument|Pima|04019',
 'AZZ502' => '32.1434|-112.064|Tohono O\'odham Nation including Sells|Pima|04019	32.1434|-112.064|Tohono O\'odham Nation including Sells|Pinal|04021',
 'AZZ503' => '31.6207|-111.163|Upper Santa Cruz River and Altar Valleys including Nogales|Pima|04019	31.6207|-111.163|Upper Santa Cruz River and Altar Valleys including Nogales|Santa Cruz|04023',
 'AZZ504' => '32.1761|-111.0565|Tucson Metro Area including Tucson/Green Valley/Marana/Vail|Pima|04019',
 'AZZ505' => '32.7452|-111.3393|South Central Pinal County including Eloy/Picacho Peak State Park|Pinal|04021',
 'AZZ506' => '32.8255|-110.7518|Southeast Pinal County including Kearny/Mammoth/Oracle|Pinal|04021',
 'AZZ507' => '31.9331|-110.3073|Upper San Pedro River Valley including Sierra Vista/Benson|Cochise|04003	31.9331|-110.3073|Upper San Pedro River Valley including Sierra Vista/Benson|Graham|04009	31.9331|-110.3073|Upper San Pedro River Valley including Sierra Vista/Benson|Pima|04019	31.9331|-110.3073|Upper San Pedro River Valley including Sierra Vista/Benson|Santa Cruz|04023',
 'AZZ508' => '31.9147|-109.5452|Eastern Cochise County Below 5000 Feet including Douglas/Willcox|Cochise|04003',
 'AZZ509' => '32.8686|-109.7443|Upper Gila River and Aravaipa Valleys including Clifton/Safford|Graham|04009	32.8686|-109.7443|Upper Gila River and Aravaipa Valleys including Clifton/Safford|Greenlee|04011',
 'AZZ510' => '33.3867|-109.4881|White Mountains of Graham and Greenlee Counties including Hannagan Meadow|Graham|04009	33.3867|-109.4881|White Mountains of Graham and Greenlee Counties including Hannagan Meadow|Greenlee|04011',
 'AZZ511' => '32.6525|-110.1153|Galiuro and Pinaleno Mountains including Mount Graham|Cochise|04003	32.6525|-110.1153|Galiuro and Pinaleno Mountains including Mount Graham|Graham|04009	32.6525|-110.1153|Galiuro and Pinaleno Mountains including Mount Graham|Pinal|04021',
 'AZZ512' => '31.8616|-109.356|Chiricahua Mountains including Chiricahua National Monument|Cochise|04003',
 'AZZ513' => '31.6043|-110.3833|Dragoon/Mule/Huachuca and Santa Rita Mountains including Bisbee/Canelo Hills/Madera Canyon|Cochise|04003	31.6043|-110.3833|Dragoon/Mule/Huachuca and Santa Rita Mountains including Bisbee/Canelo Hills/Madera Canyon|Pima|04019	31.6043|-110.3833|Dragoon/Mule/Huachuca and Santa Rita Mountains including Bisbee/Canelo Hills/Madera Canyon|Santa Cruz|04023',
 'AZZ514' => '32.3364|-110.6808|Santa Catalina and Rincon Mountains including Mount Lemmon/Summerhaven|Pima|04019	32.3364|-110.6808|Santa Catalina and Rincon Mountains including Mount Lemmon/Summerhaven|Pinal|04021',
 'AZZ515' => '31.8186|-111.5931|Baboquivari Mountains including Kitt Peak|Pima|04019',
 'AZZ530' => '33.6988|-114.4568|Parker Valley|La Paz|04012',
 'AZZ531' => '33.2172|-114.028|Kofa|La Paz|04012	33.2172|-114.028|Kofa|Yuma|04027',
 'AZZ532' => '32.6544|-114.5114|Yuma|Yuma|04027',
 'AZZ533' => '33.8115|-113.8132|Central La Paz|La Paz|04012',
 'AZZ534' => '33.8662|-112.9785|Aguila Valley|Maricopa|04013',
 'AZZ535' => '32.3859|-113.7573|Southeast Yuma County|Yuma|04027',
 'AZZ536' => '32.822|-113.804|Gila River Valley|Yuma|04027',
 'AZZ537' => '33.7421|-112.477|Northwest Valley|Maricopa|04013',
 'AZZ538' => '33.3971|-112.9704|Tonopah Desert|Maricopa|04013',
 'AZZ539' => '32.8542|-113.0566|Gila Bend|Maricopa|04013',
 'AZZ540' => '33.3912|-112.4004|Buckeye/Avondale|Maricopa|04013',
 'AZZ541' => '33.8086|-112.0129|Cave Creek/New River|Maricopa|04013',
 'AZZ542' => '33.7122|-112.1301|Deer Valley|Maricopa|04013',
 'AZZ543' => '33.4331|-112.0552|Central Phoenix|Maricopa|04013',
 'AZZ544' => '33.5716|-112.1525|North Phoenix/Glendale|Maricopa|04013',
 'AZZ545' => '33.926|-111.8887|New River Mesa|Maricopa|04013',
 'AZZ546' => '33.5351|-111.8891|Scottsdale/Paradise Valley|Maricopa|04013',
 'AZZ547' => '33.7012|-111.51|Rio Verde/Salt River|Maricopa|04013',
 'AZZ548' => '33.3765|-111.8134|East Valley|Maricopa|04013',
 'AZZ549' => '33.5349|-111.6592|Fountain Hills/East Mesa|Maricopa|04013',
 'AZZ550' => '33.2829|-112.0449|South Mountain/Ahwatukee|Maricopa|04013',
 'AZZ551' => '33.2616|-111.7353|Southeast Valley/Queen Creek|Maricopa|04013',
 'AZZ552' => '33.2702|-111.188|Superior|Pinal|04021',
 'AZZ553' => '33.0208|-111.7511|Northwest Pinal County|Pinal|04021',
 'AZZ554' => '32.8658|-112.1203|West Pinal County|Pinal|04021',
 'AZZ555' => '33.2584|-111.3827|Apache Junction/Gold Canyon|Pinal|04021',
 'AZZ556' => '33.7079|-111.1275|Tonto Basin|Gila|04007',
 'AZZ557' => '33.8233|-111.4206|Mazatzal Mountains|Gila|04007	33.8233|-111.4206|Mazatzal Mountains|Maricopa|04013',
 'AZZ558' => '33.3639|-110.9698|Pinal/Superstition Mountains|Gila|04007	33.3639|-110.9698|Pinal/Superstition Mountains|Maricopa|04013	33.3639|-110.9698|Pinal/Superstition Mountains|Pinal|04021',
 'AZZ559' => '32.8019|-112.5236|Sonoran Desert Natl Monument|Maricopa|04013',
 'AZZ560' => '33.3416|-110.5321|San Carlos|Gila|04007',
 'AZZ561' => '33.102|-110.7854|Dripping Springs|Gila|04007',
 'AZZ562' => '33.4344|-110.8175|Globe/Miami|Gila|04007',
 'AZZ563' => '33.6107|-110.4548|Southeast Gila County|Gila|04007',
 'C' => '||||',
 'CAC001' => '37.6466|-121.8860|Alameda||',
 'CAC003' => '38.5973|-119.8207|Alpine||',
 'CAC005' => '38.4461|-120.6519|Amador||',
 'CAC007' => '39.6669|-121.6007|Butte||',
 'CAC009' => '38.2046|-120.5541|Calaveras||',
 'CAC011' => '39.1775|-122.2370|Colusa||',
 'CAC013' => '37.9163|-121.9276|Contra Costa||',
 'CAC015' => '41.7431|-123.8970|Del Norte||',
 'CAC017' => '38.7785|-120.5247|El Dorado||',
 'CAC019' => '36.7584|-119.6503|Fresno||',
 'CAC021' => '39.5984|-122.3922|Glenn||',
 'CAC023' => '40.6984|-123.8735|Humboldt||',
 'CAC025' => '33.0395|-115.3653|Imperial||',
 'CAC027' => '36.5111|-117.4107|Inyo||',
 'CAC029' => '35.3429|-118.7298|Kern||',
 'CAC031' => '36.0753|-119.8156|Kings||',
 'CAC033' => '39.0997|-122.7532|Lake||',
 'CAC035' => '40.6736|-120.5943|Lassen||',
 'CAC037' => '34.3203|-118.2252|Los Angeles||',
 'CAC039' => '37.2180|-119.7626|Madera||',
 'CAC041' => '38.0725|-122.7185|Marin||',
 'CAC043' => '37.5815|-119.9055|Mariposa||',
 'CAC045' => '39.4400|-123.3912|Mendocino||',
 'CAC047' => '37.1926|-120.7180|Merced||',
 'CAC049' => '41.5899|-120.7250|Modoc||',
 'CAC051' => '37.9390|-118.8867|Mono||',
 'CAC053' => '36.2169|-121.2389|Monterey||',
 'CAC055' => '38.5066|-122.3305|Napa||',
 'CAC057' => '39.3014|-120.7683|Nevada||',
 'CAC059' => '33.7030|-117.7605|Orange||',
 'CAC061' => '39.0635|-120.7176|Placer||',
 'CAC063' => '40.0047|-120.8386|Plumas||',
 'CAC065' => '33.7437|-115.9939|Riverside||',
 'CAC067' => '38.4542|-121.3384|Sacramento||',
 'CAC069' => '36.6057|-121.0750|San Benito||',
 'CAC071' => '34.8415|-116.1784|San Bernardino||',
 'CAC073' => '33.0354|-116.7335|San Diego||',
 'CAC075' => '37.7558|-122.4424|San Francisco||',
 'CAC077' => '37.9345|-121.2720|San Joaquin||',
 'CAC079' => '35.3872|-120.4040|San Luis Obispo||',
 'CAC081' => '37.4218|-122.3293|San Mateo||',
 'CAC083' => '34.6731|-120.0165|Santa Barbara||',
 'CAC085' => '37.2325|-121.6963|Santa Clara||',
 'CAC087' => '37.0563|-122.0018|Santa Cruz||',
 'CAC089' => '40.7638|-122.0405|Shasta||',
 'CAC091' => '39.5804|-120.5160|Sierra||',
 'CAC093' => '41.5927|-122.5404|Siskiyou||',
 'CAC095' => '38.2805|-121.9266|Solano||',
 'CAC097' => '38.5286|-122.8873|Sonoma||',
 'CAC099' => '37.5592|-120.9978|Stanislaus||',
 'CAC101' => '39.0345|-121.6949|Sutter||',
 'CAC103' => '40.1257|-122.2339|Tehama||',
 'CAC105' => '40.6507|-123.1126|Trinity||',
 'CAC107' => '36.2201|-118.8005|Tulare||',
 'CAC109' => '38.0276|-119.9548|Tuolumne||',
 'CAC111' => '34.4567|-119.0835|Ventura||',
 'CAC113' => '38.6867|-121.9016|Yolo||',
 'CAC115' => '39.2691|-121.3512|Yuba||',
 'CAZ006' => '37.7558|-122.4423|San Francisco|San Francisco|06075',
 'CAZ013' => '40.9299|-122.2247|Shasta Lake Area / Northern Shasta County|Shasta|06089',
 'CAZ014' => '40.9423|-121.4882|Burney Basin / Eastern Shasta County|Shasta|06089',
 'CAZ015' => '40.2198|-122.2949|Northern Sacramento Valley|Shasta|06089	40.2198|-122.2949|Northern Sacramento Valley|Tehama|06103',
 'CAZ016' => '39.3764|-121.926|Central Sacramento Valley|Butte|06007	39.3764|-121.926|Central Sacramento Valley|Colusa|06011	39.3764|-121.926|Central Sacramento Valley|Glenn|06021	39.3764|-121.926|Central Sacramento Valley|Nevada|06057	39.3764|-121.926|Central Sacramento Valley|Sutter|06101	39.3764|-121.926|Central Sacramento Valley|Yuba|06115',
 'CAZ017' => '38.6268|-121.5625|Southern Sacramento Valley|Amador|06005	38.6268|-121.5625|Southern Sacramento Valley|El Dorado|06017	38.6268|-121.5625|Southern Sacramento Valley|Placer|06061	38.6268|-121.5625|Southern Sacramento Valley|Sacramento|06067	38.6268|-121.5625|Southern Sacramento Valley|Solano|06095	38.6268|-121.5625|Southern Sacramento Valley|Sutter|06101	38.6268|-121.5625|Southern Sacramento Valley|Yolo|06113',
 'CAZ018' => '38.1432|-121.7623|Carquinez Strait and Delta|Sacramento|06067	38.1432|-121.7623|Carquinez Strait and Delta|San Joaquin|06077	38.1432|-121.7623|Carquinez Strait and Delta|Solano|06095',
 'CAZ019' => '37.7581|-121.041|Northern San Joaquin Valley|Amador|06005	37.7581|-121.041|Northern San Joaquin Valley|Calaveras|06009	37.7581|-121.041|Northern San Joaquin Valley|San Joaquin|06077	37.7581|-121.041|Northern San Joaquin Valley|Stanislaus|06099	37.7581|-121.041|Northern San Joaquin Valley|Tuolumne|06109',
 'CAZ038' => '34.9422|-119.7374|Cuyama Valley|Santa Barbara|06083',
 'CAZ043' => '32.9783|-117.2367|San Diego County Coastal Areas|San Diego|06073',
 'CAZ048' => '33.8486|-117.2412|San Bernardino and Riverside County Valleys -The Inland Empire|Riverside|06065	33.8486|-117.2412|San Bernardino and Riverside County Valleys -The Inland Empire|San Bernardino|06071',
 'CAZ050' => '33.0047|-116.9604|San Diego County Valleys|San Diego|06073',
 'CAZ055' => '34.2304|-117.0957|San Bernardino County Mountains|San Bernardino|06071',
 'CAZ056' => '33.66|-116.6434|Riverside County Mountains|Riverside|06065',
 'CAZ057' => '33.6256|-117.455|Santa Ana Mountains and Foothills|Orange|06059	33.6256|-117.455|Santa Ana Mountains and Foothills|Riverside|06065	33.6256|-117.455|Santa Ana Mountains and Foothills|San Diego|06073',
 'CAZ058' => '33.0713|-116.5324|San Diego County Mountains|San Diego|06073',
 'CAZ060' => '34.5427|-117.0143|Apple and Lucerne Valleys|San Bernardino|06071',
 'CAZ061' => '33.7424|-116.3024|Coachella Valley|Riverside|06065',
 'CAZ062' => '33.0511|-116.2536|San Diego County Deserts|San Diego|06073',
 'CAZ063' => '39.8175|-122.7565|Mountains Southwestern Shasta County to Western Colusa County|Colusa|06011	39.8175|-122.7565|Mountains Southwestern Shasta County to Western Colusa County|Glenn|06021	39.8175|-122.7565|Mountains Southwestern Shasta County to Western Colusa County|Shasta|06089	39.8175|-122.7565|Mountains Southwestern Shasta County to Western Colusa County|Tehama|06103',
 'CAZ065' => '33.7185|-115.2342|San Gorgonio Pass Near Banning|Riverside|06065',
 'CAZ066' => '40.1117|-121.7566|Northeast Foothills/Sacramento Valley|Butte|06007	40.1117|-121.7566|Northeast Foothills/Sacramento Valley|Shasta|06089	40.1117|-121.7566|Northeast Foothills/Sacramento Valley|Tehama|06103',
 'CAZ067' => '38.6192|-120.7698|Motherlode|Amador|06005	38.6192|-120.7698|Motherlode|Calaveras|06009	38.6192|-120.7698|Motherlode|El Dorado|06017	38.6192|-120.7698|Motherlode|Nevada|06057	38.6192|-120.7698|Motherlode|Placer|06061	38.6192|-120.7698|Motherlode|Tuolumne|06109	38.6192|-120.7698|Motherlode|Yuba|06115',
 'CAZ068' => '40.1971|-121.3501|Western Plumas County/Lassen Park|Butte|06007	40.1971|-121.3501|Western Plumas County/Lassen Park|Lassen|06035	40.1971|-121.3501|Western Plumas County/Lassen Park|Plumas|06063	40.1971|-121.3501|Western Plumas County/Lassen Park|Shasta|06089	40.1971|-121.3501|Western Plumas County/Lassen Park|Tehama|06103',
 'CAZ069' => '38.7829|-120.3423|West Slope Northern Sierra Nevada|Alpine|06003	38.7829|-120.3423|West Slope Northern Sierra Nevada|Amador|06005	38.7829|-120.3423|West Slope Northern Sierra Nevada|Calaveras|06009	38.7829|-120.3423|West Slope Northern Sierra Nevada|El Dorado|06017	38.7829|-120.3423|West Slope Northern Sierra Nevada|Nevada|06057	38.7829|-120.3423|West Slope Northern Sierra Nevada|Placer|06061	38.7829|-120.3423|West Slope Northern Sierra Nevada|Sierra|06091	38.7829|-120.3423|West Slope Northern Sierra Nevada|Tuolumne|06109	38.7829|-120.3423|West Slope Northern Sierra Nevada|Yuba|06115',
 'CAZ070' => '41.6116|-120.0862|Surprise Valley California|Modoc|06049',
 'CAZ071' => '40.466|-120.5471|Lassen-Eastern Plumas-Eastern Sierra Counties|Lassen|06035	40.466|-120.5471|Lassen-Eastern Plumas-Eastern Sierra Counties|Plumas|06063	40.466|-120.5471|Lassen-Eastern Plumas-Eastern Sierra Counties|Sierra|06091',
 'CAZ072' => '38.9481|-119.9683|Greater Lake Tahoe Area|Alpine|06003	38.9481|-119.9683|Greater Lake Tahoe Area|El Dorado|06017	38.9481|-119.9683|Greater Lake Tahoe Area|Nevada|06057	38.9481|-119.9683|Greater Lake Tahoe Area|Placer|06061',
 'CAZ073' => '37.939|-118.8867|Mono|Mono|06051',
 'CAZ080' => '41.5562|-123.1641|Western Siskiyou County|Siskiyou|06093',
 'CAZ081' => '41.7362|-122.5631|Central Siskiyou County|Siskiyou|06093',
 'CAZ082' => '41.2704|-122.1846|South Central Siskiyou County|Siskiyou|06093',
 'CAZ083' => '41.5425|-121.8967|North Central and Southeast Siskiyou County|Siskiyou|06093',
 'CAZ084' => '41.8639|-121.6371|Northeast Siskiyou and Northwest Modoc Counties|Modoc|06049	41.8639|-121.6371|Northeast Siskiyou and Northwest Modoc Counties|Siskiyou|06093',
 'CAZ085' => '41.5611|-120.7585|Modoc County|Modoc|06049',
 'CAZ087' => '33.382|-118.4331|Catalina Island|Los Angeles|06037',
 'CAZ088' => '34.4534|-118.5579|Santa Clarita Valley|Los Angeles|06037',
 'CAZ101' => '41.0243|-124.0956|Coastal Del Norte|Del Norte|06015',
 'CAZ102' => '41.0243|-124.0956|Del Norte Interior|Del Norte|06015',
 'CAZ103' => '41.0243|-124.0956|Northern Humboldt Coast|Humboldt|06023',
 'CAZ104' => '41.0243|-124.0956|Southwestern Humboldt|Humboldt|06023',
 'CAZ105' => '41.0243|-124.0956|Northern Humboldt Interior|Humboldt|06023',
 'CAZ106' => '41.0243|-124.0956|Southern Humboldt Interior|Humboldt|06023',
 'CAZ107' => '40.7088|-123.111|Northern Trinity|Trinity|06105',
 'CAZ108' => '40.7088|-123.111|Southern Trinity|Trinity|06105',
 'CAZ109' => '39.3778|-123.7271|Mendocino Coast|Mendocino|06045',
 'CAZ110' => '39.6359|-123.4371|Northwestern Mendocino Interior|Mendocino|06045',
 'CAZ111' => '39.7603|-123.1396|Northeastern Mendocino Interior|Mendocino|06045',
 'CAZ112' => '39.1561|-123.4915|Southwestern Mendocino Interior|Mendocino|06045',
 'CAZ113' => '39.0904|-123.1953|Southeastern Mendocino Interior|Mendocino|06045',
 'CAZ114' => '39.3619|-122.8628|Northern Lake County|Lake|06033',
 'CAZ115' => '38.9779|-122.7022|Southern Lake County|Lake|06033',
 'CAZ300' => '36.6593|-120.7869|West Side Mountains north of 198|Fresno|06019	36.6593|-120.7869|West Side Mountains north of 198|Merced|06047',
 'CAZ301' => '36.9125|-120.7212|Los Banos - Dos Palos|Fresno|06019	36.9125|-120.7212|Los Banos - Dos Palos|Merced|06047',
 'CAZ302' => '37.0903|-120.4536|Merced - Madera - Mendota|Fresno|06019	37.0903|-120.4536|Merced - Madera - Mendota|Madera|06039	37.0903|-120.4536|Merced - Madera - Mendota|Merced|06047',
 'CAZ303' => '37.2577|-120.193|Planada - Le Grand - Snelling|Madera|06039	37.2577|-120.193|Planada - Le Grand - Snelling|Mariposa|06043	37.2577|-120.193|Planada - Le Grand - Snelling|Merced|06047',
 'CAZ304' => '36.0678|-120.1879|Coalinga - Avenal|Fresno|06019	36.0678|-120.1879|Coalinga - Avenal|Kings|06031',
 'CAZ305' => '36.287|-120.1034|West Side of Fresno and Kings Counties|Fresno|06019	36.287|-120.1034|West Side of Fresno and Kings Counties|Kings|06031',
 'CAZ306' => '36.5869|-119.8953|Caruthers - San Joaquin - Selma|Fresno|06019	36.5869|-119.8953|Caruthers - San Joaquin - Selma|Tulare|06107',
 'CAZ307' => '36.7953|-119.7342|Fresno-Clovis|Fresno|06019',
 'CAZ308' => '35.6837|-120.0363|West Side Mountains South of 198|Fresno|06019	35.6837|-120.0363|West Side Mountains South of 198|Kern|06029	35.6837|-120.0363|West Side Mountains South of 198|Kings|06031',
 'CAZ309' => '35.6098|-119.6082|Buttonwillow - Lost Hills - I5|Kern|06029	35.6098|-119.6082|Buttonwillow - Lost Hills - I5|Kings|06031',
 'CAZ310' => '35.7752|-119.3702|Delano-Wasco-Shafter|Kern|06029	35.7752|-119.3702|Delano-Wasco-Shafter|Kings|06031	35.7752|-119.3702|Delano-Wasco-Shafter|Tulare|06107',
 'CAZ311' => '36.226|-119.5882|Hanford - Corcoran - Lemoore|Fresno|06019	36.226|-119.5882|Hanford - Corcoran - Lemoore|Kings|06031	36.226|-119.5882|Hanford - Corcoran - Lemoore|Tulare|06107',
 'CAZ312' => '36.3626|-119.2605|Visalia - Porterville - Reedley|Fresno|06019	36.3626|-119.2605|Visalia - Porterville - Reedley|Tulare|06107',
 'CAZ313' => '35.2078|-119.4499|Buena Vista|Kern|06029',
 'CAZ314' => '35.3612|-119.0216|Bakersfield|Kern|06029',
 'CAZ315' => '35.7755|-119.0391|Southeast San Joaquin Valley|Kern|06029	35.7755|-119.0391|Southeast San Joaquin Valley|Tulare|06107',
 'CAZ316' => '35.1382|-118.9898|South End San Joaquin Valley|Kern|06029',
 'CAZ317' => '37.3511|-119.9965|Mariposa Madera Foothills|Madera|06039	37.3511|-119.9965|Mariposa Madera Foothills|Mariposa|06043	37.3511|-119.9965|Mariposa Madera Foothills|Merced|06047',
 'CAZ318' => '37.4854|-119.8078|Mariposa-Madera Lower Sierra|Madera|06039	37.4854|-119.8078|Mariposa-Madera Lower Sierra|Mariposa|06043',
 'CAZ319' => '36.607|-119.2012|Fresno-Tulare Foothills|Fresno|06019	36.607|-119.2012|Fresno-Tulare Foothills|Tulare|06107',
 'CAZ320' => '36.837|-119.1509|Fresno-Tulare Lower Sierra|Fresno|06019	36.837|-119.1509|Fresno-Tulare Lower Sierra|Tulare|06107',
 'CAZ321' => '35.7347|-118.88|South End Sierra Foothills|Kern|06029	35.7347|-118.88|South End Sierra Foothills|Tulare|06107',
 'CAZ322' => '35.9436|-118.7513|South End of the Lower Sierra|Kern|06029	35.9436|-118.7513|South End of the Lower Sierra|Tulare|06107',
 'CAZ323' => '37.8529|-119.553|Yosemite NP outside of the valley|Madera|06039	37.8529|-119.553|Yosemite NP outside of the valley|Mariposa|06043	37.8529|-119.553|Yosemite NP outside of the valley|Tuolumne|06109',
 'CAZ324' => '37.7184|-119.662|Yosemite Valley|Mariposa|06043',
 'CAZ325' => '37.3286|-119.3176|San Joaquin River Canyon|Fresno|06019	37.3286|-119.3176|San Joaquin River Canyon|Madera|06039',
 'CAZ326' => '37.4492|-119.1195|Upper San Joaquin River|Fresno|06019	37.4492|-119.1195|Upper San Joaquin River|Madera|06039',
 'CAZ327' => '37.1044|-119.0287|Kaiser to Rodgers Ridge|Fresno|06019',
 'CAZ328' => '36.899|-118.5876|Kings Canyon NP|Fresno|06019	36.899|-118.5876|Kings Canyon NP|Tulare|06107',
 'CAZ329' => '36.7902|-118.8599|Grant Grove Area|Fresno|06019	36.7902|-118.8599|Grant Grove Area|Tulare|06107',
 'CAZ330' => '36.5082|-118.575|Sequoia NP|Tulare|06107',
 'CAZ331' => '36.0209|-118.3399|South End of the Upper Sierra|Kern|06029	36.0209|-118.3399|South End of the Upper Sierra|Tulare|06107',
 'CAZ332' => '35.6428|-118.4122|Kern River Valley|Kern|06029	35.6428|-118.4122|Kern River Valley|Tulare|06107',
 'CAZ333' => '35.4383|-118.4292|Piute Walker Basin|Kern|06029',
 'CAZ334' => '35.1324|-118.5472|Tehachapi|Kern|06029',
 'CAZ335' => '34.8909|-118.9043|Grapevine|Kern|06029',
 'CAZ336' => '34.9239|-119.1812|Frazier Mountain Communities|Kern|06029',
 'CAZ337' => '35.6195|-117.7591|Indian Wells Valley|Kern|06029',
 'CAZ338' => '35.2364|-118.1893|Mojave Desert Slopes|Kern|06029',
 'CAZ339' => '35.0734|-117.9052|Mojave Desert|Kern|06029',
 'CAZ340' => '35.3656|-120.8857|San Luis Obispo County Beaches|San Luis Obispo|06079',
 'CAZ341' => '35.1214|-120.5471|San Luis Obispo County Inland Central Coast|San Luis Obispo|06079',
 'CAZ342' => '35.4597|-120.795|Santa Lucia Mountains|San Luis Obispo|06079',
 'CAZ343' => '35.6395|-120.7122|Southern Salinas Valley|San Luis Obispo|06079',
 'CAZ344' => '35.4405|-120.1532|San Luis Obispo County Interior Valleys|San Luis Obispo|06079',
 'CAZ345' => '35.1768|-120.1048|San Luis Obispo County Mountains|San Luis Obispo|06079',
 'CAZ346' => '34.7179|-120.5534|Santa Barbara County Central Coast Beaches|Santa Barbara|06083',
 'CAZ347' => '34.7553|-120.3762|Santa Barbara County Inland Central Coast|Santa Barbara|06083',
 'CAZ348' => '34.6908|-120.0988|Santa Ynez Valley|Santa Barbara|06083',
 'CAZ349' => '34.5052|-120.3013|Santa Barbara County Southwestern Coast|Santa Barbara|06083',
 'CAZ350' => '34.4344|-119.7142|Santa Barbara County Southeastern Coast|Santa Barbara|06083',
 'CAZ351' => '34.5164|-119.9838|Santa Ynez Mountains Western Range|Santa Barbara|06083',
 'CAZ352' => '34.4707|-119.548|Santa Ynez Mountains Eastern Range|Santa Barbara|06083	34.4707|-119.548|Santa Ynez Mountains Eastern Range|Ventura|06111',
 'CAZ353' => '34.7747|-119.823|Santa Barbara County Interior Mountains|Santa Barbara|06083',
 'CAZ354' => '34.2116|-119.2077|Ventura County Beaches|Ventura|06111',
 'CAZ355' => '34.2366|-119.0715|Ventura County Inland Coast|Ventura|06111',
 'CAZ356' => '34.4011|-119.3447|Lake Casitas|Ventura|06111',
 'CAZ357' => '34.4268|-119.2615|Ojai Valley|Ventura|06111',
 'CAZ358' => '34.3897|-119.0367|Central Ventura County Valleys|Ventura|06111',
 'CAZ362' => '34.0408|-118.6777|Malibu Coast|Los Angeles|06037',
 'CAZ366' => '33.8457|-118.3308|Los Angeles County Beaches|Los Angeles|06037',
 'CAZ367' => '33.7652|-118.3624|Palos Verdes Hills|Los Angeles|06037',
 'CAZ368' => '33.9486|-118.2407|Los Angeles County Inland Coast including Downtown Los Angeles|Los Angeles|06037',
 'CAZ369' => '34.0907|-118.889|Western Santa Monica Mountains|Los Angeles|06037	34.0907|-118.889|Western Santa Monica Mountains|Ventura|06111',
 'CAZ370' => '34.0938|-118.5622|Eastern Santa Monica Mountains|Los Angeles|06037',
 'CAZ371' => '34.1299|-118.7423|Calabasas and Agoura Hills|Los Angeles|06037',
 'CAZ372' => '34.2249|-118.5083|Western San Fernando Valley|Los Angeles|06037',
 'CAZ373' => '34.1898|-118.2987|Eastern San Fernando Valley|Los Angeles|06037',
 'CAZ374' => '34.2322|-118.8394|Southeastern Ventura County Valleys|Ventura|06111',
 'CAZ375' => '34.3387|-118.7386|Santa Susana Mountains|Los Angeles|06037	34.543|-119.0936|Santa Susana Mountains|Ventura|06111',
 'CAZ376' => '34.543|-119.0936|Southern Ventura County Mountains|Ventura|06111',
 'CAZ377' => '34.7342|-119.1611|Northern Ventura County Mountains|Ventura|06111',
 'CAZ378' => '34.6716|-118.7273|Northwestern Los Angeles County Mountains including the Interstate 5 Corridor|Los Angeles|06037',
 'CAZ379' => '34.4617|-118.2964|Western San Gabriel Mountains including the Highway 14 Corridor|Los Angeles|06037',
 'CAZ380' => '34.2905|-117.8806|Eastern San Gabriel Mountains|Los Angeles|06037',
 'CAZ381' => '34.6494|-118.3779|Western Antelope Valley Foothills|Los Angeles|06037',
 'CAZ382' => '34.4909|-117.8141|Eastern Antelope Valley Foothills|Los Angeles|06037',
 'CAZ383' => '34.7001|-118.0482|Antelope Valley |Los Angeles|06037',
 'CAZ502' => '38.0602|-122.6859|Marin Coastal Range|Marin|06041',
 'CAZ503' => '38.6598|-123.1621|Sonoma Coastal Range|Sonoma|06097',
 'CAZ504' => '38.5823|-122.4433|North Bay Interior Mountains|Napa|06055	38.5823|-122.4433|North Bay Interior Mountains|Sonoma|06097',
 'CAZ505' => '38.2364|-122.9543|Coastal North Bay Including Point Reyes National Seashore|Marin|06041	38.2364|-122.9543|Coastal North Bay Including Point Reyes National Seashore|Sonoma|06097',
 'CAZ506' => '38.3698|-122.6419|North Bay Interior Valleys|Marin|06041	38.3698|-122.6419|North Bay Interior Valleys|Napa|06055	38.3698|-122.6419|North Bay Interior Valleys|Sonoma|06097',
 'CAZ508' => '37.5938|-122.165|San Francisco Bay Shoreline|Alameda|06001	37.5938|-122.165|San Francisco Bay Shoreline|Contra Costa|06013	37.5938|-122.165|San Francisco Bay Shoreline|San Mateo|06081	37.5938|-122.165|San Francisco Bay Shoreline|Santa Clara|06085',
 'CAZ509' => '37.374|-122.3923|San Fransisco Peninsula Coast|San Mateo|06081	37.374|-122.3923|San Fransisco Peninsula Coast|Santa Cruz|06087',
 'CAZ510' => '37.8803|-121.8801|East Bay Interior Valleys|Alameda|06001	37.8803|-121.8801|East Bay Interior Valleys|Contra Costa|06013',
 'CAZ512' => '37.1726|-122.04|Santa Cruz Mountains|San Mateo|06081	37.1726|-122.04|Santa Cruz Mountains|Santa Clara|06085	37.1726|-122.04|Santa Cruz Mountains|Santa Cruz|06087',
 'CAZ513' => '37.2196|-121.7971|Santa Clara Valley Including San Jose|Santa Clara|06085',
 'CAZ514' => '37.243|-121.5277|Eastern Santa Clara Hills|Santa Clara|06085',
 'CAZ515' => '37.7045|-121.8201|East Bay Hills|Alameda|06001	37.7045|-121.8201|East Bay Hills|Contra Costa|06013',
 'CAZ516' => '36.1014|-121.0546|Southern Salinas Valley/Arroyo Seco and Lake San Antonio|Monterey|06053',
 'CAZ517' => '36.1606|-121.4188|Santa Lucia Mountains and Los Padres National Forest|Monterey|06053',
 'CAZ518' => '36.3718|-120.9214|Mountains Of San Benito County And Interior Monterey County Including Pinnacles National Monument|Monterey|06053	36.3718|-120.9214|Mountains Of San Benito County And Interior Monterey County Including Pinnacles National Monument|San Benito|06069',
 'CAZ519' => '36.8269|-118.341|Eastern Sierra Slopes of Inyo County|Inyo|06027',
 'CAZ520' => '36.5133|-118.0127|Owens Valley|Inyo|06027',
 'CAZ521' => '37.0104|-118.0388|White Mountains of Inyo County|Inyo|06027',
 'CAZ522' => '36.4199|-117.1006|Death Valley National Park|Inyo|06027',
 'CAZ523' => '35.3053|-117.0005|Western Mojave Desert|San Bernardino|06071',
 'CAZ524' => '35.1398|-115.7069|Eastern Mojave Desert Including the Mojave National Preserve|San Bernardino|06071',
 'CAZ525' => '34.3424|-116.0947|Morongo Basin|San Bernardino|06071',
 'CAZ526' => '34.3849|-115.0956|Cadiz Basin|San Bernardino|06071',
 'CAZ527' => '34.4988|-114.5011|San Bernadino County-Upper Colorado River Valley|San Bernardino|06071',
 'CAZ528' => '36.6769|-121.5047|Northern Salinas Valley/Hollister Valley and Carmel Valley|Monterey|06053	36.6769|-121.5047|Northern Salinas Valley/Hollister Valley and Carmel Valley|San Benito|06069',
 'CAZ529' => '36.9757|-121.9005|Northern Monterey Bay|Santa Cruz|06087',
 'CAZ530' => '36.6165|-121.7566|Southern Monterey Bay and Big Sur Coast|Monterey|06053',
 'CAZ548' => '34.0657|-117.9738|Los Angeles County San Gabriel Valley|Los Angeles|06037',
 'CAZ549' => '33.9774|-120.1462|San Miguel and Santa Rosa Islands|Santa Barbara|06083',
 'CAZ550' => '34.0138|-119.7416|Santa Cruz and Anacapa Islands|Santa Barbara|06083',
 'CAZ552' => '33.7028|-117.7899|Orange County Coastal|Orange|06059',
 'CAZ554' => '33.7234|-117.7705|Orange County Inland|Orange|06059',
 'CAZ560' => '33.9359|-116.0847|Joshua Tree NP West|San Bernardino|06071',
 'CAZ561' => '33.9564|-115.6533|Joshua Tree NP East|San Bernardino|06071',
 'CAZ562' => '32.8129|-116.039|Imperial County Southwest|Imperial|06025',
 'CAZ563' => '33.3091|-115.8096|Salton Sea|Imperial|06025	33.3091|-115.8096|Salton Sea|Riverside|06065',
 'CAZ564' => '33.3715|-115.2724|Chuckwalla Mountains|Imperial|06025	33.3715|-115.2724|Chuckwalla Mountains|Riverside|06065',
 'CAZ565' => '32.886|-114.9902|Imperial County Southeast|Imperial|06025',
 'CAZ566' => '32.9908|-115.9008|Imperial County West|Imperial|06025',
 'CAZ567' => '32.9245|-115.5185|Imperial Valley|Imperial|06025',
 'CAZ568' => '33.6785|-115.6832|Chiriaco Summit|Riverside|06065',
 'CAZ569' => '33.4256|-114.6527|Palo Verde Valley|Imperial|06025	33.4256|-114.6527|Palo Verde Valley|Riverside|06065',
 'CAZ570' => '33.8125|-115.0182|Chuckwalla Valley|Riverside|06065',
 'COC001' => '39.8736|-104.3379|Adams||',
 'COC003' => '37.5729|-105.7883|Alamosa||',
 'COC005' => '39.6497|-104.3381|Arapahoe||',
 'COC007' => '37.1936|-107.0483|Archuleta||',
 'COC009' => '37.3192|-102.5605|Baca||',
 'COC011' => '37.9551|-103.0717|Bent||',
 'COC013' => '40.0925|-105.3575|Boulder||',
 'COC014' => '39.9540|-105.0525|Broomfield||',
 'COC015' => '38.7466|-106.1938|Chaffee||',
 'COC017' => '38.8279|-102.6034|Cheyenne||',
 'COC019' => '39.6891|-105.6444|Clear Creek||',
 'COC021' => '37.2007|-106.1917|Conejos||',
 'COC023' => '37.2781|-105.4283|Costilla||',
 'COC025' => '38.3266|-103.7849|Crowley||',
 'COC027' => '38.1087|-105.3674|Custer||',
 'COC029' => '38.8613|-107.8630|Delta||',
 'COC031' => '39.7611|-104.8772|Denver||',
 'COC033' => '37.7516|-108.5172|Dolores||',
 'COC035' => '39.3297|-104.9295|Douglas||',
 'COC037' => '39.6278|-106.6953|Eagle||',
 'COC039' => '39.2866|-104.1359|Elbert||',
 'COC041' => '38.8321|-104.5256|El Paso||',
 'COC043' => '38.4730|-105.4396|Fremont||',
 'COC045' => '39.5993|-107.9039|Garfield||',
 'COC047' => '39.8576|-105.5226|Gilpin||',
 'COC049' => '40.1026|-106.1184|Grand||',
 'COC051' => '38.6668|-107.0317|Gunnison||',
 'COC053' => '37.8213|-107.3003|Hinsdale||',
 'COC055' => '37.6847|-104.9606|Huerfano||',
 'COC057' => '40.6664|-106.3428|Jackson||',
 'COC059' => '39.5865|-105.2506|Jefferson||',
 'COC061' => '38.4327|-102.7404|Kiowa||',
 'COC063' => '39.3054|-102.6029|Kit Carson||',
 'COC065' => '39.2020|-106.3451|Lake||',
 'COC067' => '37.2866|-107.8435|La Plata||',
 'COC069' => '40.6664|-105.4612|Larimer||',
 'COC071' => '37.3159|-104.0387|Las Animas||',
 'COC073' => '38.9880|-103.5140|Lincoln||',
 'COC075' => '40.7247|-103.1101|Logan||',
 'COC077' => '39.0183|-108.4665|Mesa||',
 'COC079' => '37.6690|-106.9241|Mineral||',
 'COC081' => '40.6184|-108.2073|Moffat||',
 'COC083' => '37.3384|-108.5968|Montezuma||',
 'COC085' => '38.4022|-108.2694|Montrose||',
 'COC087' => '40.2627|-103.8098|Morgan||',
 'COC089' => '37.9027|-103.7164|Otero||',
 'COC091' => '38.1555|-107.7693|Ouray||',
 'COC093' => '39.1193|-105.7172|Park||',
 'COC095' => '40.5939|-102.3575|Phillips||',
 'COC097' => '39.2171|-106.9166|Pitkin||',
 'COC099' => '37.9552|-102.3933|Prowers||',
 'COC101' => '38.1734|-104.5128|Pueblo||',
 'COC103' => '39.9798|-108.2172|Rio Blanco||',
 'COC105' => '37.5825|-106.3832|Rio Grande||',
 'COC107' => '40.4851|-106.9912|Routt||',
 'COC109' => '38.0806|-106.2815|Saguache||',
 'COC111' => '37.7640|-107.6761|San Juan||',
 'COC113' => '38.0038|-108.4058|San Miguel||',
 'COC115' => '40.8758|-102.3518|Sedgwick||',
 'COC117' => '39.6342|-106.1163|Summit||',
 'COC119' => '38.8822|-105.1618|Teller||',
 'COC121' => '39.9710|-103.2013|Washington||',
 'COC123' => '40.5549|-104.3925|Weld||',
 'COC125' => '40.0029|-102.4243|Yuma||',
 'COZ001' => '40.444|-108.6994|Lower Yampa River Basin|Garfield|08045	40.444|-108.6994|Lower Yampa River Basin|Moffat|08081	40.444|-108.6994|Lower Yampa River Basin|Rio Blanco|08103',
 'COZ002' => '40.4046|-107.9134|Central Yampa River Basin|Moffat|08081	40.4046|-107.9134|Central Yampa River Basin|Rio Blanco|08103	40.4046|-107.9134|Central Yampa River Basin|Routt|08107',
 'COZ003' => '39.5758|-108.4377|Roan and Tavaputs Plateaus|Garfield|08045	39.5758|-108.4377|Roan and Tavaputs Plateaus|Mesa|08077	39.5758|-108.4377|Roan and Tavaputs Plateaus|Rio Blanco|08103',
 'COZ004' => '40.5653|-106.9552|Elkhead and Park Mountains|Moffat|08081	40.5653|-106.9552|Elkhead and Park Mountains|Routt|08107',
 'COZ005' => '40.3903|-106.9616|Upper Yampa River Basin|Routt|08107',
 'COZ006' => '39.1541|-108.6809|Grand Valley|Garfield|08045	39.1541|-108.6809|Grand Valley|Mesa|08077',
 'COZ007' => '39.4422|-107.9773|Debeque to Silt Corridor|Garfield|08045	39.4422|-107.9773|Debeque to Silt Corridor|Mesa|08077',
 'COZ008' => '39.6286|-107.0292|Central Colorado River Basin|Eagle|08037	39.6286|-107.0292|Central Colorado River Basin|Garfield|08045	39.6286|-107.0292|Central Colorado River Basin|Pitkin|08097',
 'COZ009' => '39.1332|-107.8549|Grand and Battlement Mesas|Delta|08029	39.1332|-107.8549|Grand and Battlement Mesas|Garfield|08045	39.1332|-107.8549|Grand and Battlement Mesas|Mesa|08077',
 'COZ010' => '39.4353|-106.8147|Gore and Elk Mountains/Central Mountain Valleys|Eagle|08037	39.4353|-106.8147|Gore and Elk Mountains/Central Mountain Valleys|Garfield|08045	39.4353|-106.8147|Gore and Elk Mountains/Central Mountain Valleys|Pitkin|08097',
 'COZ011' => '38.6735|-107.9201|Central Gunnison and Uncompahgre River Basin|Delta|08029	38.6735|-107.9201|Central Gunnison and Uncompahgre River Basin|Gunnison|08051	38.6735|-107.9201|Central Gunnison and Uncompahgre River Basin|Mesa|08077	38.6735|-107.9201|Central Gunnison and Uncompahgre River Basin|Montrose|08085',
 'COZ012' => '38.8011|-107.0042|West Elk and Sawatch Mountains|Delta|08029	38.8011|-107.0042|West Elk and Sawatch Mountains|Gunnison|08051	38.8011|-107.0042|West Elk and Sawatch Mountains|Montrose|08085',
 'COZ013' => '39.9766|-107.4376|Flattops|Eagle|08037	39.9766|-107.4376|Flattops|Garfield|08045	39.9766|-107.4376|Flattops|Moffat|08081	39.9766|-107.4376|Flattops|Rio Blanco|08103	39.9766|-107.4376|Flattops|Routt|08107',
 'COZ014' => '38.4776|-107.1881|Upper Gunnison River Valley|Gunnison|08051	38.4776|-107.1881|Upper Gunnison River Valley|Montrose|08085',
 'COZ017' => '38.5539|-108.4296|Uncompahgre Plateu/Dallas Divide|Delta|08029	38.5539|-108.4296|Uncompahgre Plateu/Dallas Divide|Mesa|08077	38.5539|-108.4296|Uncompahgre Plateu/Dallas Divide|Montrose|08085	38.5539|-108.4296|Uncompahgre Plateu/Dallas Divide|Ouray|08091	38.5539|-108.4296|Uncompahgre Plateu/Dallas Divide|San Miguel|08113',
 'COZ018' => '38.0588|-107.5504|Northwestern San Juan Mountains|Gunnison|08051	38.0588|-107.5504|Northwestern San Juan Mountains|Hinsdale|08053	38.0588|-107.5504|Northwestern San Juan Mountains|Montrose|08085	38.0588|-107.5504|Northwestern San Juan Mountains|Ouray|08091	38.0588|-107.5504|Northwestern San Juan Mountains|San Miguel|08113',
 'COZ019' => '37.5206|-107.6597|Southwest San Juan Mountains|Archuleta|08007	37.5206|-107.6597|Southwest San Juan Mountains|Dolores|08033	37.5206|-107.6597|Southwest San Juan Mountains|Hinsdale|08053	37.5206|-107.6597|Southwest San Juan Mountains|La Plata|08067	37.5206|-107.6597|Southwest San Juan Mountains|Montezuma|08083	37.5206|-107.6597|Southwest San Juan Mountains|San Juan|08111	37.5206|-107.6597|Southwest San Juan Mountains|San Miguel|08113',
 'COZ020' => '38.1963|-108.7095|Paradox Valley/Little Dolores River|Dolores|08033	38.1963|-108.7095|Paradox Valley/Little Dolores River|Mesa|08077	38.1963|-108.7095|Paradox Valley/Little Dolores River|Montrose|08085	38.1963|-108.7095|Paradox Valley/Little Dolores River|San Miguel|08113',
 'COZ021' => '37.3809|-108.7278|Four Corners/Upper Dolores River|Dolores|08033	37.3809|-108.7278|Four Corners/Upper Dolores River|Montezuma|08083	37.3809|-108.7278|Four Corners/Upper Dolores River|San Miguel|08113',
 'COZ022' => '37.1488|-107.8775|Animas River Basin|La Plata|08067',
 'COZ023' => '37.1383|-107.2004|San Juan River Basin|Archuleta|08007',
 'COZ030' => '40.6766|-106.309|Jackson County Below 9000 Feet|Jackson|08057',
 'COZ031' => '40.6175|-106.6092|West Jackson and West Grand Counties Above 9000 Feet|Grand|08049	40.6175|-106.6092|West Jackson and West Grand Counties Above 9000 Feet|Jackson|08057',
 'COZ032' => '40.0726|-106.209|Grand and Summit Counties Below 9000 Feet|Grand|08049	40.0726|-106.209|Grand and Summit Counties Below 9000 Feet|Summit|08117',
 'COZ033' => '40.488|-105.9071|South and East Jackson/Larimer/North and Northeast Grand/Northwest Boulder Counties Above 9000 Feet|Boulder|08013	40.488|-105.9071|South and East Jackson/Larimer/North and Northeast Grand/Northwest Boulder Counties Above 9000 Feet|Grand|08049	40.488|-105.9071|South and East Jackson/Larimer/North and Northeast Grand/Northwest Boulder Counties Above 9000 Feet|Jackson|08057	40.488|-105.9071|South and East Jackson/Larimer/North and Northeast Grand/Northwest Boulder Counties Above 9000 Feet|Larimer|08069',
 'COZ034' => '39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Boulder|08013	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Clear Creek|08019	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Gilpin|08047	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Grand|08049	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Jefferson|08059	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Park|08093	39.6044|-105.8505|South and Southeast Grand/West Central and Southwest Boulder/Gilpin/Clear Creek/Summit/North and West Park Counties Above 9000 Feet|Summit|08117',
 'COZ035' => '40.6099|-105.4708|Larimer and Boulder Counties Between 6000 and 9000 Feet|Boulder|08013	40.6099|-105.4708|Larimer and Boulder Counties Between 6000 and 9000 Feet|Larimer|08069',
 'COZ036' => '39.4838|-105.2681|Jefferson and West Douglas Counties Above  6000 Feet/Gilpin/Clear Creek/Northeast Park Counties Below 9000 Feet|Clear Creek|08019	39.4838|-105.2681|Jefferson and West Douglas Counties Above  6000 Feet/Gilpin/Clear Creek/Northeast Park Counties Below 9000 Feet|Douglas|08035	39.4838|-105.2681|Jefferson and West Douglas Counties Above  6000 Feet/Gilpin/Clear Creek/Northeast Park Counties Below 9000 Feet|Gilpin|08047	39.4838|-105.2681|Jefferson and West Douglas Counties Above  6000 Feet/Gilpin/Clear Creek/Northeast Park Counties Below 9000 Feet|Jefferson|08059	39.4838|-105.2681|Jefferson and West Douglas Counties Above  6000 Feet/Gilpin/Clear Creek/Northeast Park Counties Below 9000 Feet|Park|08093',
 'COZ037' => '38.9846|-105.6737|Central and Southeast Park County|Park|08093',
 'COZ038' => '40.7183|-104.8423|Larimer County Below 6000 Feet/Northwest Weld County|Larimer|08069	40.7183|-104.8423|Larimer County Below 6000 Feet/Northwest Weld County|Weld|08123',
 'COZ039' => '39.9606|-105.156|Boulder And Jefferson Counties Below 6000 Feet/West Broomfield County|Boulder|08013	39.9606|-105.156|Boulder And Jefferson Counties Below 6000 Feet/West Broomfield County|Broomfield|08014	39.9606|-105.156|Boulder And Jefferson Counties Below 6000 Feet/West Broomfield County|Jefferson|08059',
 'COZ040' => '39.7656|-104.804|North Douglas County Below 6000 Feet/Denver/West Adams and Arapahoe Counties/East Broomfield County|Adams|08001	39.7656|-104.804|North Douglas County Below 6000 Feet/Denver/West Adams and Arapahoe Counties/East Broomfield County|Arapahoe|08005	39.7656|-104.804|North Douglas County Below 6000 Feet/Denver/West Adams and Arapahoe Counties/East Broomfield County|Broomfield|08014	39.7656|-104.804|North Douglas County Below 6000 Feet/Denver/West Adams and Arapahoe Counties/East Broomfield County|Denver|08031	39.7656|-104.804|North Douglas County Below 6000 Feet/Denver/West Adams and Arapahoe Counties/East Broomfield County|Douglas|08035',
 'COZ041' => '39.3075|-104.5091|Elbert/Central and East Douglas Counties Above 6000 Feet|Arapahoe|08005	39.3075|-104.5091|Elbert/Central and East Douglas Counties Above 6000 Feet|Douglas|08035	39.3075|-104.5091|Elbert/Central and East Douglas Counties Above 6000 Feet|Elbert|08039',
 'COZ042' => '40.7427|-104.0025|Northeast Weld County|Weld|08123',
 'COZ043' => '40.2668|-104.5924|Central and South Weld County|Weld|08123',
 'COZ044' => '40.2627|-103.8098|Morgan County|Morgan|08087',
 'COZ045' => '39.7839|-104.1048|Central and East Adams and Arapahoe Counties|Adams|08001	39.7839|-104.1048|Central and East Adams and Arapahoe Counties|Arapahoe|08005',
 'COZ046' => '39.356|-103.6814|North and Northeast Elbert County Below 6000 Feet/North Lincoln County|Elbert|08039	39.356|-103.6814|North and Northeast Elbert County Below 6000 Feet/North Lincoln County|Lincoln|08073',
 'COZ047' => '38.8048|-103.5944|Southeast Elbert County Below 6000 Feet/South Lincoln County|Elbert|08039	38.8048|-103.5944|Southeast Elbert County Below 6000 Feet/South Lincoln County|Lincoln|08073',
 'COZ048' => '40.7247|-103.1101|Logan County|Logan|08075',
 'COZ049' => '39.971|-103.2013|Washington County|Washington|08121',
 'COZ050' => '40.8758|-102.3518|Sedgwick County|Sedgwick|08115',
 'COZ051' => '40.5939|-102.3575|Phillips County|Phillips|08095',
 'COZ058' => '39.2545|-106.2141|Western Mosquito Range/East Lake County Above 11000 Ft|Lake|08065',
 'COZ059' => '39.1873|-106.3446|Leadville Vicinity/Lake County Below 11000 Ft|Lake|08065',
 'COZ060' => '38.8197|-106.3586|Eastern Sawatch Mountains above 11000 Ft|Chaffee|08015	38.8197|-106.3586|Eastern Sawatch Mountains above 11000 Ft|Lake|08065	38.8197|-106.3586|Eastern Sawatch Mountains above 11000 Ft|Saguache|08109',
 'COZ061' => '38.7415|-106.2559|Western Chaffee County Between 9000 and 11000 Ft|Chaffee|08015',
 'COZ062' => '38.6873|-106.0928|Central Chaffee County Below 9000 Ft|Chaffee|08015',
 'COZ063' => '38.8243|-106.0253|Western Mosquito Range/East Chaffee County above 9000Ft|Chaffee|08015',
 'COZ064' => '38.3063|-106.7044|Saguache County West of Continental Divide Below 10000 Ft|Saguache|08109',
 'COZ065' => '38.1071|-106.3423|Saguache County East of Continental Divide below 10000 Ft|Rio Grande|08105	38.1071|-106.3423|Saquache County East of Continental Divide below 10000 Ft|Saguache|08109',
 'COZ066' => '38.0229|-106.7318|La Garita Mountains Above 10000 Ft|Mineral|08079	38.0229|-106.7318|La Garita Mountains Above 10000 Ft|Rio Grande|08105	38.0229|-106.7318|La Garita Mountains Above 10000 Ft|Saguache|08109',
 'COZ067' => '37.469|-106.5413|Upper Rio Grande Valley/Eastern San Juan Mountains Below 10000 Ft|Conejos|08021	37.469|-106.5413|Upper Rio Grande Valley/Eastern San Juan Mountains Below 10000 Ft|Mineral|08079	37.469|-106.5413|Upper Rio Grande Valley/Eastern San Juan Mountains Below 10000 Ft|Rio Grande|08105',
 'COZ068' => '37.4272|-106.7002|Eastern San Juan Mountains Above 10000 Ft|Conejos|08021	37.4272|-106.7002|Eastern San Juan Mountains Above 10000 Ft|Mineral|08079	37.4272|-106.7002|Eastern San Juan Mountains Above 10000 Ft|Rio Grande|08105',
 'COZ069' => '37.9152|-106.0347|Del Norte Vicinity/Northern San Luis Valley Below 8500 Ft|Rio Grande|08105	37.9152|-106.0347|Del Norte Vicinity/Northern San Luis Valley Below 8500 Ft|Saguache|08109',
 'COZ070' => '37.5614|-105.8929|Alamosa  Vicinity/Central San Luis Valley Below 8500 Ft|Alamosa|08003	37.5614|-105.8929|Alamosa  Vicinity/Central San Luis Valley Below 8500 Ft|Rio Grande|08105',
 'COZ071' => '37.2224|-105.7537|Southern San Luis Valley|Conejos|08021	37.2224|-105.7537|Southern San Luis Valley|Costilla|08023',
 'COZ072' => '37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Alamosa|08003	37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Chaffee|08015	37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Costilla|08023	37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Custer|08027	37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Fremont|08043	37.9018|-105.5379|Northern Sangre de Christo Mountains Between 8500 And 11000 Ft|Huerfano|08055	37.9018|-105.5379|Northern Sangre de Cristo Mountains Between 8500 And 11000 Ft|Saguache|08109',
 'COZ073' => '37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Alamosa|08003	37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Costilla|08023	37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Custer|08027	37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Fremont|08043	37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Huerfano|08055	37.9767|-105.617|Northern Sangre de Cristo Mountains above 11000 Ft|Saguache|08109',
 'COZ074' => '37.2245|-105.0257|Southern Sangre De Cristo Mountains Between 7500 and 11000 Ft|Costilla|08023	37.2245|-105.0257|Southern Sangre De Cristo Mountains Between 7500 and 11000 Ft|Huerfano|08055	37.2245|-105.0257|Southern Sangre De Cristo Mountains Between 7500 and 11000 Ft|Las Animas|08071',
 'COZ075' => '37.2046|-105.1708|Southern Sangre De Cristo Mountains Above 11000 Ft|Costilla|08023	37.2046|-105.1708|Southern Sangre De Cristo Mountains Above 11000 Ft|Huerfano|08055	37.2046|-105.1708|Southern Sangre De Cristo Mountains Above 11000 Ft|Las Animas|08071',
 'COZ076' => '38.6011|-105.6475|Northwestern Fremont County  Above 8500Ft|Fremont|08043',
 'COZ077' => '38.4248|-105.5558|Western/Central Fremont County Below 8500 Ft|Fremont|08043',
 'COZ078' => '38.1353|-105.4502|Wet Mountain Valley Below 8500 Ft|Custer|08027	38.1353|-105.4502|Wet Mountain Valley Below 8500 Ft|Huerfano|08055',
 'COZ079' => '38.046|-105.1469|Wet Mountains between 6300 and 10000Ft|Custer|08027	38.046|-105.1469|Wet Mountains between 6300 and 10000Ft|Fremont|08043	38.046|-105.1469|Wet Mountains between 6300 and 10000Ft|Huerfano|08055	38.046|-105.1469|Wet Mountains between 6300 and 10000Ft|Pueblo|08101',
 'COZ080' => '37.9888|-105.1345|Wet Mountains above 10000 Ft|Custer|08027	37.9888|-105.1345|Wet Mountains above 10000 Ft|Huerfano|08055	37.9888|-105.1345|Wet Mountains above 10000 Ft|Pueblo|08101',
 'COZ081' => '38.8708|-105.113|Teller County/Rampart Range above 7500fT/Pike\'s Peak Between 7500 And 11000 Ft|El Paso|08041	38.8708|-105.113|Teller County/Rampart Range above 7500fT/Pike\'s Peak Between 7500 And 11000 Ft|Fremont|08043	38.8708|-105.113|Teller County/Rampart Range above 7500fT/Pike\'s Peak Between 7500 And 11000 Ft|Teller|08119',
 'COZ082' => '38.8156|-105.0464|Pikes Peak above 11000 Ft|El Paso|08041	38.8156|-105.0464|Pikes Peak above 11000 Ft|Teller|08119',
 'COZ083' => '38.4443|-105.1148|Canon City Vicinity/Eastern Fremont County|Custer|08027	38.4443|-105.1148|Canon City Vicinity/Eastern Fremont County|Fremont|08043	38.4443|-105.1148|Canon City Vicinity/Eastern Fremont County|Teller|08119',
 'COZ084' => '39.0124|-104.4498|Northern El Paso County/Monument Ridge/Rampart Range Below 7500 Ft|El Paso|08041',
 'COZ085' => '38.7125|-104.5034|Colorado Springs Vicinity/Southern El Paso County/Rampart Range Below 7400 Ft|El Paso|08041',
 'COZ086' => '38.1821|-104.4872|Pueblo Vicinity/Pueblo County Below 6300 Feet|Pueblo|08101',
 'COZ087' => '37.6899|-104.8578|Walsenburg Vicinity/Upper Huerfano River Basin Below 7500 Ft|Huerfano|08055',
 'COZ088' => '37.3538|-104.3935|Trinidad Vicinity/Western Las Animas County Below 7500 Ft|Las Animas|08071',
 'COZ089' => '38.3266|-103.7849|Crowley County|Crowley|08025',
 'COZ090' => '40.0029|-102.4243|Yuma County|Yuma|08125',
 'COZ091' => '39.3054|-102.6029|Kit Carson County|Kit Carson|08063',
 'COZ092' => '38.8279|-102.6034|Cheyenne County|Cheyenne|08017',
 'COZ093' => '37.9027|-103.7164|La Junta Vicinity/Otero County|Otero|08089',
 'COZ094' => '37.3221|-103.5645|Eastern Las Animas County|Las Animas|08071',
 'COZ095' => '38.424|-103.0919|Western Kiowa County|Kiowa|08061',
 'COZ096' => '38.4414|-102.3891|Eastern Kiowa County|Kiowa|08061',
 'COZ097' => '37.9551|-103.0717|Las Animas Vicinity/Bent County|Bent|08011',
 'COZ098' => '37.9552|-102.3933|Lamar Vicinity/Prowers County|Prowers|08099',
 'COZ099' => '37.3192|-102.5605|Springfield Vicinity/Baca County|Baca|08009',
 'CTC001' => '41.2731|-73.3887|Fairfield||',
 'CTC003' => '41.8064|-72.7328|Hartford||',
 'CTC005' => '41.7925|-73.2453|Litchfield||',
 'CTC007' => '41.4624|-72.5340|Middlesex||',
 'CTC009' => '41.4108|-72.9324|New Haven||',
 'CTC011' => '41.4893|-72.1004|New London||',
 'CTC013' => '41.8550|-72.3365|Tolland||',
 'CTC015' => '41.8299|-71.9875|Windham||',
 'CTZ001' => '41.8851|-73.2502|Northern Litchfield|Litchfield|09005',
 'CTZ002' => '41.8064|-72.7328|Hartford|Hartford|09003',
 'CTZ003' => '41.855|-72.3365|Tolland|Tolland|09013',
 'CTZ004' => '41.83|-71.9875|Windham|Windham|09015',
 'CTZ005' => '41.353|-73.3629|Northern Fairfield|Fairfield|09001',
 'CTZ006' => '41.4648|-72.9956|Northern New Haven|New Haven|09009',
 'CTZ007' => '41.4977|-72.5551|Northern Middlesex|Middlesex|09007',
 'CTZ008' => '41.5317|-72.0992|Northern New London|New London|09011',
 'CTZ009' => '41.1301|-73.435|Southern Fairfield|Fairfield|09001',
 'CTZ010' => '41.3108|-72.8154|Southern New Haven|New Haven|09009',
 'CTZ011' => '41.3211|-72.4498|Southern Middlesex|Middlesex|09007',
 'CTZ012' => '41.3615|-72.1034|Southern New London|New London|09011',
 'CTZ013' => '41.6344|-73.2368|Southern Litchfield|Litchfield|09005',
 'DCC001' => '38.9093|-77.0146|District of Columbia||',
 'DCZ001' => '38.9093|-77.0146|District of Columbia|District of Columbia|11001',
 'DEC001' => '39.0867|-75.5688|Kent||',
 'DEC003' => '39.5811|-75.6488|New Castle||',
 'DEC005' => '38.6621|-75.3990|Sussex||',
 'DEZ001' => '39.581|-75.6489|New Castle|New Castle|10003',
 'DEZ002' => '39.0867|-75.5688|Kent|Kent|10001',
 'DEZ003' => '38.6653|-75.4181|Inland Sussex|Sussex|10005',
 'DEZ004' => '38.6114|-75.0919|Delaware Beaches|Sussex|10005',
 'FLC001' => '29.6749|-82.3576|Alachua||',
 'FLC003' => '30.3310|-82.2846|Baker||',
 'FLC005' => '30.2797|-85.6151|Bay||',
 'FLC007' => '29.9502|-82.1689|Bradford||',
 'FLC009' => '28.2631|-80.7436|Brevard||',
 'FLC011' => '26.1519|-80.4886|Broward||',
 'FLC013' => '30.4061|-85.1972|Calhoun||',
 'FLC015' => '26.9069|-81.8940|Charlotte||	26.9689|-82.1080|Charlotte||',
 'FLC017' => '28.8509|-82.4670|Citrus||	28.8125|-82.6088|Citrus||',
 'FLC019' => '29.9831|-81.8579|Clay||',
 'FLC021' => '26.1196|-81.3393|Collier||',
 'FLC023' => '30.2243|-82.6215|Columbia||',
 'FLC027' => '27.1863|-81.8093|DeSoto||',
 'FLC029' => '29.6101|-83.1583|Dixie||',
 'FLC031' => '30.3302|-81.6740|Duval||',
 'FLC033' => '30.7012|-87.3777|Escambia||',
 'FLC035' => '29.4605|-81.3145|Flagler||',
 'FLC037' => '29.8773|-84.8172|Franklin||	29.9194|-84.6607|Franklin||',
 'FLC039' => '30.5795|-84.6137|Gadsden||',
 'FLC041' => '29.7259|-82.8006|Gilchrist||',
 'FLC043' => '26.9605|-81.2397|Glades||',
 'FLC045' => '29.9458|-85.1435|Gulf||	29.9562|-85.2283|Gulf||',
 'FLC047' => '30.4964|-82.9478|Hamilton||',
 'FLC049' => '27.4927|-81.8099|Hardee||',
 'FLC051' => '26.5473|-81.1719|Hendry||',
 'FLC053' => '28.5528|-82.4209|Hernando||',
 'FLC055' => '27.3434|-81.3410|Highlands||',
 'FLC057' => '27.9306|-82.3072|Hillsborough||	27.7786|-82.4146|Hillsborough||',
 'FLC059' => '30.8679|-85.8143|Holmes||',
 'FLC061' => '27.6929|-80.6158|Indian River||',
 'FLC063' => '30.7956|-85.2194|Jackson||	30.7800|-84.9213|Jackson||',
 'FLC065' => '30.4380|-83.8951|Jefferson||',
 'FLC067' => '29.9855|-83.1811|Lafayette||',
 'FLC069' => '28.7615|-81.7113|Lake||',
 'FLC071' => '26.5786|-81.8210|Lee||	26.6135|-81.8902|Lee||',
 'FLC073' => '30.4581|-84.2778|Leon||',
 'FLC075' => '29.2827|-83.0885|Levy||	29.3216|-82.7389|Levy||',
 'FLC077' => '30.2414|-84.8829|Liberty||',
 'FLC079' => '30.4442|-83.4700|Madison||',
 'FLC081' => '27.4713|-82.2978|Manatee||	27.5051|-82.5210|Manatee||',
 'FLC083' => '29.2103|-82.0567|Marion||',
 'FLC085' => '27.0844|-80.3893|Martin||',
 'FLC086' => '25.6171|-80.5682|Miami-Dade||',
 'FLC087' => '25.5205|-81.0326|Mainland Monroe||	24.6514|-81.5527|Lower Keys in Monroe||	24.7471|-80.9876|Middle Keys in Monroe||	25.1496|-80.4175|Upper Keys in Monroe||',
 'FLC089' => '30.6095|-81.8085|Nassau||',
 'FLC091' => '30.7068|-86.5964|Okaloosa||',
 'FLC093' => '27.4283|-80.9015|Okeechobee||',
 'FLC095' => '28.5148|-81.3238|Orange||',
 'FLC097' => '28.0627|-81.1496|Osceola||',
 'FLC099' => '26.6230|-80.4329|Palm Beach||',
 'FLC101' => '28.3093|-82.3911|Pasco||',
 'FLC103' => '27.9280|-82.7220|Pinellas||	28.1264|-82.7303|Pinellas||',
 'FLC105' => '27.9489|-81.6978|Polk||',
 'FLC107' => '29.6086|-81.7442|Putnam||',
 'FLC109' => '29.9013|-81.4439|St. Johns||',
 'FLC111' => '27.3764|-80.4836|St. Lucie||',
 'FLC113' => '30.7320|-87.0172|Santa Rosa||',
 'FLC115' => '27.1810|-82.3219|Sarasota||	27.0267|-82.2770|Sarasota||',
 'FLC117' => '28.7170|-81.2362|Seminole||',
 'FLC119' => '28.7046|-82.0810|Sumter||',
 'FLC121' => '30.1956|-82.9915|Suwannee||',
 'FLC123' => '30.0477|-83.6030|Taylor||',
 'FLC125' => '30.0439|-82.3714|Union||',
 'FLC127' => '29.0604|-81.1912|Volusia||',
 'FLC129' => '30.1703|-84.4026|Wakulla||	30.0061|-84.4749|Wakulla||',
 'FLC131' => '30.6598|-86.1631|Walton||	30.5448|-85.8977|Walton||',
 'FLC133' => '30.6106|-85.6656|Washington||',
 'FLZ007' => '30.8499|-86.2133|North Walton|Walton|12131',
 'FLZ008' => '30.5928|-86.1117|Central Walton|Walton|12131',
 'FLZ009' => '30.8679|-85.8143|Holmes|Holmes|12059',
 'FLZ010' => '30.6107|-85.6653|Washington|Washington|12133',
 'FLZ011' => '30.78|-84.9213|Jackson|Jackson|12063	30.7956|-85.2194|Jackson|Jackson|12063',
 'FLZ012' => '30.366|-85.5408|Inland Bay|Bay|12005',
 'FLZ013' => '30.4061|-85.1972|Calhoun|Calhoun|12013',
 'FLZ014' => '29.9507|-85.1548|Inland Gulf|Gulf|12045	30.0103|-85.211|Inland Gulf|Gulf|12045',
 'FLZ015' => '29.9462|-84.8653|Inland Franklin|Franklin|12037',
 'FLZ016' => '30.5795|-84.6137|Gadsden|Gadsden|12039',
 'FLZ017' => '30.4581|-84.2779|Leon|Leon|12073',
 'FLZ018' => '30.4578|-83.8865|Inland Jefferson|Jefferson|12065',
 'FLZ019' => '30.4442|-83.47|Madison|Madison|12079',
 'FLZ021' => '30.1956|-82.9915|Suwannee|Suwannee|12121',
 'FLZ023' => '30.331|-82.2846|Baker|Baker|12003',
 'FLZ024' => '30.6095|-81.8085|Inland Nassau|Nassau|12089',
 'FLZ026' => '30.2414|-84.8829|Liberty|Liberty|12077',
 'FLZ027' => '30.2017|-84.4474|Inland Wakulla|Wakulla|12129',
 'FLZ028' => '30.0954|-83.5767|Inland Taylor|Taylor|12123',
 'FLZ029' => '29.9855|-83.1811|Lafayette|Lafayette|12067',
 'FLZ030' => '30.0439|-82.3714|Union|Union|12125',
 'FLZ031' => '29.9502|-82.1689|Bradford|Bradford|12007',
 'FLZ033' => '29.8671|-81.4979|Inland St. Johns|St. Johns|12109',
 'FLZ034' => '29.6711|-83.1235|Inland Dixie|Dixie|12029',
 'FLZ035' => '29.7259|-82.8005|Gilchrist|Gilchrist|12041',
 'FLZ038' => '29.4499|-81.3306|Inland Flagler|Flagler|12035',
 'FLZ041' => '29.0622|-81.2756|Inland Volusia County|Volusia|12127',
 'FLZ043' => '28.7046|-82.081|Sumter|Sumter|12119',
 'FLZ044' => '28.9313|-81.6301|Northern Lake County|Lake|12069',
 'FLZ045' => '28.5148|-81.3238|Orange|Orange|12095',
 'FLZ046' => '28.717|-81.2362|Seminole|Seminole|12117',
 'FLZ050' => '27.9283|-82.7219|Pinellas|Pinellas|12103',
 'FLZ052' => '27.9489|-81.6978|Polk|Polk|12105',
 'FLZ053' => '28.0627|-81.1495|Osceola|Osceola|12097',
 'FLZ056' => '27.4927|-81.8099|Hardee|Hardee|12049',
 'FLZ057' => '27.3434|-81.3409|Highlands|Highlands|12055',
 'FLZ058' => '27.4283|-80.9015|Okeechobee|Okeechobee|12093',
 'FLZ061' => '27.1863|-81.8093|De Soto|DeSoto|12027',
 'FLZ063' => '26.9605|-81.2397|Glades|Glades|12043',
 'FLZ066' => '26.5473|-81.1718|Hendry|Hendry|12051',
 'FLZ067' => '26.6172|-80.5109|Inland Palm Beach County|Palm Beach|12099',
 'FLZ068' => '26.6222|-80.1464|Metro Palm Beach County|Palm Beach|12099',
 'FLZ069' => '26.015|-81.6017|Coastal Collier County|Collier|12021',
 'FLZ070' => '26.138|-81.293|Inland Collier County|Collier|12021',
 'FLZ071' => '26.1632|-80.6145|Inland Broward County|Broward|12011',
 'FLZ072' => '26.1257|-80.2706|Metro Broward County|Broward|12011',
 'FLZ073' => '25.6928|-80.6786|Inland Miami-Dade County|Miami-Dade|12086',
 'FLZ074' => '25.7790|-80.3602|Metropolitan Miami Dade|Miami-Dade|12086',
 'FLZ075' => '25.5205|-81.0326|Mainland Monroe|Mainland Monroe|12087',
 'FLZ076' => '25.1472|-80.4195|Monroe Upper Keys|Upper Keys in Monroe|12087',
 'FLZ077' => '24.7471|-80.9876|Monroe Middle Keys|Middle Keys in Monroe|12087',
 'FLZ078' => '24.6514|-81.5527|Monroe Lower Keys|Lower Keys in Monroe|12087',
 'FLZ108' => '30.4183|-86.171|South Walton|Walton|12131	30.4183|-86.171|South Walton|Walton|12131',
 'FLZ112' => '30.2213|-85.6654|Coastal Bay|Bay|12005',
 'FLZ114' => '29.8173|-85.2726|Coastal Gulf|Gulf|12045',
 'FLZ115' => '29.8382|-84.7899|Coastal Franklin|Franklin|12037',
 'FLZ118' => '30.1477|-84.0221|Coastal Jefferson|Jefferson|12065',
 'FLZ120' => '30.4942|-82.8552|Eastern Hamilton|Hamilton|12047',
 'FLZ124' => '30.6095|-81.8085|Coastal Nassau|Nassau|12089',
 'FLZ125' => '30.352|-81.5262|Coastal Duval|Duval|12031',
 'FLZ127' => '30.0968|-84.3009|Coastal Wakulla|Wakulla|12129',
 'FLZ128' => '29.9259|-83.6703|Coastal Taylor|Taylor|12123',
 'FLZ132' => '30.0117|-81.6792|Eastern Clay|Clay|12019',
 'FLZ133' => '29.9525|-81.3629|Coastal St. Johns|St. Johns|12109',
 'FLZ134' => '29.4924|-83.2251|Coastal Dixie|Dixie|12029',
 'FLZ136' => '29.6896|-82.2664|Eastern Alachua |Alachua|12001',
 'FLZ137' => '29.5498|-81.612|Eastern Putnam|Putnam|12107',
 'FLZ138' => '29.5436|-81.1875|Coastal Flagler|Flagler|12035',
 'FLZ139' => '29.3216|-82.7385|Coastal Levy|Levy|12075',
 'FLZ140' => '29.217|-81.7957|Eastern Marion |Marion|12083',
 'FLZ141' => '29.0562|-80.9907|Coastal Volusia County|Volusia|12127',
 'FLZ142' => '28.8507|-82.4673|Coastal Citrus|Citrus|12017',
 'FLZ144' => '28.5634|-81.8061|Southern Lake County|Lake|12069',
 'FLZ148' => '28.5528|-82.4209|Coastal Hernando|Hernando|12053',
 'FLZ149' => '28.3093|-82.3912|Inland Pasco|Pasco|12101',
 'FLZ151' => '27.9291|-82.4769|Coastal Hillsborough|Hillsborough|12057',
 'FLZ154' => '27.6872|-80.4549|Coastal Indian River|Indian River|12061',
 'FLZ155' => '27.4713|-82.2978|Coastal Manatee|Manatee|12081',
 'FLZ159' => '27.3965|-80.3424|Coastal St. Lucie|St. Lucie|12111',
 'FLZ160' => '27.1806|-82.3219|Coastal Sarasota|Sarasota|12115',
 'FLZ162' => '26.9118|-82.1135|Coastal Charlotte|Charlotte|12015',
 'FLZ164' => '27.104|-80.2014|Coastal Martin|Martin|12085',
 'FLZ165' => '26.6135|-81.8902|Coastal Lee|Lee|12071',
 'FLZ168' => '26.7053|-80.0806|Coastal Palm Beach County|Palm Beach|12099',
 'FLZ172' => '26.1498|-80.1266|Coastal Broward County|Broward|12011',
 'FLZ173' => '25.5815|-80.3117|Coastal Miami Dade County|Miami-Dade|12086',
 'FLZ174' => '25.299|-80.6497|Far South Miami-Dade County|Miami-Dade|12086',
 'FLZ201' => '30.8725|-87.4324|Escambia Inland|Escambia|12033',
 'FLZ202' => '30.51|-87.3166|Escambia Coastal|Escambia|12033',
 'FLZ203' => '30.8503|-87.036|Santa Rosa Inland|Santa Rosa|12113',
 'FLZ204' => '30.5786|-86.9928|Santa Rosa Coastal|Santa Rosa|12113',
 'FLZ205' => '30.8517|-86.5894|Okaloosa Inland|Okaloosa|12091',
 'FLZ206' => '30.563|-86.6034|Okaloosa Coastal|Okaloosa|12091',
 'FLZ220' => '30.5003|-83.1184|Western Hamilton|Hamilton|12047',
 'FLZ225' => '30.4129|-81.7184|Trout River|Duval|12031',
 'FLZ232' => '29.9783|-81.8881|Western Clay|Clay|12019',
 'FLZ236' => '29.6482|-82.523|Western Alachua |Alachua|12001',
 'FLZ237' => '29.6558|-81.8502|Western Putnam|Putnam|12107',
 'FLZ239' => '29.3216|-82.7385|Inland Levy|Levy|12075',
 'FLZ240' => '29.2233|-82.0497|Central Marion |Marion|12083',
 'FLZ242' => '28.8507|-82.4673|inland Citrus|Citrus|12017',
 'FLZ247' => '28.6092|-80.9007|Inland Northern Brevard|Brevard|12009',
 'FLZ248' => '28.5528|-82.4209|Inland Hernando|Hernando|12053',
 'FLZ249' => '28.3093|-82.3912|Coastal Pasco|Pasco|12101',
 'FLZ251' => '27.9311|-82.2469|Inland Hillsborough|Hillsborough|12057',
 'FLZ254' => '27.6955|-80.6904|Inland Indian River|Indian River|12061',
 'FLZ255' => '27.4713|-82.2978|Inland Manatee|Manatee|12081',
 'FLZ259' => '27.3694|-80.5329|Inland St. Lucie|St. Lucie|12111',
 'FLZ260' => '27.1806|-82.3219|Inland Sarasota|Sarasota|12115',
 'FLZ262' => '26.9037|-81.7547|Inland Charlotte|Charlotte|12015',
 'FLZ264' => '27.0779|-80.4514|Inland Martin|Martin|12085',
 'FLZ265' => '26.5785|-81.8208|Inland Lee|Lee|12071',
 'FLZ322' => '30.4143|-82.5870|Northern Columbia|Columbia|12023',
 'FLZ325' => '30.2148|-81.6487|South Central Duval|Duval|12031',
 'FLZ340' => '29.1889|-82.3279|Western Marion |Marion|12083',
 'FLZ347' => '28.5862|-80.8265|Mainland Northern Brevard|Brevard|12009',
 'FLZ422' => '30.1473|-82.5731|Southeastern Columbia|Columbia|12023',
 'FLZ425' => '30.3364|-81.8388|Western Duval|Duval|12031',
 'FLZ447' => '28.5687|-80.6731|Northern Brevard Barrier Islands|Brevard|12009',
 'FLZ522' => '30.0264|-82.7012|Southwestern Columbia|Columbia|12023',
 'FLZ547' => '28.0506|-80.7634|Inland Southern Brevard|Brevard|12009',
 'FLZ647' => '28.0939|-80.6434|Mainland Southern Brevard|Brevard|12009',
 'FLZ747' => '28.235|-80.6167|Southern Brevard Barrier Islands|Brevard|12009',
 'FMC001' => '7.0649|157.8033|Pakin||	6.6800|159.7581|Mwoakilloa||	5.7990|157.2493|Sapwuahfik||	3.8531|154.9572|Nukuoro||	8.5832|149.6884|Onoun||	8.5900|144.5165|Faraulep||',
 'FMC002' => '7.3701|151.7574|Chuuk Lagoon||',
 'FMC005' => '5.3102|162.9766|Kosrae||',
 'FMC010' => '6.6891|143.0600|Eauripik||',
 'FMC020' => '1.0672|154.8005|Kapingamarangi||',
 'FMC030' => '9.7631|140.5184|Fais||',
 'FMC040' => '6.8829|158.2288|Pohnpei||',
 'FMC060' => '9.5399|138.1270|Yap||',
 'FMC070' => '7.5684|155.3206|Oroluk||',
 'FMC080' => '8.3906|137.5069|Ngulu||',
 'FMC090' => '6.2150|160.7044|Pingelap||',
 'FMC110' => '9.9895|139.7259|Ulithi||',
 'FMC120' => '7.3639|143.8757|Woleai||',
 'FMC350' => '8.5612|151.9124|Fananu||',
 'FMC410' => '6.8717|152.7215|Losap||',
 'FMC420' => '5.5154|153.7735|Lukunoch||',
 'FMC610' => '7.3623|149.1871|Polowat||',
 'FMC640' => '7.3807|147.0310|Satawal||',
 'FMZ001' => '5.3102|162.9766|Kosrae|Kosrae|64005',
 'FMZ011' => '6.215|160.7044|Pingelap|Pingelap|64090',
 'FMZ012' => '6.68|159.7581|Mwoakilloa|Mwoakilloa|64040',
 'FMZ013' => '6.8829|158.2288|Pohnpei|Pohnpei|64040',
 'FMZ014' => '7.0649|157.8033|Pakin|Pakin|64040',
 'FMZ015' => '5.799|157.2493|Sapwuahfik|Sapwuahfik|64050',
 'FMZ016' => '7.5684|155.3206|Oroluk|Oroluk|64070',
 'FMZ017' => '3.8531|154.9572|Nukuoro|Nukuoro|64060',
 'FMZ018' => '1.0672|154.8005|Kapingamarangi|Kapingamarangi|64020',
 'FMZ021' => '5.5154|153.7735|Lukunoch|Lukunoch|64420',
 'FMZ022' => '6.8717|152.7215|Losap|Losap|64410',
 'FMZ023' => '7.3701|151.7574|Chuuk Lagoon|Chuuk Lagoon|64002',
 'FMZ024' => '8.5612|151.9124|Fananu|Fananu|64350',
 'FMZ025' => '8.5832|149.6884|Onoun|Onoun|64430',
 'FMZ026' => '7.3623|149.1871|Polowat|Polowat|64610',
 'FMZ031' => '7.3807|147.031|Satawal|Satawal|64090',
 'FMZ032' => '7.3639|143.8757|Woleai|Woleai|64120',
 'FMZ033' => '8.59|144.5165|Faraulep|Faraulep|64040',
 'FMZ034' => '6.6891|143.06|Eauripik|Eauripik|64010',
 'FMZ035' => '9.7631|140.5184|Fais|Fais|64030',
 'FMZ036' => '9.9895|139.7259|Ulithi|Ulithi|64110',
 'FMZ037' => '9.5399|138.127|Yap|Yap|64060',
 'FMZ038' => '8.3906|137.5069|Ngulu|Ngulu|64080',
 'GAC001' => '31.7493|-82.2890|Appling||',
 'GAC003' => '31.2971|-82.8800|Atkinson||',
 'GAC005' => '31.5537|-82.4527|Bacon||',
 'GAC007' => '31.3262|-84.4447|Baker||',
 'GAC009' => '33.0690|-83.2498|Baldwin||',
 'GAC011' => '34.3541|-83.4974|Banks||',
 'GAC013' => '33.9932|-83.7126|Barrow||',
 'GAC015' => '34.2379|-84.8405|Bartow||',
 'GAC017' => '31.7598|-83.2206|Ben Hill||',
 'GAC019' => '31.2761|-83.2297|Berrien||',
 'GAC021' => '32.8067|-83.6979|Bibb||',
 'GAC023' => '32.4344|-83.3279|Bleckley||',
 'GAC025' => '31.1970|-81.9819|Brantley||',
 'GAC027' => '30.8420|-83.5803|Brooks||',
 'GAC029' => '32.0175|-81.4474|Bryan||	31.7798|-81.1919|Bryan||',
 'GAC031' => '32.3969|-81.7432|Bulloch||',
 'GAC033' => '33.0612|-82.0008|Burke||',
 'GAC035' => '33.2891|-83.9572|Butts||',
 'GAC037' => '31.5292|-84.6249|Calhoun||',
 'GAC039' => '30.9335|-81.6820|Camden||',
 'GAC043' => '32.4035|-82.0737|Candler||',
 'GAC045' => '33.5828|-85.0797|Carroll||',
 'GAC047' => '34.9036|-85.1381|Catoosa||',
 'GAC049' => '30.7818|-82.1380|Charlton||',
 'GAC051' => '32.0099|-81.1416|Chatham||	31.9297|-81.0394|Chatham||',
 'GAC053' => '32.3470|-84.7870|Chattahoochee||',
 'GAC055' => '34.4750|-85.3454|Chattooga||',
 'GAC057' => '34.2439|-84.4764|Cherokee||',
 'GAC059' => '33.9513|-83.3675|Clarke||',
 'GAC061' => '31.6264|-84.9803|Clay||',
 'GAC063' => '33.5419|-84.3577|Clayton||',
 'GAC065' => '30.9151|-82.7063|Clinch||',
 'GAC067' => '33.9415|-84.5767|Cobb||',
 'GAC069' => '31.5492|-82.8493|Coffee||',
 'GAC071' => '31.1884|-83.7688|Colquitt||',
 'GAC073' => '33.5442|-82.2640|Columbia||',
 'GAC075' => '31.1540|-83.4305|Cook||',
 'GAC077' => '33.3535|-84.7633|Coweta||',
 'GAC079' => '32.7145|-83.9864|Crawford||',
 'GAC081' => '31.9230|-83.7681|Crisp||',
 'GAC083' => '34.8546|-85.5045|Dade||',
 'GAC085' => '34.4438|-84.1704|Dawson||',
 'GAC087' => '30.7994|-84.7577|Decatur||	30.8815|-84.5720|Decatur||',
 'GAC089' => '33.7715|-84.2263|DeKalb||',
 'GAC091' => '32.1722|-83.1684|Dodge||',
 'GAC093' => '32.1572|-83.7987|Dooly||',
 'GAC095' => '31.5333|-84.2164|Dougherty||',
 'GAC097' => '33.7015|-84.7677|Douglas||',
 'GAC099' => '31.3228|-84.9037|Early||',
 'GAC101' => '30.7101|-82.8939|Echols||',
 'GAC103' => '32.3675|-81.3407|Effingham||',
 'GAC105' => '34.1170|-82.8403|Elbert||',
 'GAC107' => '32.5898|-82.3018|Emanuel||',
 'GAC109' => '32.1568|-81.8868|Evans||',
 'GAC111' => '34.8641|-84.3197|Fannin||',
 'GAC113' => '33.4140|-84.4941|Fayette||',
 'GAC115' => '34.2632|-85.2143|Floyd||',
 'GAC117' => '34.2255|-84.1253|Forsyth||',
 'GAC119' => '34.3755|-83.2292|Franklin||',
 'GAC121' => '33.7903|-84.4669|Fulton||',
 'GAC123' => '34.6915|-84.4554|Gilmer||',
 'GAC125' => '33.2293|-82.6107|Glascock||',
 'GAC127' => '31.2365|-81.5512|Glynn||',
 'GAC129' => '34.5034|-84.8757|Gordon||',
 'GAC131' => '30.8747|-84.2344|Grady||',
 'GAC133' => '33.5788|-83.1667|Greene||',
 'GAC135' => '33.9617|-84.0235|Gwinnett||',
 'GAC137' => '34.6310|-83.5312|Habersham||',
 'GAC139' => '34.3168|-83.8197|Hall||',
 'GAC141' => '33.2703|-83.0010|Hancock||',
 'GAC143' => '33.7943|-85.2110|Haralson||',
 'GAC145' => '32.7360|-84.9090|Harris||',
 'GAC147' => '34.3511|-82.9640|Hart||',
 'GAC149' => '33.2970|-85.1283|Heard||',
 'GAC151' => '33.4534|-84.1554|Henry||',
 'GAC153' => '32.4590|-83.6662|Houston||',
 'GAC155' => '31.6023|-83.2764|Irwin||',
 'GAC157' => '34.1339|-83.5663|Jackson||',
 'GAC159' => '33.3165|-83.6881|Jasper||',
 'GAC161' => '31.8056|-82.6370|Jeff Davis||',
 'GAC163' => '33.0549|-82.4181|Jefferson||',
 'GAC165' => '32.7925|-81.9636|Jenkins||',
 'GAC167' => '32.7015|-82.6601|Johnson||',
 'GAC169' => '33.0251|-83.5605|Jones||',
 'GAC171' => '33.0765|-84.1394|Lamar||',
 'GAC173' => '31.0380|-83.0626|Lanier||',
 'GAC175' => '32.4637|-82.9222|Laurens||',
 'GAC177' => '31.7796|-84.1410|Lee||',
 'GAC179' => '31.7093|-81.2103|Liberty||	31.8308|-81.4998|Liberty||',
 'GAC181' => '33.7936|-82.4512|Lincoln||',
 'GAC183' => '31.7528|-81.7460|Long||',
 'GAC185' => '30.8339|-83.2677|Lowndes||',
 'GAC187' => '34.5722|-84.0031|Lumpkin||',
 'GAC189' => '33.4829|-82.4814|McDuffie||',
 'GAC191' => '31.5329|-81.2646|McIntosh||	31.5007|-81.4149|McIntosh||',
 'GAC193' => '32.3584|-84.0425|Macon||',
 'GAC195' => '34.1279|-83.2090|Madison||',
 'GAC197' => '32.3534|-84.5246|Marion||',
 'GAC199' => '33.0407|-84.6883|Meriwether||',
 'GAC201' => '31.1640|-84.7307|Miller||',
 'GAC205' => '31.2254|-84.1942|Mitchell||',
 'GAC207' => '33.0141|-83.9187|Monroe||',
 'GAC209' => '32.1746|-82.5338|Montgomery||',
 'GAC211' => '33.5908|-83.4924|Morgan||',
 'GAC213' => '34.7885|-84.7481|Murray||',
 'GAC215' => '32.5100|-84.8770|Muscogee||',
 'GAC217' => '33.5551|-83.8503|Newton||',
 'GAC219' => '33.8349|-83.4370|Oconee||',
 'GAC221' => '33.8807|-83.0806|Oglethorpe||',
 'GAC223' => '33.9202|-84.8672|Paulding||',
 'GAC225' => '32.5688|-83.8268|Peach||',
 'GAC227' => '34.4643|-84.4656|Pickens||',
 'GAC229' => '31.3589|-82.2134|Pierce||',
 'GAC231' => '33.0922|-84.3892|Pike||',
 'GAC233' => '34.0018|-85.1881|Polk||',
 'GAC235' => '32.2328|-83.4764|Pulaski||',
 'GAC237' => '33.3218|-83.3728|Putnam||',
 'GAC239' => '31.8674|-85.0188|Quitman||',
 'GAC241' => '34.8818|-83.4021|Rabun||',
 'GAC243' => '31.7626|-84.7542|Randolph||',
 'GAC245' => '33.3596|-82.0735|Richmond||',
 'GAC247' => '33.6545|-84.0267|Rockdale||',
 'GAC249' => '32.2620|-84.3149|Schley||',
 'GAC251' => '32.7507|-81.6119|Screven||',
 'GAC253' => '30.7935|-84.8812|Seminole||	30.9481|-84.8681|Seminole||',
 'GAC255' => '33.2609|-84.2841|Spalding||',
 'GAC257' => '34.5540|-83.2935|Stephens||',
 'GAC259' => '32.0785|-84.8351|Stewart||',
 'GAC261' => '32.0400|-84.1971|Sumter||',
 'GAC263' => '32.6995|-84.5330|Talbot||',
 'GAC265' => '33.5662|-82.8787|Taliaferro||',
 'GAC267' => '32.0458|-82.0582|Tattnall||',
 'GAC269' => '32.5556|-84.2504|Taylor||',
 'GAC271' => '31.9298|-82.9389|Telfair||',
 'GAC273' => '31.7768|-84.4368|Terrell||',
 'GAC275' => '30.8637|-83.9194|Thomas||',
 'GAC277' => '31.4575|-83.5266|Tift||',
 'GAC279' => '32.1206|-82.3306|Toombs||',
 'GAC281' => '34.9166|-83.7373|Towns||',
 'GAC283' => '32.4039|-82.5673|Treutlen||',
 'GAC285' => '33.0335|-85.0283|Troup||',
 'GAC287' => '31.7164|-83.6242|Turner||',
 'GAC289' => '32.6672|-83.4272|Twiggs||',
 'GAC291' => '34.8342|-83.9907|Union||',
 'GAC293' => '32.8812|-84.2993|Upson||',
 'GAC295' => '34.7356|-85.3009|Walker||',
 'GAC297' => '33.7816|-83.7338|Walton||',
 'GAC299' => '31.0534|-82.4238|Ware||',
 'GAC301' => '33.4090|-82.6767|Warren||',
 'GAC303' => '32.9695|-82.7959|Washington||',
 'GAC305' => '31.5515|-81.9168|Wayne||',
 'GAC307' => '32.0466|-84.5510|Webster||',
 'GAC309' => '32.1171|-82.7246|Wheeler||',
 'GAC311' => '34.6464|-83.7472|White||',
 'GAC313' => '34.8056|-84.9673|Whitfield||',
 'GAC315' => '31.9734|-83.4322|Wilcox||',
 'GAC317' => '33.7820|-82.7432|Wilkes||',
 'GAC319' => '32.8024|-83.1713|Wilkinson||',
 'GAC321' => '31.5516|-83.8510|Worth||',
 'GAZ001' => '34.8546|-85.5045|Dade|Dade|13083',
 'GAZ002' => '34.7356|-85.3009|Walker|Walker|13295',
 'GAZ003' => '34.9036|-85.1381|Catoosa|Catoosa|13047',
 'GAZ004' => '34.8056|-84.9673|Whitfield|Whitfield|13313',
 'GAZ005' => '34.7885|-84.7481|Murray|Murray|13213',
 'GAZ006' => '34.8641|-84.3197|Fannin|Fannin|13111',
 'GAZ007' => '34.6915|-84.4554|Gilmer|Gilmer|13123',
 'GAZ008' => '34.8342|-83.9907|Union|Union|13291',
 'GAZ009' => '34.9167|-83.7373|Towns|Towns|13281',
 'GAZ010' => '34.8818|-83.4021|Rabun|Rabun|13241',
 'GAZ011' => '34.475|-85.3454|Chattooga|Chattooga|13055',
 'GAZ012' => '34.5034|-84.8757|Gordon|Gordon|13129',
 'GAZ013' => '34.4643|-84.4656|Pickens|Pickens|13227',
 'GAZ014' => '34.4438|-84.1704|Dawson|Dawson|13085',
 'GAZ015' => '34.5721|-84.0031|Lumpkin|Lumpkin|13187',
 'GAZ016' => '34.6464|-83.7472|White|White|13311',
 'GAZ017' => '34.631|-83.5312|Habersham|Habersham|13137',
 'GAZ018' => '34.554|-83.2935|Stephens|Stephens|13257',
 'GAZ019' => '34.2632|-85.2143|Floyd|Floyd|13115',
 'GAZ020' => '34.2379|-84.8405|Bartow|Bartow|13015',
 'GAZ021' => '34.2439|-84.4764|Cherokee|Cherokee|13057',
 'GAZ022' => '34.2255|-84.1253|Forsyth|Forsyth|13117',
 'GAZ023' => '34.3168|-83.8197|Hall|Hall|13139',
 'GAZ024' => '34.3541|-83.4974|Banks|Banks|13011',
 'GAZ025' => '34.1339|-83.5663|Jackson|Jackson|13157',
 'GAZ026' => '34.3755|-83.2292|Franklin|Franklin|13119',
 'GAZ027' => '34.1279|-83.209|Madison|Madison|13195',
 'GAZ028' => '34.3511|-82.964|Hart|Hart|13147',
 'GAZ029' => '34.1169|-82.8403|Elbert|Elbert|13105',
 'GAZ030' => '34.0018|-85.1882|Polk|Polk|13233',
 'GAZ031' => '33.9202|-84.8672|Paulding|Paulding|13223',
 'GAZ032' => '33.9415|-84.5767|Cobb|Cobb|13067',
 'GAZ033' => '33.935|-84.3557|North Fulton|Fulton|13121',
 'GAZ034' => '33.9617|-84.0235|Gwinnett|Gwinnett|13135',
 'GAZ035' => '33.9932|-83.7127|Barrow|Barrow|13013',
 'GAZ036' => '33.9513|-83.3674|Clarke|Clarke|13059',
 'GAZ037' => '33.8349|-83.437|Oconee|Oconee|13219',
 'GAZ038' => '33.8807|-83.0806|Oglethorpe|Oglethorpe|13221',
 'GAZ039' => '33.782|-82.7432|Wilkes|Wilkes|13317',
 'GAZ040' => '33.7936|-82.4512|Lincoln|Lincoln|13181',
 'GAZ041' => '33.7942|-85.211|Haralson|Haralson|13143',
 'GAZ042' => '33.5828|-85.0797|Carroll|Carroll|13045',
 'GAZ043' => '33.7015|-84.7677|Douglas|Douglas|13097',
 'GAZ044' => '33.6085|-84.6065|South Fulton|Fulton|13121',
 'GAZ045' => '33.7715|-84.2263|De Kalb|DeKalb|13089',
 'GAZ046' => '33.6545|-84.0267|Rockdale|Rockdale|13247',
 'GAZ047' => '33.7816|-83.7338|Walton|Walton|13297	33.7816|-83.7338|Walton|Walton|13297',
 'GAZ048' => '33.5551|-83.8503|Newton|Newton|13217',
 'GAZ049' => '33.5908|-83.4924|Morgan|Morgan|13211',
 'GAZ050' => '33.5789|-83.1667|Greene|Greene|13133',
 'GAZ051' => '33.5662|-82.8787|Taliaferro|Taliaferro|13265',
 'GAZ052' => '33.297|-85.1283|Heard|Heard|13149',
 'GAZ053' => '33.3535|-84.7633|Coweta|Coweta|13077',
 'GAZ054' => '33.414|-84.4941|Fayette|Fayette|13113',
 'GAZ055' => '33.5419|-84.3577|Clayton|Clayton|13063',
 'GAZ056' => '33.2609|-84.2841|Spalding|Spalding|13255',
 'GAZ057' => '33.4534|-84.1554|Henry|Henry|13151',
 'GAZ058' => '33.2891|-83.9572|Butts|Butts|13035',
 'GAZ059' => '33.3164|-83.6881|Jasper|Jasper|13159',
 'GAZ060' => '33.3218|-83.3728|Putnam|Putnam|13237',
 'GAZ061' => '33.2703|-83.001|Hancock|Hancock|13141',
 'GAZ062' => '33.4089|-82.6767|Warren|Warren|13301',
 'GAZ063' => '33.4829|-82.4814|McDuffie|McDuffie|13189',
 'GAZ064' => '33.5442|-82.264|Columbia|Columbia|13073',
 'GAZ065' => '33.3596|-82.0735|Richmond|Richmond|13245',
 'GAZ066' => '33.0335|-85.0283|Troup|Troup|13285',
 'GAZ067' => '33.0406|-84.6883|Meriwether|Meriwether|13199',
 'GAZ068' => '33.0922|-84.3892|Pike|Pike|13231',
 'GAZ069' => '32.8813|-84.2993|Upson|Upson|13293',
 'GAZ070' => '33.0765|-84.1394|Lamar|Lamar|13171',
 'GAZ071' => '33.0141|-83.9187|Monroe|Monroe|13207',
 'GAZ072' => '33.0251|-83.5605|Jones|Jones|13169',
 'GAZ073' => '33.069|-83.2499|Baldwin|Baldwin|13009',
 'GAZ074' => '32.9695|-82.7959|Washington|Washington|13303',
 'GAZ075' => '33.2293|-82.6107|Glascock|Glascock|13125',
 'GAZ076' => '33.0549|-82.4181|Jefferson|Jefferson|13163',
 'GAZ077' => '33.0612|-82.0008|Burke|Burke|13033',
 'GAZ078' => '32.736|-84.909|Harris|Harris|13145',
 'GAZ079' => '32.6995|-84.533|Talbot|Talbot|13263',
 'GAZ080' => '32.5556|-84.2504|Taylor|Taylor|13269',
 'GAZ081' => '32.7145|-83.9864|Crawford|Crawford|13079',
 'GAZ082' => '32.8067|-83.6979|Bibb|Bibb|13021',
 'GAZ083' => '32.6672|-83.4272|Twiggs|Twiggs|13289',
 'GAZ084' => '32.8024|-83.1713|Wilkinson|Wilkinson|13319',
 'GAZ085' => '32.7015|-82.6601|Johnson|Johnson|13167',
 'GAZ086' => '32.5898|-82.3018|Emanuel|Emanuel|13107',
 'GAZ087' => '32.7925|-81.9636|Jenkins|Jenkins|13165',
 'GAZ088' => '32.7507|-81.6119|Screven|Screven|13251',
 'GAZ089' => '32.51|-84.877|Muscogee|Muscogee|13215',
 'GAZ090' => '32.347|-84.787|Chattahoochee|Chattahoochee|13053',
 'GAZ091' => '32.3534|-84.5246|Marion|Marion|13197',
 'GAZ092' => '32.262|-84.3149|Schley|Schley|13249',
 'GAZ093' => '32.3584|-84.0425|Macon|Macon|13193',
 'GAZ094' => '32.5688|-83.8269|Peach|Peach|13225',
 'GAZ095' => '32.459|-83.6662|Houston|Houston|13153',
 'GAZ096' => '32.4344|-83.3279|Bleckley|Bleckley|13023',
 'GAZ097' => '32.4637|-82.9222|Laurens|Laurens|13175',
 'GAZ098' => '32.4039|-82.5673|Treutlen|Treutlen|13283',
 'GAZ099' => '32.4035|-82.0737|Candler|Candler|13043',
 'GAZ100' => '32.3969|-81.7432|Bulloch|Bulloch|13031',
 'GAZ101' => '32.3675|-81.3407|Effingham|Effingham|13103',
 'GAZ102' => '32.0785|-84.8352|Stewart|Stewart|13259',
 'GAZ103' => '32.0466|-84.551|Webster|Webster|13307',
 'GAZ104' => '32.04|-84.1971|Sumter|Sumter|13261',
 'GAZ105' => '32.1572|-83.7987|Dooly|Dooly|13093',
 'GAZ106' => '31.923|-83.7681|Crisp|Crisp|13081',
 'GAZ107' => '32.2328|-83.4764|Pulaski|Pulaski|13235',
 'GAZ108' => '31.9733|-83.4322|Wilcox|Wilcox|13315',
 'GAZ109' => '32.1722|-83.1684|Dodge|Dodge|13091',
 'GAZ110' => '31.9298|-82.9389|Telfair|Telfair|13271',
 'GAZ111' => '32.1171|-82.7246|Wheeler|Wheeler|13309',
 'GAZ112' => '32.1746|-82.5338|Montgomery|Montgomery|13209',
 'GAZ113' => '32.1206|-82.3306|Toombs|Toombs|13279',
 'GAZ114' => '32.0458|-82.0582|Tattnall|Tattnall|13267',
 'GAZ115' => '32.1568|-81.8869|Evans|Evans|13109',
 'GAZ116' => '32.0404|-81.475|Inland Bryan|Bryan|13029',
 'GAZ117' => '31.8127|-81.2002|Coastal Bryan|Bryan|13029',
 'GAZ118' => '32.0772|-81.2278|Inland Chatham|Chatham|13051',
 'GAZ119' => '31.9182|-81.0342|Coastal Chatham|Chatham|13051	31.9392|-81.0501|Coastal Chatham|Chatham|13051',
 'GAZ120' => '31.8674|-85.0188|Quitman|Quitman|13239',
 'GAZ121' => '31.6264|-84.9803|Clay|Clay|13061',
 'GAZ122' => '31.7626|-84.7542|Randolph|Randolph|13243',
 'GAZ123' => '31.5292|-84.6249|Calhoun|Calhoun|13037',
 'GAZ124' => '31.7768|-84.4368|Terrell|Terrell|13273',
 'GAZ125' => '31.5333|-84.2164|Dougherty|Dougherty|13095',
 'GAZ126' => '31.7796|-84.141|Lee|Lee|13177',
 'GAZ127' => '31.5515|-83.851|Worth|Worth|13321',
 'GAZ128' => '31.7163|-83.6242|Turner|Turner|13287',
 'GAZ129' => '31.4575|-83.5266|Tift|Tift|13277',
 'GAZ130' => '31.7598|-83.2205|Ben Hill|Ben Hill|13017',
 'GAZ131' => '31.6023|-83.2764|Irwin|Irwin|13155',
 'GAZ132' => '31.5492|-82.8493|Coffee|Coffee|13069',
 'GAZ133' => '31.8056|-82.637|Jeff Davis|Jeff Davis|13161',
 'GAZ134' => '31.5537|-82.4527|Bacon|Bacon|13005',
 'GAZ135' => '31.7493|-82.289|Appling|Appling|13001',
 'GAZ136' => '31.5515|-81.9168|Wayne|Wayne|13305',
 'GAZ137' => '31.7528|-81.746|Long|Long|13183',
 'GAZ138' => '31.8508|-81.5352|Inland Liberty|Liberty|13179',
 'GAZ139' => '31.6625|-81.2029|Coastal Liberty|Liberty|13179	31.6716|-81.2012|Coastal Liberty|Liberty|13179',
 'GAZ140' => '31.5278|-81.4877|Inland McIntosh|McIntosh|13191',
 'GAZ141' => '31.4585|-81.3001|Coastal McIntosh|McIntosh|13191	31.4659|-81.3213|Coastal McIntosh|McIntosh|13191',
 'GAZ142' => '31.3229|-84.9037|Early|Early|13099',
 'GAZ143' => '31.164|-84.7307|Miller|Miller|13201',
 'GAZ144' => '31.3262|-84.4447|Baker|Baker|13007',
 'GAZ145' => '31.2254|-84.1942|Mitchell|Mitchell|13205',
 'GAZ146' => '31.1884|-83.7688|Colquitt|Colquitt|13071',
 'GAZ147' => '31.154|-83.4305|Cook|Cook|13075',
 'GAZ148' => '31.2761|-83.2297|Berrien|Berrien|13019',
 'GAZ149' => '31.2971|-82.88|Atkinson|Atkinson|13003',
 'GAZ151' => '31.3589|-82.2133|Pierce|Pierce|13229',
 'GAZ152' => '31.197|-81.9819|Brantley|Brantley|13025',
 'GAZ153' => '31.2698|-81.639|Inland Glynn|Glynn|13127',
 'GAZ154' => '31.1999|-81.4405|Coastal Glynn|Glynn|13127',
 'GAZ155' => '30.9481|-84.8681|Seminole|Seminole|13253',
 'GAZ156' => '30.7994|-84.7577|Decatur|Decatur|13087	30.8815|-84.572|Decatur|Decatur|13087',
 'GAZ157' => '30.8747|-84.2344|Grady|Grady|13131',
 'GAZ158' => '30.8637|-83.9194|Thomas|Thomas|13275',
 'GAZ159' => '30.842|-83.5803|Brooks|Brooks|13027',
 'GAZ160' => '30.8339|-83.2677|Lowndes|Lowndes|13185',
 'GAZ161' => '31.038|-83.0626|Lanier|Lanier|13173',
 'GAZ162' => '30.7101|-82.8939|Echols|Echols|13101',
 'GAZ163' => '30.9151|-82.7063|Clinch|Clinch|13065',
 'GAZ165' => '30.9642|-81.7688|Inland Camden|Camden|13039',
 'GAZ166' => '30.8884|-81.5544|Coastal Camden|Camden|13039',
 'GAZ250' => '31.1996|-82.4623|Northern Ware |Ware|13299',
 'GAZ264' => '30.947|-81.9942|Northeastern Charlton |Charlton|13049',
 'GAZ350' => '30.7473|-82.3431|Southern Ware |Ware|13299',
 'GAZ364' => '30.7368|-82.1771|Western Charlton |Charlton|13049',
 'GUC010' => '13.4435|144.7774|Guam||',
 'GUZ001' => '13.4435|144.7774|Guam|Guam|66010',
 'HIC001' => '19.6013|-155.5212|Hawaii in Hawaii||',
 'HIC003' => '21.4625|-157.9765|Oahu in Honolulu||',
 'HIC007' => '21.8970|-160.1570|Niihau in Kauai||	22.0614|-159.5270|Kauai in Kauai||',
 'HIC009' => '20.5503|-156.6118|Kahoolawe in Maui||	20.8383|-156.9299|Lanai in Maui||	20.7936|-156.3396|Maui in Maui||	21.1363|-157.0168|Molokai in Maui||',
 'HIZ001' => '21.897|-160.157|Niihau|Kauai|15007',
 'HIZ003' => '22.0073|-159.6639|Kauai Southwest|Kauai|15007',
 'HIZ004' => '22.0963|-159.543|Kauai Mountains|Kauai|15007',
 'HIZ006' => '21.4436|-158.1698|Waianae Coast|Honolulu|15003',
 'HIZ007' => '21.5991|-158.1007|Oahu North Shore|Honolulu|15003',
 'HIZ009' => '21.3809|-157.7459|Olomana|Honolulu|15003',
 'HIZ010' => '21.4843|-158.027|Central Oahu|Honolulu|15003',
 'HIZ011' => '21.4683|-158.1327|Waianae Mountains|Honolulu|15003',
 'HIZ015' => '20.8177|-156.9138|Lanai Mauka|Maui|15009',
 'HIZ016' => '20.5503|-156.6118|Kahoolawe|Maui|15009',
 'HIZ017' => '20.9195|-156.5762|Maui Windward West|Maui|15009',
 'HIZ018' => '20.8913|-156.6446|Maui Leeward West|Maui|15009',
 'HIZ022' => '20.7202|-156.2248|Haleakala Summit|Maui|15009',
 'HIZ023' => '19.4131|-155.8806|Kona|Hawaii|15001',
 'HIZ026' => '19.8824|-155.8068|Kohala|Hawaii|15001',
 'HIZ027' => '19.5822|-155.5756|Big Island Interior|Hawaii|15001',
 'HIZ028' => '19.5563|-155.555|Big Island Summit|Hawaii|15001',
 'HIZ029' => '22.1834|-159.5254|Kauai North|Kauai|15007',
 'HIZ030' => '22.049|-159.3899|Kauai East|Kauai|15007',
 'HIZ031' => '21.914|-159.4781|Kauai South|Kauai|15007',
 'HIZ032' => '21.2897|-157.726|East Honolulu|Honolulu|15003',
 'HIZ033' => '21.3203|-157.8849|Honolulu Metro|Honolulu|15003',
 'HIZ034' => '21.3526|-158.0226|Ewa Plain|Honolulu|15003',
 'HIZ035' => '21.5539|-157.9014|Koolau Windward|Honolulu|15003',
 'HIZ036' => '21.4387|-157.8915|Koolau Leeward|Honolulu|15003',
 'HIZ037' => '21.1494|-156.8556|Molokai Windward|Maui|15009',
 'HIZ038' => '21.097|-156.8249|Molokai Southeast|Maui|15009',
 'HIZ039' => '21.1843|-157.0947|Molokai North|Maui|15009',
 'HIZ040' => '21.1572|-157.2611|Molokai West|Maui|15009',
 'HIZ041' => '21.1257|-157.0866|Molokai Leeward South|Maui|15009',
 'HIZ042' => '20.8828|-156.9154|Lanai Windward|Maui|15009',
 'HIZ043' => '20.842|-157.0005|Lanai Leeward|Maui|15009',
 'HIZ044' => '20.7633|-156.8905|Lanai South|Maui|15009',
 'HIZ045' => '20.8708|-156.4171|Maui Central Valley North|Maui|15009',
 'HIZ046' => '20.8082|-156.4688|Maui Central Valley South|Maui|15009',
 'HIZ047' => '20.8318|-156.194|Windward Haleakala|Maui|15009',
 'HIZ048' => '20.7034|-156.0527|Kipahulu|Maui|15009',
 'HIZ049' => '20.7293|-156.3795|South Maui/Upcountry|Maui|15009',
 'HIZ050' => '20.6382|-156.2465|South Haleakala|Hawaii|15001',
 'HIZ051' => '19.0603|-155.7364|Big Island South|Hawaii|15001',
 'HIZ052' => '19.2625|-155.3822|Big Island Southeast|Hawaii|15001',
 'HIZ053' => '19.6291|-155.1341|Big Island East|Hawaii|15001',
 'HIZ054' => '20.0641|-155.596|Big Island North|Hawaii|15001',
 'IAC001' => '41.3307|-94.4710|Adair||',
 'IAC003' => '41.0290|-94.6992|Adams||',
 'IAC005' => '43.2843|-91.3781|Allamakee||',
 'IAC007' => '40.7432|-92.8687|Appanoose||',
 'IAC009' => '41.6846|-94.9058|Audubon||',
 'IAC011' => '42.0801|-92.0657|Benton||',
 'IAC013' => '42.4701|-92.3085|Black Hawk||',
 'IAC015' => '42.0366|-93.9318|Boone||',
 'IAC017' => '42.7747|-92.3182|Bremer||',
 'IAC019' => '42.4707|-91.8379|Buchanan||',
 'IAC021' => '42.7355|-95.1513|Buena Vista||',
 'IAC023' => '42.7316|-92.7902|Butler||',
 'IAC025' => '42.3852|-94.6405|Calhoun||',
 'IAC027' => '42.0362|-94.8607|Carroll||',
 'IAC029' => '41.3315|-94.9278|Cass||',
 'IAC031' => '41.7723|-91.1324|Cedar||',
 'IAC033' => '43.0815|-93.2608|Cerro Gordo||',
 'IAC035' => '42.7357|-95.6239|Cherokee||',
 'IAC037' => '43.0601|-92.3176|Chickasaw||',
 'IAC039' => '41.0290|-93.7851|Clarke||',
 'IAC041' => '43.0826|-95.1510|Clay||',
 'IAC043' => '42.8447|-91.3414|Clayton||',
 'IAC045' => '41.8980|-90.5320|Clinton||',
 'IAC047' => '42.0372|-95.3821|Crawford||',
 'IAC049' => '41.6849|-94.0398|Dallas||',
 'IAC051' => '40.7477|-92.4097|Davis||',
 'IAC053' => '40.7377|-93.7863|Decatur||',
 'IAC055' => '42.4711|-91.3673|Delaware||',
 'IAC057' => '40.9232|-91.1815|Des Moines||',
 'IAC059' => '43.3779|-95.1510|Dickinson||',
 'IAC061' => '42.4689|-90.8824|Dubuque||',
 'IAC063' => '43.3779|-94.6784|Emmet||',
 'IAC065' => '42.8625|-91.8443|Fayette||',
 'IAC067' => '43.0600|-92.7890|Floyd||',
 'IAC069' => '42.7325|-93.2624|Franklin||',
 'IAC071' => '40.7456|-95.6047|Fremont||',
 'IAC073' => '42.0362|-94.3969|Greene||',
 'IAC075' => '42.4020|-92.7911|Grundy||',
 'IAC077' => '41.6838|-94.5010|Guthrie||',
 'IAC079' => '42.3838|-93.7068|Hamilton||',
 'IAC081' => '43.0819|-93.7343|Hancock||',
 'IAC083' => '42.3838|-93.2404|Hardin||',
 'IAC085' => '41.6829|-95.8167|Harrison||',
 'IAC087' => '40.9879|-91.5446|Henry||',
 'IAC089' => '43.3568|-92.3172|Howard||',
 'IAC091' => '42.7764|-94.2073|Humboldt||',
 'IAC093' => '42.3869|-95.5136|Ida||',
 'IAC095' => '41.6863|-92.0656|Iowa||',
 'IAC097' => '42.1717|-90.5742|Jackson||',
 'IAC099' => '41.6860|-93.0537|Jasper||',
 'IAC101' => '41.0318|-91.9489|Jefferson||',
 'IAC103' => '41.6715|-91.5881|Johnson||',
 'IAC105' => '42.1212|-91.1314|Jones||',
 'IAC107' => '41.3364|-92.1787|Keokuk||',
 'IAC109' => '43.2042|-94.2067|Kossuth||',
 'IAC111' => '40.6420|-91.4792|Lee||',
 'IAC113' => '42.0789|-91.5989|Linn||',
 'IAC115' => '41.2185|-91.2597|Louisa||',
 'IAC117' => '41.0293|-93.3277|Lucas||',
 'IAC119' => '43.3805|-96.2103|Lyon||',
 'IAC121' => '41.3307|-94.0155|Madison||',
 'IAC123' => '41.3351|-92.6409|Mahaska||',
 'IAC125' => '41.3344|-93.0995|Marion||',
 'IAC127' => '42.0358|-92.9988|Marshall||',
 'IAC129' => '41.0332|-95.6214|Mills||',
 'IAC131' => '43.3564|-92.7891|Mitchell||',
 'IAC133' => '42.0516|-95.9600|Monona||',
 'IAC135' => '41.0297|-92.8690|Monroe||',
 'IAC137' => '41.0301|-95.1563|Montgomery||',
 'IAC139' => '41.4839|-91.1127|Muscatine||',
 'IAC141' => '43.0838|-95.6250|O\'Brien||',
 'IAC143' => '43.3785|-95.6237|Osceola||',
 'IAC145' => '40.7391|-95.1502|Page||',
 'IAC147' => '43.0820|-94.6782|Palo Alto||',
 'IAC149' => '42.7378|-96.2142|Plymouth||',
 'IAC151' => '42.7341|-94.6788|Pocahontas||',
 'IAC153' => '41.6855|-93.5734|Polk||',
 'IAC155' => '41.3364|-95.5423|Pottawattamie||',
 'IAC157' => '41.6864|-92.5315|Poweshiek||',
 'IAC159' => '40.7352|-94.2440|Ringgold||',
 'IAC161' => '42.3862|-95.1055|Sac||',
 'IAC163' => '41.6371|-90.6232|Scott||',
 'IAC165' => '41.6851|-95.3103|Shelby||',
 'IAC167' => '43.0826|-96.1779|Sioux||',
 'IAC169' => '42.0362|-93.4651|Story||',
 'IAC171' => '42.0798|-92.5326|Tama||',
 'IAC173' => '40.7374|-94.6965|Taylor||',
 'IAC175' => '41.0277|-94.2424|Union||',
 'IAC177' => '40.7532|-91.9500|Van Buren||',
 'IAC179' => '41.0306|-92.4095|Wapello||',
 'IAC181' => '41.3343|-93.5614|Warren||',
 'IAC183' => '41.3356|-91.7179|Washington||',
 'IAC185' => '40.7395|-93.3274|Wayne||',
 'IAC187' => '42.4278|-94.1818|Webster||',
 'IAC189' => '43.3775|-93.7342|Winnebago||',
 'IAC191' => '43.2906|-91.8436|Winneshiek||',
 'IAC193' => '42.3897|-96.0449|Woodbury||',
 'IAC195' => '43.3774|-93.2609|Worth||',
 'IAC197' => '42.7331|-93.7352|Wright||',
 'IAZ001' => '43.3805|-96.2103|Lyon|Lyon|19119',
 'IAZ002' => '43.3785|-95.6238|Osceola|Osceola|19143',
 'IAZ003' => '43.3779|-95.151|Dickinson|Dickinson|19059',
 'IAZ004' => '43.3779|-94.6784|Emmet|Emmet|19063',
 'IAZ005' => '43.2042|-94.2067|Kossuth|Kossuth|19109',
 'IAZ006' => '43.3775|-93.7342|Winnebago|Winnebago|19189',
 'IAZ007' => '43.3774|-93.2609|Worth|Worth|19195',
 'IAZ008' => '43.3564|-92.7891|Mitchell|Mitchell|19131',
 'IAZ009' => '43.3568|-92.3172|Howard|Howard|19089',
 'IAZ010' => '43.2906|-91.8437|Winneshiek|Winneshiek|19191',
 'IAZ011' => '43.2843|-91.3781|Allamakee|Allamakee|19005',
 'IAZ012' => '43.0826|-96.1779|Sioux|Sioux|19167',
 'IAZ013' => '43.0838|-95.625|O\'Brien|O\'Brien|19141',
 'IAZ014' => '43.0826|-95.151|Clay|Clay|19041',
 'IAZ015' => '43.082|-94.6782|Palo Alto|Palo Alto|19147',
 'IAZ016' => '43.0818|-93.7343|Hancock|Hancock|19081',
 'IAZ017' => '43.0816|-93.2608|Cerro Gordo|Cerro Gordo|19033',
 'IAZ018' => '43.06|-92.789|Floyd|Floyd|19067',
 'IAZ019' => '43.0601|-92.3176|Chickasaw|Chickasaw|19037',
 'IAZ020' => '42.7378|-96.2142|Plymouth|Plymouth|19149',
 'IAZ021' => '42.7357|-95.6239|Cherokee|Cherokee|19035',
 'IAZ022' => '42.7355|-95.1513|Buena Vista|Buena Vista|19021',
 'IAZ023' => '42.7341|-94.6789|Pocahontas|Pocahontas|19151',
 'IAZ024' => '42.7764|-94.2073|Humboldt|Humboldt|19091',
 'IAZ025' => '42.7331|-93.7352|Wright|Wright|19197',
 'IAZ026' => '42.7325|-93.2624|Franklin|Franklin|19069',
 'IAZ027' => '42.7316|-92.7902|Butler|Butler|19023',
 'IAZ028' => '42.7747|-92.3182|Bremer|Bremer|19017',
 'IAZ029' => '42.8625|-91.8443|Fayette|Fayette|19065',
 'IAZ030' => '42.8447|-91.3414|Clayton|Clayton|19043',
 'IAZ031' => '42.3897|-96.0449|Woodbury|Woodbury|19193',
 'IAZ032' => '42.3868|-95.5136|Ida|Ida|19093',
 'IAZ033' => '42.3862|-95.1055|Sac|Sac|19161',
 'IAZ034' => '42.3852|-94.6405|Calhoun|Calhoun|19025',
 'IAZ035' => '42.4278|-94.1818|Webster|Webster|19187',
 'IAZ036' => '42.3837|-93.7068|Hamilton|Hamilton|19079',
 'IAZ037' => '42.3838|-93.2404|Hardin|Hardin|19083',
 'IAZ038' => '42.4019|-92.791|Grundy|Grundy|19075',
 'IAZ039' => '42.4701|-92.3085|Black Hawk|Black Hawk|19013',
 'IAZ040' => '42.4707|-91.8379|Buchanan|Buchanan|19019',
 'IAZ041' => '42.4711|-91.3673|Delaware|Delaware|19055',
 'IAZ042' => '42.4688|-90.8824|Dubuque|Dubuque|19061',
 'IAZ043' => '42.0516|-95.96|Monona|Monona|19133',
 'IAZ044' => '42.0372|-95.3821|Crawford|Crawford|19047',
 'IAZ045' => '42.0362|-94.8607|Carroll|Carroll|19027',
 'IAZ046' => '42.0362|-94.3969|Greene|Greene|19073',
 'IAZ047' => '42.0366|-93.9318|Boone|Boone|19015',
 'IAZ048' => '42.0362|-93.4651|Story|Story|19169',
 'IAZ049' => '42.0358|-92.9988|Marshall|Marshall|19127',
 'IAZ050' => '42.0798|-92.5326|Tama|Tama|19171',
 'IAZ051' => '42.0801|-92.0657|Benton|Benton|19011',
 'IAZ052' => '42.0789|-91.5989|Linn|Linn|19113',
 'IAZ053' => '42.1212|-91.1314|Jones|Jones|19105',
 'IAZ054' => '42.1717|-90.5742|Jackson|Jackson|19097',
 'IAZ055' => '41.6829|-95.8167|Harrison|Harrison|19085',
 'IAZ056' => '41.6851|-95.3103|Shelby|Shelby|19165',
 'IAZ057' => '41.6846|-94.9058|Audubon|Audubon|19009',
 'IAZ058' => '41.6838|-94.501|Guthrie|Guthrie|19077',
 'IAZ059' => '41.6849|-94.0398|Dallas|Dallas|19049',
 'IAZ060' => '41.6855|-93.5734|Polk|Polk|19153',
 'IAZ061' => '41.686|-93.0537|Jasper|Jasper|19099',
 'IAZ062' => '41.6864|-92.5314|Poweshiek|Poweshiek|19157',
 'IAZ063' => '41.6863|-92.0656|Iowa|Iowa|19095',
 'IAZ064' => '41.6715|-91.5881|Johnson|Johnson|19103',
 'IAZ065' => '41.7723|-91.1324|Cedar|Cedar|19031',
 'IAZ066' => '41.898|-90.532|Clinton|Clinton|19045',
 'IAZ067' => '41.4839|-91.1127|Muscatine|Muscatine|19139',
 'IAZ068' => '41.6371|-90.6232|Scott|Scott|19163',
 'IAZ069' => '41.3364|-95.5423|Pottawattamie|Pottawattamie|19155',
 'IAZ070' => '41.3315|-94.9278|Cass|Cass|19029',
 'IAZ071' => '41.3307|-94.471|Adair|Adair|19001',
 'IAZ072' => '41.3307|-94.0155|Madison|Madison|19121',
 'IAZ073' => '41.3343|-93.5614|Warren|Warren|19181',
 'IAZ074' => '41.3344|-93.0995|Marion|Marion|19125',
 'IAZ075' => '41.3351|-92.6409|Mahaska|Mahaska|19123',
 'IAZ076' => '41.3364|-92.1787|Keokuk|Keokuk|19107',
 'IAZ077' => '41.3356|-91.7179|Washington|Washington|19183',
 'IAZ078' => '41.2185|-91.2597|Louisa|Louisa|19115',
 'IAZ079' => '41.0332|-95.6214|Mills|Mills|19129',
 'IAZ080' => '41.0301|-95.1563|Montgomery|Montgomery|19137',
 'IAZ081' => '41.029|-94.6992|Adams|Adams|19003',
 'IAZ082' => '41.0277|-94.2424|Union|Union|19175',
 'IAZ083' => '41.029|-93.7851|Clarke|Clarke|19039',
 'IAZ084' => '41.0293|-93.3277|Lucas|Lucas|19117',
 'IAZ085' => '41.0297|-92.869|Monroe|Monroe|19135',
 'IAZ086' => '41.0306|-92.4095|Wapello|Wapello|19179',
 'IAZ087' => '41.0318|-91.9489|Jefferson|Jefferson|19101',
 'IAZ088' => '40.9879|-91.5446|Henry|Henry|19087',
 'IAZ089' => '40.9232|-91.1815|Des Moines|Des Moines|19057',
 'IAZ090' => '40.7456|-95.6047|Fremont|Fremont|19071',
 'IAZ091' => '40.7391|-95.1502|Page|Page|19145',
 'IAZ092' => '40.7374|-94.6965|Taylor|Taylor|19173',
 'IAZ093' => '40.7352|-94.244|Ringgold|Ringgold|19159',
 'IAZ094' => '40.7377|-93.7863|Decatur|Decatur|19053',
 'IAZ095' => '40.7395|-93.3274|Wayne|Wayne|19185',
 'IAZ096' => '40.7432|-92.8687|Appanoose|Appanoose|19007',
 'IAZ097' => '40.7477|-92.4097|Davis|Davis|19051',
 'IAZ098' => '40.7532|-91.95|Van Buren|Van Buren|19177',
 'IAZ099' => '40.642|-91.4792|Lee|Lee|19111',
 'IDC001' => '43.4511|-116.2411|Ada||',
 'IDC003' => '44.8897|-116.4539|Adams||',
 'IDC005' => '42.6685|-112.2246|Bannock||',
 'IDC007' => '42.2848|-111.3296|Bear Lake||',
 'IDC009' => '47.2176|-116.6588|Benewah||',
 'IDC011' => '43.2165|-112.3981|Bingham||',
 'IDC013' => '43.4123|-113.9799|Blaine||',
 'IDC015' => '43.9892|-115.7301|Boise||',
 'IDC017' => '48.2997|-116.6010|Bonner||',
 'IDC019' => '43.3877|-111.6149|Bonneville||',
 'IDC021' => '48.7669|-116.4629|Boundary||',
 'IDC023' => '43.7233|-113.1711|Butte||',
 'IDC025' => '43.4633|-114.8059|Camas||',
 'IDC027' => '43.6250|-116.7092|Canyon||',
 'IDC029' => '42.7705|-111.5622|Caribou||',
 'IDC031' => '42.2839|-113.6004|Cassia||',
 'IDC033' => '44.2840|-112.3512|Clark||',
 'IDC035' => '46.6737|-115.6569|Clearwater||',
 'IDC037' => '44.2412|-114.2816|Custer||',
 'IDC039' => '43.3539|-115.4692|Elmore||',
 'IDC041' => '42.1811|-111.8132|Franklin||',
 'IDC043' => '44.2288|-111.4820|Fremont||',
 'IDC045' => '44.0617|-116.3973|Gem||',
 'IDC047' => '42.9706|-114.8124|Gooding||',
 'IDC049' => '45.8442|-115.4674|Idaho||',
 'IDC051' => '43.8201|-112.3113|Jefferson||',
 'IDC053' => '42.6898|-114.2641|Jerome||',
 'IDC055' => '47.6746|-116.7000|Kootenai||',
 'IDC057' => '46.8161|-116.7117|Latah||',
 'IDC059' => '44.9433|-113.9330|Lemhi||',
 'IDC061' => '46.2370|-116.4262|Lewis||',
 'IDC063' => '43.0023|-114.1395|Lincoln||',
 'IDC065' => '43.7842|-111.6594|Madison||',
 'IDC067' => '42.8544|-113.6375|Minidoka||',
 'IDC069' => '46.3268|-116.7502|Nez Perce||',
 'IDC071' => '42.1949|-112.5396|Oneida||',
 'IDC073' => '42.5816|-116.1700|Owyhee||',
 'IDC075' => '44.0067|-116.7608|Payette||',
 'IDC077' => '42.6937|-112.8407|Power||',
 'IDC079' => '47.3516|-115.8910|Shoshone||',
 'IDC081' => '43.7595|-111.2077|Teton||',
 'IDC083' => '42.3560|-114.6671|Twin Falls||',
 'IDC085' => '44.7667|-115.5661|Valley||',
 'IDC087' => '44.4524|-116.7848|Washington||',
 'IDZ001' => '48.4447|-116.5661|Northern Panhandle|Bonner|16017	48.4447|-116.5661|Northern Panhandle|Boundary|16021	48.4447|-116.5661|Northern Panhandle|Kootenai|16055',
 'IDZ002' => '47.6003|-116.8182|Coeur d\'Alene Area|Kootenai|16055',
 'IDZ003' => '46.9308|-116.8785|Idaho Palouse|Benewah|16009	46.9308|-116.8785|Idaho Palouse|Latah|16057',
 'IDZ004' => '47.3003|-116.1291|Central Panhandle Mountains|Benewah|16009	47.3003|-116.1291|Central Panhandle Mountains|Kootenai|16055	47.3003|-116.1291|Central Panhandle Mountains|Latah|16057	47.3003|-116.1291|Central Panhandle Mountains|Shoshone|16079',
 'IDZ005' => '46.7138|-115.5769|Northern Clearwater Mountains|Clearwater|16035',
 'IDZ006' => '45.8352|-115.2666|Southern Clearwater Mountains|Idaho|16049',
 'IDZ007' => '46.2094|-116.0712|Orofino/Grangeville Region|Clearwater|16035	46.2094|-116.0712|Orofino/Grangeville Region|Idaho|16049',
 'IDZ008' => '45.6641|-116.4493|Lower Hells Canyon/Salmon River Region|Idaho|16049',
 'IDZ009' => '45.1209|-114.3901|Western Lemhi County|Lemhi|16059',
 'IDZ010' => '44.8081|-113.5852|Eastern Lemhi County|Lemhi|16059',
 'IDZ011' => '44.7716|-115.8966|West Central Mountains|Adams|16003	44.7716|-115.8966|West Central Mountains|Gem|16045	44.7716|-115.8966|West Central Mountains|Valley|16085	44.7716|-115.8966|West Central Mountains|Washington|16087',
 'IDZ012' => '43.7962|-116.692|Lower Treasure Valley|Canyon|16027	43.7962|-116.692|Lower Treasure Valley|Gem|16045	43.7962|-116.692|Lower Treasure Valley|Owyhee|16073	43.7962|-116.692|Lower Treasure Valley|Payette|16075	43.7962|-116.692|Lower Treasure Valley|Washington|16087',
 'IDZ013' => '43.7521|-115.4718|Boise Mountains|Boise|16015	43.7521|-115.4718|Boise Mountains|Camas|16025	43.7521|-115.4718|Boise Mountains|Elmore|16039',
 'IDZ014' => '43.1035|-115.8643|Upper Treasure Valley|Ada|16001	43.1035|-115.8643|Upper Treasure Valley|Elmore|16039	43.1035|-115.8643|Upper Treasure Valley|Owyhee|16073',
 'IDZ015' => '42.3439|-116.0477|Southwest Highlands|Owyhee|16073',
 'IDZ016' => '42.7508|-114.5943|Western Magic Valley|Gooding|16047	42.7508|-114.5943|Western Magic Valley|Jerome|16053	42.7508|-114.5943|Western Magic Valley|Twin Falls|16083',
 'IDZ026' => '46.4507|-116.7031|Lewiston Area|Nez Perce|16069',
 'IDZ027' => '46.1926|-116.5889|Lewis and Southern Nez Perce Counties|Lewis|16061	46.1926|-116.5889|Lewis and Southern Nez Perce Counties|Nez Perce|16069',
 'IDZ028' => '43.301|-114.8183|Camas Prairie|Camas|16025	43.301|-114.8183|Camas Prairie|Elmore|16039',
 'IDZ029' => '42.9537|-116.7748|Owyhee Mountains|Owyhee|16073',
 'IDZ030' => '42.2255|-114.6784|Southern Twin Falls County|Twin Falls|16083',
 'IDZ033' => '44.476|-116.5799|Upper Weiser River|Adams|16003	44.476|-116.5799|Upper Weiser River|Washington|16087',
 'IDZ051' => '43.0804|-113.8956|Shoshone/Lava Beds|Blaine|16013	43.0804|-113.8956|Shoshone/Lava Beds|Lincoln|16063	43.0804|-113.8956|Shoshone/Lava Beds|Minidoka|16067',
 'IDZ052' => '43.6353|-112.7958|Arco/Mud Lake Desert|Bingham|16011	43.6353|-112.7958|Arco/Mud Lake Desert|Bonneville|16019	43.6353|-112.7958|Arco/Mud Lake Desert|Butte|16023	43.6353|-112.7958|Arco/Mud Lake Desert|Jefferson|16051',
 'IDZ053' => '43.7916|-111.9224|Upper Snake River Plain|Bonneville|16019	43.7916|-111.9224|Upper Snake River Plain|Fremont|16043	43.7916|-111.9224|Upper Snake River Plain|Jefferson|16051	43.7916|-111.9224|Upper Snake River Plain|Madison|16065',
 'IDZ054' => '43.1242|-112.6045|Lower Snake River Plain|Bannock|16005	43.1242|-112.6045|Lower Snake River Plain|Bingham|16011	43.1242|-112.6045|Lower Snake River Plain|Power|16077',
 'IDZ055' => '42.7002|-113.4605|Eastern Magic Valley|Blaine|16013	42.7002|-113.4605|Eastern Magic Valley|Cassia|16031	42.7002|-113.4605|Eastern Magic Valley|Minidoka|16067	42.7002|-113.4605|Eastern Magic Valley|Power|16077',
 'IDZ056' => '42.1932|-113.8364|Southern Hills/Albion Mountains|Cassia|16031',
 'IDZ057' => '42.2756|-113.0516|Raft River Region|Cassia|16031	42.2756|-113.0516|Raft River Region|Oneida|16071	42.2756|-113.0516|Raft River Region|Power|16077',
 'IDZ058' => '42.6797|-112.2919|Marsh and Arbon Highlands|Bannock|16005	42.6797|-112.2919|Marsh and Arbon Highlands|Bingham|16011	42.6797|-112.2919|Marsh and Arbon Highlands|Caribou|16029	42.6797|-112.2919|Marsh and Arbon Highlands|Power|16077',
 'IDZ059' => '42.2039|-112.1984|Franklin/Eastern Oneida Region|Franklin|16041	42.2039|-112.1984|Franklin/Eastern Oneida Region|Oneida|16071',
 'IDZ060' => '42.2521|-111.5742|Bear River Range|Bear Lake|16007	42.2521|-111.5742|Bear River Range|Caribou|16029	42.2521|-111.5742|Bear River Range|Franklin|16041',
 'IDZ061' => '42.2447|-111.2738|Bear Lake Valley|Bear Lake|16007',
 'IDZ062' => '42.9895|-111.747|Blackfoot Mountains|Bingham|16011	42.9895|-111.747|Blackfoot Mountains|Bonneville|16019	42.9895|-111.747|Blackfoot Mountains|Caribou|16029',
 'IDZ063' => '42.9919|-111.2925|Caribou Range|Bear Lake|16007	42.9919|-111.2925|Caribou Range|Bonneville|16019	42.9919|-111.2925|Caribou Range|Caribou|16029',
 'IDZ064' => '43.6154|-111.2986|Big Hole Mountains|Bonneville|16019	43.6154|-111.2986|Big Hole Mountains|Madison|16065	43.6154|-111.2986|Big Hole Mountains|Teton|16081',
 'IDZ065' => '43.8893|-111.2616|Teton Valley|Fremont|16043	43.8893|-111.2616|Teton Valley|Madison|16065	43.8893|-111.2616|Teton Valley|Teton|16081',
 'IDZ066' => '44.3674|-111.489|Centennial Mountains/Island Park|Clark|16033	44.3674|-111.489|Centennial Mountains/Island Park|Fremont|16043	44.3674|-111.489|Centennial Mountains/Island Park|Teton|16081',
 'IDZ067' => '44.2232|-112.5387|Beaverhead/Lemhi Highlands|Butte|16023	44.2232|-112.5387|Beaverhead/Lemhi Highlands|Clark|16033',
 'IDZ068' => '43.8834|-113.4263|Lost River Valleys|Butte|16023	43.8834|-113.4263|Lost River Valleys|Custer|16037',
 'IDZ069' => '44.122|-113.5633|Lost River Range|Butte|16023	44.122|-113.5633|Lost River Range|Custer|16037',
 'IDZ070' => '44.4002|-114.0841|Challis/Pahsimeroi Valleys|Custer|16037',
 'IDZ071' => '44.416|-114.5294|Frank Church Wilderness|Custer|16037',
 'IDZ072' => '44.2935|-114.9227|Sawtooth/Stanley Basin|Blaine|16013	44.2935|-114.9227|Sawtooth/Stanley Basin|Custer|16037',
 'IDZ073' => '43.7253|-114.4186|Sun Valley Region|Blaine|16013	43.7253|-114.4186|Sun Valley Region|Custer|16037',
 'IDZ074' => '43.8258|-113.9943|Big Lost Highlands/Copper Basin|Blaine|16013	43.8258|-113.9943|Big Lost Highlands/Copper Basin|Butte|16023	43.8258|-113.9943|Big Lost Highlands/Copper Basin|Custer|16037',
 'IDZ075' => '43.4301|-114.1369|Caribou Range|Blaine|16013',
 'ILC001' => '39.9878|-91.1886|Adams||',
 'ILC003' => '37.1915|-89.3376|Alexander||',
 'ILC005' => '38.8868|-89.4356|Bond||',
 'ILC007' => '42.3231|-88.8234|Boone||',
 'ILC009' => '39.9618|-90.7504|Brown||',
 'ILC011' => '41.4041|-89.5287|Bureau||',
 'ILC013' => '39.1692|-90.6675|Calhoun||',
 'ILC015' => '42.0688|-89.9345|Carroll||',
 'ILC017' => '39.9736|-90.2474|Cass||',
 'ILC019' => '40.1401|-88.1991|Champaign||',
 'ILC021' => '39.5458|-89.2773|Christian||',
 'ILC023' => '39.3335|-87.7878|Clark||',
 'ILC025' => '38.7542|-88.4902|Clay||',
 'ILC027' => '38.6065|-89.4224|Clinton||',
 'ILC029' => '39.5202|-88.2218|Coles||',
 'ILC031' => '41.8399|-87.8167|Cook||',
 'ILC033' => '39.0028|-87.7595|Crawford||',
 'ILC035' => '39.2732|-88.2403|Cumberland||',
 'ILC037' => '41.8934|-88.7704|De Kalb||',
 'ILC039' => '40.1746|-88.9041|De Witt||',
 'ILC041' => '39.7695|-88.2174|Douglas||',
 'ILC043' => '41.8520|-88.0857|DuPage||',
 'ILC045' => '39.6786|-87.7456|Edgar||',
 'ILC047' => '38.4165|-88.0532|Edwards||',
 'ILC049' => '39.0597|-88.5899|Effingham||',
 'ILC051' => '39.0002|-89.0242|Fayette||',
 'ILC053' => '40.5972|-88.2233|Ford||',
 'ILC055' => '37.9923|-88.9242|Franklin||',
 'ILC057' => '40.4728|-90.2075|Fulton||',
 'ILC059' => '37.7628|-88.2305|Gallatin||',
 'ILC061' => '39.3562|-90.3905|Greene||',
 'ILC063' => '41.2850|-88.4185|Grundy||',
 'ILC065' => '38.0816|-88.5391|Hamilton||',
 'ILC067' => '40.4037|-91.1647|Hancock||',
 'ILC069' => '37.5182|-88.2669|Hardin||',
 'ILC071' => '40.8181|-90.9251|Henderson||',
 'ILC073' => '41.3531|-90.1314|Henry||',
 'ILC075' => '40.7474|-87.8243|Iroquois||',
 'ILC077' => '37.7852|-89.3821|Jackson||',
 'ILC079' => '39.0100|-88.1538|Jasper||',
 'ILC081' => '38.3005|-88.9240|Jefferson||',
 'ILC083' => '39.0856|-90.3566|Jersey||',
 'ILC085' => '42.3657|-90.2123|Jo Daviess||',
 'ILC087' => '37.4596|-88.8809|Johnson||',
 'ILC089' => '41.9390|-88.4287|Kane||',
 'ILC091' => '41.1377|-87.8618|Kankakee||',
 'ILC093' => '41.5906|-88.4289|Kendall||',
 'ILC095' => '40.9318|-90.2133|Knox||',
 'ILC097' => '42.3231|-88.0036|Lake||',
 'ILC099' => '41.3439|-88.8859|La Salle||',
 'ILC101' => '38.7200|-87.7266|Lawrence||',
 'ILC103' => '41.7461|-89.3005|Lee||',
 'ILC105' => '40.8914|-88.5578|Livingston||',
 'ILC107' => '40.1245|-89.3676|Logan||',
 'ILC109' => '40.4562|-90.6780|McDonough||',
 'ILC111' => '42.3244|-88.4524|McHenry||',
 'ILC113' => '40.4908|-88.8473|McLean||',
 'ILC115' => '39.8599|-88.9617|Macon||',
 'ILC117' => '39.2610|-89.9244|Macoupin||',
 'ILC119' => '38.8299|-89.9051|Madison||',
 'ILC121' => '38.6496|-88.9190|Marion||',
 'ILC123' => '41.0332|-89.3448|Marshall||',
 'ILC125' => '40.2397|-89.9168|Mason||',
 'ILC127' => '37.2190|-88.7078|Massac||',
 'ILC129' => '40.0274|-89.8022|Menard||',
 'ILC131' => '41.2053|-90.7414|Mercer||',
 'ILC133' => '38.2785|-90.1774|Monroe||',
 'ILC135' => '39.2310|-89.4789|Montgomery||',
 'ILC137' => '39.7156|-90.2015|Morgan||',
 'ILC139' => '39.6413|-88.6194|Moultrie||',
 'ILC141' => '42.0427|-89.3207|Ogle||',
 'ILC143' => '40.7881|-89.7600|Peoria||',
 'ILC145' => '38.0838|-89.3671|Perry||',
 'ILC147' => '40.0104|-88.5911|Piatt||',
 'ILC149' => '39.6225|-90.8862|Pike||',
 'ILC151' => '37.4127|-88.5615|Pope||',
 'ILC153' => '37.2228|-89.1267|Pulaski||',
 'ILC155' => '41.2045|-89.2858|Putnam||',
 'ILC157' => '38.0521|-89.8253|Randolph||',
 'ILC159' => '38.7124|-88.0850|Richland||',
 'ILC161' => '41.4673|-90.5674|Rock Island||',
 'ILC163' => '38.4703|-89.9284|St. Clair||',
 'ILC165' => '37.7533|-88.5408|Saline||',
 'ILC167' => '39.7582|-89.6589|Sangamon||',
 'ILC169' => '40.1580|-90.6151|Schuyler||',
 'ILC171' => '39.6442|-90.4747|Scott||',
 'ILC173' => '39.3911|-88.8055|Shelby||',
 'ILC175' => '41.0934|-89.7975|Stark||',
 'ILC177' => '42.3517|-89.6625|Stephenson||',
 'ILC179' => '40.5075|-89.5134|Tazewell||',
 'ILC181' => '37.4712|-89.2551|Union||',
 'ILC183' => '40.1836|-87.7329|Vermilion||',
 'ILC185' => '38.4461|-87.8443|Wabash||',
 'ILC187' => '40.8488|-90.6150|Warren||',
 'ILC189' => '38.3522|-89.4105|Washington||',
 'ILC191' => '38.4295|-88.4256|Wayne||',
 'ILC193' => '38.0875|-88.1795|White||',
 'ILC195' => '41.7564|-89.9141|Whiteside||',
 'ILC197' => '41.4450|-87.9787|Will||',
 'ILC199' => '37.7303|-88.9299|Williamson||',
 'ILC201' => '42.3363|-89.1609|Winnebago||',
 'ILC203' => '40.7882|-89.2111|Woodford||',
 'ILZ001' => '42.3657|-90.2123|Jo Daviess|Jo Daviess|17085',
 'ILZ002' => '42.3517|-89.6625|Stephenson|Stephenson|17177',
 'ILZ003' => '42.3363|-89.1609|Winnebago|Winnebago|17201',
 'ILZ004' => '42.3231|-88.8234|Boone|Boone|17007',
 'ILZ005' => '42.3244|-88.4524|McHenry|McHenry|17111',
 'ILZ006' => '42.3231|-88.0036|Lake|Lake|17097',
 'ILZ007' => '42.0688|-89.9345|Carroll|Carroll|17015',
 'ILZ008' => '42.0427|-89.3207|Ogle|Ogle|17141',
 'ILZ009' => '41.7563|-89.9141|Whiteside|Whiteside|17195',
 'ILZ010' => '41.7461|-89.3005|Lee|Lee|17103',
 'ILZ011' => '41.8934|-88.7704|De Kalb|De Kalb|17037',
 'ILZ012' => '41.939|-88.4287|Kane|Kane|17089',
 'ILZ013' => '41.852|-88.0857|DuPage|DuPage|17043',
 'ILZ015' => '41.4674|-90.5674|Rock Island|Rock Island|17161',
 'ILZ016' => '41.3531|-90.1314|Henry|Henry|17073',
 'ILZ017' => '41.4041|-89.5287|Bureau|Bureau|17011',
 'ILZ018' => '41.2045|-89.2858|Putnam|Putnam|17155',
 'ILZ019' => '41.3439|-88.8859|La Salle|La Salle|17099',
 'ILZ020' => '41.5906|-88.4289|Kendall|Kendall|17093',
 'ILZ021' => '41.2849|-88.4185|Grundy|Grundy|17063',
 'ILZ023' => '41.1377|-87.8618|Kankakee|Kankakee|17091',
 'ILZ024' => '41.2053|-90.7414|Mercer|Mercer|17131',
 'ILZ025' => '40.8181|-90.9251|Henderson|Henderson|17071',
 'ILZ026' => '40.8488|-90.615|Warren|Warren|17187',
 'ILZ027' => '40.9318|-90.2133|Knox|Knox|17095',
 'ILZ028' => '41.0934|-89.7975|Stark|Stark|17175',
 'ILZ029' => '40.7881|-89.76|Peoria|Peoria|17143',
 'ILZ030' => '41.0332|-89.3448|Marshall|Marshall|17123',
 'ILZ031' => '40.7882|-89.2111|Woodford|Woodford|17203',
 'ILZ032' => '40.8914|-88.5578|Livingston|Livingston|17105',
 'ILZ033' => '40.7474|-87.8243|Iroquois|Iroquois|17075',
 'ILZ034' => '40.4037|-91.1647|Hancock|Hancock|17067',
 'ILZ035' => '40.4562|-90.678|McDonough|McDonough|17109',
 'ILZ036' => '40.4728|-90.2075|Fulton|Fulton|17057',
 'ILZ037' => '40.5075|-89.5135|Tazewell|Tazewell|17179',
 'ILZ038' => '40.4908|-88.8473|McLean|McLean|17113',
 'ILZ039' => '40.5972|-88.2233|Ford|Ford|17053',
 'ILZ040' => '40.158|-90.6151|Schuyler|Schuyler|17169',
 'ILZ041' => '40.2397|-89.9168|Mason|Mason|17125',
 'ILZ042' => '40.1245|-89.3676|Logan|Logan|17107',
 'ILZ043' => '40.1746|-88.9041|De Witt|De Witt|17039',
 'ILZ044' => '40.0104|-88.5911|Piatt|Piatt|17147',
 'ILZ045' => '40.1401|-88.1991|Champaign|Champaign|17019',
 'ILZ046' => '40.1836|-87.7329|Vermilion|Vermilion|17183',
 'ILZ047' => '39.9736|-90.2474|Cass|Cass|17017',
 'ILZ048' => '40.0274|-89.8022|Menard|Menard|17129',
 'ILZ049' => '39.6442|-90.4747|Scott|Scott|17171',
 'ILZ050' => '39.7156|-90.2015|Morgan|Morgan|17137',
 'ILZ051' => '39.7582|-89.6589|Sangamon|Sangamon|17167',
 'ILZ052' => '39.5458|-89.2773|Christian|Christian|17021',
 'ILZ053' => '39.8599|-88.9617|Macon|Macon|17115',
 'ILZ054' => '39.6414|-88.6194|Moultrie|Moultrie|17139',
 'ILZ055' => '39.7695|-88.2174|Douglas|Douglas|17041',
 'ILZ056' => '39.5202|-88.2218|Coles|Coles|17029',
 'ILZ057' => '39.6786|-87.7456|Edgar|Edgar|17045',
 'ILZ058' => '39.3562|-90.3905|Greene|Greene|17061',
 'ILZ059' => '39.261|-89.9244|Macoupin|Macoupin|17117',
 'ILZ060' => '39.231|-89.4789|Montgomery|Montgomery|17135',
 'ILZ061' => '39.3911|-88.8055|Shelby|Shelby|17173',
 'ILZ062' => '39.2732|-88.2402|Cumberland|Cumberland|17035',
 'ILZ063' => '39.3335|-87.7878|Clark|Clark|17023',
 'ILZ064' => '38.8868|-89.4356|Bond|Bond|17005',
 'ILZ065' => '39.0002|-89.0242|Fayette|Fayette|17051',
 'ILZ066' => '39.0597|-88.5899|Effingham|Effingham|17049',
 'ILZ067' => '39.01|-88.1538|Jasper|Jasper|17079',
 'ILZ068' => '39.0028|-87.7595|Crawford|Crawford|17033',
 'ILZ069' => '38.6065|-89.4224|Clinton|Clinton|17027',
 'ILZ070' => '38.6496|-88.919|Marion|Marion|17121',
 'ILZ071' => '38.7542|-88.4902|Clay|Clay|17025',
 'ILZ072' => '38.7124|-88.085|Richland|Richland|17159',
 'ILZ073' => '38.72|-87.7266|Lawrence|Lawrence|17101',
 'ILZ074' => '38.3522|-89.4105|Washington|Washington|17189',
 'ILZ075' => '38.3006|-88.924|Jefferson|Jefferson|17081',
 'ILZ076' => '38.4295|-88.4256|Wayne|Wayne|17191',
 'ILZ077' => '38.4165|-88.0532|Edwards|Edwards|17047',
 'ILZ078' => '38.4461|-87.8443|Wabash|Wabash|17185',
 'ILZ079' => '38.0521|-89.8253|Randolph|Randolph|17157',
 'ILZ080' => '38.0838|-89.3671|Perry|Perry|17145',
 'ILZ081' => '37.9923|-88.9242|Franklin|Franklin|17055',
 'ILZ082' => '38.0816|-88.5392|Hamilton|Hamilton|17065',
 'ILZ083' => '38.0875|-88.1795|White|White|17193',
 'ILZ084' => '37.7852|-89.3821|Jackson|Jackson|17077',
 'ILZ085' => '37.7303|-88.9299|Williamson|Williamson|17199',
 'ILZ086' => '37.7533|-88.5408|Saline|Saline|17165',
 'ILZ087' => '37.7628|-88.2305|Gallatin|Gallatin|17059',
 'ILZ088' => '37.4712|-89.2551|Union|Union|17181',
 'ILZ089' => '37.4596|-88.8809|Johnson|Johnson|17087',
 'ILZ090' => '37.4126|-88.5615|Pope|Pope|17151',
 'ILZ091' => '37.5182|-88.2669|Hardin|Hardin|17069',
 'ILZ092' => '37.1915|-89.3376|Alexander|Alexander|17003',
 'ILZ093' => '37.2228|-89.1267|Pulaski|Pulaski|17153',
 'ILZ094' => '37.219|-88.7078|Massac|Massac|17127',
 'ILZ095' => '39.9878|-91.1886|Adams|Adams|17001',
 'ILZ096' => '39.9618|-90.7504|Brown|Brown|17009',
 'ILZ097' => '39.6225|-90.8863|Pike|Pike|17149',
 'ILZ098' => '39.1692|-90.6675|Calhoun|Calhoun|17013',
 'ILZ099' => '39.0856|-90.3566|Jersey|Jersey|17083',
 'ILZ100' => '38.8299|-89.9051|Madison|Madison|17119',
 'ILZ101' => '38.4703|-89.9284|St. Clair|St. Clair|17163',
 'ILZ102' => '38.2785|-90.1774|Monroe|Monroe|17133',
 'ILZ103' => '42.0711|-87.9824|Northern Cook|Cook|17031',
 'ILZ104' => '41.8208|-87.7444|Central Cook|Cook|17031',
 'ILZ105' => '41.5834|-87.7273|Southern Cook|Cook|17031',
 'ILZ106' => '41.5776|-88.0699|Northern Will|Will|17197',
 'ILZ107' => '41.3459|-88.0891|Southern Will|Will|17197',
 'ILZ108' => '41.3833|-87.7148|Eastern Will|Will|17197',
 'INC001' => '40.7456|-84.9366|Adams||',
 'INC003' => '41.0908|-85.0665|Allen||',
 'INC005' => '39.2059|-85.8977|Bartholomew||',
 'INC007' => '40.6063|-87.3109|Benton||',
 'INC009' => '40.4735|-85.3248|Blackford||',
 'INC011' => '40.0508|-86.4687|Boone||',
 'INC013' => '39.1962|-86.2274|Brown||',
 'INC015' => '40.5829|-86.5635|Carroll||',
 'INC017' => '40.7615|-86.3460|Cass||',
 'INC019' => '38.4773|-85.7073|Clark||',
 'INC021' => '39.3928|-87.1158|Clay||',
 'INC023' => '40.3017|-86.4752|Clinton||',
 'INC025' => '38.2923|-86.4517|Crawford||',
 'INC027' => '38.7024|-87.0721|Daviess||',
 'INC029' => '39.1453|-84.9733|Dearborn||',
 'INC031' => '39.3069|-85.5013|Decatur||',
 'INC033' => '41.3976|-84.9991|De Kalb||',
 'INC035' => '40.2275|-85.3969|Delaware||',
 'INC037' => '38.3643|-86.8798|Dubois||',
 'INC039' => '41.5974|-85.8587|Elkhart||',
 'INC041' => '39.6401|-85.1787|Fayette||',
 'INC043' => '38.3194|-85.9068|Floyd||',
 'INC045' => '40.1209|-87.2419|Fountain||',
 'INC047' => '39.4148|-85.0603|Franklin||',
 'INC049' => '41.0470|-86.2636|Fulton||',
 'INC051' => '38.3118|-87.5846|Gibson||',
 'INC053' => '40.5158|-85.6548|Grant||',
 'INC055' => '39.0364|-86.9620|Greene||',
 'INC057' => '40.0725|-86.0520|Hamilton||',
 'INC059' => '39.8235|-85.7732|Hancock||',
 'INC061' => '38.1952|-86.1113|Harrison||',
 'INC063' => '39.7695|-86.5100|Hendricks||',
 'INC065' => '39.9310|-85.3964|Henry||',
 'INC067' => '40.4836|-86.1170|Howard||',
 'INC069' => '40.8291|-85.4881|Huntington||',
 'INC071' => '38.9064|-86.0376|Jackson||',
 'INC073' => '41.0230|-87.1162|Jasper||',
 'INC075' => '40.4380|-85.0057|Jay||',
 'INC077' => '38.7858|-85.4385|Jefferson||',
 'INC079' => '38.9969|-85.6281|Jennings||',
 'INC081' => '39.4899|-86.1017|Johnson||',
 'INC083' => '38.6891|-87.4180|Knox||',
 'INC085' => '41.2441|-85.8607|Kosciusko||',
 'INC087' => '41.6427|-85.4265|Lagrange||',
 'INC089' => '41.4156|-87.3817|Lake||',
 'INC091' => '41.5460|-86.7400|La Porte||',
 'INC093' => '38.8412|-86.4834|Lawrence||',
 'INC095' => '40.1617|-85.7194|Madison||',
 'INC097' => '39.7816|-86.1384|Marion||',
 'INC099' => '41.3250|-86.2618|Marshall||',
 'INC101' => '38.7080|-86.8031|Martin||',
 'INC103' => '40.7695|-86.0451|Miami||',
 'INC105' => '39.1609|-86.5231|Monroe||',
 'INC107' => '40.0404|-86.8933|Montgomery||',
 'INC109' => '39.4815|-86.4462|Morgan||',
 'INC111' => '40.9559|-87.3975|Newton||',
 'INC113' => '41.3986|-85.4174|Noble||',
 'INC115' => '38.9501|-84.9650|Ohio||',
 'INC117' => '38.5418|-86.4951|Orange||',
 'INC119' => '39.3129|-86.8376|Owen||',
 'INC121' => '39.7736|-87.2063|Parke||',
 'INC123' => '38.0797|-86.6380|Perry||',
 'INC125' => '38.3988|-87.2322|Pike||',
 'INC127' => '41.4605|-87.0672|Porter||',
 'INC129' => '38.0218|-87.8684|Posey||',
 'INC131' => '41.0419|-86.6989|Pulaski||',
 'INC133' => '39.6663|-86.8450|Putnam||',
 'INC135' => '40.1576|-85.0114|Randolph||',
 'INC137' => '39.1034|-85.2624|Ripley||',
 'INC139' => '39.6199|-85.4658|Rush||',
 'INC141' => '41.6167|-86.2898|St. Joseph||',
 'INC143' => '38.6851|-85.7474|Scott||',
 'INC145' => '39.5236|-85.7918|Shelby||',
 'INC147' => '38.0142|-87.0077|Spencer||',
 'INC149' => '41.2810|-86.6478|Starke||',
 'INC151' => '41.6439|-85.0008|Steuben||',
 'INC153' => '39.0888|-87.4146|Sullivan||',
 'INC155' => '38.8262|-85.0370|Switzerland||',
 'INC157' => '40.3886|-86.8941|Tippecanoe||',
 'INC159' => '40.3114|-86.0519|Tipton||',
 'INC161' => '39.6255|-84.9251|Union||',
 'INC163' => '38.0254|-87.5857|Vanderburgh||',
 'INC165' => '39.8538|-87.4640|Vermillion||',
 'INC167' => '39.4306|-87.3900|Vigo||',
 'INC169' => '40.8457|-85.7940|Wabash||',
 'INC171' => '40.3469|-87.3533|Warren||',
 'INC173' => '38.0922|-87.2721|Warrick||',
 'INC175' => '38.6000|-86.1053|Washington||',
 'INC177' => '39.8644|-85.0099|Wayne||',
 'INC179' => '40.7291|-85.2212|Wells||',
 'INC181' => '40.7499|-86.8654|White||',
 'INC183' => '41.1394|-85.5052|Whitley||',
 'INZ001' => '41.4156|-87.3817|Lake|Lake|18089',
 'INZ002' => '41.4605|-87.0671|Porter|Porter|18127',
 'INZ005' => '41.5974|-85.8587|Elkhart|Elkhart|18039',
 'INZ006' => '41.6427|-85.4265|Lagrange|Lagrange|18087',
 'INZ007' => '41.6439|-85.0008|Steuben|Steuben|18151',
 'INZ008' => '41.3986|-85.4174|Noble|Noble|18113',
 'INZ009' => '41.3976|-84.9991|De Kalb|De Kalb|18033',
 'INZ010' => '40.9559|-87.3975|Newton|Newton|18111',
 'INZ011' => '41.023|-87.1162|Jasper|Jasper|18073',
 'INZ012' => '41.281|-86.6478|Starke|Starke|18149',
 'INZ013' => '41.0419|-86.6989|Pulaski|Pulaski|18131',
 'INZ014' => '41.325|-86.2618|Marshall|Marshall|18099',
 'INZ015' => '41.047|-86.2636|Fulton|Fulton|18049',
 'INZ017' => '41.1394|-85.5052|Whitley|Whitley|18183',
 'INZ018' => '41.0908|-85.0665|Allen|Allen|18003',
 'INZ019' => '40.6063|-87.3109|Benton|Benton|18007',
 'INZ020' => '40.7499|-86.8654|White|White|18181',
 'INZ021' => '40.5828|-86.5635|Carroll|Carroll|18015',
 'INZ022' => '40.7615|-86.346|Cass|Cass|18017',
 'INZ023' => '40.7695|-86.0451|Miami|Miami|18103',
 'INZ024' => '40.8457|-85.794|Wabash|Wabash|18169',
 'INZ025' => '40.8292|-85.4881|Huntington|Huntington|18069',
 'INZ026' => '40.7291|-85.2212|Wells|Wells|18179',
 'INZ027' => '40.7455|-84.9366|Adams|Adams|18001',
 'INZ028' => '40.3469|-87.3533|Warren|Warren|18171',
 'INZ029' => '40.3886|-86.8941|Tippecanoe|Tippecanoe|18157',
 'INZ030' => '40.3017|-86.4752|Clinton|Clinton|18023',
 'INZ031' => '40.4836|-86.1169|Howard|Howard|18067',
 'INZ032' => '40.5158|-85.6548|Grant|Grant|18053',
 'INZ033' => '40.4735|-85.3248|Blackford|Blackford|18009',
 'INZ034' => '40.438|-85.0057|Jay|Jay|18075',
 'INZ035' => '40.1209|-87.2419|Fountain|Fountain|18045',
 'INZ036' => '40.0404|-86.8933|Montgomery|Montgomery|18107',
 'INZ037' => '40.0508|-86.4687|Boone|Boone|18011',
 'INZ038' => '40.3114|-86.0519|Tipton|Tipton|18159',
 'INZ039' => '40.0725|-86.052|Hamilton|Hamilton|18057',
 'INZ040' => '40.1616|-85.7194|Madison|Madison|18095',
 'INZ041' => '40.2276|-85.3969|Delaware|Delaware|18035',
 'INZ042' => '40.1576|-85.0114|Randolph|Randolph|18135',
 'INZ043' => '39.8538|-87.464|Vermillion|Vermillion|18165',
 'INZ044' => '39.7736|-87.2063|Parke|Parke|18121',
 'INZ045' => '39.6663|-86.845|Putnam|Putnam|18133',
 'INZ046' => '39.7695|-86.51|Hendricks|Hendricks|18063',
 'INZ047' => '39.7816|-86.1384|Marion|Marion|18097',
 'INZ048' => '39.8235|-85.7732|Hancock|Hancock|18059',
 'INZ049' => '39.9311|-85.3965|Henry|Henry|18065',
 'INZ050' => '39.8644|-85.0099|Wayne|Wayne|18177',
 'INZ051' => '39.4306|-87.39|Vigo|Vigo|18167',
 'INZ052' => '39.3928|-87.1158|Clay|Clay|18021',
 'INZ053' => '39.3129|-86.8376|Owen|Owen|18119',
 'INZ054' => '39.4815|-86.4462|Morgan|Morgan|18109',
 'INZ055' => '39.4899|-86.1017|Johnson|Johnson|18081',
 'INZ056' => '39.5236|-85.7918|Shelby|Shelby|18145',
 'INZ057' => '39.6199|-85.4657|Rush|Rush|18139',
 'INZ058' => '39.6401|-85.1787|Fayette|Fayette|18041',
 'INZ059' => '39.6255|-84.9251|Union|Union|18161',
 'INZ060' => '39.0888|-87.4146|Sullivan|Sullivan|18153',
 'INZ061' => '39.0363|-86.962|Greene|Greene|18055',
 'INZ062' => '39.1609|-86.5231|Monroe|Monroe|18105',
 'INZ063' => '39.1962|-86.2274|Brown|Brown|18013',
 'INZ064' => '39.2059|-85.8977|Bartholomew|Bartholomew|18005',
 'INZ065' => '39.3069|-85.5013|Decatur|Decatur|18031',
 'INZ066' => '39.4148|-85.0603|Franklin|Franklin|18047',
 'INZ067' => '38.6891|-87.418|Knox|Knox|18083',
 'INZ068' => '38.7024|-87.0721|Daviess|Daviess|18027',
 'INZ069' => '38.708|-86.8031|Martin|Martin|18101',
 'INZ070' => '38.8412|-86.4834|Lawrence|Lawrence|18093',
 'INZ071' => '38.9064|-86.0376|Jackson|Jackson|18071',
 'INZ072' => '38.9969|-85.6281|Jennings|Jennings|18079',
 'INZ073' => '39.1034|-85.2624|Ripley|Ripley|18137',
 'INZ074' => '39.1453|-84.9733|Dearborn|Dearborn|18029',
 'INZ075' => '38.9501|-84.965|Ohio|Ohio|18115',
 'INZ076' => '38.5418|-86.4951|Orange|Orange|18117',
 'INZ077' => '38.6|-86.1053|Washington|Washington|18175',
 'INZ078' => '38.6851|-85.7474|Scott|Scott|18143',
 'INZ079' => '38.7858|-85.4385|Jefferson|Jefferson|18077',
 'INZ080' => '38.8262|-85.037|Switzerland|Switzerland|18155',
 'INZ081' => '38.3118|-87.5846|Gibson|Gibson|18051',
 'INZ082' => '38.3988|-87.2322|Pike|Pike|18125',
 'INZ083' => '38.3643|-86.8798|Dubois|Dubois|18037',
 'INZ084' => '38.2923|-86.4517|Crawford|Crawford|18025',
 'INZ085' => '38.0218|-87.8684|Posey|Posey|18129',
 'INZ086' => '38.0254|-87.5857|Vanderburgh|Vanderburgh|18163',
 'INZ087' => '38.0922|-87.2721|Warrick|Warrick|18173',
 'INZ088' => '38.0142|-87.0077|Spencer|Spencer|18147',
 'INZ089' => '38.0797|-86.638|Perry|Perry|18123',
 'INZ090' => '38.1952|-86.1113|Harrison|Harrison|18061',
 'INZ091' => '38.3194|-85.9068|Floyd|Floyd|18043',
 'INZ092' => '38.4773|-85.7073|Clark|Clark|18019',
 'INZ103' => '41.6261|-86.7063|Northern La Porte|La Porte|18091',
 'INZ104' => '41.6193|-86.2095|Eastern St. Joseph|St. Joseph|18141',
 'INZ116' => '41.3378|-85.8378|Northern Kosciusko|Kosciusko|18085',
 'INZ203' => '41.4091|-86.7975|Southern La Porte|La Porte|18091',
 'INZ204' => '41.6119|-86.4382|Western St. Joseph|St. Joseph|18141',
 'INZ216' => '41.1497|-85.8838|Southern Kosciusko|Kosciusko|18085',
 'KSC001' => '37.8858|-95.3014|Allen||',
 'KSC003' => '38.2143|-95.2933|Anderson||',
 'KSC005' => '39.5319|-95.3129|Atchison||',
 'KSC007' => '37.2289|-98.6848|Barber||',
 'KSC009' => '38.4790|-98.7565|Barton||',
 'KSC011' => '37.8552|-94.8493|Bourbon||',
 'KSC013' => '39.8266|-95.5642|Brown||',
 'KSC015' => '37.7813|-96.8391|Butler||',
 'KSC017' => '38.3021|-96.5940|Chase||',
 'KSC019' => '37.1501|-96.2453|Chautauqua||',
 'KSC021' => '37.1693|-94.8462|Cherokee||',
 'KSC023' => '39.7858|-101.7311|Cheyenne||',
 'KSC025' => '37.2355|-99.8203|Clark||',
 'KSC027' => '39.3497|-97.1651|Clay||',
 'KSC029' => '39.4804|-97.6495|Cloud||',
 'KSC031' => '38.2370|-95.7342|Coffey||',
 'KSC033' => '37.1913|-99.2719|Comanche||',
 'KSC035' => '37.2378|-96.8375|Cowley||',
 'KSC037' => '37.5073|-94.8518|Crawford||',
 'KSC039' => '39.7847|-100.4599|Decatur||',
 'KSC041' => '38.8664|-97.1527|Dickinson||',
 'KSC043' => '39.7885|-95.1470|Doniphan||',
 'KSC045' => '38.8845|-95.2924|Douglas||',
 'KSC047' => '37.8876|-99.3120|Edwards||',
 'KSC049' => '37.4537|-96.2441|Elk||',
 'KSC051' => '38.9148|-99.3173|Ellis||',
 'KSC053' => '38.6966|-98.2048|Ellsworth||',
 'KSC055' => '38.0444|-100.7369|Finney||',
 'KSC057' => '37.6917|-99.8879|Ford||',
 'KSC059' => '38.5646|-95.2859|Franklin||',
 'KSC061' => '39.0024|-96.7526|Geary||',
 'KSC063' => '38.9160|-100.4829|Gove||',
 'KSC065' => '39.3497|-99.8833|Graham||',
 'KSC067' => '37.5622|-101.3080|Grant||',
 'KSC069' => '37.7382|-100.4378|Gray||',
 'KSC071' => '38.4805|-101.8060|Greeley||',
 'KSC073' => '37.8778|-96.2327|Greenwood||',
 'KSC075' => '37.9991|-101.7913|Hamilton||',
 'KSC077' => '37.1916|-98.0755|Harper||',
 'KSC079' => '38.0432|-97.4273|Harvey||',
 'KSC081' => '37.5623|-100.8712|Haskell||',
 'KSC083' => '38.0875|-99.8979|Hodgeman||',
 'KSC085' => '39.4170|-95.7937|Jackson||',
 'KSC087' => '39.2358|-95.3834|Jefferson||',
 'KSC089' => '39.7847|-98.2184|Jewell||',
 'KSC091' => '38.8838|-94.8223|Johnson||',
 'KSC093' => '38.0002|-101.3199|Kearny||',
 'KSC095' => '37.5589|-98.1364|Kingman||',
 'KSC097' => '37.5582|-99.2860|Kiowa||',
 'KSC099' => '37.1913|-95.2976|Labette||',
 'KSC101' => '38.4814|-100.4664|Lane||',
 'KSC103' => '39.1993|-95.0379|Leavenworth||',
 'KSC105' => '39.0453|-98.2078|Lincoln||',
 'KSC107' => '38.2122|-94.8429|Linn||',
 'KSC109' => '38.9173|-101.1485|Logan||',
 'KSC111' => '38.4563|-96.1527|Lyon||',
 'KSC113' => '38.3916|-97.6480|McPherson||',
 'KSC115' => '38.3588|-97.0969|Marion||',
 'KSC117' => '39.7836|-96.5229|Marshall||',
 'KSC119' => '37.2383|-100.3662|Meade||',
 'KSC121' => '38.5636|-94.8381|Miami||',
 'KSC123' => '39.3933|-98.2095|Mitchell||',
 'KSC125' => '37.1925|-95.7429|Montgomery||',
 'KSC127' => '38.6875|-96.6499|Morris||',
 'KSC129' => '37.1914|-101.7993|Morton||',
 'KSC131' => '39.7835|-96.0141|Nemaha||',
 'KSC133' => '37.5586|-95.3068|Neosho||',
 'KSC135' => '38.4795|-99.9162|Ness||',
 'KSC137' => '39.7844|-99.9034|Norton||',
 'KSC139' => '38.6524|-95.7269|Osage||',
 'KSC141' => '39.3504|-98.7679|Osborne||',
 'KSC143' => '39.1326|-97.6503|Ottawa||',
 'KSC145' => '38.1814|-99.2368|Pawnee||',
 'KSC147' => '39.7845|-99.3469|Phillips||',
 'KSC149' => '39.3790|-96.3425|Pottawatomie||',
 'KSC151' => '37.6478|-98.7396|Pratt||',
 'KSC153' => '39.7852|-101.0757|Rawlins||',
 'KSC155' => '37.9529|-98.0861|Reno||',
 'KSC157' => '39.8278|-97.6505|Republic||',
 'KSC159' => '38.3471|-98.2011|Rice||',
 'KSC161' => '39.2965|-96.7352|Riley||',
 'KSC163' => '39.3502|-99.3251|Rooks||',
 'KSC165' => '38.5233|-99.3092|Rush||',
 'KSC167' => '38.9149|-98.7623|Russell||',
 'KSC169' => '38.7839|-97.6500|Saline||',
 'KSC171' => '38.4822|-100.9069|Scott||',
 'KSC173' => '37.6848|-97.4611|Sedgwick||',
 'KSC175' => '37.1933|-100.8513|Seward||',
 'KSC177' => '39.0415|-95.7564|Shawnee||',
 'KSC179' => '39.3503|-100.4418|Sheridan||',
 'KSC181' => '39.3514|-101.7200|Sherman||',
 'KSC183' => '39.7851|-98.7855|Smith||',
 'KSC185' => '38.0311|-98.7175|Stafford||',
 'KSC187' => '37.5630|-101.7842|Stanton||',
 'KSC189' => '37.1924|-101.3121|Stevens||',
 'KSC191' => '37.2373|-97.4765|Sumner||',
 'KSC193' => '39.3509|-101.0555|Thomas||',
 'KSC195' => '38.9143|-99.8729|Trego||',
 'KSC197' => '38.9533|-96.2049|Wabaunsee||',
 'KSC199' => '38.9166|-101.7636|Wallace||',
 'KSC201' => '39.7842|-97.0874|Washington||',
 'KSC203' => '38.4821|-101.3474|Wichita||',
 'KSC205' => '37.5593|-95.7434|Wilson||',
 'KSC207' => '37.8867|-95.7402|Woodson||',
 'KSC209' => '39.1145|-94.7646|Wyandotte||',
 'KSZ001' => '39.7858|-101.7312|Cheyenne|Cheyenne|20023',
 'KSZ002' => '39.7852|-101.0758|Rawlins|Rawlins|20153',
 'KSZ003' => '39.7847|-100.4599|Decatur|Decatur|20039',
 'KSZ004' => '39.7844|-99.9034|Norton|Norton|20137',
 'KSZ005' => '39.7845|-99.3469|Phillips|Phillips|20147',
 'KSZ006' => '39.7851|-98.7855|Smith|Smith|20183',
 'KSZ007' => '39.7847|-98.2184|Jewell|Jewell|20089',
 'KSZ008' => '39.8278|-97.6506|Republic|Republic|20157',
 'KSZ009' => '39.7842|-97.0874|Washington|Washington|20201',
 'KSZ010' => '39.7836|-96.5229|Marshall|Marshall|20117',
 'KSZ011' => '39.7835|-96.0141|Nemaha|Nemaha|20131',
 'KSZ012' => '39.8266|-95.5642|Brown|Brown|20013',
 'KSZ013' => '39.3514|-101.72|Sherman|Sherman|20181',
 'KSZ014' => '39.3509|-101.0555|Thomas|Thomas|20193',
 'KSZ015' => '39.3503|-100.4418|Sheridan|Sheridan|20179',
 'KSZ016' => '39.3497|-99.8833|Graham|Graham|20065',
 'KSZ017' => '39.3501|-99.3251|Rooks|Rooks|20163',
 'KSZ018' => '39.3503|-98.7679|Osborne|Osborne|20141',
 'KSZ019' => '39.3933|-98.2095|Mitchell|Mitchell|20123',
 'KSZ020' => '39.4804|-97.6495|Cloud|Cloud|20029',
 'KSZ021' => '39.3497|-97.1651|Clay|Clay|20027',
 'KSZ022' => '39.2965|-96.7352|Riley|Riley|20161',
 'KSZ023' => '39.379|-96.3425|Pottawatomie|Pottawatomie|20149',
 'KSZ024' => '39.417|-95.7937|Jackson|Jackson|20085',
 'KSZ025' => '39.532|-95.3129|Atchison|Atchison|20005',
 'KSZ026' => '39.2358|-95.3834|Jefferson|Jefferson|20087',
 'KSZ027' => '38.9166|-101.7636|Wallace|Wallace|20199',
 'KSZ028' => '38.9173|-101.1485|Logan|Logan|20109',
 'KSZ029' => '38.9161|-100.4829|Gove|Gove|20063',
 'KSZ030' => '38.9143|-99.8729|Trego|Trego|20195',
 'KSZ031' => '38.9148|-99.3173|Ellis|Ellis|20051',
 'KSZ032' => '38.9149|-98.7623|Russell|Russell|20167',
 'KSZ033' => '39.0454|-98.2078|Lincoln|Lincoln|20105',
 'KSZ034' => '39.1326|-97.6503|Ottawa|Ottawa|20143',
 'KSZ035' => '38.8664|-97.1527|Dickinson|Dickinson|20041',
 'KSZ036' => '39.0024|-96.7526|Geary|Geary|20061',
 'KSZ037' => '38.6875|-96.6499|Morris|Morris|20127',
 'KSZ038' => '38.9533|-96.205|Wabaunsee|Wabaunsee|20197',
 'KSZ039' => '39.0415|-95.7564|Shawnee|Shawnee|20177',
 'KSZ040' => '38.8845|-95.2924|Douglas|Douglas|20045',
 'KSZ041' => '38.4805|-101.806|Greeley|Greeley|20071',
 'KSZ042' => '38.4821|-101.3474|Wichita|Wichita|20203',
 'KSZ043' => '38.4822|-100.9069|Scott|Scott|20171',
 'KSZ044' => '38.4814|-100.4664|Lane|Lane|20101',
 'KSZ045' => '38.4795|-99.9162|Ness|Ness|20135',
 'KSZ046' => '38.5233|-99.3092|Rush|Rush|20165',
 'KSZ047' => '38.479|-98.7565|Barton|Barton|20009',
 'KSZ048' => '38.6966|-98.2048|Ellsworth|Ellsworth|20053',
 'KSZ049' => '38.7839|-97.6501|Saline|Saline|20169',
 'KSZ050' => '38.3471|-98.2011|Rice|Rice|20159',
 'KSZ051' => '38.3916|-97.648|McPherson|McPherson|20113',
 'KSZ052' => '38.3588|-97.0969|Marion|Marion|20115',
 'KSZ053' => '38.302|-96.594|Chase|Chase|20017',
 'KSZ054' => '38.4563|-96.1527|Lyon|Lyon|20111',
 'KSZ055' => '38.6524|-95.7269|Osage|Osage|20139',
 'KSZ056' => '38.5646|-95.2859|Franklin|Franklin|20059',
 'KSZ057' => '38.5636|-94.8381|Miami|Miami|20121',
 'KSZ058' => '38.237|-95.7342|Coffey|Coffey|20031',
 'KSZ059' => '38.2143|-95.2933|Anderson|Anderson|20003',
 'KSZ060' => '38.2123|-94.8429|Linn|Linn|20107',
 'KSZ061' => '37.9991|-101.7913|Hamilton|Hamilton|20075',
 'KSZ062' => '38.0002|-101.3199|Kearny|Kearny|20093',
 'KSZ063' => '38.0444|-100.7369|Finney|Finney|20055',
 'KSZ064' => '38.0875|-99.8979|Hodgeman|Hodgeman|20083',
 'KSZ065' => '38.1814|-99.2368|Pawnee|Pawnee|20145',
 'KSZ066' => '38.0311|-98.7175|Stafford|Stafford|20185',
 'KSZ067' => '37.9529|-98.0861|Reno|Reno|20155',
 'KSZ068' => '38.0432|-97.4274|Harvey|Harvey|20079',
 'KSZ069' => '37.7812|-96.8391|Butler|Butler|20015',
 'KSZ070' => '37.8778|-96.2327|Greenwood|Greenwood|20073',
 'KSZ071' => '37.8867|-95.7402|Woodson|Woodson|20207',
 'KSZ072' => '37.8858|-95.3014|Allen|Allen|20001',
 'KSZ073' => '37.8552|-94.8493|Bourbon|Bourbon|20011',
 'KSZ074' => '37.563|-101.7842|Stanton|Stanton|20187',
 'KSZ075' => '37.5622|-101.308|Grant|Grant|20067',
 'KSZ076' => '37.5623|-100.8712|Haskell|Haskell|20081',
 'KSZ077' => '37.7382|-100.4378|Gray|Gray|20069',
 'KSZ078' => '37.6917|-99.8879|Ford|Ford|20057',
 'KSZ079' => '37.8876|-99.312|Edwards|Edwards|20047',
 'KSZ080' => '37.5582|-99.286|Kiowa|Kiowa|20097',
 'KSZ081' => '37.6478|-98.7396|Pratt|Pratt|20151',
 'KSZ082' => '37.5589|-98.1364|Kingman|Kingman|20095',
 'KSZ083' => '37.6848|-97.4611|Sedgwick|Sedgwick|20173',
 'KSZ084' => '37.1914|-101.7993|Morton|Morton|20129',
 'KSZ085' => '37.1924|-101.3121|Stevens|Stevens|20189',
 'KSZ086' => '37.1933|-100.8513|Seward|Seward|20175',
 'KSZ087' => '37.2382|-100.3662|Meade|Meade|20119',
 'KSZ088' => '37.2355|-99.8203|Clark|Clark|20025',
 'KSZ089' => '37.1913|-99.2719|Comanche|Comanche|20033',
 'KSZ090' => '37.2289|-98.6848|Barber|Barber|20007',
 'KSZ091' => '37.1916|-98.0755|Harper|Harper|20077',
 'KSZ092' => '37.2373|-97.4765|Sumner|Sumner|20191',
 'KSZ093' => '37.2377|-96.8375|Cowley|Cowley|20035',
 'KSZ094' => '37.4537|-96.2441|Elk|Elk|20049',
 'KSZ095' => '37.5593|-95.7434|Wilson|Wilson|20205',
 'KSZ096' => '37.5586|-95.3068|Neosho|Neosho|20133',
 'KSZ097' => '37.5073|-94.8518|Crawford|Crawford|20037',
 'KSZ098' => '37.1501|-96.2453|Chautauqua|Chautauqua|20019',
 'KSZ099' => '37.1925|-95.7429|Montgomery|Montgomery|20125',
 'KSZ100' => '37.1913|-95.2976|Labette|Labette|20099',
 'KSZ101' => '37.1693|-94.8462|Cherokee|Cherokee|20021',
 'KSZ102' => '39.7885|-95.147|Doniphan|Doniphan|20043',
 'KSZ103' => '39.1993|-95.0379|Leavenworth|Leavenworth|20103',
 'KSZ104' => '39.1145|-94.7646|Wyandotte|Wyandotte|20209',
 'KSZ105' => '38.8838|-94.8223|Johnson|Johnson|20091',
 'KYC001' => '37.1041|-85.2805|Adair||',
 'KYC003' => '36.7513|-86.1904|Allen||',
 'KYC005' => '38.0040|-84.9909|Anderson||',
 'KYC007' => '37.0584|-88.9992|Ballard||',
 'KYC009' => '36.9656|-85.9336|Barren||',
 'KYC011' => '38.1449|-83.7428|Bath||',
 'KYC013' => '36.7307|-83.6740|Bell||',
 'KYC015' => '38.9700|-84.7279|Boone||',
 'KYC017' => '38.2068|-84.2171|Bourbon||',
 'KYC019' => '38.3596|-82.6877|Boyd||',
 'KYC021' => '37.6244|-84.8667|Boyle||',
 'KYC023' => '38.6888|-84.0901|Bracken||',
 'KYC025' => '37.5216|-83.3241|Breathitt||',
 'KYC027' => '37.7732|-86.4293|Breckinridge||',
 'KYC029' => '37.9700|-85.6959|Bullitt||',
 'KYC031' => '37.2074|-86.6816|Butler||',
 'KYC033' => '37.1453|-87.8679|Caldwell||',
 'KYC035' => '36.6211|-88.2723|Calloway||',
 'KYC037' => '38.9465|-84.3793|Campbell||',
 'KYC039' => '36.8532|-88.9709|Carlisle||',
 'KYC041' => '38.6679|-85.1235|Carroll||',
 'KYC043' => '38.3181|-83.0495|Carter||',
 'KYC045' => '37.3223|-84.9283|Casey||',
 'KYC047' => '36.8941|-87.4904|Christian||',
 'KYC049' => '37.9709|-84.1475|Clark||',
 'KYC051' => '37.1598|-83.7146|Clay||',
 'KYC053' => '36.7275|-85.1361|Clinton||',
 'KYC055' => '37.3527|-88.0972|Crittenden||',
 'KYC057' => '36.7866|-85.3884|Cumberland||',
 'KYC059' => '37.7318|-87.0873|Daviess||',
 'KYC061' => '37.2087|-86.2385|Edmonson||',
 'KYC063' => '38.1179|-83.0976|Elliott||',
 'KYC065' => '37.6924|-83.9643|Estill||',
 'KYC067' => '38.0423|-84.4588|Fayette||',
 'KYC069' => '38.3701|-83.6967|Fleming||',
 'KYC071' => '37.5572|-82.7457|Floyd||',
 'KYC073' => '38.2391|-84.8770|Franklin||',
 'KYC075' => '36.5541|-89.1873|Fulton||',
 'KYC077' => '38.7569|-84.8592|Gallatin||',
 'KYC079' => '37.6396|-84.5376|Garrard||',
 'KYC081' => '38.6488|-84.6245|Grant||',
 'KYC083' => '36.7230|-88.6512|Graves||',
 'KYC085' => '37.4608|-86.3439|Grayson||',
 'KYC087' => '37.2639|-85.5531|Green||',
 'KYC089' => '38.5456|-82.9223|Greenup||',
 'KYC091' => '37.8415|-86.7780|Hancock||',
 'KYC093' => '37.6979|-85.9635|Hardin||',
 'KYC095' => '36.8570|-83.2179|Harlan||',
 'KYC097' => '38.4418|-84.3315|Harrison||',
 'KYC099' => '37.2999|-85.8847|Hart||',
 'KYC101' => '37.7961|-87.5729|Henderson||',
 'KYC103' => '38.4484|-85.1189|Henry||',
 'KYC105' => '36.6781|-88.9761|Hickman||',
 'KYC107' => '37.3088|-87.5410|Hopkins||',
 'KYC109' => '37.4198|-84.0058|Jackson||',
 'KYC111' => '38.1872|-85.6595|Jefferson||',
 'KYC113' => '37.8720|-84.5809|Jessamine||',
 'KYC115' => '37.8467|-82.8314|Johnson||',
 'KYC117' => '38.9334|-84.5331|Kenton||',
 'KYC119' => '37.3540|-82.9540|Knott||',
 'KYC121' => '36.8907|-83.8539|Knox||',
 'KYC123' => '37.5457|-85.6980|Larue||',
 'KYC125' => '37.1107|-84.1178|Laurel||',
 'KYC127' => '38.0679|-82.7347|Lawrence||',
 'KYC129' => '37.5947|-83.7163|Lee||',
 'KYC131' => '37.0941|-83.3811|Leslie||',
 'KYC133' => '37.1212|-82.8553|Letcher||',
 'KYC135' => '38.5317|-83.3781|Lewis||',
 'KYC137' => '37.4552|-84.6607|Lincoln||',
 'KYC139' => '37.2097|-88.3536|Livingston||',
 'KYC141' => '36.8597|-86.8789|Logan||',
 'KYC143' => '37.0191|-88.0832|Lyon||',
 'KYC145' => '37.0539|-88.7127|McCracken||',
 'KYC147' => '36.7371|-84.4841|McCreary||',
 'KYC149' => '37.5291|-87.2636|McLean||',
 'KYC151' => '37.7202|-84.2780|Madison||',
 'KYC153' => '37.7066|-83.0648|Magoffin||',
 'KYC155' => '37.5525|-85.2696|Marion||',
 'KYC157' => '36.8834|-88.3293|Marshall||',
 'KYC159' => '37.8016|-82.5132|Martin||',
 'KYC161' => '38.5952|-83.8240|Mason||',
 'KYC163' => '37.9695|-86.2169|Meade||',
 'KYC165' => '37.9414|-83.5989|Menifee||',
 'KYC167' => '37.8111|-84.8744|Mercer||',
 'KYC169' => '36.9905|-85.6291|Metcalfe||',
 'KYC171' => '36.7122|-85.7164|Monroe||',
 'KYC173' => '38.0336|-83.9132|Montgomery||',
 'KYC175' => '37.9223|-83.2589|Morgan||',
 'KYC177' => '37.2157|-87.1421|Muhlenberg||',
 'KYC179' => '37.8051|-85.4662|Nelson||',
 'KYC181' => '38.3356|-84.0153|Nicholas||',
 'KYC183' => '37.4783|-86.8490|Ohio||',
 'KYC185' => '38.3995|-85.4485|Oldham||',
 'KYC187' => '38.5197|-84.8280|Owen||',
 'KYC189' => '37.4192|-83.6832|Owsley||',
 'KYC191' => '38.6957|-84.3602|Pendleton||',
 'KYC193' => '37.2443|-83.2215|Perry||',
 'KYC195' => '37.4690|-82.3958|Pike||',
 'KYC197' => '37.8312|-83.8238|Powell||',
 'KYC199' => '37.1039|-84.5771|Pulaski||',
 'KYC201' => '38.5188|-84.0521|Robertson||',
 'KYC203' => '37.3652|-84.3160|Rockcastle||',
 'KYC205' => '38.1963|-83.4211|Rowan||',
 'KYC207' => '36.9911|-85.0586|Russell||',
 'KYC209' => '38.2915|-84.5839|Scott||',
 'KYC211' => '38.2155|-85.1948|Shelby||',
 'KYC213' => '36.7419|-86.5823|Simpson||',
 'KYC215' => '38.0325|-85.3279|Spencer||',
 'KYC217' => '37.3664|-85.3279|Taylor||',
 'KYC219' => '36.8356|-87.1791|Todd||',
 'KYC221' => '36.8064|-87.8734|Trigg||',
 'KYC223' => '38.6130|-85.3374|Trimble||',
 'KYC225' => '37.6584|-87.9453|Union||',
 'KYC227' => '36.9936|-86.4239|Warren||',
 'KYC229' => '37.7534|-85.1747|Washington||',
 'KYC231' => '36.8013|-84.8285|Wayne||',
 'KYC233' => '37.5183|-87.6832|Webster||',
 'KYC235' => '36.7582|-84.1452|Whitley||',
 'KYC237' => '37.7393|-83.4931|Wolfe||',
 'KYC239' => '38.0423|-84.7435|Woodford||',
 'KYZ001' => '36.5541|-89.1873|Fulton|Fulton|21075',
 'KYZ002' => '36.6781|-88.9761|Hickman|Hickman|21105',
 'KYZ003' => '36.8532|-88.9709|Carlisle|Carlisle|21039',
 'KYZ004' => '37.0584|-88.9992|Ballard|Ballard|21007',
 'KYZ005' => '37.0539|-88.7127|McCracken|McCracken|21145',
 'KYZ006' => '36.723|-88.6512|Graves|Graves|21083',
 'KYZ007' => '37.2097|-88.3536|Livingston|Livingston|21139',
 'KYZ008' => '36.8834|-88.3293|Marshall|Marshall|21157',
 'KYZ009' => '36.6211|-88.2723|Calloway|Calloway|21035',
 'KYZ010' => '37.3527|-88.0972|Crittenden|Crittenden|21055',
 'KYZ011' => '37.0191|-88.0832|Lyon|Lyon|21143',
 'KYZ012' => '36.8064|-87.8734|Trigg|Trigg|21221',
 'KYZ013' => '37.1453|-87.8679|Caldwell|Caldwell|21033',
 'KYZ014' => '37.6584|-87.9453|Union|Union|21225',
 'KYZ015' => '37.5183|-87.6832|Webster|Webster|21233',
 'KYZ016' => '37.3088|-87.5409|Hopkins|Hopkins|21107',
 'KYZ017' => '36.8941|-87.4904|Christian|Christian|21047',
 'KYZ018' => '37.7961|-87.5729|Henderson|Henderson|21101',
 'KYZ019' => '37.7318|-87.0873|Daviess|Daviess|21059',
 'KYZ020' => '37.5291|-87.2636|McLean|McLean|21149',
 'KYZ021' => '37.2157|-87.1421|Muhlenberg|Muhlenberg|21177',
 'KYZ022' => '36.8356|-87.1791|Todd|Todd|21219',
 'KYZ023' => '37.8415|-86.778|Hancock|Hancock|21091',
 'KYZ024' => '37.7732|-86.4293|Breckinridge|Breckinridge|21027',
 'KYZ025' => '37.9695|-86.2169|Meade|Meade|21163',
 'KYZ026' => '37.4783|-86.849|Ohio|Ohio|21183',
 'KYZ027' => '37.4608|-86.3439|Grayson|Grayson|21085',
 'KYZ028' => '37.6979|-85.9635|Hardin|Hardin|21093',
 'KYZ029' => '37.97|-85.6959|Bullitt|Bullitt|21029',
 'KYZ030' => '38.1872|-85.6595|Jefferson|Jefferson|21111',
 'KYZ031' => '38.3995|-85.4485|Oldham|Oldham|21185',
 'KYZ032' => '38.613|-85.3374|Trimble|Trimble|21223',
 'KYZ033' => '38.4484|-85.1189|Henry|Henry|21103',
 'KYZ034' => '38.2155|-85.1948|Shelby|Shelby|21211',
 'KYZ035' => '38.2391|-84.877|Franklin|Franklin|21073',
 'KYZ036' => '38.2915|-84.5839|Scott|Scott|21209',
 'KYZ037' => '38.4418|-84.3315|Harrison|Harrison|21097',
 'KYZ038' => '38.0325|-85.3279|Spencer|Spencer|21215',
 'KYZ039' => '38.004|-84.9909|Anderson|Anderson|21005',
 'KYZ040' => '38.0423|-84.7435|Woodford|Woodford|21239',
 'KYZ041' => '38.0423|-84.4588|Fayette|Fayette|21067',
 'KYZ042' => '38.2068|-84.2171|Bourbon|Bourbon|21017',
 'KYZ043' => '38.3356|-84.0153|Nicholas|Nicholas|21181',
 'KYZ044' => '38.3701|-83.6967|Fleming|Fleming|21069',
 'KYZ045' => '37.8051|-85.4662|Nelson|Nelson|21179',
 'KYZ046' => '37.7534|-85.1747|Washington|Washington|21229',
 'KYZ047' => '37.8111|-84.8744|Mercer|Mercer|21167',
 'KYZ048' => '37.872|-84.5809|Jessamine|Jessamine|21113',
 'KYZ049' => '37.9709|-84.1475|Clark|Clark|21049',
 'KYZ050' => '38.0336|-83.9132|Montgomery|Montgomery|21173',
 'KYZ051' => '38.1449|-83.7428|Bath|Bath|21011',
 'KYZ052' => '38.1963|-83.4211|Rowan|Rowan|21205',
 'KYZ053' => '37.5457|-85.698|Larue|Larue|21123',
 'KYZ054' => '37.5525|-85.2696|Marion|Marion|21155',
 'KYZ055' => '37.6244|-84.8667|Boyle|Boyle|21021',
 'KYZ056' => '37.6396|-84.5376|Garrard|Garrard|21079',
 'KYZ057' => '37.7202|-84.278|Madison|Madison|21151',
 'KYZ058' => '37.6924|-83.9643|Estill|Estill|21065',
 'KYZ059' => '37.8312|-83.8239|Powell|Powell|21197',
 'KYZ060' => '37.9414|-83.5989|Menifee|Menifee|21165',
 'KYZ061' => '37.2074|-86.6816|Butler|Butler|21031',
 'KYZ062' => '37.2087|-86.2385|Edmonson|Edmonson|21061',
 'KYZ063' => '37.2999|-85.8847|Hart|Hart|21099',
 'KYZ064' => '37.2639|-85.5531|Green|Green|21087',
 'KYZ065' => '37.3664|-85.3279|Taylor|Taylor|21217',
 'KYZ066' => '37.3223|-84.9283|Casey|Casey|21045',
 'KYZ067' => '37.4552|-84.6607|Lincoln|Lincoln|21137',
 'KYZ068' => '37.3652|-84.316|Rockcastle|Rockcastle|21203',
 'KYZ069' => '37.4198|-84.0058|Jackson|Jackson|21109',
 'KYZ070' => '36.8597|-86.8788|Logan|Logan|21141',
 'KYZ071' => '36.9936|-86.4239|Warren|Warren|21227',
 'KYZ072' => '36.7419|-86.5823|Simpson|Simpson|21213',
 'KYZ073' => '36.7513|-86.1904|Allen|Allen|21003',
 'KYZ074' => '36.9656|-85.9336|Barren|Barren|21009',
 'KYZ075' => '36.7122|-85.7164|Monroe|Monroe|21171',
 'KYZ076' => '36.9905|-85.6291|Metcalf|Metcalfe|21169',
 'KYZ077' => '37.1041|-85.2806|Adair|Adair|21001',
 'KYZ078' => '36.9911|-85.0586|Russell|Russell|21207',
 'KYZ079' => '37.1039|-84.5771|Pulaski|Pulaski|21199',
 'KYZ080' => '37.1107|-84.1178|Laurel|Laurel|21125',
 'KYZ081' => '36.7866|-85.3884|Cumberland|Cumberland|21057',
 'KYZ082' => '36.7275|-85.1361|Clinton|Clinton|21053',
 'KYZ083' => '36.8013|-84.8285|Wayne|Wayne|21231',
 'KYZ084' => '36.7371|-84.4841|McCreary|McCreary|21147',
 'KYZ085' => '36.7582|-84.1452|Whitley|Whitley|21235',
 'KYZ086' => '36.8907|-83.8539|Knox|Knox|21121',
 'KYZ087' => '36.7307|-83.674|Bell|Bell|21013',
 'KYZ088' => '36.857|-83.2179|Harlan|Harlan|21095',
 'KYZ089' => '38.6679|-85.1235|Carroll|Carroll|21041',
 'KYZ090' => '38.7569|-84.8592|Gallatin|Gallatin|21077',
 'KYZ091' => '38.97|-84.7279|Boone|Boone|21015',
 'KYZ092' => '38.9333|-84.5331|Kenton|Kenton|21117',
 'KYZ093' => '38.9465|-84.3793|Campbell|Campbell|21037',
 'KYZ094' => '38.5197|-84.828|Owen|Owen|21187',
 'KYZ095' => '38.6488|-84.6245|Grant|Grant|21081',
 'KYZ096' => '38.6957|-84.3602|Pendleton|Pendleton|21191',
 'KYZ097' => '38.6888|-84.0901|Bracken|Bracken|21023',
 'KYZ098' => '38.5188|-84.0521|Robertson|Robertson|21201',
 'KYZ099' => '38.5952|-83.824|Mason|Mason|21161',
 'KYZ100' => '38.5317|-83.3781|Lewis|Lewis|21135',
 'KYZ101' => '38.5456|-82.9223|Greenup|Greenup|21089',
 'KYZ102' => '38.3181|-83.0495|Carter|Carter|21043',
 'KYZ103' => '38.3596|-82.6877|Boyd|Boyd|21019',
 'KYZ104' => '38.1179|-83.0976|Elliott|Elliott|21063',
 'KYZ105' => '38.0679|-82.7347|Lawrence|Lawrence|21127',
 'KYZ106' => '37.9223|-83.2589|Morgan|Morgan|21175',
 'KYZ107' => '37.8467|-82.8314|Johnson|Johnson|21115',
 'KYZ108' => '37.7393|-83.4931|Wolfe|Wolfe|21237',
 'KYZ109' => '37.7066|-83.0648|Magoffin|Magoffin|21153',
 'KYZ110' => '37.5572|-82.7457|Floyd|Floyd|21071',
 'KYZ111' => '37.5947|-83.7163|Lee|Lee|21129',
 'KYZ112' => '37.5216|-83.3241|Breathitt|Breathitt|21025',
 'KYZ113' => '37.354|-82.954|Knott|Knott|21119',
 'KYZ114' => '37.4193|-83.6832|Owsley|Owsley|21189',
 'KYZ115' => '37.2443|-83.2215|Perry|Perry|21193',
 'KYZ116' => '37.1598|-83.7146|Clay|Clay|21051',
 'KYZ117' => '37.0941|-83.3811|Leslie|Leslie|21131',
 'KYZ118' => '37.1212|-82.8553|Letcher|Letcher|21133',
 'KYZ119' => '37.8016|-82.5132|Martin|Martin|21159',
 'KYZ120' => '37.469|-82.3958|Pike|Pike|21195',
 'LAC001' => '30.2906|-92.4120|Acadia||',
 'LAC003' => '30.6528|-92.8279|Allen||',
 'LAC005' => '30.2035|-90.9113|Ascension||',
 'LAC007' => '29.9006|-91.0626|Assumption||',
 'LAC009' => '31.0762|-92.0013|Avoyelles||',
 'LAC011' => '30.6485|-93.3434|Beauregard||',
 'LAC013' => '32.3472|-93.0560|Bienville||',
 'LAC015' => '32.6795|-93.6052|Bossier||',
 'LAC017' => '32.5797|-93.8821|Caddo||',
 'LAC019' => '30.2292|-93.3579|Calcasieu||',
 'LAC021' => '32.0922|-92.1167|Caldwell||',
 'LAC023' => '29.8717|-93.1618|Cameron||',
 'LAC025' => '31.6661|-91.8471|Catahoula||',
 'LAC027' => '32.8226|-92.9957|Claiborne||',
 'LAC029' => '31.4458|-91.6397|Concordia||',
 'LAC031' => '32.0554|-93.7373|De Soto||',
 'LAC033' => '30.5383|-91.0957|East Baton Rouge||',
 'LAC035' => '32.7325|-91.2350|East Carroll||',
 'LAC037' => '30.8451|-91.0455|East Feliciana||',
 'LAC039' => '30.7290|-92.4059|Evangeline||',
 'LAC041' => '32.1333|-91.6738|Franklin||',
 'LAC043' => '31.5997|-92.5594|Grant||',
 'LAC045' => '29.8941|-91.7307|Iberia||',
 'LAC047' => '30.2585|-91.3494|Iberville||',
 'LAC049' => '32.3020|-92.5577|Jackson||',
 'LAC051' => '29.7299|-90.1174|Jefferson||',
 'LAC053' => '30.2669|-92.8138|Jefferson Davis||',
 'LAC055' => '30.2063|-92.0639|Lafayette||',
 'LAC057' => '29.5682|-90.4291|Lafourche||',
 'LAC059' => '31.6767|-92.1604|La Salle||',
 'LAC061' => '32.6016|-92.6647|Lincoln||',
 'LAC063' => '30.4507|-90.7393|Livingston||',
 'LAC065' => '32.3643|-91.2427|Madison||',
 'LAC067' => '32.8205|-91.8017|Morehouse||',
 'LAC069' => '31.7236|-93.0963|Natchitoches||',
 'LAC071' => '30.0385|-89.9037|Orleans||',
 'LAC073' => '32.4785|-92.1545|Ouachita||',
 'LAC075' => '29.4705|-89.6553|Plaquemines||',
 'LAC077' => '30.7097|-91.6009|Pointe Coupee||',
 'LAC079' => '31.1986|-92.5332|Rapides||',
 'LAC081' => '32.0933|-93.3400|Red River||',
 'LAC083' => '32.4177|-91.7636|Richland||',
 'LAC085' => '31.5640|-93.5547|Sabine||',
 'LAC087' => '29.8628|-89.6178|St. Bernard||',
 'LAC089' => '29.8836|-90.3631|St. Charles||',
 'LAC091' => '30.8220|-90.7103|St. Helena||',
 'LAC093' => '30.0263|-90.7962|St. James||',
 'LAC095' => '30.0792|-90.5462|St. John The Baptist||',
 'LAC097' => '30.5989|-92.0058|St. Landry||',
 'LAC099' => '30.1291|-91.6083|St. Martin||',
 'LAC101' => '29.7196|-91.4494|St. Mary||',
 'LAC103' => '30.4481|-89.9401|St. Tammany||',
 'LAC105' => '30.6453|-90.4118|Tangipahoa||',
 'LAC107' => '32.0016|-91.3400|Tensas||',
 'LAC109' => '29.4206|-90.8659|Terrebonne||',
 'LAC111' => '32.8319|-92.3748|Union||',
 'LAC113' => '29.8455|-92.3241|Vermilion||',
 'LAC115' => '31.1083|-93.1842|Vernon||',
 'LAC117' => '30.8534|-90.0406|Washington||',
 'LAC119' => '32.7135|-93.3350|Webster||',
 'LAC121' => '30.4634|-91.3134|West Baton Rouge||',
 'LAC123' => '32.7885|-91.4567|West Carroll||',
 'LAC125' => '30.8798|-91.4200|West Feliciana||',
 'LAC127' => '31.9442|-92.6368|Winn||',
 'LAZ001' => '32.5797|-93.8821|Caddo|Caddo|22017',
 'LAZ002' => '32.6794|-93.6052|Bossier|Bossier|22015',
 'LAZ003' => '32.7135|-93.335|Webster|Webster|22119',
 'LAZ004' => '32.8226|-92.9957|Claiborne|Claiborne|22027',
 'LAZ005' => '32.6016|-92.6647|Lincoln|Lincoln|22061',
 'LAZ006' => '32.8319|-92.3748|Union|Union|22111',
 'LAZ007' => '32.8205|-91.8017|Morehouse|Morehouse|22067',
 'LAZ008' => '32.7885|-91.4567|West Carroll|West Carroll|22123',
 'LAZ009' => '32.7326|-91.2351|East Carroll|East Carroll|22035',
 'LAZ010' => '32.0554|-93.7373|De Soto|De Soto|22031',
 'LAZ011' => '32.0933|-93.34|Red River|Red River|22081',
 'LAZ012' => '32.3472|-93.056|Bienville|Bienville|22013',
 'LAZ013' => '32.302|-92.5577|Jackson|Jackson|22049',
 'LAZ014' => '32.4785|-92.1545|Ouachita|Ouachita|22073',
 'LAZ015' => '32.4177|-91.7636|Richland|Richland|22083',
 'LAZ016' => '32.3643|-91.2427|Madison|Madison|22065',
 'LAZ017' => '31.564|-93.5547|Sabine|Sabine|22085',
 'LAZ018' => '31.7236|-93.0963|Natchitoches|Natchitoches|22069',
 'LAZ019' => '31.9442|-92.6368|Winn|Winn|22127',
 'LAZ020' => '31.5997|-92.5594|Grant|Grant|22043',
 'LAZ021' => '32.0922|-92.1167|Caldwell|Caldwell|22021',
 'LAZ022' => '31.6767|-92.1604|La Salle|La Salle|22059',
 'LAZ023' => '32.1332|-91.6738|Franklin|Franklin|22041',
 'LAZ024' => '31.6661|-91.8471|Catahoula|Catahoula|22025',
 'LAZ025' => '32.0017|-91.34|Tensas|Tensas|22107',
 'LAZ026' => '31.4458|-91.6397|Concordia|Concordia|22029',
 'LAZ027' => '31.1083|-93.1842|Vernon|Vernon|22115',
 'LAZ028' => '31.1986|-92.5332|Rapides|Rapides|22079',
 'LAZ029' => '31.0762|-92.0013|Avoyelles|Avoyelles|22009',
 'LAZ030' => '30.6485|-93.3434|Beauregard|Beauregard|22011',
 'LAZ031' => '30.6528|-92.8279|Allen|Allen|22003',
 'LAZ032' => '30.729|-92.4059|Evangeline|Evangeline|22039',
 'LAZ033' => '30.5989|-92.0058|St. Landry|St. Landry|22097',
 'LAZ034' => '30.7097|-91.6009|Pointe Coupee|Pointe Coupee|22077',
 'LAZ035' => '30.8798|-91.42|West Feliciana|West Feliciana|22125',
 'LAZ036' => '30.8451|-91.0455|East Feliciana|East Feliciana|22037',
 'LAZ037' => '30.822|-90.7103|St. Helena|St. Helena|22091',
 'LAZ039' => '30.8534|-90.0405|Washington|Washington|22117',
 'LAZ044' => '30.2063|-92.0639|Lafayette|Lafayette|22055',
 'LAZ045' => '30.2282|-91.7267|Upper St. Martin|St. Martin|22099',
 'LAZ046' => '30.2585|-91.3494|Iberville|Iberville|22047',
 'LAZ047' => '30.4634|-91.3134|West Baton Rouge|West Baton Rouge|22121',
 'LAZ048' => '30.5383|-91.0957|East Baton Rouge|East Baton Rouge|22033',
 'LAZ055' => '29.8466|-91.2705|Lower St. Martin|St. Martin|22099',
 'LAZ056' => '29.9006|-91.0626|Assumption|Assumption|22007',
 'LAZ057' => '30.0263|-90.7962|St. James|St. James|22093',
 'LAZ058' => '30.0792|-90.5462|St. John The Baptist|St. John The Baptist|22095',
 'LAZ059' => '29.7251|-90.5707|Upper Lafourche|Lafourche|22057',
 'LAZ060' => '29.8836|-90.363|St. Charles|St. Charles|22089',
 'LAZ064' => '29.913|-89.874|Upper St. Bernard|St. Bernard|22087',
 'LAZ065' => '29.639|-90.8383|Upper Terrebonne|Terrebonne|22109',
 'LAZ066' => '29.3727|-90.8628|Lower Terrebonne|Terrebonne|22109',
 'LAZ067' => '29.3739|-90.2534|Lower Lafourche|Lafourche|22057',
 'LAZ068' => '29.5064|-90.0566|Coastal Jefferson|Jefferson|22051',
 'LAZ069' => '29.4206|-89.6038|Lower Plaquemines|Plaquemines|22075',
 'LAZ070' => '29.8488|-89.5466|Lower St. Bernard|St. Bernard|22087',
 'LAZ071' => '30.8274|-90.4379|Northern Tangipahoa|Tangipahoa|22105',
 'LAZ073' => '29.8677|-93.146|West Cameron|Cameron|22023',
 'LAZ074' => '29.8677|-93.146|East Cameron|Cameron|22023',
 'LAZ076' => '30.2377|-89.7162|Southeast St. Tammany|St. Tammany|22103',
 'LAZ077' => '29.9827|-90.0257|Western Orleans|Orleans|22071',
 'LAZ078' => '30.0867|-89.7981|Eastern Orleans|Orleans|22071',
 'LAZ079' => '30.5081|-89.9603|Northern St. Tammany|St. Tammany|22103',
 'LAZ080' => '30.3605|-90.0385|Southwestern St. Tammany|St. Tammany|22103',
 'LAZ081' => '30.5718|-90.4031|Central Tangipahoa|Tangipahoa|22105',
 'LAZ082' => '30.3899|-90.372|Lower Tangipahoa|Tangipahoa|22105',
 'LAZ083' => '30.505|-90.7744|Northern Livingston|Livingston|22063',
 'LAZ084' => '30.3135|-90.6508|Southern Livingston|Livingston|22063',
 'LAZ085' => '30.207|-90.9623|Western Ascension|Ascension|22005',
 'LAZ086' => '30.1944|-90.7769|Eastern Ascension|Ascension|22005',
 'LAZ087' => '29.9317|-90.1645|Upper Jefferson|Jefferson|22051',
 'LAZ088' => '29.7222|-90.1222|Lower Jefferson|Jefferson|22051',
 'LAZ089' => '29.8465|-90.0107|Upper Plaquemines|Plaquemines|22075',
 'LAZ090' => '29.7668|-89.9679|Central Plaquemines|Plaquemines|22075',
 'LAZ125' => '30.0498|-92.2739|Upper Vermilion|Vermilion|22113',
 'LAZ141' => '30.3127|-93.4199|Northern Calcasieu|Calcasieu|22019',
 'LAZ142' => '30.3481|-92.8227|Northern Jefferson Davis|Jefferson Davis|22053',
 'LAZ143' => '30.3309|-92.4024|Northern Acadia|Acadia|22001',
 'LAZ153' => '30.0091|-91.6312|Upper Iberia|Iberia|22045',
 'LAZ154' => '29.8162|-91.4287|Upper St. Mary|St. Mary|22101',
 'LAZ241' => '30.1333|-93.2867|Southern Calcasieu|Calcasieu|22019',
 'LAZ242' => '30.1392|-92.7996|Southern Jefferson Davis|Jefferson Davis|22053',
 'LAZ243' => '30.1309|-92.45|Southern Acadia|Acadia|22001',
 'LAZ252' => '29.7894|-92.3378|Lower Vermilion|Vermilion|22113',
 'LAZ253' => '29.7499|-91.8554|Lower Iberia|Iberia|22045',
 'LAZ254' => '29.671|-91.4596|Lower St. Mary|St. Mary|22101',
 'MAC001' => '41.7257|-70.2982|Barnstable||',
 'MAC003' => '42.3706|-73.2064|Berkshire||',
 'MAC005' => '41.8020|-71.1153|Bristol||',
 'MAC007' => '41.3966|-70.6561|Dukes||',
 'MAC009' => '42.6729|-70.9581|Essex||',
 'MAC011' => '42.5831|-72.5919|Franklin||',
 'MAC013' => '42.1351|-72.6316|Hampden||',
 'MAC015' => '42.3401|-72.6638|Hampshire||',
 'MAC017' => '42.4855|-71.3918|Middlesex||',
 'MAC019' => '41.2781|-70.0744|Nantucket||',
 'MAC021' => '42.1550|-71.2248|Norfolk||',
 'MAC023' => '41.9547|-70.8129|Plymouth||',
 'MAC025' => '42.3308|-71.0818|Suffolk||',
 'MAC027' => '42.3514|-71.9077|Worcester||',
 'MAZ001' => '42.56|-73.1518|Northern Berkshire|Berkshire|25003',
 'MAZ002' => '42.6171|-72.7907|Western Franklin|Franklin|25011',
 'MAZ003' => '42.5591|-72.4514|Eastern Franklin|Franklin|25011',
 'MAZ004' => '42.4539|-71.9778|Northern Worcester|Worcester|25027',
 'MAZ005' => '42.4633|-71.3797|Central Middlesex County|Middlesex|25017',
 'MAZ006' => '42.7153|-71.0659|Western Essex|Essex|25009',
 'MAZ007' => '42.6372|-70.8674|Eastern Essex|Essex|25009',
 'MAZ008' => '42.3891|-72.8687|Western Hampshire|Hampshire|25015',
 'MAZ009' => '42.1675|-72.9334|Western Hampden|Hampden|25013',
 'MAZ010' => '42.3044|-72.5146|Eastern Hampshire|Hampshire|25015',
 'MAZ011' => '42.1202|-72.493|Eastern Hampden|Hampden|25013',
 'MAZ012' => '42.1513|-71.7709|Southern Worcester|Worcester|25027',
 'MAZ013' => '42.1423|-71.2658|Western Norfolk|Norfolk|25021',
 'MAZ014' => '42.4193|-71.157|Southeast Middlesex|Middlesex|25017',
 'MAZ015' => '42.3308|-71.0826|Suffolk|Norfolk|25021	42.3308|-71.0826|Suffolk|Suffolk|25025',
 'MAZ016' => '42.2217|-71.0093|Eastern Norfolk|Norfolk|25021',
 'MAZ017' => '41.9171|-71.1849|Northern Bristol|Bristol|25005',
 'MAZ018' => '41.9679|-70.8932|Western Plymouth|Plymouth|25023',
 'MAZ019' => '42.0271|-70.7171|Eastern Plymouth|Norfolk|25021	42.0271|-70.7171|Eastern Plymouth|Plymouth|25023',
 'MAZ020' => '41.6746|-71.0384|Southern Bristol|Bristol|25005',
 'MAZ021' => '41.7415|-70.7761|Southern Plymouth|Plymouth|25023',
 'MAZ022' => '41.7262|-70.2986|Barnstable|Barnstable|25001',
 'MAZ023' => '41.3966|-70.6561|Dukes|Dukes|25007',
 'MAZ024' => '41.2781|-70.0744|Nantucket|Nantucket|25019',
 'MAZ025' => '42.2158|-73.2511|Southern Berkshire|Berkshire|25003',
 'MAZ026' => '42.6386|-71.6598|Northwest Middlesex County|Middlesex|25017',
 'MDC001' => '39.6215|-78.6989|Allegany||',
 'MDC003' => '38.9332|-76.5279|Anne Arundel||	39.0074|-76.6088|Anne Arundel||',
 'MDC005' => '39.2950|-76.4054|Baltimore||	39.4664|-76.6448|Baltimore||',
 'MDC009' => '38.5529|-76.5696|Calvert||	38.3838|-76.4805|Calvert||',
 'MDC011' => '38.8717|-75.8317|Caroline||',
 'MDC013' => '39.5631|-77.0228|Carroll||',
 'MDC015' => '39.5750|-75.9384|Cecil||	39.5606|-76.0103|Cecil||',
 'MDC017' => '38.5077|-76.9899|Charles||	38.3930|-76.9809|Charles||',
 'MDC019' => '38.5492|-76.1372|Dorchester||	38.4797|-76.0083|Dorchester||',
 'MDC021' => '39.4722|-77.3981|Frederick||',
 'MDC023' => '39.5286|-79.2739|Garrett||',
 'MDC025' => '39.5616|-76.3194|Harford||	39.5818|-76.1813|Harford||',
 'MDC027' => '39.2510|-76.9315|Howard||',
 'MDC029' => '39.2574|-76.0362|Kent||	39.1548|-76.1543|Kent||',
 'MDC031' => '39.1363|-77.2041|Montgomery||',
 'MDC033' => '38.7014|-77.0099|Prince Georges||	38.8313|-76.8436|Prince Georges||',
 'MDC035' => '38.9890|-76.1834|Queen Anne\'s||	39.0738|-76.0131|Queen Anne\'s||',
 'MDC037' => '38.3052|-76.6076|St. Marys||	38.2729|-76.6202|St. Marys||',
 'MDC039' => '38.0910|-75.8241|Somerset||	38.1190|-75.7449|Somerset||',
 'MDC041' => '38.7767|-76.0892|Talbot||	38.7175|-76.1393|Talbot||',
 'MDC043' => '39.6037|-77.8142|Washington||',
 'MDC045' => '38.3734|-75.6210|Wicomico||	38.2520|-75.8431|Wicomico||',
 'MDC047' => '38.1195|-75.4976|Worcester||	38.2186|-75.3568|Worcester||',
 'MDC510' => '39.3087|-76.6163|Baltimore City||	39.2531|-76.5758|Baltimore City||',
 'MDZ001' => '39.5286|-79.2739|Garrett|Garrett|24023',
 'MDZ003' => '39.6037|-77.8142|Washington|Washington|24043',
 'MDZ004' => '39.4722|-77.3981|Frederick|Frederick|24021',
 'MDZ005' => '39.5631|-77.0227|Carroll|Carroll|24013',
 'MDZ006' => '39.5444|-76.6677|Northern Baltimore|Baltimore|24005',
 'MDZ008' => '39.4885|-75.9418|Cecil|Cecil|24015	39.5749|-75.9384|Cecil|Cecil|24015',
 'MDZ011' => '39.2929|-76.4049|Southern Baltimore|Baltimore|24005	39.3312|-76.6096|Southern Baltimore|Baltimore|24005	39.3312|-76.6096|Southern Baltimore|Baltimore City|24510',
 'MDZ012' => '39.1797|-76.116|Kent|Kent|24029	39.2574|-76.0362|Kent|Kent|24029',
 'MDZ013' => '38.8313|-76.8436|Prince Georges|Prince Georges|24033',
 'MDZ014' => '38.933|-76.528|Anne Arundel|Anne Arundel|24003	39.0074|-76.6088|Anne Arundel|Anne Arundel|24003',
 'MDZ015' => '39.0705|-76.0196|Queen Anne\'s|Queen Anne\'s|24035	39.0705|-76.0196|Queen Anne\'s|Queen Anne\'s|24035',
 'MDZ016' => '38.3923|-76.9809|Charles|Charles|24017	38.5078|-76.99|Charles|Charles|24017',
 'MDZ017' => '38.2233|-76.6289|St. Marys|St. Marys|24037	38.3046|-76.6081|St. Marys|St. Marys|24037',
 'MDZ018' => '38.5513|-76.5696|Calvert|Calvert|24009',
 'MDZ019' => '38.7739|-76.0928|Talbot|Talbot|24041',
 'MDZ020' => '38.8717|-75.8317|Caroline|Caroline|24011',
 'MDZ021' => '38.4799|-76.008|Dorchester|Dorchester|24019',
 'MDZ022' => '38.3737|-75.6193|Wicomico|Wicomico|24045',
 'MDZ023' => '38.1188|-75.7449|Somerset|Somerset|24039',
 'MDZ024' => '38.2142|-75.3833|Inland Worcester|Worcester|24047',
 'MDZ025' => '38.251|-75.1598|Maryland Beaches|Worcester|24047',
 'MDZ501' => '39.6015|-78.9284|Extreme Western Allegany|Allegany|24001',
 'MDZ502' => '39.6304|-78.597|Central and Eastern Allegany|Allegany|24001',
 'MDZ503' => '39.1949|-77.3233|Northwest Montgomery|Montgomery|24031',
 'MDZ504' => '39.0917|-77.1134|Central and Southeast Montgomery|Montgomery|24031',
 'MDZ505' => '39.3234|-77.0597|Northwest Howard|Howard|24027',
 'MDZ506' => '39.2259|-76.8872|Central and Southeast Howard|Howard|24027',
 'MDZ507' => '39.6258|-76.3985|Northwest Harford|Harford|24025',
 'MDZ508' => '39.6395|-76.3985|Southeast Harford|Harford|24025',
 'MEC001' => '44.1654|-70.2045|Androscoggin||',
 'MEC003' => '46.6588|-68.5988|Aroostook||',
 'MEC005' => '43.8487|-70.4096|Cumberland||',
 'MEC007' => '44.9740|-70.4440|Franklin||',
 'MEC009' => '44.6749|-68.3531|Hancock||',
 'MEC011' => '44.4093|-69.7672|Kennebec||',
 'MEC013' => '44.1500|-69.1730|Knox||',
 'MEC015' => '44.0752|-69.5431|Lincoln||',
 'MEC017' => '44.4990|-70.7555|Oxford||',
 'MEC019' => '45.4006|-68.6494|Penobscot||',
 'MEC021' => '45.8380|-69.2835|Piscataquis||',
 'MEC023' => '43.9705|-69.8613|Sagadahoc||',
 'MEC025' => '45.5138|-69.9582|Somerset||',
 'MEC027' => '44.5037|-69.1478|Waldo||',
 'MEC029' => '45.0363|-67.6361|Washington||',
 'MEC031' => '43.4796|-70.7156|York||',
 'MEZ001' => '46.948|-69.1077|Northwest Aroostook|Aroostook|23003',
 'MEZ002' => '46.7264|-68.2182|Northeast Aroostook|Aroostook|23003',
 'MEZ003' => '46.2366|-69.9716|Northern Somerset|Somerset|23025',
 'MEZ004' => '46.1825|-69.24|Northern Piscataquis|Piscataquis|23021',
 'MEZ005' => '45.9454|-68.6456|Northern Penobscot|Penobscot|23019',
 'MEZ006' => '46.0031|-68.1173|Southeast Aroostook|Aroostook|23003',
 'MEZ007' => '44.8431|-70.8789|Northern Oxford|Oxford|23017',
 'MEZ008' => '45.0717|-70.5249|Northern Franklin|Franklin|23007',
 'MEZ009' => '45.48|-70.068|Central Somerset|Somerset|23025',
 'MEZ010' => '45.5609|-69.4281|Central Piscataquis|Piscataquis|23021',
 'MEZ011' => '45.3901|-68.4069|Central Penobscot|Penobscot|23019',
 'MEZ012' => '44.2631|-70.6709|Southern Oxford|Oxford|23017',
 'MEZ013' => '44.6571|-70.1818|Southern Franklin|Franklin|23007',
 'MEZ014' => '44.8398|-69.6632|Southern Somerset|Somerset|23025',
 'MEZ015' => '44.9362|-68.8441|Southern Penobscot|Penobscot|23019',
 'MEZ016' => '44.851|-68.3239|Interior Hancock|Hancock|23009',
 'MEZ017' => '45.0093|-67.6338|Central Washington|Washington|23029',
 'MEZ018' => '43.559|-70.7784|Interior York|York|23031',
 'MEZ019' => '43.8563|-70.4616|Central Interior Cumberland|Cumberland|23005',
 'MEZ020' => '44.1654|-70.2045|Androscoggin|Androscoggin|23001',
 'MEZ021' => '44.4093|-69.7672|Kennebec|Kennebec|23011',
 'MEZ022' => '44.5406|-69.1709|Interior Waldo|Waldo|23027',
 'MEZ023' => '43.3339|-70.6005|Coastal York|York|23031',
 'MEZ024' => '43.7449|-70.186|Coastal Cumberland|Cumberland|23005',
 'MEZ025' => '43.9705|-69.8613|Sagadahoc|Sagadahoc|23023',
 'MEZ026' => '44.0752|-69.5431|Lincoln|Lincoln|23015',
 'MEZ027' => '44.15|-69.173|Knox|Knox|23013',
 'MEZ028' => '44.349|-69.0512|Coastal Waldo|Waldo|23027',
 'MEZ029' => '44.4349|-68.3928|Coastal Hancock|Hancock|23009',
 'MEZ030' => '44.6796|-67.5411|Coastal Washington|Washington|23029',
 'MEZ031' => '45.2475|-69.1568|Southern Piscataquis|Piscataquis|23021',
 'MEZ032' => '45.4766|-67.7419|Northern Washington|Washington|23029',
 'MEZ033' => '44.0404|-70.6904|Interior Cumberland Highlands|Cumberland|23005',
 'MHC010' => '7.3959|168.7633|Ailinglaplap||',
 'MHC040' => '7.0602|171.7228|Arno||',
 'MHC090' => '11.4745|162.3155|Enewetak||',
 'MHC120' => '5.9418|169.6133|Jaluit||',
 'MHC150' => '9.0685|167.4829|Kwajalein||',
 'MHC190' => '7.1086|171.1789|Majuro||',
 'MHC320' => '6.0564|171.9031|Mili||',
 'MHC390' => '9.1107|165.6317|Ujae||',
 'MHC410' => '11.2304|169.8404|Utrok||',
 'MHC430' => '9.4713|170.1603|Wotje||',
 'MHZ001' => '7.0602|171.7228|Arno|Arno|68040',
 'MHZ002' => '7.1086|171.1789|Majuro|Majuro|68190',
 'MHZ003' => '9.4713|170.1603|Wotje|Wotje|68430',
 'MHZ004' => '6.0564|171.9031|Mili|Mili|68320',
 'MHZ005' => '11.2304|169.8404|Utrok|Utrok|68410',
 'MHZ006' => '5.9418|169.6133|Jaluit|Jaluit|68120',
 'MHZ007' => '7.3959|168.7633|Ailinglaplap|Ailinglaplap|68010',
 'MHZ008' => '9.0685|167.4829|Kwajalein|Kwajalein|68150',
 'MHZ009' => '9.1107|165.6317|Ujae|Ujae|68390',
 'MHZ010' => '11.4745|162.3155|Enewetak|Enewetak|68090',
 'MIC001' => '44.6854|-83.5938|Alcona||',
 'MIC003' => '46.4099|-86.6018|Alger||',
 'MIC005' => '42.5913|-85.8884|Allegan||',
 'MIC007' => '45.0348|-83.6277|Alpena||',
 'MIC009' => '45.0003|-85.1377|Antrim||',
 'MIC011' => '44.0656|-83.8948|Arenac||',
 'MIC013' => '46.6626|-88.3652|Baraga||',
 'MIC015' => '42.5950|-85.3090|Barry||',
 'MIC017' => '43.7072|-83.9921|Bay||',
 'MIC019' => '44.6395|-86.0158|Benzie||',
 'MIC021' => '41.9546|-86.4123|Berrien||',
 'MIC023' => '41.9161|-85.0590|Branch||',
 'MIC025' => '42.2466|-85.0055|Calhoun||',
 'MIC027' => '41.9153|-85.9936|Cass||',
 'MIC029' => '45.3020|-85.1283|Charlevoix||',
 'MIC031' => '45.4468|-84.4999|Cheboygan||',
 'MIC033' => '46.3031|-84.5921|Chippewa||',
 'MIC035' => '43.9879|-84.8478|Clare||',
 'MIC037' => '42.9436|-84.6015|Clinton||',
 'MIC039' => '44.6836|-84.6103|Crawford||',
 'MIC041' => '45.9197|-86.9244|Delta||',
 'MIC043' => '46.0091|-87.8704|Dickinson||',
 'MIC045' => '42.5961|-84.8384|Eaton||',
 'MIC047' => '45.5205|-84.8905|Emmet||',
 'MIC049' => '43.0217|-83.7067|Genesee||',
 'MIC051' => '43.9906|-84.3882|Gladwin||',
 'MIC053' => '46.4089|-89.6944|Gogebic||',
 'MIC055' => '44.6709|-85.5590|Grand Traverse||',
 'MIC057' => '43.2927|-84.6048|Gratiot||',
 'MIC059' => '41.8878|-84.5930|Hillsdale||',
 'MIC061' => '46.8934|-88.6918|Houghton||',
 'MIC063' => '43.8333|-83.0193|Huron||',
 'MIC065' => '42.5971|-84.3736|Ingham||',
 'MIC067' => '42.9451|-85.0746|Ionia||',
 'MIC069' => '44.3559|-83.6360|Iosco||',
 'MIC071' => '46.2087|-88.5305|Iron||',
 'MIC073' => '43.6406|-84.8467|Isabella||',
 'MIC075' => '42.2485|-84.4233|Jackson||',
 'MIC077' => '42.2454|-85.5311|Kalamazoo||',
 'MIC079' => '44.6846|-85.0902|Kalkaska||',
 'MIC081' => '43.0322|-85.5492|Kent||',
 'MIC083' => '47.6104|-88.4287|Keweenaw||',
 'MIC085' => '43.9900|-85.8017|Lake||',
 'MIC087' => '43.0901|-83.2218|Lapeer||',
 'MIC089' => '44.9366|-85.8123|Leelanau||',
 'MIC091' => '41.8951|-84.0664|Lenawee||',
 'MIC093' => '42.6030|-83.9115|Livingston||',
 'MIC095' => '46.4707|-85.5443|Luce||',
 'MIC097' => '46.0812|-85.0921|Mackinac||',
 'MIC099' => '42.6956|-82.9322|Macomb||',
 'MIC101' => '44.3332|-86.0571|Manistee||',
 'MIC103' => '46.4314|-87.6415|Marquette||',
 'MIC105' => '43.9954|-86.2497|Mason||	43.9392|-86.4421|Mason||',
 'MIC107' => '43.6409|-85.3245|Mecosta||',
 'MIC109' => '45.5792|-87.5573|Menominee||',
 'MIC111' => '43.6468|-84.3879|Midland||',
 'MIC113' => '44.3373|-85.0947|Missaukee||',
 'MIC115' => '41.9292|-83.5373|Monroe||',
 'MIC117' => '43.3110|-85.1524|Montcalm||',
 'MIC119' => '45.0276|-84.1273|Montmorency||',
 'MIC121' => '43.2912|-86.1481|Muskegon||	43.2922|-86.3219|Muskegon||',
 'MIC123' => '43.5542|-85.8009|Newaygo||',
 'MIC125' => '42.6604|-83.3855|Oakland||',
 'MIC127' => '43.6407|-86.2673|Oceana||	43.7692|-86.4212|Oceana||',
 'MIC129' => '44.3349|-84.1266|Ogemaw||',
 'MIC131' => '46.6644|-89.3150|Ontonagon||',
 'MIC133' => '43.9899|-85.3252|Osceola||',
 'MIC135' => '44.6817|-84.1297|Oscoda||',
 'MIC137' => '45.0214|-84.5988|Otsego||',
 'MIC139' => '42.9435|-86.1799|Ottawa||	42.9601|-85.9939|Ottawa||',
 'MIC141' => '45.3402|-83.9173|Presque Isle||',
 'MIC143' => '44.3356|-84.6116|Roscommon||',
 'MIC145' => '43.3350|-84.0532|Saginaw||',
 'MIC147' => '42.9425|-82.6823|St. Clair||',
 'MIC149' => '41.9145|-85.5278|St. Joseph||',
 'MIC151' => '43.4235|-82.8201|Sanilac||',
 'MIC153' => '46.1967|-86.1995|Schoolcraft||',
 'MIC155' => '42.9537|-84.1467|Shiawassee||',
 'MIC157' => '43.4641|-83.4168|Tuscola||',
 'MIC159' => '42.2513|-86.0189|Van Buren||',
 'MIC161' => '42.2534|-83.8384|Washtenaw||',
 'MIC163' => '42.2840|-83.2865|Wayne||',
 'MIC165' => '44.3384|-85.5785|Wexford||',
 'MIZ001' => '47.6027|-88.422|Keweenaw|Keweenaw|26083',
 'MIZ002' => '46.6644|-89.315|Ontonagon|Ontonagon|26131',
 'MIZ003' => '47.0531|-88.6207|Houghton|Houghton|26061',
 'MIZ004' => '46.6626|-88.3652|Baraga|Baraga|26013',
 'MIZ005' => '46.4314|-87.6415|Marquette|Marquette|26103',
 'MIZ006' => '46.4099|-86.6019|Alger|Alger|26003',
 'MIZ007' => '46.4707|-85.5443|Luce|Luce|26095',
 'MIZ009' => '46.4089|-89.6944|Gogebic|Gogebic|26053',
 'MIZ010' => '46.2087|-88.5306|Iron|Iron|26071',
 'MIZ011' => '46.0091|-87.8704|Dickinson|Dickinson|26043',
 'MIZ012' => '45.5792|-87.5573|Menominee|Menominee|26109',
 'MIZ013' => '45.9197|-86.9244|Delta|Delta|26041',
 'MIZ014' => '46.052|-86.1917|Southern Schoolcraft|Schoolcraft|26153',
 'MIZ016' => '45.5205|-84.8905|Emmet|Emmet|26047',
 'MIZ017' => '45.4468|-84.4999|Cheboygan|Cheboygan|26031',
 'MIZ018' => '45.3396|-83.9159|Presque Isle|Presque Isle|26141',
 'MIZ020' => '44.9367|-85.8123|Leelanau|Leelanau|26089',
 'MIZ021' => '45.0003|-85.1377|Antrim|Antrim|26009',
 'MIZ022' => '45.0214|-84.5988|Otsego|Otsego|26137',
 'MIZ023' => '45.0275|-84.1273|Montmorency|Montmorency|26119',
 'MIZ024' => '45.0347|-83.6285|Alpena|Alpena|26007',
 'MIZ025' => '44.6395|-86.0158|Benzie|Benzie|26019',
 'MIZ026' => '44.6709|-85.559|Grand Traverse|Grand Traverse|26055',
 'MIZ027' => '44.6846|-85.0902|Kalkaska|Kalkaska|26079',
 'MIZ028' => '44.6836|-84.6103|Crawford|Crawford|26039',
 'MIZ029' => '44.6817|-84.1297|Oscoda|Oscoda|26135',
 'MIZ030' => '44.6854|-83.5938|Alcona|Alcona|26001',
 'MIZ031' => '44.3332|-86.0571|Manistee|Manistee|26101',
 'MIZ032' => '44.3384|-85.5785|Wexford|Wexford|26165',
 'MIZ033' => '44.3373|-85.0947|Missaukee|Missaukee|26113',
 'MIZ034' => '44.3356|-84.6116|Roscommon|Roscommon|26143',
 'MIZ035' => '44.3349|-84.1266|Ogemaw|Ogemaw|26129',
 'MIZ036' => '44.3559|-83.636|Iosco|Iosco|26069',
 'MIZ037' => '43.9954|-86.2497|Mason|Mason|26105',
 'MIZ038' => '43.99|-85.8017|Lake|Lake|26085',
 'MIZ039' => '43.9899|-85.3252|Osceola|Osceola|26133',
 'MIZ040' => '43.9879|-84.8478|Clare|Clare|26035',
 'MIZ041' => '43.9906|-84.3882|Gladwin|Gladwin|26051',
 'MIZ042' => '44.0656|-83.8948|Arenac|Arenac|26011',
 'MIZ043' => '43.6407|-86.2673|Oceana|Oceana|26127',
 'MIZ044' => '43.5542|-85.8009|Newaygo|Newaygo|26123',
 'MIZ045' => '43.6409|-85.3245|Mecosta|Mecosta|26107',
 'MIZ046' => '43.6406|-84.8467|Isabella|Isabella|26073',
 'MIZ047' => '43.6468|-84.3879|Midland|Midland|26111',
 'MIZ048' => '43.7072|-83.9921|Bay|Bay|26017',
 'MIZ049' => '43.8333|-83.0193|Huron|Huron|26063',
 'MIZ050' => '43.2912|-86.1481|Muskegon|Muskegon|26121',
 'MIZ051' => '43.311|-85.1524|Montcalm|Montcalm|26117',
 'MIZ052' => '43.2927|-84.6048|Gratiot|Gratiot|26057',
 'MIZ053' => '43.335|-84.0532|Saginaw|Saginaw|26145',
 'MIZ054' => '43.4641|-83.4167|Tuscola|Tuscola|26157',
 'MIZ055' => '43.4235|-82.8201|Sanilac|Sanilac|26151',
 'MIZ056' => '42.9601|-85.9939|Ottawa|Ottawa|26139',
 'MIZ057' => '43.0322|-85.5492|Kent|Kent|26081',
 'MIZ058' => '42.9451|-85.0746|Ionia|Ionia|26067',
 'MIZ059' => '42.9436|-84.6015|Clinton|Clinton|26037',
 'MIZ060' => '42.9537|-84.1467|Shiawassee|Shiawassee|26155',
 'MIZ061' => '43.0217|-83.7067|Genesee|Genesee|26049',
 'MIZ062' => '43.0901|-83.2218|Lapeer|Lapeer|26087',
 'MIZ063' => '42.9425|-82.682|St. Clair|St. Clair|26147',
 'MIZ064' => '42.5913|-85.8884|Allegan|Allegan|26005',
 'MIZ065' => '42.595|-85.309|Barry|Barry|26015',
 'MIZ066' => '42.5961|-84.8384|Eaton|Eaton|26045',
 'MIZ067' => '42.5971|-84.3736|Ingham|Ingham|26065',
 'MIZ068' => '42.603|-83.9115|Livingston|Livingston|26093',
 'MIZ069' => '42.6604|-83.3855|Oakland|Oakland|26125',
 'MIZ070' => '42.6956|-82.9322|Macomb|Macomb|26099',
 'MIZ071' => '42.2513|-86.0189|Van Buren|Van Buren|26159',
 'MIZ072' => '42.2454|-85.5312|Kalamazoo|Kalamazoo|26077',
 'MIZ073' => '42.2466|-85.0055|Calhoun|Calhoun|26025',
 'MIZ074' => '42.2485|-84.4233|Jackson|Jackson|26075',
 'MIZ075' => '42.2534|-83.8385|Washtenaw|Washtenaw|26161',
 'MIZ076' => '42.284|-83.2865|Wayne|Wayne|26163',
 'MIZ078' => '41.9153|-85.9936|Cass|Cass|26027',
 'MIZ079' => '41.9145|-85.5278|St. Joseph|St. Joseph|26149',
 'MIZ080' => '41.9161|-85.059|Branch|Branch|26023',
 'MIZ081' => '41.8878|-84.593|Hillsdale|Hillsdale|26059',
 'MIZ082' => '41.8951|-84.0664|Lenawee|Lenawee|26091',
 'MIZ083' => '41.9292|-83.5373|Monroe|Monroe|26115',
 'MIZ084' => '46.607|-88.8192|Southern Houghton|Houghton|26061',
 'MIZ085' => '46.3325|-86.2069|Northern Schoolcraft|Schoolcraft|26153',
 'MIZ086' => '46.3926|-84.9529|Western Chippewa |Chippewa|26033',
 'MIZ087' => '46.3221|-84.3611|Central Chippewa |Chippewa|26033',
 'MIZ088' => '46.0374|-83.9354|Southeast Chippewa |Chippewa|26033',
 'MIZ095' => '46.1362|-85.5266|Western Mackinac |Mackinac|26097',
 'MIZ096' => '46.0504|-84.7048|Eastern Mackinac |Mackinac|26097',
 'MIZ097' => '45.779|-84.4809|Mackinac Island/Bois Blanc Island |Mackinac|26097',
 'MIZ098' => '45.6807|-85.55|Beaver Island |Charlevoix|26029',
 'MIZ099' => '45.2247|-85.0407|Charlevoix |Charlevoix|26029',
 'MIZ177' => '42.1472|-86.3368|Northern Berrien|Berrien|26021',
 'MIZ277' => '41.8971|-86.4348|Southern Berrien|Berrien|26021',
 'MNC001' => '46.6083|-93.4154|Aitkin||',
 'MNC003' => '45.2732|-93.2464|Anoka||',
 'MNC005' => '46.9346|-95.6738|Becker||',
 'MNC007' => '47.9738|-94.9377|Beltrami||',
 'MNC009' => '45.6991|-93.9989|Benton||',
 'MNC011' => '45.4261|-96.4110|Big Stone||',
 'MNC013' => '44.0346|-94.0671|Blue Earth||',
 'MNC015' => '44.2421|-94.7277|Brown||',
 'MNC017' => '46.5924|-92.6771|Carlton||',
 'MNC019' => '44.8208|-93.8025|Carver||',
 'MNC021' => '46.9496|-94.3253|Cass||',
 'MNC023' => '45.0223|-95.5666|Chippewa||',
 'MNC025' => '45.5025|-92.9083|Chisago||',
 'MNC027' => '46.8924|-96.4906|Clay||',
 'MNC029' => '47.5776|-95.3790|Clearwater||',
 'MNC031' => '47.9027|-90.5344|Cook||',
 'MNC033' => '44.0071|-95.1812|Cottonwood||',
 'MNC035' => '46.4824|-94.0709|Crow Wing||',
 'MNC037' => '44.6718|-93.0656|Dakota||',
 'MNC039' => '44.0225|-92.8620|Dodge||',
 'MNC041' => '45.9337|-95.4535|Douglas||',
 'MNC043' => '43.6739|-93.9478|Faribault||',
 'MNC045' => '43.6740|-92.0901|Fillmore||',
 'MNC047' => '43.6738|-93.3489|Freeborn||',
 'MNC049' => '44.4099|-92.7225|Goodhue||',
 'MNC051' => '45.9340|-96.0121|Grant||',
 'MNC053' => '45.0045|-93.4768|Hennepin||',
 'MNC055' => '43.6714|-91.4929|Houston||',
 'MNC057' => '47.1087|-94.9166|Hubbard||',
 'MNC059' => '45.5615|-93.2952|Isanti||',
 'MNC061' => '47.5095|-93.6320|Itasca||',
 'MNC063' => '43.6741|-95.1541|Jackson||',
 'MNC065' => '45.9453|-93.2935|Kanabec||',
 'MNC067' => '45.1524|-95.0048|Kandiyohi||',
 'MNC069' => '48.7766|-96.7826|Kittson||',
 'MNC071' => '48.2453|-93.7834|Koochiching||',
 'MNC073' => '44.9955|-96.1735|Lac qui Parle||',
 'MNC075' => '47.6420|-91.4452|Lake||',
 'MNC077' => '48.7718|-94.9048|Lake of the Woods||',
 'MNC079' => '44.3714|-93.7300|Le Sueur||',
 'MNC081' => '44.4126|-96.2670|Lincoln||',
 'MNC083' => '44.4135|-95.8390|Lyon||',
 'MNC085' => '44.8235|-94.2724|McLeod||',
 'MNC087' => '47.3252|-95.8090|Mahnomen||',
 'MNC089' => '48.3581|-96.3685|Marshall||',
 'MNC091' => '43.6742|-94.5511|Martin||',
 'MNC093' => '45.1231|-94.5274|Meeker||',
 'MNC095' => '45.9380|-93.6301|Mille Lacs||',
 'MNC097' => '46.0126|-94.2684|Morrison||',
 'MNC099' => '43.6714|-92.7525|Mower||',
 'MNC101' => '44.0221|-95.7632|Murray||',
 'MNC103' => '44.3500|-94.2474|Nicollet||',
 'MNC105' => '43.6742|-95.7534|Nobles||',
 'MNC107' => '47.3265|-96.4551|Norman||',
 'MNC109' => '44.0036|-92.4018|Olmsted||',
 'MNC111' => '46.4088|-95.7079|Otter Tail||',
 'MNC113' => '48.0662|-96.0367|Pennington||',
 'MNC115' => '46.1208|-92.7414|Pine||',
 'MNC117' => '44.0230|-96.2586|Pipestone||',
 'MNC119' => '47.7738|-96.4018|Polk||',
 'MNC121' => '45.5861|-95.4445|Pope||',
 'MNC123' => '45.0171|-93.0994|Ramsey||',
 'MNC125' => '47.8717|-96.0953|Red Lake||',
 'MNC127' => '44.4037|-95.2539|Redwood||',
 'MNC129' => '44.7268|-94.9472|Renville||',
 'MNC131' => '44.3541|-93.2966|Rice||',
 'MNC133' => '43.6747|-96.2532|Rock||',
 'MNC135' => '48.7751|-95.8107|Roseau||',
 'MNC137' => '47.6040|-92.4708|St. Louis||',
 'MNC139' => '44.6484|-93.5358|Scott||',
 'MNC141' => '45.4439|-93.7745|Sherburne||',
 'MNC143' => '44.5795|-94.2321|Sibley||',
 'MNC145' => '45.5522|-94.6130|Stearns||',
 'MNC147' => '44.0223|-93.2260|Steele||',
 'MNC149' => '45.5861|-96.0003|Stevens||',
 'MNC151' => '45.2827|-95.6813|Swift||',
 'MNC153' => '46.0706|-94.8976|Todd||',
 'MNC155' => '45.7721|-96.4716|Traverse||',
 'MNC157' => '44.2842|-92.2303|Wabasha||',
 'MNC159' => '46.5858|-94.9693|Wadena||',
 'MNC161' => '44.0221|-93.5873|Waseca||',
 'MNC163' => '45.0383|-92.8839|Washington||',
 'MNC165' => '43.9783|-94.6141|Watonwan||',
 'MNC167' => '46.3571|-96.4683|Wilkin||',
 'MNC169' => '43.9869|-91.7791|Winona||',
 'MNC171' => '45.1739|-93.9630|Wright||',
 'MNC173' => '44.7162|-95.8683|Yellow Medicine||',
 'MNZ001' => '47.8466|-96.7048|West Polk|Polk|27119',
 'MNZ002' => '47.3265|-96.4551|Norman|Norman|27107',
 'MNZ003' => '46.8924|-96.4906|Clay|Clay|27027',
 'MNZ004' => '48.7766|-96.7826|Kittson|Kittson|27069',
 'MNZ005' => '48.7751|-95.8107|Roseau|Roseau|27135',
 'MNZ006' => '48.7719|-94.9051|Lake Of The Woods|Lake of the Woods|27077',
 'MNZ007' => '48.3592|-96.7657|West Marshall|Marshall|27089',
 'MNZ008' => '48.3571|-95.9961|East Marshall|Marshall|27089',
 'MNZ009' => '48.1627|-95.0124|North Beltrami|Beltrami|27007',
 'MNZ010' => '48.2422|-93.7874|Koochiching|Koochiching|27071',
 'MNZ011' => '48.139|-92.5294|North St. Louis|St. Louis|27137',
 'MNZ012' => '47.8238|-91.1981|Northern Cook/Northern Lake|Cook|27031	47.8238|-91.1981|Northern Cook/Northern Lake|Lake|27075',
 'MNZ013' => '48.0662|-96.0367|Pennington|Pennington|27113',
 'MNZ014' => '47.8717|-96.0953|Red Lake|Red Lake|27125',
 'MNZ015' => '47.6577|-95.918|East Polk|Polk|27119',
 'MNZ016' => '47.752|-95.3891|North Clearwater|Clearwater|27029',
 'MNZ017' => '47.6313|-94.8022|South Beltrami|Beltrami|27007',
 'MNZ018' => '47.6644|-93.7298|North Itasca|Itasca|27061',
 'MNZ019' => '47.4461|-92.4352|Central St. Louis|St. Louis|27137',
 'MNZ020' => '47.282|-91.4479|Southern Lake/North Shore|Lake|27075	47.282|-91.4479|Southern Lake/North Shore|St. Louis|27137',
 'MNZ021' => '47.8033|-90.4117|Southern Cook/North Shore|Cook|27031',
 'MNZ022' => '47.3252|-95.809|Mahnomen|Mahnomen|27087',
 'MNZ023' => '47.3228|-95.3643|South Clearwater|Clearwater|27029',
 'MNZ024' => '47.1087|-94.9166|Hubbard|Hubbard|27057',
 'MNZ025' => '47.1039|-94.2344|North Cass|Cass|27021',
 'MNZ026' => '47.2596|-93.4742|South Itasca|Itasca|27061',
 'MNZ027' => '46.9358|-95.9229|West Becker|Becker|27005',
 'MNZ028' => '46.9334|-95.4143|East Becker|Becker|27005',
 'MNZ029' => '46.357|-96.4684|Wilkin|Wilkin|27167',
 'MNZ030' => '46.4061|-96.0175|West Otter Tail|Otter Tail|27111',
 'MNZ031' => '46.4109|-95.4624|East Otter Tail|Otter Tail|27111',
 'MNZ032' => '46.5858|-94.9694|Wadena|Wadena|27159',
 'MNZ033' => '46.5646|-94.5522|South Cass|Cass|27021',
 'MNZ034' => '46.4824|-94.0709|Crow Wing|Crow Wing|27035',
 'MNZ035' => '46.826|-93.4185|Northern Aitkin|Aitkin|27001',
 'MNZ036' => '46.4095|-93.4126|South Aitkin|Aitkin|27001',
 'MNZ037' => '46.7516|-92.5801|Carlton/South St. Louis|Carlton|27017	46.7516|-92.5801|Carlton/South St. Louis|St. Louis|27137',
 'MNZ038' => '46.1208|-92.7414|Pine|Pine|27115',
 'MNZ039' => '45.7721|-96.4716|Traverse|Traverse|27155',
 'MNZ040' => '45.934|-96.0121|Grant|Grant|27051',
 'MNZ041' => '45.9337|-95.4535|Douglas|Douglas|27041',
 'MNZ042' => '46.0706|-94.8976|Todd|Todd|27153',
 'MNZ043' => '46.0126|-94.2684|Morrison|Morrison|27097',
 'MNZ044' => '45.938|-93.6301|Mille Lacs|Mille Lacs|27095',
 'MNZ045' => '45.9453|-93.2935|Kanabec|Kanabec|27065',
 'MNZ046' => '45.4261|-96.411|Big Stone|Big Stone|27011',
 'MNZ047' => '45.5861|-96.0003|Stevens|Stevens|27149',
 'MNZ048' => '45.586|-95.4445|Pope|Pope|27121',
 'MNZ049' => '45.5522|-94.613|Stearns|Stearns|27145',
 'MNZ050' => '45.6991|-93.9989|Benton|Benton|27009',
 'MNZ051' => '45.4439|-93.7745|Sherburne|Sherburne|27141',
 'MNZ052' => '45.5615|-93.2952|Isanti|Isanti|27059',
 'MNZ053' => '45.5025|-92.9083|Chisago|Chisago|27025',
 'MNZ054' => '44.9955|-96.1735|Lac Qui Parle|Lac qui Parle|27073',
 'MNZ055' => '45.2827|-95.6814|Swift|Swift|27151',
 'MNZ056' => '45.0223|-95.5666|Chippewa|Chippewa|27023',
 'MNZ057' => '45.1524|-95.0048|Kandiyohi|Kandiyohi|27067',
 'MNZ058' => '45.1231|-94.5274|Meeker|Meeker|27093',
 'MNZ059' => '45.1739|-93.963|Wright|Wright|27171',
 'MNZ060' => '45.0045|-93.4768|Hennepin|Hennepin|27053',
 'MNZ061' => '45.2732|-93.2464|Anoka|Anoka|27003',
 'MNZ062' => '45.0171|-93.0994|Ramsey|Ramsey|27123',
 'MNZ063' => '45.0383|-92.8839|Washington|Washington|27163',
 'MNZ064' => '44.7162|-95.8683|Yellow Medicine|Yellow Medicine|27173',
 'MNZ065' => '44.7268|-94.9472|Renville|Renville|27129',
 'MNZ066' => '44.8235|-94.2724|McLeod|McLeod|27085',
 'MNZ067' => '44.5795|-94.2321|Sibley|Sibley|27143',
 'MNZ068' => '44.8208|-93.8025|Carver|Carver|27019',
 'MNZ069' => '44.6484|-93.5357|Scott|Scott|27139',
 'MNZ070' => '44.6718|-93.0656|Dakota|Dakota|27037',
 'MNZ071' => '44.4126|-96.2671|Lincoln|Lincoln|27081',
 'MNZ072' => '44.4135|-95.839|Lyon|Lyon|27083',
 'MNZ073' => '44.4037|-95.2539|Redwood|Redwood|27127',
 'MNZ074' => '44.2421|-94.7277|Brown|Brown|27015',
 'MNZ075' => '44.35|-94.2474|Nicollet|Nicollet|27103',
 'MNZ076' => '44.3714|-93.73|Le Sueur|Le Sueur|27079',
 'MNZ077' => '44.3541|-93.2966|Rice|Rice|27131',
 'MNZ078' => '44.4099|-92.7225|Goodhue|Goodhue|27049',
 'MNZ079' => '44.2842|-92.2303|Wabasha|Wabasha|27157',
 'MNZ080' => '44.0221|-95.7632|Murray|Murray|27101',
 'MNZ081' => '44.0071|-95.1812|Cottonwood|Cottonwood|27033',
 'MNZ082' => '43.9783|-94.6141|Watonwan|Watonwan|27165',
 'MNZ083' => '44.0346|-94.0671|Blue Earth|Blue Earth|27013',
 'MNZ084' => '44.0221|-93.5873|Waseca|Waseca|27161',
 'MNZ085' => '44.0223|-93.226|Steele|Steele|27147',
 'MNZ086' => '44.0225|-92.862|Dodge|Dodge|27039',
 'MNZ087' => '44.0036|-92.4018|Olmsted|Olmsted|27109',
 'MNZ088' => '43.9869|-91.7791|Winona|Winona|27169',
 'MNZ089' => '43.6742|-95.7534|Nobles|Nobles|27105',
 'MNZ090' => '43.6741|-95.1541|Jackson|Jackson|27063',
 'MNZ091' => '43.6742|-94.5511|Martin|Martin|27091',
 'MNZ092' => '43.6739|-93.9479|Faribault|Faribault|27043',
 'MNZ093' => '43.6738|-93.3489|Freeborn|Freeborn|27047',
 'MNZ094' => '43.6714|-92.7525|Mower|Mower|27099',
 'MNZ095' => '43.674|-92.0901|Fillmore|Fillmore|27045',
 'MNZ096' => '43.6714|-91.4928|Houston|Houston|27055',
 'MNZ097' => '44.023|-96.2586|Pipestone|Pipestone|27117',
 'MNZ098' => '43.6747|-96.2532|Rock|Rock|27133',
 'MOC001' => '40.1906|-92.6007|Adair||',
 'MOC003' => '39.9834|-94.8021|Andrew||',
 'MOC005' => '40.4307|-95.4270|Atchison||',
 'MOC007' => '39.2158|-91.8416|Audrain||',
 'MOC009' => '36.7099|-93.8291|Barry||',
 'MOC011' => '37.5023|-94.3471|Barton||',
 'MOC013' => '38.2573|-94.3400|Bates||',
 'MOC015' => '38.2948|-93.2879|Benton||',
 'MOC017' => '37.3222|-90.0259|Bollinger||',
 'MOC019' => '38.9907|-92.3096|Boone||',
 'MOC021' => '39.6598|-94.8062|Buchanan||',
 'MOC023' => '36.7164|-90.4065|Butler||',
 'MOC025' => '39.6557|-93.9828|Caldwell||',
 'MOC027' => '38.8355|-91.9260|Callaway||',
 'MOC029' => '38.0271|-92.7660|Camden||',
 'MOC031' => '37.3839|-89.6845|Cape Girardeau||',
 'MOC033' => '39.4268|-93.5052|Carroll||',
 'MOC035' => '36.9413|-90.9623|Carter||',
 'MOC037' => '38.6470|-94.3548|Cass||',
 'MOC039' => '37.7238|-93.8566|Cedar||',
 'MOC041' => '39.5145|-92.9626|Chariton||',
 'MOC043' => '36.9696|-93.1889|Christian||',
 'MOC045' => '40.4104|-91.7384|Clark||',
 'MOC047' => '39.3105|-94.4208|Clay||',
 'MOC049' => '39.6018|-94.4046|Clinton||',
 'MOC051' => '38.5055|-92.2816|Cole||',
 'MOC053' => '38.8439|-92.8103|Cooper||',
 'MOC055' => '37.9764|-91.3040|Crawford||',
 'MOC057' => '37.4320|-93.8502|Dade||',
 'MOC059' => '37.6804|-93.0236|Dallas||',
 'MOC061' => '39.9607|-93.9855|Daviess||',
 'MOC063' => '39.8932|-94.4047|DeKalb||',
 'MOC065' => '37.6066|-91.5079|Dent||',
 'MOC067' => '36.9326|-92.4988|Douglas||',
 'MOC069' => '36.2718|-90.0909|Dunklin||',
 'MOC071' => '38.4112|-91.0750|Franklin||',
 'MOC073' => '38.4409|-91.5079|Gasconade||',
 'MOC075' => '40.2121|-94.4099|Gentry||',
 'MOC077' => '37.2581|-93.3420|Greene||',
 'MOC079' => '40.1140|-93.5653|Grundy||',
 'MOC081' => '40.3547|-93.9921|Harrison||',
 'MOC083' => '38.3852|-93.7927|Henry||',
 'MOC085' => '37.9408|-93.3207|Hickory||',
 'MOC087' => '40.0946|-95.2150|Holt||',
 'MOC089' => '39.1428|-92.6958|Howard||',
 'MOC091' => '36.7740|-91.8865|Howell||',
 'MOC093' => '37.5552|-90.7735|Iron||',
 'MOC095' => '39.0085|-94.3461|Jackson||',
 'MOC097' => '37.2035|-94.3406|Jasper||',
 'MOC099' => '38.2610|-90.5378|Jefferson||',
 'MOC101' => '38.7441|-93.8063|Johnson||',
 'MOC103' => '40.1282|-92.1481|Knox||',
 'MOC105' => '37.6583|-92.5903|Laclede||',
 'MOC107' => '39.0656|-93.7855|Lafayette||',
 'MOC109' => '37.1063|-93.8329|Lawrence||',
 'MOC111' => '40.0969|-91.7222|Lewis||',
 'MOC113' => '39.0581|-90.9602|Lincoln||',
 'MOC115' => '39.8702|-93.1072|Linn||',
 'MOC117' => '39.7821|-93.5483|Livingston||',
 'MOC119' => '36.6287|-94.3484|McDonald||',
 'MOC121' => '39.8308|-92.5646|Macon||',
 'MOC123' => '37.4781|-90.3450|Madison||',
 'MOC125' => '38.1616|-91.9249|Maries||',
 'MOC127' => '39.8060|-91.6224|Marion||',
 'MOC129' => '40.4223|-93.5685|Mercer||',
 'MOC131' => '38.2145|-92.4284|Miller||',
 'MOC133' => '36.8281|-89.2911|Mississippi||',
 'MOC135' => '38.6327|-92.5830|Moniteau||',
 'MOC137' => '39.4955|-92.0007|Monroe||',
 'MOC139' => '38.9415|-91.4702|Montgomery||',
 'MOC141' => '38.4239|-92.8861|Morgan||',
 'MOC143' => '36.5942|-89.6516|New Madrid||',
 'MOC145' => '36.9055|-94.3392|Newton||',
 'MOC147' => '40.3607|-94.8834|Nodaway||',
 'MOC149' => '36.6867|-91.4033|Oregon||',
 'MOC151' => '38.4604|-91.8618|Osage||',
 'MOC153' => '36.6493|-92.4446|Ozark||',
 'MOC155' => '36.2111|-89.7858|Pemiscot||',
 'MOC157' => '37.7071|-89.8244|Perry||',
 'MOC159' => '38.7283|-93.2851|Pettis||',
 'MOC161' => '37.8771|-91.7924|Phelps||',
 'MOC163' => '39.3438|-91.1714|Pike||',
 'MOC165' => '39.3804|-94.7736|Platte||',
 'MOC167' => '37.6165|-93.4005|Polk||',
 'MOC169' => '37.8246|-92.2076|Pulaski||',
 'MOC171' => '40.4789|-93.0161|Putnam||',
 'MOC173' => '39.5276|-91.5219|Ralls||',
 'MOC175' => '39.4402|-92.4971|Randolph||',
 'MOC177' => '39.3524|-93.9899|Ray||',
 'MOC179' => '37.3623|-90.9691|Reynolds||',
 'MOC181' => '36.6528|-90.8639|Ripley||',
 'MOC183' => '38.7819|-90.6752|St. Charles||',
 'MOC185' => '38.0371|-93.7760|St. Clair||',
 'MOC186' => '37.8940|-90.1952|Ste. Genevieve||',
 'MOC187' => '37.8104|-90.4729|St. Francois||',
 'MOC189' => '38.6407|-90.4430|St. Louis||',
 'MOC195' => '39.1366|-93.2022|Saline||',
 'MOC197' => '40.4703|-92.5209|Schuyler||',
 'MOC199' => '40.4526|-92.1471|Scotland||',
 'MOC201' => '37.0530|-89.5686|Scott||',
 'MOC203' => '37.1574|-91.4005|Shannon||',
 'MOC205' => '39.7978|-92.0766|Shelby||',
 'MOC207' => '36.8555|-89.9444|Stoddard||',
 'MOC209' => '36.7469|-93.4559|Stone||',
 'MOC211' => '40.2107|-93.1115|Sullivan||',
 'MOC213' => '36.6547|-93.0410|Taney||',
 'MOC215' => '37.3173|-91.9651|Texas||',
 'MOC217' => '37.8506|-94.3424|Vernon||',
 'MOC219' => '38.7646|-91.1607|Warren||',
 'MOC221' => '37.9617|-90.8774|Washington||',
 'MOC223' => '37.1127|-90.4614|Wayne||',
 'MOC225' => '37.2809|-92.8759|Webster||',
 'MOC227' => '40.4791|-94.4222|Worth||',
 'MOC229' => '37.2701|-92.4687|Wright||',
 'MOC510' => '38.6358|-90.2450|St. Louis City||',
 'MOZ001' => '40.4307|-95.427|Atchison|Atchison|29005',
 'MOZ002' => '40.3607|-94.8834|Nodaway|Nodaway|29147',
 'MOZ003' => '40.4791|-94.4222|Worth|Worth|29227',
 'MOZ004' => '40.2121|-94.4099|Gentry|Gentry|29075',
 'MOZ005' => '40.3547|-93.9921|Harrison|Harrison|29081',
 'MOZ006' => '40.4223|-93.5685|Mercer|Mercer|29129',
 'MOZ007' => '40.4789|-93.0161|Putnam|Putnam|29171',
 'MOZ008' => '40.4702|-92.5209|Schuyler|Schuyler|29197',
 'MOZ009' => '40.4526|-92.1471|Scotland|Scotland|29199',
 'MOZ010' => '40.4103|-91.7384|Clark|Clark|29045',
 'MOZ011' => '40.0946|-95.215|Holt|Holt|29087',
 'MOZ012' => '39.9834|-94.802|Andrew|Andrew|29003',
 'MOZ013' => '39.8932|-94.4047|De Kalb|DeKalb|29063',
 'MOZ014' => '39.9607|-93.9855|Daviess|Daviess|29061',
 'MOZ015' => '40.114|-93.5653|Grundy|Grundy|29079',
 'MOZ016' => '40.2107|-93.1115|Sullivan|Sullivan|29211',
 'MOZ017' => '40.1906|-92.6007|Adair|Adair|29001',
 'MOZ018' => '40.1282|-92.1481|Knox|Knox|29103',
 'MOZ019' => '40.0969|-91.7222|Lewis|Lewis|29111',
 'MOZ020' => '39.6598|-94.8062|Buchanan|Buchanan|29021',
 'MOZ021' => '39.6018|-94.4046|Clinton|Clinton|29049',
 'MOZ022' => '39.6557|-93.9828|Caldwell|Caldwell|29025',
 'MOZ023' => '39.7821|-93.5483|Livingston|Livingston|29117',
 'MOZ024' => '39.8702|-93.1072|Linn|Linn|29115',
 'MOZ025' => '39.8308|-92.5646|Macon|Macon|29121',
 'MOZ026' => '39.7978|-92.0766|Shelby|Shelby|29205',
 'MOZ027' => '39.806|-91.6224|Marion|Marion|29127',
 'MOZ028' => '39.3804|-94.7736|Platte|Platte|29165',
 'MOZ029' => '39.3105|-94.4208|Clay|Clay|29047',
 'MOZ030' => '39.3524|-93.9899|Ray|Ray|29177',
 'MOZ031' => '39.4268|-93.5051|Carroll|Carroll|29033',
 'MOZ032' => '39.5145|-92.9626|Chariton|Chariton|29041',
 'MOZ033' => '39.4402|-92.4971|Randolph|Randolph|29175',
 'MOZ034' => '39.4955|-92.0007|Monroe|Monroe|29137',
 'MOZ035' => '39.5276|-91.522|Ralls|Ralls|29173',
 'MOZ036' => '39.3438|-91.1714|Pike|Pike|29163',
 'MOZ037' => '39.0085|-94.3461|Jackson|Jackson|29095',
 'MOZ038' => '39.0656|-93.7855|Lafayette|Lafayette|29107',
 'MOZ039' => '39.1366|-93.2022|Saline|Saline|29195',
 'MOZ040' => '39.1427|-92.6958|Howard|Howard|29089',
 'MOZ041' => '38.9907|-92.3096|Boone|Boone|29019',
 'MOZ042' => '39.2158|-91.8416|Audrain|Audrain|29007',
 'MOZ043' => '38.647|-94.3548|Cass|Cass|29037',
 'MOZ044' => '38.7441|-93.8063|Johnson|Johnson|29101',
 'MOZ045' => '38.7283|-93.2851|Pettis|Pettis|29159',
 'MOZ046' => '38.8439|-92.8103|Cooper|Cooper|29053',
 'MOZ047' => '38.6327|-92.5831|Moniteau|Moniteau|29135',
 'MOZ048' => '38.5055|-92.2816|Cole|Cole|29051',
 'MOZ049' => '38.4604|-91.8618|Osage|Osage|29151',
 'MOZ050' => '38.8355|-91.926|Callaway|Callaway|29027',
 'MOZ051' => '38.9415|-91.4702|Montgomery|Montgomery|29139',
 'MOZ052' => '39.0581|-90.9602|Lincoln|Lincoln|29113',
 'MOZ053' => '38.2573|-94.34|Bates|Bates|29013',
 'MOZ054' => '38.3852|-93.7927|Henry|Henry|29083',
 'MOZ055' => '38.2948|-93.2879|Benton|Benton|29015',
 'MOZ056' => '38.4239|-92.8861|Morgan|Morgan|29141',
 'MOZ057' => '38.2145|-92.4284|Miller|Miller|29131',
 'MOZ058' => '38.1616|-91.9249|Maries|Maries|29125',
 'MOZ059' => '38.4409|-91.5079|Gasconade|Gasconade|29073',
 'MOZ060' => '38.7646|-91.1607|Warren|Warren|29219',
 'MOZ061' => '38.7819|-90.6752|St. Charles|St. Charles|29183',
 'MOZ062' => '38.4112|-91.075|Franklin|Franklin|29071',
 'MOZ063' => '38.6407|-90.443|St. Louis|St. Louis|29189',
 'MOZ064' => '38.6358|-90.245|St. Louis City|St. Louis City|29510',
 'MOZ065' => '38.261|-90.5378|Jefferson|Jefferson|29099',
 'MOZ066' => '37.8506|-94.3424|Vernon|Vernon|29217',
 'MOZ067' => '38.0371|-93.776|St. Clair|St. Clair|29185',
 'MOZ068' => '37.9408|-93.3207|Hickory|Hickory|29085',
 'MOZ069' => '38.0271|-92.766|Camden|Camden|29029',
 'MOZ070' => '37.8246|-92.2076|Pulaski|Pulaski|29169',
 'MOZ071' => '37.8771|-91.7924|Phelps|Phelps|29161',
 'MOZ072' => '37.9764|-91.304|Crawford|Crawford|29055',
 'MOZ073' => '37.9617|-90.8774|Washington|Washington|29221',
 'MOZ074' => '37.8104|-90.4729|St. Francois|St. Francois|29187',
 'MOZ075' => '37.894|-90.1952|Ste. Genevieve|Ste. Genevieve|29186',
 'MOZ076' => '37.7071|-89.8244|Perry|Perry|29157',
 'MOZ077' => '37.5023|-94.3471|Barton|Barton|29011',
 'MOZ078' => '37.7238|-93.8566|Cedar|Cedar|29039',
 'MOZ079' => '37.6165|-93.4005|Polk|Polk|29167',
 'MOZ080' => '37.6804|-93.0236|Dallas|Dallas|29059',
 'MOZ081' => '37.6583|-92.5903|Laclede|Laclede|29105',
 'MOZ082' => '37.3173|-91.9651|Texas|Texas|29215',
 'MOZ083' => '37.6066|-91.5079|Dent|Dent|29065',
 'MOZ084' => '37.5552|-90.7735|Iron|Iron|29093',
 'MOZ085' => '37.4781|-90.345|Madison|Madison|29123',
 'MOZ086' => '37.3222|-90.0259|Bollinger|Bollinger|29017',
 'MOZ087' => '37.3839|-89.6845|Cape Girardeau|Cape Girardeau|29031',
 'MOZ088' => '37.2035|-94.3406|Jasper|Jasper|29097',
 'MOZ089' => '37.432|-93.8503|Dade|Dade|29057',
 'MOZ090' => '37.2581|-93.342|Greene|Greene|29077',
 'MOZ091' => '37.2809|-92.8759|Webster|Webster|29225',
 'MOZ092' => '37.2701|-92.4687|Wright|Wright|29229',
 'MOZ093' => '36.9055|-94.3392|Newton|Newton|29145',
 'MOZ094' => '37.1064|-93.8329|Lawrence|Lawrence|29109',
 'MOZ095' => '36.9696|-93.1889|Christian|Christian|29043',
 'MOZ096' => '36.9326|-92.4988|Douglas|Douglas|29067',
 'MOZ097' => '36.774|-91.8865|Howell|Howell|29091',
 'MOZ098' => '37.1574|-91.4005|Shannon|Shannon|29203',
 'MOZ099' => '37.3623|-90.9691|Reynolds|Reynolds|29179',
 'MOZ100' => '37.1126|-90.4614|Wayne|Wayne|29223',
 'MOZ101' => '36.6287|-94.3484|McDonald|McDonald|29119',
 'MOZ102' => '36.7099|-93.8291|Barry|Barry|29009',
 'MOZ103' => '36.7469|-93.4559|Stone|Stone|29209',
 'MOZ104' => '36.6547|-93.041|Taney|Taney|29213',
 'MOZ105' => '36.6493|-92.4446|Ozark|Ozark|29153',
 'MOZ106' => '36.6867|-91.4033|Oregon|Oregon|29149',
 'MOZ107' => '36.9413|-90.9623|Carter|Carter|29035',
 'MOZ108' => '36.6528|-90.8639|Ripley|Ripley|29181',
 'MOZ109' => '36.7164|-90.4065|Butler|Butler|29023',
 'MOZ110' => '36.8555|-89.9444|Stoddard|Stoddard|29207',
 'MOZ111' => '37.053|-89.5686|Scott|Scott|29201',
 'MOZ112' => '36.8281|-89.2911|Mississippi|Mississippi|29133',
 'MOZ113' => '36.2719|-90.0909|Dunklin|Dunklin|29069',
 'MOZ114' => '36.5942|-89.6516|New Madrid|New Madrid|29143',
 'MOZ115' => '36.2111|-89.7858|Pemiscot|Pemiscot|29155',
 'MPC085' => '18.7710|145.6674|Agrihan||	16.3519|145.6774|Anatahan||	17.5998|145.8330|Alamagan||	18.1166|145.7666|Pagan||',
 'MPC100' => '14.1576|145.2148|Rota||',
 'MPC110' => '15.1889|145.7534|Saipan||',
 'MPC120' => '15.0030|145.6267|Tinian||',
 'MPZ001' => '14.1576|145.2148|Rota|Rota|69100',
 'MPZ002' => '15.003|145.6267|Tinian|Tinian|69120',
 'MPZ003' => '15.1889|145.7534|Saipan|Saipan|69110',
 'MPZ004' => '16.3519|145.6774|Anatahan|Anatahan|69085',
 'MPZ005' => '17.5998|145.833|Alamagan|Alamagan|69085',
 'MPZ006' => '18.1166|145.7666|Pagan|Pagan|69085',
 'MPZ007' => '18.771|145.6674|Agrihan|Agrihan|69085',
 'MSC001' => '31.4832|-91.3531|Adams||',
 'MSC003' => '34.8808|-88.5803|Alcorn||',
 'MSC005' => '31.1744|-90.8045|Amite||',
 'MSC007' => '33.0863|-89.5817|Attala||',
 'MSC009' => '34.8173|-89.1885|Benton||',
 'MSC011' => '33.7955|-90.8804|Bolivar||',
 'MSC013' => '33.9364|-89.3364|Calhoun||',
 'MSC015' => '33.4485|-89.9202|Carroll||',
 'MSC017' => '33.9208|-88.9479|Chickasaw||',
 'MSC019' => '33.3473|-89.2484|Choctaw||',
 'MSC021' => '31.9737|-90.9118|Claiborne||',
 'MSC023' => '32.0414|-88.6894|Clarke||',
 'MSC025' => '33.6557|-88.7815|Clay||',
 'MSC027' => '34.2292|-90.6027|Coahoma||',
 'MSC029' => '31.8692|-90.4488|Copiah||',
 'MSC031' => '31.6332|-89.5526|Covington||',
 'MSC033' => '34.8754|-89.9918|DeSoto||',
 'MSC035' => '31.1889|-89.2579|Forrest||',
 'MSC037' => '31.4772|-90.8978|Franklin||',
 'MSC039' => '30.8626|-88.6440|George||',
 'MSC041' => '31.2142|-88.6392|Greene||',
 'MSC043' => '33.7700|-89.8020|Grenada||',
 'MSC045' => '30.4164|-89.4887|Hancock||',
 'MSC047' => '30.5150|-89.1185|Harrison||',
 'MSC049' => '32.2667|-90.4427|Hinds||',
 'MSC051' => '33.1235|-90.0922|Holmes||',
 'MSC053' => '33.1287|-90.5265|Humphreys||',
 'MSC055' => '32.7414|-90.9892|Issaquena||',
 'MSC057' => '34.2800|-88.3613|Itawamba||',
 'MSC059' => '30.5459|-88.6362|Jackson||',
 'MSC061' => '32.0191|-89.1189|Jasper||',
 'MSC063' => '31.7342|-91.0371|Jefferson||',
 'MSC065' => '31.5696|-89.8230|Jefferson Davis||',
 'MSC067' => '31.6226|-89.1688|Jones||',
 'MSC069' => '32.7546|-88.6412|Kemper||',
 'MSC071' => '34.3568|-89.4849|Lafayette||',
 'MSC073' => '31.2059|-89.5087|Lamar||',
 'MSC075' => '32.4043|-88.6626|Lauderdale||',
 'MSC077' => '31.5502|-90.1070|Lawrence||',
 'MSC079' => '32.7535|-89.5241|Leake||',
 'MSC081' => '34.2899|-88.6804|Lee||',
 'MSC083' => '33.5505|-90.3010|Leflore||',
 'MSC085' => '31.5324|-90.4540|Lincoln||',
 'MSC087' => '33.4729|-88.4433|Lowndes||',
 'MSC089' => '32.6347|-90.0338|Madison||',
 'MSC091' => '31.2308|-89.8224|Marion||',
 'MSC093' => '34.7623|-89.5031|Marshall||',
 'MSC095' => '33.8923|-88.4804|Monroe||',
 'MSC097' => '33.4941|-89.6164|Montgomery||',
 'MSC099' => '32.7535|-89.1176|Neshoba||',
 'MSC101' => '32.4002|-89.1188|Newton||',
 'MSC103' => '33.1101|-88.5698|Noxubee||',
 'MSC105' => '33.4250|-88.8793|Oktibbeha||',
 'MSC107' => '34.3639|-89.9505|Panola||',
 'MSC109' => '30.7686|-89.5898|Pearl River||',
 'MSC111' => '31.1720|-88.9923|Perry||',
 'MSC113' => '31.1749|-90.4042|Pike||',
 'MSC115' => '34.2254|-89.0374|Pontotoc||',
 'MSC117' => '34.6183|-88.5201|Prentiss||',
 'MSC119' => '34.2514|-90.2891|Quitman||',
 'MSC121' => '32.2641|-89.9457|Rankin||',
 'MSC123' => '32.4064|-89.5376|Scott||',
 'MSC125' => '32.8797|-90.8132|Sharkey||',
 'MSC127' => '31.9132|-89.9195|Simpson||',
 'MSC129' => '32.0177|-89.5067|Smith||',
 'MSC131' => '30.7900|-89.1177|Stone||',
 'MSC133' => '33.6023|-90.5886|Sunflower||',
 'MSC135' => '33.9505|-90.1732|Tallahatchie||',
 'MSC137' => '34.6503|-89.9448|Tate||',
 'MSC139' => '34.7684|-88.9089|Tippah||',
 'MSC141' => '34.7404|-88.2393|Tishomingo||',
 'MSC143' => '34.6520|-90.3755|Tunica||',
 'MSC145' => '34.4905|-89.0038|Union||',
 'MSC147' => '31.1485|-90.1061|Walthall||',
 'MSC149' => '32.3573|-90.8521|Warren||',
 'MSC151' => '33.2836|-90.9474|Washington||',
 'MSC153' => '31.6408|-88.6958|Wayne||',
 'MSC155' => '33.6131|-89.2848|Webster||',
 'MSC157' => '31.1610|-91.3109|Wilkinson||',
 'MSC159' => '33.0885|-89.0344|Winston||',
 'MSC161' => '34.0282|-89.7076|Yalobusha||',
 'MSC163' => '32.7804|-90.3965|Yazoo||',
 'MSZ001' => '34.8754|-89.9918|DeSoto|DeSoto|28033',
 'MSZ002' => '34.7623|-89.5031|Marshall|Marshall|28093',
 'MSZ003' => '34.8173|-89.1885|Benton|Benton|28009',
 'MSZ004' => '34.7684|-88.9089|Tippah|Tippah|28139',
 'MSZ005' => '34.8808|-88.5803|Alcorn|Alcorn|28003',
 'MSZ006' => '34.7404|-88.2393|Tishomingo|Tishomingo|28141',
 'MSZ007' => '34.652|-90.3755|Tunica|Tunica|28143',
 'MSZ008' => '34.6503|-89.9448|Tate|Tate|28137',
 'MSZ009' => '34.6183|-88.5201|Prentiss|Prentiss|28117',
 'MSZ010' => '34.2292|-90.6027|Coahoma|Coahoma|28027',
 'MSZ011' => '34.2514|-90.2891|Quitman|Quitman|28119',
 'MSZ012' => '34.3639|-89.9505|Panola|Panola|28107',
 'MSZ013' => '34.3568|-89.4849|Lafayette|Lafayette|28071',
 'MSZ014' => '34.4905|-89.0038|Union|Union|28145',
 'MSZ015' => '34.2254|-89.0374|Pontotoc|Pontotoc|28115',
 'MSZ016' => '34.2899|-88.6804|Lee|Lee|28081',
 'MSZ017' => '34.28|-88.3613|Itawamba|Itawamba|28057',
 'MSZ018' => '33.7955|-90.8804|Bolivar|Bolivar|28011',
 'MSZ019' => '33.6023|-90.5887|Sunflower|Sunflower|28133',
 'MSZ020' => '33.9505|-90.1732|Tallahatchie|Tallahatchie|28135',
 'MSZ021' => '34.0282|-89.7076|Yalobusha|Yalobusha|28161',
 'MSZ022' => '33.9364|-89.3364|Calhoun|Calhoun|28013',
 'MSZ023' => '33.9208|-88.9479|Chickasaw|Chickasaw|28017',
 'MSZ024' => '33.8923|-88.4804|Monroe|Monroe|28095',
 'MSZ025' => '33.5505|-90.301|Leflore|Leflore|28083',
 'MSZ026' => '33.77|-89.802|Grenada|Grenada|28043',
 'MSZ027' => '33.4485|-89.9202|Carroll|Carroll|28015',
 'MSZ028' => '33.4941|-89.6164|Montgomery|Montgomery|28097',
 'MSZ029' => '33.6131|-89.2848|Webster|Webster|28155',
 'MSZ030' => '33.6557|-88.7815|Clay|Clay|28025',
 'MSZ031' => '33.4729|-88.4433|Lowndes|Lowndes|28087',
 'MSZ032' => '33.3473|-89.2484|Choctaw|Choctaw|28019',
 'MSZ033' => '33.425|-88.8793|Oktibbeha|Oktibbeha|28105',
 'MSZ034' => '33.2836|-90.9474|Washington|Washington|28151',
 'MSZ035' => '33.1287|-90.5265|Humphreys|Humphreys|28053',
 'MSZ036' => '33.1235|-90.0921|Holmes|Holmes|28051',
 'MSZ037' => '33.0863|-89.5817|Attala|Attala|28007',
 'MSZ038' => '33.0885|-89.0344|Winston|Winston|28159',
 'MSZ039' => '33.1101|-88.5698|Noxubee|Noxubee|28103',
 'MSZ040' => '32.7414|-90.9892|Issaquena|Issaquena|28055',
 'MSZ041' => '32.8797|-90.8132|Sharkey|Sharkey|28125',
 'MSZ042' => '32.7804|-90.3965|Yazoo|Yazoo|28163',
 'MSZ043' => '32.6347|-90.0338|Madison|Madison|28089',
 'MSZ044' => '32.7535|-89.5241|Leake|Leake|28079',
 'MSZ045' => '32.7535|-89.1176|Neshoba|Neshoba|28099',
 'MSZ046' => '32.7546|-88.6412|Kemper|Kemper|28069',
 'MSZ047' => '32.3574|-90.8521|Warren|Warren|28149',
 'MSZ048' => '32.2667|-90.4427|Hinds|Hinds|28049',
 'MSZ049' => '32.2641|-89.9457|Rankin|Rankin|28121',
 'MSZ050' => '32.4064|-89.5376|Scott|Scott|28123',
 'MSZ051' => '32.4002|-89.1188|Newton|Newton|28101',
 'MSZ052' => '32.4043|-88.6626|Lauderdale|Lauderdale|28075',
 'MSZ053' => '31.9737|-90.9118|Claiborne|Claiborne|28021',
 'MSZ054' => '31.8692|-90.4488|Copiah|Copiah|28029',
 'MSZ055' => '31.9132|-89.9195|Simpson|Simpson|28127',
 'MSZ056' => '32.0177|-89.5067|Smith|Smith|28129',
 'MSZ057' => '32.0191|-89.1188|Jasper|Jasper|28061',
 'MSZ058' => '32.0414|-88.6894|Clarke|Clarke|28023',
 'MSZ059' => '31.7342|-91.0371|Jefferson|Jefferson|28063',
 'MSZ060' => '31.4832|-91.3531|Adams|Adams|28001',
 'MSZ061' => '31.4772|-90.8978|Franklin|Franklin|28037',
 'MSZ062' => '31.5324|-90.454|Lincoln|Lincoln|28085',
 'MSZ063' => '31.5502|-90.107|Lawrence|Lawrence|28077',
 'MSZ064' => '31.5696|-89.823|Jefferson Davis|Jefferson Davis|28065',
 'MSZ065' => '31.6332|-89.5526|Covington|Covington|28031',
 'MSZ066' => '31.6226|-89.1688|Jones|Jones|28067',
 'MSZ067' => '31.6408|-88.6958|Wayne|Wayne|28153',
 'MSZ068' => '31.161|-91.3109|Wilkinson|Wilkinson|28157',
 'MSZ069' => '31.1744|-90.8045|Amite|Amite|28005',
 'MSZ070' => '31.1749|-90.4042|Pike|Pike|28113',
 'MSZ071' => '31.1485|-90.1061|Walthall|Walthall|28147',
 'MSZ072' => '31.2308|-89.8224|Marion|Marion|28091',
 'MSZ073' => '31.2059|-89.5087|Lamar|Lamar|28073',
 'MSZ074' => '31.1889|-89.2579|Forrest|Forrest|28035',
 'MSZ075' => '31.1721|-88.9923|Perry|Perry|28111',
 'MSZ076' => '31.2142|-88.6392|Greene|Greene|28041',
 'MSZ077' => '30.7686|-89.5898|Pearl River|Pearl River|28109',
 'MSZ078' => '30.79|-89.1177|Stone|Stone|28131',
 'MSZ079' => '30.8626|-88.644|George|George|28039',
 'MSZ083' => '30.5171|-89.4768|Northern Hancock|Hancock|28045',
 'MSZ084' => '30.5627|-89.1206|Northern Harrison|Harrison|28047',
 'MSZ085' => '30.6348|-88.6549|Northern Jackson|Jackson|28059',
 'MSZ086' => '30.4164|-89.4887|Southern Hancock|Hancock|28045',
 'MSZ087' => '30.4062|-89.1138|Southern Harrison|Harrison|28047',
 'MSZ088' => '30.4468|-88.6154|Southern Jackson|Jackson|28059',
 'MTC001' => '45.1328|-112.8988|Beaverhead||',
 'MTC003' => '45.4235|-107.4897|Big Horn||',
 'MTC005' => '48.4327|-108.9586|Blaine||',
 'MTC007' => '46.3319|-111.4955|Broadwater||',
 'MTC009' => '45.2273|-109.0283|Carbon||',
 'MTC011' => '45.5168|-104.5362|Carter||',
 'MTC013' => '47.3080|-111.3472|Cascade||',
 'MTC015' => '47.8806|-110.4352|Chouteau||',
 'MTC017' => '46.2527|-105.5718|Custer||',
 'MTC019' => '48.7838|-105.5485|Daniels||',
 'MTC021' => '47.2664|-104.8994|Dawson||',
 'MTC023' => '46.0608|-113.0677|Deer Lodge||',
 'MTC025' => '46.3340|-104.4174|Fallon||',
 'MTC027' => '47.2636|-109.2243|Fergus||',
 'MTC029' => '48.2951|-114.0496|Flathead||',
 'MTC031' => '45.5403|-111.1703|Gallatin||',
 'MTC033' => '47.2777|-106.9928|Garfield||',
 'MTC035' => '48.7058|-112.9950|Glacier||',
 'MTC037' => '46.3812|-109.1749|Golden Valley||',
 'MTC039' => '46.4045|-113.4403|Granite||',
 'MTC041' => '48.6282|-110.1113|Hill||',
 'MTC043' => '46.1485|-112.0937|Jefferson||',
 'MTC045' => '47.0455|-110.2661|Judith Basin||',
 'MTC047' => '47.6459|-114.0892|Lake||',
 'MTC049' => '47.1223|-112.3903|Lewis and Clark||',
 'MTC051' => '48.5617|-111.0246|Liberty||',
 'MTC053' => '48.5425|-115.4051|Lincoln||',
 'MTC055' => '47.6452|-105.7953|McCone||',
 'MTC057' => '45.3008|-111.9203|Madison||',
 'MTC059' => '46.5982|-110.8856|Meagher||',
 'MTC061' => '47.1474|-114.9985|Mineral||',
 'MTC063' => '47.0364|-113.9237|Missoula||',
 'MTC065' => '46.4966|-108.3977|Musselshell||',
 'MTC067' => '45.4884|-110.5263|Park||',
 'MTC069' => '47.1175|-108.2501|Petroleum||',
 'MTC071' => '48.2591|-107.9133|Phillips||',
 'MTC073' => '48.2283|-112.2288|Pondera||',
 'MTC075' => '45.3950|-105.6301|Powder River||',
 'MTC077' => '46.8566|-112.9362|Powell||',
 'MTC079' => '46.8605|-105.3780|Prairie||',
 'MTC081' => '46.0817|-114.1207|Ravalli||',
 'MTC083' => '47.7879|-104.5613|Richland||',
 'MTC085' => '48.2946|-105.0165|Roosevelt||',
 'MTC087' => '46.2297|-106.7308|Rosebud||',
 'MTC089' => '47.6749|-115.1333|Sanders||',
 'MTC091' => '48.7212|-104.5046|Sheridan||',
 'MTC093' => '45.9024|-112.6567|Silver Bow||',
 'MTC095' => '45.6694|-109.3948|Stillwater||',
 'MTC097' => '45.8137|-109.9410|Sweet Grass||',
 'MTC099' => '47.8373|-112.2408|Teton||',
 'MTC101' => '48.6552|-111.6957|Toole||',
 'MTC103' => '46.2115|-107.2717|Treasure||',
 'MTC105' => '48.3653|-106.6675|Valley||',
 'MTC107' => '46.4664|-109.8444|Wheatland||',
 'MTC109' => '46.9653|-104.2490|Wibaux||',
 'MTC111' => '45.9372|-108.2744|Yellowstone||',
 'MTZ001' => '48.3391|-115.2165|Kootenai/Cabinet Region|Flathead|30029	48.3391|-115.2165|Kootenai/Cabinet Region|Lincoln|30053	48.3391|-115.2165|Kootenai/Cabinet Region|Sanders|30089',
 'MTZ002' => '48.2755|-113.8037|West Glacier/Bob Marshall Region|Flathead|30029	48.2755|-113.8037|West Glacier/Bob Marshall Region|Lake|30047',
 'MTZ003' => '47.7732|-114.298|Flathead/Mission Valleys|Flathead|30029	47.7732|-114.298|Flathead/Mission Valleys|Lake|30047	47.7732|-114.298|Flathead/Mission Valleys|Sanders|30089',
 'MTZ004' => '47.3078|-115.0063|Lower Clark Fork Region|Mineral|30061	47.3078|-115.0063|Lower Clark Fork Region|Missoula|30063	47.3078|-115.0063|Lower Clark Fork Region|Sanders|30089',
 'MTZ005' => '46.4888|-114.1079|Missoula/Bitterroot Valleys|Missoula|30063	46.4888|-114.1079|Missoula/Bitterroot Valleys|Ravalli|30081',
 'MTZ006' => '46.1931|-113.9667|Bitterroot/Sapphire Mountains|Granite|30039	46.1931|-113.9667|Bitterroot/Sapphire Mountains|Missoula|30063	46.1931|-113.9667|Bitterroot/Sapphire Mountains|Ravalli|30081',
 'MTZ007' => '46.3886|-112.9185|Butte/Pintlar Region|Deer Lodge|30023	46.3886|-112.9185|Butte/Pintlar Region|Granite|30039	46.3886|-112.9185|Butte/Pintlar Region|Powell|30077	46.3886|-112.9185|Butte/Pintlar Region|Silver Bow|30093',
 'MTZ016' => '48.1191|-107.8379|Central and Southeast Phillips|Phillips|30071',
 'MTZ017' => '48.1821|-106.6828|Central and Southern Valley|Valley|30105',
 'MTZ018' => '48.7838|-105.5485|Daniels|Daniels|30019',
 'MTZ019' => '48.7212|-104.5046|Sheridan|Sheridan|30091',
 'MTZ020' => '48.3139|-105.4045|Western Roosevelt|Roosevelt|30085',
 'MTZ021' => '47.1175|-108.2501|Petroleum|Petroleum|30069',
 'MTZ022' => '47.2777|-106.9928|Garfield|Garfield|30033',
 'MTZ023' => '47.6452|-105.7953|McCone|McCone|30055',
 'MTZ024' => '47.7879|-104.5614|Richland|Richland|30083',
 'MTZ025' => '47.2664|-104.8994|Dawson|Dawson|30021',
 'MTZ026' => '46.8605|-105.3779|Prairie|Prairie|30079',
 'MTZ027' => '46.9653|-104.249|Wibaux|Wibaux|30109',
 'MTZ029' => '46.4966|-108.3977|Musselshell|Musselshell|30065',
 'MTZ030' => '46.2115|-107.2717|Treasure|Treasure|30103',
 'MTZ031' => '46.3849|-106.7762|Northern Rosebud|Rosebud|30087',
 'MTZ032' => '46.2527|-105.5718|Custer|Custer|30017',
 'MTZ033' => '46.334|-104.4174|Fallon|Fallon|30025',
 'MTZ034' => '45.8098|-109.2176|Northern Stillwater|Stillwater|30095',
 'MTZ036' => '45.395|-105.6301|Powder River|Powder River|30075',
 'MTZ037' => '45.5168|-104.5362|Carter|Carter|30011',
 'MTZ040' => '45.9621|-110.6013|Northern Park|Park|30067',
 'MTZ042' => '46.3251|-109.1643|Golden Valley|Golden Valley|30037',
 'MTZ043' => '47.2005|-113.584|Blackfoot Region|Granite|30039	47.2005|-113.584|Blackfoot Region|Lake|30047	47.2005|-113.584|Blackfoot Region|Missoula|30063	47.2005|-113.584|Blackfoot Region|Powell|30077',
 'MTZ056' => '45.2833|-109.2924|Red Lodge Foothills|Carbon|30009',
 'MTZ057' => '45.7318|-107.4595|Northern Big Horn|Big Horn|30003',
 'MTZ058' => '45.4286|-106.4963|Southern Rosebud|Rosebud|30087',
 'MTZ059' => '48.7814|-107.7403|Northern Phillips|Phillips|30071',
 'MTZ060' => '47.8159|-108.487|Southwest Phillips|Phillips|30071',
 'MTZ061' => '48.7789|-106.6331|Northern Valley|Valley|30105',
 'MTZ062' => '48.2705|-104.5328|Eastern Roosevelt|Roosevelt|30085',
 'MTZ063' => '46.6384|-109.6782|Judith Gap|Golden Valley|30037	46.6384|-109.6782|Judith Gap|Wheatland|30107',
 'MTZ064' => '45.3939|-110.7098|Paradise Valley|Park|30067',
 'MTZ065' => '45.6959|-110.5011|Livingston Area|Park|30067',
 'MTZ066' => '45.5734|-109.8035|Beartooth Foothills|Stillwater|30095	45.5734|-109.8035|Beartooth Foothills|Sweet Grass|30097',
 'MTZ067' => '45.2637|-110.1893|Absaroka/Beartooth Mountains|Carbon|30009	45.2637|-110.1893|Absaroka/Beartooth Mountains|Park|30067	45.2637|-110.1893|Absaroka/Beartooth Mountains|Stillwater|30095	45.2637|-110.1893|Absaroka/Beartooth Mountains|Sweet Grass|30097',
 'MTZ068' => '46.0653|-110.3156|Crazy Mountains|Park|30067	46.0653|-110.3156|Crazy Mountains|Sweet Grass|30097	46.0653|-110.3156|Crazy Mountains|Wheatland|30107',
 'MTZ138' => '45.2712|-107.3455|Southern Big Horn|Big Horn|30003',
 'MTZ139' => '45.1361|-108.8466|Southeastern Carbon|Big Horn|30003	45.1361|-108.8466|Southeastern Carbon|Carbon|30009',
 'MTZ141' => '45.9146|-109.8014|Northern Sweet Grass|Sweet Grass|30097',
 'MTZ169' => '45.1827|-108.1417|Bighorn Canyon|Big Horn|30003	45.1827|-108.1417|Bighorn Canyon|Carbon|30009',
 'MTZ170' => '45.4565|-108.9346|Northern Carbon|Carbon|30009',
 'MTZ171' => '45.1683|-108.2446|Pryor/Northern Bighorn Mountains|Big Horn|30003	45.1683|-108.2446|Pryor/Northern Bighorn Mountains|Carbon|30009',
 'MTZ172' => '46.1376|-110.0264|Melville Foothills|Sweet Grass|30097	46.1376|-110.0264|Melville Foothills|Wheatland|30107',
 'MTZ173' => '46.1581|-107.9135|Northeastern Yellowstone|Yellowstone|30111',
 'MTZ228' => '46.4003|-109.8006|Southern Wheatland|Wheatland|30107',
 'MTZ235' => '45.8003|-108.4981|Southwestern Yellowstone|Yellowstone|30111',
 'MTZ301' => '48.6372|-113.422|East Glacier Park Region|Glacier|30035	48.6372|-113.422|East Glacier Park Region|Pondera|30073',
 'MTZ302' => '48.5425|-112.8524|Northern High Plains|Glacier|30035	48.5425|-112.8524|Northern High Plains|Pondera|30073',
 'MTZ303' => '48.6453|-112.2726|Eastern Glacier, Western Toole, and Central Pondera|Glacier|30035	48.6453|-112.2726|Eastern Glacier, Western Toole, and Central Pondera|Pondera|30073	48.6453|-112.2726|Eastern Glacier, Western Toole, and Central Pondera|Toole|30101',
 'MTZ304' => '48.5958|-111.2827|Eastern Toole and Liberty|Toole|30101	48.5958|-111.2827|Eastern Toole and Liberty|Liberty|30051',
 'MTZ305' => '48.6691|-110.1728|Hill County|Hill|30041',
 'MTZ306' => '48.7135|-108.8425|Northern Blaine County|Blaine|30005',
 'MTZ307' => '47.5101|-112.7733|Southern Rocky Mountain Front|Lewis and Clark|30049	47.5101|-112.7733|Southern Rocky Mountain Front|Teton|30099',
 'MTZ308' => '47.6849|-112.3405|Southern High Plains|Lewis and Clark|30049	47.6849|-112.3405|Southern High Plains|Teton|30099',
 'MTZ309' => '47.9541|-111.7646|Eastern Pondera and Eastern Teton|Pondera|30073	47.9541|-111.7646|Eastern Pondera and Eastern Teton|Teton|30099',
 'MTZ310' => '47.8751|-110.5845|Western and Central Chouteau County|Chouteau|30015',
 'MTZ311' => '48.1247|-109.3165|Bears Paw Mountains and Southern Blaine|Hill|30041	48.1247|-109.3165|Bears Paw Mountains and Southern Blaine|Blaine|30005	48.1247|-109.3165|Bears Paw Mountains and Southern Blaine|Chouteau|30015',
 'MTZ312' => '47.4133|-111.3871|Cascade County below 5000ft|Cascade|30013',
 'MTZ313' => '47.098|-110.1395|Judith Basin County and Judith Gap|Judith Basin|30045	47.098|-110.1395|Judith Basin County and Judith Gap|Fergus|30027',
 'MTZ314' => '47.346|-109.2016|Fergus County below 4500ft|Fergus|30027',
 'MTZ315' => '46.806|-112.4247|Upper Blackfoot and MacDonald Pass|Lewis and Clark|30049',
 'MTZ316' => '47.0048|-111.9932|Gates of the Mountains|Lewis and Clark|30049	47.0048|-111.9932|Gates of the Mountains|Cascade|30013',
 'MTZ317' => '46.9742|-110.7705|Little Belt and Highwood Mountains|Cascade|30013	46.9742|-110.7705|Little Belt and Highwood Mountains|Meagher|30059	46.9742|-110.7705|Little Belt and Highwood Mountains|Judith Basin|30045	46.9742|-110.7705|Little Belt and Highwood Mountains|Chouteau|30015',
 'MTZ318' => '46.9085|-109.2789|Snowy and Judith Mountains|Fergus|30027',
 'MTZ319' => '46.6543|-111.9392|Helena Valley|Lewis and Clark|30049',
 'MTZ320' => '46.3337|-111.1323|Big Belt, Bridger and Castle Mountains|Lewis and Clark|30049	46.3337|-111.1323|Big Belt, Bridger and Castle Mountains|Broadwater|30007	46.3337|-111.1323|Big Belt, Bridger and Castle Mountains|Gallatin|30031	46.3337|-111.1323|Big Belt, Bridger and Castle Mountains|Meagher|30059',
 'MTZ321' => '46.5176|-110.8308|Meagher County Valleys|Meagher|30059',
 'MTZ322' => '46.2336|-112.1068|Elkhorn and Boulder Mountains|Jefferson|30043	46.2336|-112.1068|Elkhorn and Boulder Mountains|Broadwater|30007',
 'MTZ323' => '46.2952|-111.5425|Canyon Ferry Area|Lewis and Clark|30049	46.2952|-111.5425|Canyon Ferry Area|Broadwater|30007',
 'MTZ324' => '45.8502|-111.8024|Missouri Headwaters|Jefferson|30043	45.8502|-111.8024|Missouri Headwaters|Madison|30057	45.8502|-111.8024|Missouri Headwaters|Gallatin|30031',
 'MTZ325' => '45.3268|-111.6756|Madison River Valley|Madison|30057',
 'MTZ326' => '45.7532|-111.196|Gallatin Valley|Gallatin|30031',
 'MTZ327' => '45.4903|-113.2984|Northwest Beaverhead County|Beaverhead|30001',
 'MTZ328' => '45.2964|-112.5631|Beaverhead and Western Madison below 6000ft|Beaverhead|30001	45.2964|-112.5631|Beaverhead and Western Madison below 6000ft|Madison|30057',
 'MTZ329' => '44.8223|-112.6561|Ruby Mountains and Southern Beaverhead Mountains|Beaverhead|30001	44.8223|-112.6561|Ruby Mountains and Southern Beaverhead Mountains|Madison|30057',
 'MTZ330' => '45.0978|-111.6002|Gallatin and Madison County Mountains and Centennial Mountains|Beaverhead|30001	45.0978|-111.6002|Gallatin and Madison County Mountains and Centennial Mountains|Madison|30057	45.0978|-111.6002|Gallatin and Madison County Mountains and Centennial Mountains|Gallatin|30031',
 'NCC001' => '36.0440|-79.3995|Alamance||',
 'NCC003' => '35.9211|-81.1772|Alexander||',
 'NCC005' => '36.4915|-81.1286|Alleghany||',
 'NCC007' => '34.9738|-80.1027|Anson||',
 'NCC009' => '36.4346|-81.5010|Ashe||',
 'NCC011' => '36.0766|-81.9224|Avery||',
 'NCC013' => '35.4947|-76.8631|Beaufort||',
 'NCC015' => '36.1197|-76.7246|Bertie||	36.0662|-76.9791|Bertie||',
 'NCC017' => '34.6143|-78.5632|Bladen||',
 'NCC019' => '33.9633|-78.0599|Brunswick||	34.0747|-78.2441|Brunswick||',
 'NCC021' => '35.6112|-82.5302|Buncombe||',
 'NCC023' => '35.7495|-81.7045|Burke||',
 'NCC025' => '35.3868|-80.5519|Cabarrus||',
 'NCC027' => '35.9530|-81.5465|Caldwell||',
 'NCC029' => '36.3902|-76.2101|Camden||	36.2239|-76.0277|Camden||',
 'NCC031' => '34.8306|-76.6707|Carteret||',
 'NCC033' => '36.3934|-79.3337|Caswell||',
 'NCC035' => '35.6626|-81.2144|Catawba||',
 'NCC037' => '35.7027|-79.2553|Chatham||',
 'NCC039' => '35.1339|-84.0635|Cherokee||',
 'NCC041' => '36.1507|-76.6080|Chowan||	36.1513|-76.6914|Chowan||',
 'NCC043' => '35.0572|-83.7502|Clay||',
 'NCC045' => '35.3340|-81.5554|Cleveland||',
 'NCC047' => '34.2655|-78.6550|Columbus||',
 'NCC049' => '35.1262|-77.0969|Craven||',
 'NCC051' => '35.0485|-78.8273|Cumberland||',
 'NCC053' => '36.4011|-76.0141|Currituck||	36.2197|-75.9184|Currituck||',
 'NCC055' => '35.7715|-75.8009|Dare||',
 'NCC057' => '35.7932|-80.2127|Davidson||',
 'NCC059' => '35.9292|-80.5446|Davie||',
 'NCC061' => '34.9365|-77.9333|Duplin||',
 'NCC063' => '36.0359|-78.8764|Durham||',
 'NCC065' => '35.9129|-77.5971|Edgecombe||',
 'NCC067' => '36.1304|-80.2563|Forsyth||',
 'NCC069' => '36.0827|-78.2857|Franklin||',
 'NCC071' => '35.2945|-81.1801|Gaston||',
 'NCC073' => '36.4449|-76.7011|Gates||',
 'NCC075' => '35.3502|-83.8335|Graham||',
 'NCC077' => '36.3040|-78.6530|Granville||',
 'NCC079' => '35.4852|-77.6756|Greene||',
 'NCC081' => '36.0794|-79.7890|Guilford||',
 'NCC083' => '36.2575|-77.6519|Halifax||',
 'NCC085' => '35.3687|-78.8693|Harnett||',
 'NCC087' => '35.5561|-82.9822|Haywood||',
 'NCC089' => '35.3362|-82.4799|Henderson||',
 'NCC091' => '36.3590|-76.9837|Hertford||	36.3111|-76.7495|Hertford||',
 'NCC093' => '35.0174|-79.2371|Hoke||',
 'NCC095' => '35.5318|-76.2485|Hyde||',
 'NCC097' => '35.8072|-80.8736|Iredell||',
 'NCC099' => '35.2874|-83.1408|Jackson||',
 'NCC101' => '35.5176|-78.3657|Johnston||',
 'NCC103' => '35.0222|-77.3555|Jones||',
 'NCC105' => '35.4750|-79.1716|Lee||',
 'NCC107' => '35.2393|-77.6416|Lenoir||',
 'NCC109' => '35.4862|-81.2239|Lincoln||',
 'NCC111' => '35.6813|-82.0487|McDowell||',
 'NCC113' => '35.1504|-83.4221|Macon||',
 'NCC115' => '35.8581|-82.7057|Madison||',
 'NCC117' => '35.8416|-77.1072|Martin||',
 'NCC119' => '35.2468|-80.8328|Mecklenburg||',
 'NCC121' => '36.0133|-82.1634|Mitchell||',
 'NCC123' => '35.3324|-79.9054|Montgomery||',
 'NCC125' => '35.3107|-79.4813|Moore||',
 'NCC127' => '35.9672|-77.9864|Nash||',
 'NCC129' => '34.1047|-77.8921|New Hanover||	34.2422|-77.8846|New Hanover||',
 'NCC131' => '36.4177|-77.3967|Northampton||',
 'NCC133' => '34.7374|-77.4342|Onslow||',
 'NCC135' => '36.0614|-79.1205|Orange||',
 'NCC137' => '35.1407|-76.7488|Pamlico||',
 'NCC139' => '36.2974|-76.2867|Pasquotank||	36.2046|-76.1331|Pasquotank||',
 'NCC141' => '34.5255|-77.9070|Pender||	34.3860|-77.6199|Pender||',
 'NCC143' => '36.2069|-76.4419|Perquimans||	36.1410|-76.3487|Perquimans||',
 'NCC145' => '36.3901|-78.9717|Person||',
 'NCC147' => '35.5935|-77.3748|Pitt||',
 'NCC149' => '35.2793|-82.1696|Polk||',
 'NCC151' => '35.7103|-79.8060|Randolph||',
 'NCC153' => '35.0059|-79.7480|Richmond||',
 'NCC155' => '34.6401|-79.1035|Robeson||',
 'NCC157' => '36.3961|-79.7751|Rockingham||',
 'NCC159' => '35.6396|-80.5247|Rowan||',
 'NCC161' => '35.4023|-81.9202|Rutherford||',
 'NCC163' => '34.9915|-78.3712|Sampson||',
 'NCC165' => '34.8411|-79.4805|Scotland||',
 'NCC167' => '35.3120|-80.2507|Stanly||',
 'NCC169' => '36.4018|-80.2395|Stokes||',
 'NCC171' => '36.4148|-80.6882|Surry||',
 'NCC173' => '35.4867|-83.4927|Swain||',
 'NCC175' => '35.2022|-82.7983|Transylvania||',
 'NCC177' => '35.8161|-76.2118|Tyrrell||',
 'NCC179' => '34.9884|-80.5307|Union||',
 'NCC181' => '36.3648|-78.4083|Vance||',
 'NCC183' => '35.7901|-78.6504|Wake||',
 'NCC185' => '36.3966|-78.1069|Warren||',
 'NCC187' => '35.8221|-76.5767|Washington||',
 'NCC189' => '36.2313|-81.6969|Watauga||',
 'NCC191' => '35.3638|-78.0040|Wayne||',
 'NCC193' => '36.2065|-81.1638|Wilkes||',
 'NCC195' => '35.7048|-77.9185|Wilson||',
 'NCC197' => '36.1605|-80.6653|Yadkin||',
 'NCC199' => '35.8989|-82.3076|Yancey||',
 'NCZ001' => '36.4346|-81.501|Ashe|Ashe|37009',
 'NCZ002' => '36.4915|-81.1286|Alleghany|Alleghany|37005',
 'NCZ003' => '36.4148|-80.6882|Surry|Surry|37171',
 'NCZ004' => '36.4018|-80.2395|Stokes|Stokes|37169',
 'NCZ005' => '36.3961|-79.7751|Rockingham|Rockingham|37157',
 'NCZ006' => '36.3934|-79.3337|Caswell|Caswell|37033',
 'NCZ007' => '36.3901|-78.9717|Person|Person|37145',
 'NCZ008' => '36.304|-78.653|Granville|Granville|37077',
 'NCZ009' => '36.3648|-78.4083|Vance|Vance|37181',
 'NCZ010' => '36.3966|-78.1069|Warren|Warren|37185',
 'NCZ011' => '36.2575|-77.6519|Halifax|Halifax|37083',
 'NCZ012' => '36.4177|-77.3967|Northampton|Northampton|37131',
 'NCZ013' => '36.359|-76.9838|Hertford|Hertford|37091',
 'NCZ014' => '36.4444|-76.7017|Gates|Gates|37073',
 'NCZ015' => '36.2974|-76.2867|Pasquotank|Pasquotank|37139',
 'NCZ016' => '36.3902|-76.2101|Camden|Camden|37029',
 'NCZ017' => '36.4012|-76.034|Western Currituck|Currituck|37053',
 'NCZ018' => '36.2313|-81.6969|Watauga|Watauga|37189',
 'NCZ019' => '36.2065|-81.1638|Wilkes|Wilkes|37193',
 'NCZ020' => '36.1605|-80.6653|Yadkin|Yadkin|37197',
 'NCZ021' => '36.1304|-80.2563|Forsyth|Forsyth|37067',
 'NCZ022' => '36.0794|-79.789|Guilford|Guilford|37081',
 'NCZ023' => '36.044|-79.3995|Alamance|Alamance|37001',
 'NCZ024' => '36.0614|-79.1205|Orange|Orange|37135',
 'NCZ025' => '36.0359|-78.8764|Durham|Durham|37063',
 'NCZ026' => '36.0827|-78.2857|Franklin|Franklin|37069',
 'NCZ027' => '35.9672|-77.9865|Nash|Nash|37127',
 'NCZ028' => '35.9129|-77.5971|Edgecombe|Edgecombe|37065',
 'NCZ029' => '35.8416|-77.1071|Martin|Martin|37117',
 'NCZ030' => '36.0662|-76.9791|Bertie|Bertie|37015',
 'NCZ031' => '36.1507|-76.608|Chowan|Chowan|37041',
 'NCZ032' => '36.2069|-76.4419|Perquimans|Perquimans|37143',
 'NCZ033' => '36.0766|-81.9224|Avery|Avery|37011',
 'NCZ035' => '35.9211|-81.1772|Alexander|Alexander|37003',
 'NCZ036' => '35.8072|-80.8736|Iredell|Iredell|37097',
 'NCZ037' => '35.9292|-80.5446|Davie|Davie|37059',
 'NCZ038' => '35.7932|-80.2127|Davidson|Davidson|37057',
 'NCZ039' => '35.7103|-79.806|Randolph|Randolph|37151',
 'NCZ040' => '35.7028|-79.2553|Chatham|Chatham|37037',
 'NCZ041' => '35.7901|-78.6504|Wake|Wake|37183',
 'NCZ042' => '35.5176|-78.3657|Johnston|Johnston|37101',
 'NCZ043' => '35.7048|-77.9185|Wilson|Wilson|37195',
 'NCZ044' => '35.5935|-77.3748|Pitt|Pitt|37147',
 'NCZ045' => '35.8221|-76.5766|Washington|Washington|37187',
 'NCZ046' => '35.8161|-76.2118|Tyrrell|Tyrrell|37177',
 'NCZ047' => '35.7753|-75.8577|Mainland Dare|Dare|37055',
 'NCZ048' => '35.8581|-82.7057|Madison|Madison|37115',
 'NCZ049' => '35.8989|-82.3076|Yancey|Yancey|37199',
 'NCZ050' => '36.0133|-82.1634|Mitchell|Mitchell|37121',
 'NCZ051' => '35.4867|-83.4927|Swain|Swain|37173',
 'NCZ052' => '35.5561|-82.9822|Haywood|Haywood|37087',
 'NCZ053' => '35.6112|-82.5302|Buncombe|Buncombe|37021',
 'NCZ056' => '35.6626|-81.2144|Catawba|Catawba|37035',
 'NCZ057' => '35.6396|-80.5247|Rowan|Rowan|37159',
 'NCZ058' => '35.3502|-83.8335|Graham|Graham|37075',
 'NCZ059' => '35.3638|-83.1778|Northern Jackson|Jackson|37099',
 'NCZ060' => '35.1339|-84.0635|Cherokee|Cherokee|37039',
 'NCZ061' => '35.0572|-83.7502|Clay|Clay|37043',
 'NCZ062' => '35.1504|-83.4221|Macon|Macon|37113',
 'NCZ063' => '35.1614|-83.0799|Southern Jackson|Jackson|37099',
 'NCZ064' => '35.2022|-82.7983|Transylvania|Transylvania|37175',
 'NCZ065' => '35.3362|-82.4799|Henderson|Henderson|37089',
 'NCZ068' => '35.334|-81.5554|Cleveland|Cleveland|37045',
 'NCZ069' => '35.4862|-81.2239|Lincoln|Lincoln|37109',
 'NCZ070' => '35.2945|-81.1801|Gaston|Gaston|37071',
 'NCZ071' => '35.2468|-80.8328|Mecklenburg|Mecklenburg|37119',
 'NCZ072' => '35.3868|-80.5519|Cabarrus|Cabarrus|37025',
 'NCZ073' => '35.312|-80.2507|Stanly|Stanly|37167',
 'NCZ074' => '35.3324|-79.9054|Montgomery|Montgomery|37123',
 'NCZ075' => '35.3107|-79.4813|Moore|Moore|37125',
 'NCZ076' => '35.475|-79.1716|Lee|Lee|37105',
 'NCZ077' => '35.3687|-78.8693|Harnett|Harnett|37085',
 'NCZ078' => '35.3638|-78.004|Wayne|Wayne|37191',
 'NCZ079' => '35.4852|-77.6756|Greene|Greene|37079',
 'NCZ080' => '35.4947|-76.8631|Beaufort|Beaufort|37013',
 'NCZ081' => '35.5375|-76.2532|Mainland Hyde|Hyde|37095',
 'NCZ082' => '34.9884|-80.5307|Union|Union|37179',
 'NCZ083' => '34.9738|-80.1027|Anson|Anson|37007',
 'NCZ084' => '35.0059|-79.748|Richmond|Richmond|37153',
 'NCZ085' => '34.8411|-79.4805|Scotland|Scotland|37165',
 'NCZ086' => '35.0174|-79.2371|Hoke|Hoke|37093',
 'NCZ087' => '34.6401|-79.1035|Robeson|Robeson|37155',
 'NCZ088' => '35.0485|-78.8273|Cumberland|Cumberland|37051',
 'NCZ089' => '34.9915|-78.3712|Sampson|Sampson|37163',
 'NCZ090' => '34.9365|-77.9333|Duplin|Duplin|37061',
 'NCZ091' => '35.2393|-77.6416|Lenoir|Lenoir|37107',
 'NCZ092' => '35.0222|-77.3555|Jones|Jones|37103',
 'NCZ094' => '35.1407|-76.7487|Pamlico|Pamlico|37137',
 'NCZ096' => '34.6143|-78.5632|Bladen|Bladen|37017',
 'NCZ099' => '34.2655|-78.655|Columbus|Columbus|37047',
 'NCZ102' => '36.4001|-75.844|Eastern Currituck|Currituck|37053',
 'NCZ105' => '34.5328|-77.9208|Inland Pender|Pender|37141',
 'NCZ106' => '34.3814|-77.6465|Coastal Pender|Pender|37141',
 'NCZ107' => '34.2817|-77.8983|Inland New Hanover|New Hanover|37129',
 'NCZ108' => '34.1372|-77.8612|Coastal New Hanover|New Hanover|37129	34.1372|-77.8612|Coastal New Hanover|New Hanover|37129',
 'NCZ109' => '34.1066|-78.2492|Inland Brunswick|Brunswick|37019',
 'NCZ110' => '33.9367|-78.2222|Coastal Brunswick|Brunswick|37019	33.9529|-77.9712|Coastal Brunswick|Brunswick|37019',
 'NCZ193' => '35.2508|-77.1891|Northern Craven|Craven|37049',
 'NCZ194' => '34.9541|-76.9698|Southern Craven |Craven|37049',
 'NCZ195' => '34.7672|-76.9068|West Carteret |Carteret|37031',
 'NCZ196' => '34.8732|-76.5121|East Carteret |Carteret|37031',
 'NCZ198' => '34.7775|-77.4736|Inland Onslow|Onslow|37133',
 'NCZ199' => '34.6161|-77.3148|Coastal Onslow |Onslow|37133',
 'NCZ203' => '35.9623|-75.6658|Northern Outer Banks |Dare|37055',
 'NCZ204' => '35.1283|-75.9146|Ocracoke Island |Hyde|37095',
 'NCZ205' => '35.3945|-75.5413|Hatteras Island |Dare|37055',
 'NCZ501' => '36.0301|-81.6408|Caldwell Mountains|Caldwell|37027',
 'NCZ502' => '35.9012|-81.4832|Greater Caldwell|Caldwell|37027',
 'NCZ503' => '35.8886|-81.862|Burke Mountains|Burke|37023',
 'NCZ504' => '35.7148|-81.6652|Greater Burke|Burke|37023',
 'NCZ505' => '35.7082|-82.1054|McDowell Mountains|McDowell|37111',
 'NCZ506' => '35.6327|-81.9458|Eastern McDowell|McDowell|37111',
 'NCZ507' => '35.465|-82.193|Rutherford Mountains|Rutherford|37161',
 'NCZ508' => '35.3952|-81.8892|Greater Rutherford|Rutherford|37161',
 'NCZ509' => '35.2856|-82.293|Polk Mountains|Polk|37149',
 'NCZ510' => '35.2776|-82.1356|Eastern Polk|Polk|37149',
 'NDC001' => '46.0969|-102.5285|Adams||',
 'NDC003' => '46.9361|-98.0716|Barnes||',
 'NDC005' => '48.0694|-99.3660|Benson||',
 'NDC007' => '47.0234|-103.3764|Billings||',
 'NDC009' => '48.7921|-100.8335|Bottineau||',
 'NDC011' => '46.1126|-103.5207|Bowman||',
 'NDC013' => '48.7909|-102.5182|Burke||',
 'NDC015' => '46.9774|-100.4688|Burleigh||',
 'NDC017' => '46.9330|-97.2481|Cass||',
 'NDC019' => '48.7721|-98.4650|Cavalier||',
 'NDC021' => '46.1102|-98.5045|Dickey||',
 'NDC023' => '48.8149|-103.4873|Divide||',
 'NDC025' => '47.3568|-102.6183|Dunn||',
 'NDC027' => '47.7176|-98.9016|Eddy||',
 'NDC029' => '46.2851|-100.2388|Emmons||',
 'NDC031' => '47.4571|-98.8831|Foster||',
 'NDC033' => '46.9402|-103.8467|Golden Valley||',
 'NDC035' => '47.9219|-97.4570|Grand Forks||',
 'NDC037' => '46.3583|-101.6397|Grant||',
 'NDC039' => '47.4572|-98.2371|Griggs||',
 'NDC041' => '46.4326|-102.4603|Hettinger||',
 'NDC043' => '46.9802|-99.7801|Kidder||',
 'NDC045' => '46.4569|-98.5355|LaMoure||',
 'NDC047' => '46.4574|-99.4775|Logan||',
 'NDC049' => '48.2346|-100.6363|McHenry||',
 'NDC051' => '46.1119|-99.4412|McIntosh||',
 'NDC053' => '47.7402|-103.3953|McKenzie||',
 'NDC055' => '47.6070|-101.3219|McLean||',
 'NDC057' => '47.3092|-101.8315|Mercer||',
 'NDC059' => '46.7161|-101.2811|Morton||',
 'NDC061' => '48.2013|-102.3556|Mountrail||',
 'NDC063' => '47.9216|-98.1921|Nelson||',
 'NDC065' => '47.1153|-101.3403|Oliver||',
 'NDC067' => '48.7672|-97.5517|Pembina||',
 'NDC069' => '48.2496|-99.9718|Pierce||',
 'NDC071' => '48.2689|-98.7201|Ramsey||',
 'NDC073' => '46.4561|-97.6575|Ransom||',
 'NDC075' => '48.7192|-101.6581|Renville||',
 'NDC077' => '46.2646|-96.9483|Richland||',
 'NDC079' => '48.7724|-99.8411|Rolette||',
 'NDC081' => '46.1078|-97.6306|Sargent||',
 'NDC083' => '47.5754|-100.3456|Sheridan||',
 'NDC085' => '46.1127|-101.0404|Sioux||',
 'NDC087' => '46.4472|-103.4599|Slope||',
 'NDC089' => '46.8107|-102.6550|Stark||',
 'NDC091' => '47.4562|-97.7247|Steele||',
 'NDC093' => '46.9792|-98.9588|Stutsman||',
 'NDC095' => '48.6856|-99.2459|Towner||',
 'NDC097' => '47.4542|-97.1615|Traill||',
 'NDC099' => '48.3694|-97.7214|Walsh||',
 'NDC101' => '48.2218|-101.5419|Ward||',
 'NDC103' => '47.5876|-99.6610|Wells||',
 'NDC105' => '48.3437|-103.4802|Williams||',
 'NDZ001' => '48.8149|-103.4873|Divide|Divide|38023',
 'NDZ002' => '48.7909|-102.5183|Burke|Burke|38013',
 'NDZ003' => '48.7192|-101.6581|Renville|Renville|38075',
 'NDZ004' => '48.7921|-100.8335|Bottineau|Bottineau|38009',
 'NDZ005' => '48.7724|-99.8411|Rolette|Rolette|38079',
 'NDZ006' => '48.6856|-99.2459|Towner|Towner|38095',
 'NDZ007' => '48.7722|-98.465|Cavalier|Cavalier|38019',
 'NDZ008' => '48.7672|-97.5517|Pembina|Pembina|38067',
 'NDZ009' => '48.3437|-103.4802|Williams|Williams|38105',
 'NDZ010' => '48.2013|-102.3556|Mountrail|Mountrail|38061',
 'NDZ011' => '48.2218|-101.5418|Ward|Ward|38101',
 'NDZ012' => '48.2346|-100.6363|McHenry|McHenry|38049',
 'NDZ013' => '48.2496|-99.9718|Pierce|Pierce|38069',
 'NDZ014' => '48.0694|-99.3659|Benson|Benson|38005',
 'NDZ015' => '48.269|-98.7201|Ramsey|Ramsey|38071',
 'NDZ016' => '48.3683|-97.4998|Eastern Walsh County|Walsh|38099',
 'NDZ017' => '47.7402|-103.3953|McKenzie|McKenzie|38053',
 'NDZ018' => '47.3568|-102.6182|Dunn|Dunn|38025',
 'NDZ019' => '47.3092|-101.8315|Mercer|Mercer|38057',
 'NDZ020' => '47.1153|-101.3403|Oliver|Oliver|38065',
 'NDZ021' => '47.607|-101.3218|McLean|McLean|38055',
 'NDZ022' => '47.5754|-100.3456|Sheridan|Sheridan|38083',
 'NDZ023' => '47.5876|-99.661|Wells|Wells|38103',
 'NDZ024' => '47.7176|-98.9016|Eddy|Eddy|38027',
 'NDZ025' => '47.4571|-98.8831|Foster|Foster|38031',
 'NDZ026' => '47.9216|-98.1921|Nelson|Nelson|38063',
 'NDZ027' => '47.9219|-97.457|Grand Forks|Grand Forks|38035',
 'NDZ028' => '47.4572|-98.2371|Griggs|Griggs|38039',
 'NDZ029' => '47.4562|-97.7247|Steele|Steele|38091',
 'NDZ030' => '47.4542|-97.1615|Traill|Traill|38097',
 'NDZ031' => '46.9402|-103.8467|Golden Valley|Golden Valley|38033',
 'NDZ032' => '47.0235|-103.3764|Billings|Billings|38007',
 'NDZ033' => '46.8107|-102.655|Stark|Stark|38089',
 'NDZ034' => '46.7161|-101.2811|Morton|Morton|38059',
 'NDZ035' => '46.9774|-100.4688|Burleigh|Burleigh|38015',
 'NDZ036' => '46.9802|-99.7801|Kidder|Kidder|38043',
 'NDZ037' => '46.9792|-98.9588|Stutsman|Stutsman|38093',
 'NDZ038' => '46.9361|-98.0716|Barnes|Barnes|38003',
 'NDZ039' => '46.933|-97.2481|Cass|Cass|38017',
 'NDZ040' => '46.4472|-103.4599|Slope|Slope|38087',
 'NDZ041' => '46.4326|-102.4604|Hettinger|Hettinger|38041',
 'NDZ042' => '46.3583|-101.6397|Grant|Grant|38037',
 'NDZ043' => '46.1126|-103.5207|Bowman|Bowman|38011',
 'NDZ044' => '46.0969|-102.5285|Adams|Adams|38001',
 'NDZ045' => '46.1126|-101.0405|Sioux|Sioux|38085',
 'NDZ046' => '46.2851|-100.2388|Emmons|Emmons|38029',
 'NDZ047' => '46.4574|-99.4775|Logan|Logan|38047',
 'NDZ048' => '46.4569|-98.5355|La Moure|LaMoure|38045',
 'NDZ049' => '46.4561|-97.6575|Ransom|Ransom|38073',
 'NDZ050' => '46.1119|-99.4412|McIntosh|McIntosh|38051',
 'NDZ051' => '46.1102|-98.5046|Dickey|Dickey|38021',
 'NDZ052' => '46.1078|-97.6306|Sargent|Sargent|38081',
 'NDZ053' => '46.2646|-96.9483|Richland|Richland|38077',
 'NDZ054' => '48.3714|-98.084|Western Walsh County|Walsh|38099',
 'NEC001' => '40.5245|-98.5012|Adams||',
 'NEC003' => '42.1770|-98.0667|Antelope||',
 'NEC005' => '41.5689|-101.6959|Arthur||',
 'NEC007' => '41.5460|-103.7104|Banner||',
 'NEC009' => '41.9128|-99.9769|Blaine||',
 'NEC011' => '41.7068|-98.0673|Boone||',
 'NEC013' => '42.2198|-103.0857|Box Butte||',
 'NEC015' => '42.8997|-98.7665|Boyd||',
 'NEC017' => '42.4300|-99.9295|Brown||',
 'NEC019' => '40.8551|-99.0750|Buffalo||',
 'NEC021' => '41.8515|-96.3287|Burt||',
 'NEC023' => '41.2250|-97.1314|Butler||',
 'NEC025' => '40.9098|-96.1408|Cass||',
 'NEC027' => '42.5993|-97.2523|Cedar||',
 'NEC029' => '40.5242|-101.6979|Chase||',
 'NEC031' => '42.5449|-101.1186|Cherry||',
 'NEC033' => '41.2198|-102.9950|Cheyenne||',
 'NEC035' => '40.5244|-98.0512|Clay||',
 'NEC037' => '41.5733|-97.0865|Colfax||',
 'NEC039' => '41.9164|-96.7874|Cuming||',
 'NEC041' => '41.3943|-99.7262|Custer||',
 'NEC043' => '42.3911|-96.5646|Dakota||',
 'NEC045' => '42.7197|-103.1355|Dawes||',
 'NEC047' => '40.8699|-99.8195|Dawson||',
 'NEC049' => '41.1116|-102.3339|Deuel||',
 'NEC051' => '42.4932|-96.8678|Dixon||',
 'NEC053' => '41.5780|-96.6540|Dodge||',
 'NEC055' => '41.2953|-96.1544|Douglas||',
 'NEC057' => '40.1762|-101.6879|Dundy||',
 'NEC059' => '40.5247|-97.5964|Fillmore||',
 'NEC061' => '40.1764|-98.9527|Franklin||',
 'NEC063' => '40.5301|-100.3942|Frontier||',
 'NEC065' => '40.1765|-99.9123|Furnas||',
 'NEC067' => '40.2619|-96.6893|Gage||',
 'NEC069' => '41.6194|-102.3354|Garden||',
 'NEC071' => '41.9143|-98.9914|Garfield||',
 'NEC073' => '40.5148|-99.8307|Gosper||',
 'NEC075' => '41.9150|-101.7405|Grant||',
 'NEC077' => '41.5675|-98.5212|Greeley||',
 'NEC079' => '40.8725|-98.5022|Hall||',
 'NEC081' => '40.8735|-98.0233|Hamilton||',
 'NEC083' => '40.1765|-99.4046|Harlan||',
 'NEC085' => '40.5248|-101.0618|Hayes||',
 'NEC087' => '40.1763|-101.0422|Hitchcock||',
 'NEC089' => '42.4557|-98.7838|Holt||',
 'NEC091' => '41.9159|-101.1353|Hooker||',
 'NEC093' => '41.2200|-98.5171|Howard||',
 'NEC095' => '40.1757|-97.1426|Jefferson||',
 'NEC097' => '40.3926|-96.2649|Johnson||',
 'NEC099' => '40.5067|-98.9480|Kearney||',
 'NEC101' => '41.1988|-101.6613|Keith||',
 'NEC103' => '42.8789|-99.7124|Keya Paha||',
 'NEC105' => '41.1977|-103.7150|Kimball||',
 'NEC107' => '42.6369|-97.8919|Knox||',
 'NEC109' => '40.7841|-96.6878|Lancaster||',
 'NEC111' => '41.0478|-100.7452|Lincoln||',
 'NEC113' => '41.5665|-100.4829|Logan||',
 'NEC115' => '41.9138|-99.4544|Loup||',
 'NEC117' => '41.5681|-101.0605|McPherson||',
 'NEC119' => '41.9167|-97.6008|Madison||',
 'NEC121' => '41.1698|-98.0376|Merrick||',
 'NEC123' => '41.7160|-103.0105|Morrill||',
 'NEC125' => '41.3973|-97.9923|Nance||',
 'NEC127' => '40.3881|-95.8486|Nemaha||',
 'NEC129' => '40.1764|-98.0472|Nuckolls||',
 'NEC131' => '40.6485|-96.1348|Otoe||',
 'NEC133' => '40.1314|-96.2370|Pawnee||',
 'NEC135' => '40.8509|-101.6496|Perkins||',
 'NEC137' => '40.5111|-99.4145|Phelps||',
 'NEC139' => '42.2644|-97.6013|Pierce||',
 'NEC141' => '41.5708|-97.5206|Platte||',
 'NEC143' => '41.1869|-97.5684|Polk||',
 'NEC145' => '40.1758|-100.4768|Red Willow||',
 'NEC147' => '40.1249|-95.7167|Richardson||',
 'NEC149' => '42.4213|-99.4500|Rock||',
 'NEC151' => '40.5240|-97.1408|Saline||',
 'NEC153' => '41.1131|-96.1119|Sarpy||',
 'NEC155' => '41.2265|-96.6374|Saunders||',
 'NEC157' => '41.8506|-103.7080|Scotts Bluff||',
 'NEC159' => '40.8723|-97.1395|Seward||',
 'NEC161' => '42.5048|-102.4090|Sheridan||',
 'NEC163' => '41.2205|-98.9763|Sherman||',
 'NEC165' => '42.4877|-103.7589|Sioux||',
 'NEC167' => '41.9169|-97.1939|Stanton||',
 'NEC169' => '40.1763|-97.5947|Thayer||',
 'NEC171' => '41.9135|-100.5559|Thomas||',
 'NEC173' => '42.1582|-96.5441|Thurston||',
 'NEC175' => '41.5673|-98.9819|Valley||',
 'NEC177' => '41.5311|-96.2218|Washington||',
 'NEC179' => '42.2092|-97.1193|Wayne||',
 'NEC181' => '40.1764|-98.4999|Webster||',
 'NEC183' => '41.9148|-98.5282|Wheeler||',
 'NEC185' => '40.8727|-97.5971|York||',
 'NEZ002' => '42.7197|-103.1354|Dawes|Dawes|31045',
 'NEZ003' => '42.2198|-103.0857|Box Butte|Box Butte|31013',
 'NEZ004' => '42.5048|-102.409|Sheridan|Sheridan|31161',
 'NEZ005' => '42.5577|-100.5076|Eastern Cherry|Cherry|31031',
 'NEZ006' => '42.8789|-99.7124|Keya Paha|Keya Paha|31103',
 'NEZ007' => '42.8997|-98.7665|Boyd|Boyd|31015',
 'NEZ008' => '42.43|-99.9295|Brown|Brown|31017',
 'NEZ009' => '42.4213|-99.45|Rock|Rock|31149',
 'NEZ010' => '42.4557|-98.7838|Holt|Holt|31089',
 'NEZ011' => '42.6369|-97.8919|Knox|Knox|31107',
 'NEZ012' => '42.5993|-97.2523|Cedar|Cedar|31027',
 'NEZ013' => '42.4932|-96.8677|Dixon|Dixon|31051',
 'NEZ014' => '42.3911|-96.5646|Dakota|Dakota|31043',
 'NEZ015' => '42.1582|-96.5441|Thurston|Thurston|31173',
 'NEZ016' => '42.1769|-98.0667|Antelope|Antelope|31003',
 'NEZ017' => '42.2644|-97.6013|Pierce|Pierce|31139',
 'NEZ018' => '42.2092|-97.1193|Wayne|Wayne|31179',
 'NEZ019' => '41.8506|-103.708|Scotts Bluff|Scotts Bluff|31157',
 'NEZ020' => '41.546|-103.7104|Banner|Banner|31007',
 'NEZ021' => '41.716|-103.0105|Morrill|Morrill|31123',
 'NEZ022' => '41.6194|-102.3354|Garden|Garden|31069',
 'NEZ023' => '41.915|-101.7405|Grant|Grant|31075',
 'NEZ024' => '41.9159|-101.1353|Hooker|Hooker|31091',
 'NEZ025' => '41.9135|-100.5558|Thomas|Thomas|31171',
 'NEZ026' => '41.9128|-99.9769|Blaine|Blaine|31009',
 'NEZ027' => '41.9138|-99.4544|Loup|Loup|31115',
 'NEZ028' => '41.9143|-98.9914|Garfield|Garfield|31071',
 'NEZ029' => '41.9148|-98.5282|Wheeler|Wheeler|31183',
 'NEZ030' => '41.7068|-98.0673|Boone|Boone|31011',
 'NEZ031' => '41.9166|-97.6008|Madison|Madison|31119',
 'NEZ032' => '41.9168|-97.1939|Stanton|Stanton|31167',
 'NEZ033' => '41.9164|-96.7874|Cuming|Cuming|31039',
 'NEZ034' => '41.8515|-96.3287|Burt|Burt|31021',
 'NEZ035' => '41.5689|-101.6959|Arthur|Arthur|31005',
 'NEZ036' => '41.5681|-101.0605|McPherson|McPherson|31117',
 'NEZ037' => '41.5665|-100.4828|Logan|Logan|31113',
 'NEZ038' => '41.3943|-99.7261|Custer|Custer|31041',
 'NEZ039' => '41.5673|-98.9819|Valley|Valley|31175',
 'NEZ040' => '41.5675|-98.5212|Greeley|Greeley|31077',
 'NEZ041' => '41.3973|-97.9923|Nance|Nance|31125',
 'NEZ042' => '41.5701|-97.5198|Platte|Platte|31141',
 'NEZ043' => '41.5731|-97.0867|Colfax|Colfax|31037',
 'NEZ044' => '41.5777|-96.6542|Dodge|Dodge|31053',
 'NEZ045' => '41.5311|-96.2218|Washington|Washington|31177',
 'NEZ046' => '41.2205|-98.9763|Sherman|Sherman|31163',
 'NEZ047' => '41.22|-98.5171|Howard|Howard|31093',
 'NEZ048' => '41.1698|-98.0376|Merrick|Merrick|31121',
 'NEZ049' => '41.1869|-97.5684|Polk|Polk|31143',
 'NEZ050' => '41.2242|-97.1306|Butler|Butler|31023',
 'NEZ051' => '41.2261|-96.6373|Saunders|Saunders|31155',
 'NEZ052' => '41.2953|-96.1544|Douglas|Douglas|31055',
 'NEZ053' => '41.1131|-96.1119|Sarpy|Sarpy|31153',
 'NEZ054' => '41.1977|-103.715|Kimball|Kimball|31105',
 'NEZ055' => '41.2198|-102.995|Cheyenne|Cheyenne|31033',
 'NEZ056' => '41.1116|-102.3339|Deuel|Deuel|31049',
 'NEZ057' => '41.1988|-101.6613|Keith|Keith|31101',
 'NEZ058' => '40.8509|-101.6496|Perkins|Perkins|31135',
 'NEZ059' => '41.0478|-100.7452|Lincoln|Lincoln|31111',
 'NEZ060' => '40.8699|-99.8195|Dawson|Dawson|31047',
 'NEZ061' => '40.8551|-99.075|Buffalo|Buffalo|31019',
 'NEZ062' => '40.8725|-98.5022|Hall|Hall|31079',
 'NEZ063' => '40.8735|-98.0233|Hamilton|Hamilton|31081',
 'NEZ064' => '40.8728|-97.5971|York|York|31185',
 'NEZ065' => '40.8723|-97.1395|Seward|Seward|31159',
 'NEZ066' => '40.7841|-96.6878|Lancaster|Lancaster|31109',
 'NEZ067' => '40.9098|-96.1408|Cass|Cass|31025',
 'NEZ068' => '40.6485|-96.1348|Otoe|Otoe|31131',
 'NEZ069' => '40.5242|-101.6979|Chase|Chase|31029',
 'NEZ070' => '40.5248|-101.0618|Hayes|Hayes|31085',
 'NEZ071' => '40.5301|-100.3942|Frontier|Frontier|31063',
 'NEZ072' => '40.5148|-99.8307|Gosper|Gosper|31073',
 'NEZ073' => '40.5111|-99.4145|Phelps|Phelps|31137',
 'NEZ074' => '40.5067|-98.948|Kearney|Kearney|31099',
 'NEZ075' => '40.5245|-98.5012|Adams|Adams|31001',
 'NEZ076' => '40.5244|-98.0512|Clay|Clay|31035',
 'NEZ077' => '40.5247|-97.5965|Fillmore|Fillmore|31059',
 'NEZ078' => '40.524|-97.1408|Saline|Saline|31151',
 'NEZ079' => '40.1762|-101.6879|Dundy|Dundy|31057',
 'NEZ080' => '40.1763|-101.0422|Hitchcock|Hitchcock|31087',
 'NEZ081' => '40.1758|-100.4768|Red Willow|Red Willow|31145',
 'NEZ082' => '40.1764|-99.9123|Furnas|Furnas|31065',
 'NEZ083' => '40.1765|-99.4046|Harlan|Harlan|31083',
 'NEZ084' => '40.1763|-98.9527|Franklin|Franklin|31061',
 'NEZ085' => '40.1764|-98.4999|Webster|Webster|31181',
 'NEZ086' => '40.1764|-98.0472|Nuckolls|Nuckolls|31129',
 'NEZ087' => '40.1763|-97.5948|Thayer|Thayer|31169',
 'NEZ088' => '40.1757|-97.1426|Jefferson|Jefferson|31095',
 'NEZ089' => '40.2619|-96.6893|Gage|Gage|31067',
 'NEZ090' => '40.3926|-96.2649|Johnson|Johnson|31097',
 'NEZ091' => '40.3881|-95.8486|Nemaha|Nemaha|31127',
 'NEZ092' => '40.1314|-96.237|Pawnee|Pawnee|31133',
 'NEZ093' => '40.1249|-95.7167|Richardson|Richardson|31147',
 'NEZ094' => '42.5381|-101.4432|Western Cherry|Cherry|31031',
 'NEZ095' => '42.7142|-103.7719|North Sioux|Sioux|31165',
 'NEZ096' => '42.2153|-103.7432|South Sioux|Sioux|31165',
 'NHC001' => '43.5188|-71.4233|Belknap||',
 'NHC003' => '43.8739|-71.2028|Carroll||',
 'NHC005' => '42.9193|-72.2512|Cheshire||',
 'NHC007' => '44.6893|-71.3057|Coos||',
 'NHC009' => '43.9409|-71.8205|Grafton||',
 'NHC011' => '42.9153|-71.7160|Hillsborough||',
 'NHC013' => '43.2977|-71.6802|Merrimack||',
 'NHC015' => '42.9877|-71.1251|Rockingham||',
 'NHC017' => '43.2975|-71.0293|Strafford||',
 'NHC019' => '43.3612|-72.2223|Sullivan||',
 'NHZ001' => '44.9761|-71.2832|Northern Coos|Coos|33007',
 'NHZ002' => '44.4715|-71.3228|Southern Coos|Coos|33007',
 'NHZ003' => '44.0964|-71.7514|Northern Grafton|Grafton|33009',
 'NHZ004' => '44.078|-71.1778|Northern Carroll|Carroll|33003',
 'NHZ005' => '43.7209|-71.9182|Southern Grafton|Grafton|33009',
 'NHZ006' => '43.7506|-71.2178|Southern Carroll|Carroll|33003',
 'NHZ007' => '43.3612|-72.2223|Sullivan|Sullivan|33019',
 'NHZ008' => '43.2977|-71.6802|Merrimack|Merrimack|33013',
 'NHZ009' => '43.5188|-71.4233|Belknap|Belknap|33001',
 'NHZ010' => '43.2975|-71.0293|Strafford|Strafford|33017',
 'NHZ011' => '42.9193|-72.2512|Cheshire|Cheshire|33005',
 'NHZ012' => '42.8448|-71.4574|Eastern Hillsborough|Hillsborough|33011',
 'NHZ013' => '42.9853|-71.1814|Interior Rockingham|Rockingham|33015',
 'NHZ014' => '43.0005|-70.8291|Coastal Rockingham|Rockingham|33015',
 'NHZ015' => '42.9363|-71.7929|Western And Central Hillsborough|Hillsborough|33011',
 'NJC001' => '39.4825|-74.6766|Atlantic||',
 'NJC003' => '40.9599|-74.0743|Bergen||',
 'NJC005' => '39.8774|-74.6679|Burlington||',
 'NJC007' => '39.8038|-74.9599|Camden||',
 'NJC009' => '39.1519|-74.8072|Cape May||',
 'NJC011' => '39.3736|-75.1099|Cumberland||',
 'NJC013' => '40.7872|-74.2471|Essex||',
 'NJC015' => '39.7173|-75.1419|Gloucester||',
 'NJC017' => '40.7368|-74.0784|Hudson||',
 'NJC019' => '40.5672|-74.9123|Hunterdon||',
 'NJC021' => '40.2833|-74.7014|Mercer||',
 'NJC023' => '40.4394|-74.4113|Middlesex||',
 'NJC025' => '40.2590|-74.2257|Monmouth||',
 'NJC027' => '40.8621|-74.5445|Morris||',
 'NJC029' => '39.9092|-74.2988|Ocean||',
 'NJC031' => '41.0337|-74.3003|Passaic||',
 'NJC033' => '39.5873|-75.3459|Salem||',
 'NJC035' => '40.5637|-74.6164|Somerset||',
 'NJC037' => '41.1395|-74.6902|Sussex||',
 'NJC039' => '40.6600|-74.3086|Union||',
 'NJC041' => '40.8574|-74.9970|Warren||',
 'NJZ001' => '41.1394|-74.6902|Sussex|Sussex|34037',
 'NJZ002' => '41.0934|-74.3518|Western Passaic|Passaic|34031',
 'NJZ004' => '40.9176|-74.1999|Eastern Passaic|Passaic|34031',
 'NJZ006' => '40.741|-74.0775|Hudson|Hudson|34017',
 'NJZ007' => '40.8574|-74.997|Warren|Warren|34041',
 'NJZ008' => '40.8621|-74.5445|Morris|Morris|34027',
 'NJZ009' => '40.5672|-74.9123|Hunterdon|Hunterdon|34019',
 'NJZ010' => '40.5637|-74.6163|Somerset|Somerset|34035',
 'NJZ012' => '40.4394|-74.4113|Middlesex|Middlesex|34023',
 'NJZ013' => '40.2596|-74.2614|Western Monmouth|Monmouth|34025',
 'NJZ014' => '40.2557|-74.0295|Eastern Monmouth|Monmouth|34025',
 'NJZ015' => '40.2833|-74.7015|Mercer|Mercer|34021',
 'NJZ016' => '39.5872|-75.3459|Salem|Salem|34033',
 'NJZ017' => '39.7173|-75.1419|Gloucester|Gloucester|34015',
 'NJZ018' => '39.8038|-74.9599|Camden|Camden|34007',
 'NJZ019' => '39.985|-74.7572|Northwestern Burlington|Burlington|34005',
 'NJZ020' => '39.9191|-74.3099|Ocean|Ocean|34029',
 'NJZ021' => '39.3735|-75.1099|Cumberland|Cumberland|34011',
 'NJZ022' => '39.4906|-74.6976|Atlantic|Atlantic|34001',
 'NJZ023' => '39.1768|-74.8227|Cape May|Cape May|34009',
 'NJZ024' => '39.0952|-74.7718|Atlantic Coastal Cape May|Cape May|34009',
 'NJZ025' => '39.393|-74.4448|Coastal Atlantic|Atlantic|34001',
 'NJZ026' => '39.789|-74.1647|Coastal Ocean|Ocean|34029',
 'NJZ027' => '39.7478|-74.5605|Southeastern Burlington|Burlington|34005',
 'NJZ103' => '41.0243|-74.1547|Western Bergen|Bergen|34003',
 'NJZ104' => '40.9158|-74.0224|Eastern Bergen|Bergen|34003',
 'NJZ105' => '40.8034|-74.2767|Western Essex|Essex|34013',
 'NJZ106' => '40.7475|-74.1724|Eastern Essex|Essex|34013',
 'NJZ107' => '40.6666|-74.3579|Western Union|Eastern Union|34039',
 'NJZ108' => '40.6496|-74.2352|Eastern Union|Eastern Union|34039',
 'NMC001' => '35.0515|-106.6702|Bernalillo||',
 'NMC003' => '33.9153|-108.4047|Catron||',
 'NMC005' => '33.3632|-104.4670|Chaves||',
 'NMC006' => '34.9126|-107.9997|Cibola||',
 'NMC007' => '36.6061|-104.6468|Colfax||',
 'NMC009' => '34.5741|-103.3468|Curry||',
 'NMC011' => '34.3424|-104.4120|De Baca||',
 'NMC013' => '32.3527|-106.8328|Dona Ana||',
 'NMC015' => '32.4715|-104.3043|Eddy||',
 'NMC017' => '32.7390|-108.3822|Grant||',
 'NMC019' => '34.8633|-104.7907|Guadalupe||',
 'NMC021' => '35.8580|-103.8199|Harding||',
 'NMC023' => '31.9142|-108.7148|Hidalgo||',
 'NMC025' => '32.7922|-103.4124|Lea||',
 'NMC027' => '33.7453|-105.4592|Lincoln||',
 'NMC028' => '35.8693|-106.3072|Los Alamos||',
 'NMC029' => '32.1822|-107.7497|Luna||',
 'NMC031' => '35.5806|-108.2619|McKinley||',
 'NMC033' => '36.0099|-104.9446|Mora||',
 'NMC035' => '32.6132|-105.7417|Otero||',
 'NMC037' => '35.1043|-103.5497|Quay||',
 'NMC039' => '36.5096|-106.6931|Rio Arriba||',
 'NMC041' => '34.0213|-103.4802|Roosevelt||',
 'NMC043' => '35.6887|-106.8659|Sandoval||',
 'NMC045' => '36.5085|-108.3206|San Juan||',
 'NMC047' => '35.4803|-104.8159|San Miguel||',
 'NMC049' => '35.5068|-105.9761|Santa Fe||',
 'NMC051' => '33.1305|-107.1925|Sierra||',
 'NMC053' => '34.0072|-106.9303|Socorro||',
 'NMC055' => '36.5783|-105.6309|Taos||',
 'NMC057' => '34.6405|-105.8508|Torrance||',
 'NMC059' => '36.4818|-103.4710|Union||',
 'NMC061' => '34.7154|-106.8091|Valencia||',
 'NMZ027' => '32.239|-104.7304|Guadalupe Mountains of Eddy County|Eddy|35015',
 'NMZ028' => '32.4993|-104.2534|Eddy County Plains|Eddy|35015',
 'NMZ029' => '33.282|-103.4057|Northern Lea County|Lea|35025',
 'NMZ033' => '32.7504|-103.4363|Central Lea County|Lea|35025',
 'NMZ034' => '32.2502|-103.3937|Southern Lea County|Lea|35025',
 'NMZ201' => '36.427|-108.4064|Northwest Plateau|McKinley|35031	36.427|-108.4064|Northwest Plateau|San Juan|35045',
 'NMZ202' => '36.0409|-108.9296|Chuska Mountains|McKinley|35031	36.0409|-108.9296|Chuska Mountains|San Juan|35045',
 'NMZ203' => '36.6585|-107.1028|Far Northwest Highlands|Rio Arriba|35039	36.6585|-107.1028|Far Northwest Highlands|Sandoval|35043	36.6585|-107.1028|Far Northwest Highlands|San Juan|35045',
 'NMZ204' => '36.0067|-107.5052|Northwest Highlands|McKinley|35031	36.0067|-107.5052|Northwest Highlands|Rio Arriba|35039	36.0067|-107.5052|Northwest Highlands|Sandoval|35043	36.0067|-107.5052|Northwest Highlands|San Juan|35045',
 'NMZ205' => '35.0288|-108.817|West Central Plateau|Catron|35003	35.0288|-108.817|West Central Plateau|Cibola|35006	35.0288|-108.817|West Central Plateau|McKinley|35031',
 'NMZ206' => '35.0709|-108.0574|West Central Mountains|Catron|35003	35.0709|-108.0574|West Central Mountains|Cibola|35006	35.0709|-108.0574|West Central Mountains|McKinley|35031	35.0709|-108.0574|West Central Mountains|Sandoval|35043	35.0709|-108.0574|West Central Mountains|Socorro|35053',
 'NMZ207' => '34.9677|-107.3538|West Central Highlands|Bernalillo|35001	34.9677|-107.3538|West Central Highlands|Cibola|35006	34.9677|-107.3538|West Central Highlands|McKinley|35031	34.9677|-107.3538|West Central Highlands|Sandoval|35043	34.9677|-107.3538|West Central Highlands|Socorro|35053	34.9677|-107.3538|West Central Highlands|Valencia|35061',
 'NMZ208' => '33.8571|-108.317|Southwest Mountains|Catron|35003	33.8571|-108.317|Southwest Mountains|Socorro|35053',
 'NMZ209' => '33.509|-108.8601|San Francisco River Valley|Catron|35003',
 'NMZ210' => '36.7058|-106.2539|Tusas Mountains Including Chama|Rio Arriba|35039	36.7058|-106.2539|Tusas Mountains Including Chama|Taos|35055',
 'NMZ211' => '35.9021|-106.5974|Jemez Mountains|Los Alamos|35028	35.9021|-106.5974|Jemez Mountains|Rio Arriba|35039	35.9021|-106.5974|Jemez Mountains|Sandoval|35043',
 'NMZ212' => '35.516|-105.694|Glorieta Mesa Including Glorieta Pass|San Miguel|35047	35.516|-105.694|Glorieta Mesa Including Glorieta Pass|Santa Fe|35049',
 'NMZ213' => '36.7161|-105.3905|Northern Sangre de Cristo Mountains|Colfax|35007	36.7161|-105.3905|Northern Sangre de Cristo Mountains|Taos|35055',
 'NMZ214' => '35.9865|-105.5998|Southern Sangre de Cristo Mountains|Colfax|35007	35.9865|-105.5998|Southern Sangre de Cristo Mountains|Mora|35033	35.9865|-105.5998|Southern Sangre de Cristo Mountains|Rio Arriba|35039	35.9865|-105.5998|Southern Sangre de Cristo Mountains|San Miguel|35047	35.9865|-105.5998|Southern Sangre de Cristo Mountains|Santa Fe|35049	35.9865|-105.5998|Southern Sangre de Cristo Mountains|Taos|35055',
 'NMZ215' => '36.2296|-105.1554|East Slopes Sangre de Cristo Mountains|Colfax|35007	36.2296|-105.1554|East Slopes Sangre de Cristo Mountains|Mora|35033	36.2296|-105.1554|East Slopes Sangre de Cristo Mountains|San Miguel|35047',
 'NMZ216' => '36.6232|-105.7524|Upper Rio Grande Valley|Rio Arriba|35039	36.6232|-105.7524|Upper Rio Grande Valley|Taos|35055',
 'NMZ217' => '36.1335|-106.0931|Espanola Valley|Rio Arriba|35039	36.1335|-106.0931|Espanola Valley|Santa Fe|35049	36.1335|-106.0931|Espanola Valley|Taos|35055',
 'NMZ218' => '35.5304|-106.1074|Santa Fe Metro Area|Bernalillo|35001	35.5304|-106.1074|Santa Fe Metro Area|Sandoval|35043	35.5304|-106.1074|Santa Fe Metro Area|Santa Fe|35049',
 'NMZ219' => '35.0023|-106.7444|Middle Rio Grande Valley/Albuquerque Metro Area|Bernalillo|35001	35.0023|-106.7444|Middle Rio Grande Valley/Albuquerque Metro Area|Cibola|35006	35.0023|-106.7444|Middle Rio Grande Valley/Albuquerque Metro Area|Sandoval|35043	35.0023|-106.7444|Middle Rio Grande Valley/Albuquerque Metro Area|Torrance|35057	35.0023|-106.7444|Middle Rio Grande Valley/Albuquerque Metro Area|Valencia|35061',
 'NMZ220' => '33.9223|-106.8008|Lower Rio Grande Valley|Socorro|35053',
 'NMZ221' => '34.9556|-106.3043|Sandia/Manzano Mountains Including Edgewood|Bernalillo|35001	34.9556|-106.3043|Sandia/Manzano Mountains Including Edgewood|Sandoval|35043	34.9556|-106.3043|Sandia/Manzano Mountains Including Edgewood|Santa Fe|35049	34.9556|-106.3043|Sandia/Manzano Mountains Including Edgewood|Torrance|35057	34.9556|-106.3043|Sandia/Manzano Mountains Including Edgewood|Valencia|35061',
 'NMZ222' => '34.789|-105.9856|Estancia Valley|Bernalillo|35001	34.789|-105.9856|Estancia Valley|Santa Fe|35049	34.789|-105.9856|Estancia Valley|Torrance|35057',
 'NMZ223' => '34.8354|-105.5657|Central Highlands|San Miguel|35047	34.8354|-105.5657|Central Highlands|Santa Fe|35049	34.8354|-105.5657|Central Highlands|Torrance|35057',
 'NMZ224' => '34.1329|-106.1646|South Central Highlands|Lincoln|35027	34.1329|-106.1646|South Central Highlands|Socorro|35053	34.1329|-106.1646|South Central Highlands|Torrance|35057	34.1329|-106.1646|South Central Highlands|Valencia|35061',
 'NMZ225' => '33.6587|-106.0398|Upper Tularosa Valley|Lincoln|35027	33.6587|-106.0398|Upper Tularosa Valley|Socorro|35053',
 'NMZ226' => '33.5868|-105.5869|South Central Mountains|Lincoln|35027',
 'NMZ227' => '36.7769|-104.3106|Johnson and Bartlett Mesas Including Raton Pass|Colfax|35007	36.7769|-104.3106|Johnson and Bartlett Mesas Including Raton Pass|Union|35059',
 'NMZ228' => '36.256|-104.5899|Far Northeast Highlands|Colfax|35007	36.256|-104.5899|Far Northeast Highlands|Mora|35033',
 'NMZ229' => '35.5317|-105.0208|Northeast Highlands|San Miguel|35047',
 'NMZ230' => '36.4519|-103.4227|Union County|Union|35059',
 'NMZ231' => '35.858|-103.8199|Harding County|Harding|35021',
 'NMZ232' => '35.4457|-104.2579|Eastern San Miguel County|San Miguel|35047',
 'NMZ233' => '34.8633|-104.7907|Guadalupe County|Guadalupe|35019',
 'NMZ234' => '35.1043|-103.5497|Quay County|Quay|35037',
 'NMZ235' => '34.5741|-103.3468|Curry County|Curry|35009',
 'NMZ236' => '34.0213|-103.4802|Roosevelt County|Roosevelt|35041',
 'NMZ237' => '34.3424|-104.412|De Baca County|De Baca|35011',
 'NMZ238' => '33.498|-104.3114|Chaves County Plains|Chaves|35005',
 'NMZ239' => '33.7904|-105.1628|Eastern Lincoln County|Lincoln|35027',
 'NMZ240' => '32.8182|-105.0963|Southwest Chaves County|Chaves|35005',
 'NMZ241' => '33.9792|-107.5332|San Agustin Plains and Adjacent Lowlands|Catron|35003	33.9792|-107.5332|San Agustin Plains and Adjacent Lowlands|Socorro|35053',
 'NMZ401' => '33.0652|-109.0457|Upper Gila River Valley|Grant|35017	33.0652|-109.0457|Upper Gila River Valley|Hidalgo|35023',
 'NMZ403' => '32.5961|-108.0435|Southern Gila Foothills/Mimbres Valley|Grant|35017	32.5961|-108.0435|Southern Gila Foothills/Mimbres Valley|Luna|35029',
 'NMZ404' => '32.984|-109.0449|Southwest Desert/Lower Gila River Valley|Grant|35017	32.984|-109.0449|Southwest Desert/Lower Gila River Valley|Hidalgo|35023',
 'NMZ405' => '31.7623|-108.5699|Lowlands of the Bootheel|Grant|35017	31.7623|-108.5699|Lowlands of the Bootheel|Hidalgo|35023',
 'NMZ406' => '31.5516|-108.8399|Uplands of the Bootheel|Hidalgo|35023',
 'NMZ407' => '32.1585|-107.7431|Southwest Desert/Mimbres Basin|Grant|35017	32.1585|-107.7431|Southwest Desert/Mimbres Basin|Luna|35029',
 'NMZ408' => '33.0357|-107.5193|Eastern Black Range Foothills|Grant|35017	33.0357|-107.5193|Eastern Black Range Foothills|Luna|35029	33.0357|-107.5193|Eastern Black Range Foothills|Sierra|35051',
 'NMZ409' => '33.1033|-107.0436|Sierra County Lakes|Sierra|35051',
 'NMZ410' => '32.6132|-106.9177|Northern Dona Ana County|Dona Ana|35013',
 'NMZ411' => '32.1002|-106.9151|Southern Dona Ana County/Mesilla Valley|Dona Ana|35013',
 'NMZ414' => '32.8801|-105.7623|West Slopes Sacramento Mountains Below 7500 Feet|Otero|35035',
 'NMZ415' => '32.9911|-105.6803|Sacramento Mountains Above 7500 Feet|Otero|35035',
 'NMZ416' => '32.9357|-105.4385|East Slopes Sacramento Mountains Below 7500 Feet|Otero|35035',
 'NMZ417' => '32.261|-105.4233|Otero Mesa|Otero|35035',
 'NMZ425' => '32.76|-108.0997|Central Grant County/Silver City Area |Grant|35017',
 'NMZ426' => '33.0716|-108.0453|Southern Gila Region Highlands/Black Range |Grant|35017	33.0716|-108.0453|Southern Gila Region Highlands/Black Range |Sierra|35051',
 'NMZ427' => '32.7419|-106.4202|West Central Tularosa Basin/White Sands |Sierra|35051	32.7419|-106.4202|West Central Tularosa Basin/White Sands |Dona Ana|35013	32.7419|-106.4202|West Central Tularosa Basin/White Sands |Otero|35035',
 'NMZ428' => '33.0694|-106.0993|East Central Tularosa Basin/Alamogordo |Otero|35035',
 'NMZ429' => '32.3354|-106.1094|Southeast Tularosa Basin |Otero|35035',
 'NVC001' => '39.5809|-118.3356|Churchill||',
 'NVC003' => '36.2145|-115.0187|Clark||',
 'NVC005' => '38.9123|-119.6164|Douglas||',
 'NVC007' => '41.1458|-115.3578|Elko||',
 'NVC009' => '37.7847|-117.6324|Esmeralda||',
 'NVC011' => '39.9839|-116.2686|Eureka||',
 'NVC013' => '41.4068|-118.1120|Humboldt||',
 'NVC015' => '39.9338|-117.0379|Lander||',
 'NVC017' => '37.6433|-114.8775|Lincoln||',
 'NVC019' => '39.0180|-119.1890|Lyon||',
 'NVC021' => '38.5388|-118.4352|Mineral||',
 'NVC023' => '38.0466|-116.4732|Nye||',
 'NVC027' => '40.4404|-118.4044|Pershing||',
 'NVC029' => '39.4466|-119.5291|Storey||',
 'NVC031' => '40.6639|-119.6637|Washoe||',
 'NVC033' => '39.4422|-114.9016|White Pine||',
 'NVC510' => '39.1507|-119.7465|Carson City||',
 'NVZ001' => '38.6067|-118.6034|Mineral and Southern Lyon Counties|Lyon|32019	38.6067|-118.6034|Mineral and Southern Lyon Counties|Mineral|32021',
 'NVZ002' => '39.2153|-119.9149|Greater Lake Tahoe Area|Douglas|32005	39.2153|-119.9149|Greater Lake Tahoe Area|Washoe|32031	39.2153|-119.9149|Greater Lake Tahoe Area|Carson City|32510',
 'NVZ003' => '39.4151|-119.6557|Greater Reno-Carson City-Minden Area|Douglas|32005	39.4151|-119.6557|Greater Reno-Carson City-Minden Area|Lyon|32019	39.4151|-119.6557|Greater Reno-Carson City-Minden Area|Storey|32029	39.4151|-119.6557|Greater Reno-Carson City-Minden Area|Washoe|32031	39.4151|-119.6557|Greater Reno-Carson City-Minden Area|Carson City|32510',
 'NVZ004' => '40.0152|-118.49|Western Nevada Basin and Range including Pyramid Lake|Churchill|32001	40.0152|-118.49|Western Nevada Basin and Range including Pyramid Lake|Lyon|32019	40.0152|-118.49|Western Nevada Basin and Range including Pyramid Lake|Pershing|32027	40.0152|-118.49|Western Nevada Basin and Range including Pyramid Lake|Washoe|32031',
 'NVZ005' => '41.1126|-119.6686|Northern Washoe County|Washoe|32031',
 'NVZ014' => '37.5763|-116.9511|Esmeralda and Central Nye County|Esmeralda|32009	37.5763|-116.9511|Esmeralda and Central Nye County|Nye|32023',
 'NVZ015' => '37.6576|-114.8708|Lincoln County|Lincoln|32017',
 'NVZ016' => '36.5977|-114.5107|Northeast Clark County|Clark|32003',
 'NVZ017' => '36.5162|-115.9843|Western Clark and Southern Nye County|Clark|32003	36.5162|-115.9843|Western Clark and Southern Nye County|Nye|32023',
 'NVZ018' => '36.7786|-115.1511|Sheep Range|Clark|32003	36.7786|-115.1511|Sheep Range|Lincoln|32017',
 'NVZ019' => '36.2348|-115.6791|Spring Mountains-Red Rock Canyon|Clark|32003	36.2348|-115.6791|Spring Mountains-Red Rock Canyon|Nye|32023',
 'NVZ020' => '36.1435|-115.1712|Las Vegas Valley|Clark|32003',
 'NVZ021' => '35.9412|-114.5934|Lake Mead National Recreation Area|Clark|32003',
 'NVZ022' => '35.5358|-115.0222|Southern Clark County|Clark|32003',
 'NVZ030' => '41.4068|-118.112|Humboldt County|Humboldt|32013',
 'NVZ031' => '41.5447|-115.5974|Northern Elko County|Elko|32007',
 'NVZ033' => '40.6482|-114.2331|Extreme Eastern Elko County|Elko|32007',
 'NVZ034' => '40.544|-115.3911|Ruby Mountains/East Humboldt Range|Elko|32007	40.544|-115.3911|Ruby Mountains/East Humboldt Range|White Pine|32033',
 'NVZ035' => '39.4383|-114.8977|White Pine County|White Pine|32033',
 'NVZ036' => '40.4898|-116.7009|Northern Lander County and Northern Eureka County|Eureka|32011	40.4898|-116.7009|Northern Lander County and Northern Eureka County|Lander|32015',
 'NVZ037' => '39.6135|-116.7096|Southern Lander County and Southern Eureka County|Eureka|32011	39.6135|-116.7096|Southern Lander County and Southern Eureka County|Lander|32015',
 'NVZ038' => '40.7184|-115.7303|Southwest Elko County|Elko|32007',
 'NVZ039' => '40.5796|-114.8566|South Central Elko County|Elko|32007',
 'NVZ040' => '38.0466|-116.4732|Northwestern Nye County|Nye|32023',
 'NVZ041' => '38.5497|-115.8689|Northeastern Nye County|Nye|32023',
 'NYC001' => '42.6002|-73.9735|Albany||',
 'NYC003' => '42.2574|-78.0276|Allegany||',
 'NYC005' => '40.8497|-73.8673|Bronx||',
 'NYC007' => '42.1602|-75.8196|Broome||',
 'NYC009' => '42.2486|-78.6789|Cattaraugus||',
 'NYC011' => '42.9169|-76.5543|Cayuga||',
 'NYC013' => '42.2282|-79.3664|Chautauqua||',
 'NYC015' => '42.1413|-76.7600|Chemung||',
 'NYC017' => '42.4936|-75.6115|Chenango||',
 'NYC019' => '44.7462|-73.6781|Clinton||',
 'NYC021' => '42.2501|-73.6318|Columbia||',
 'NYC023' => '42.5950|-76.0702|Cortland||',
 'NYC025' => '42.1982|-74.9664|Delaware||',
 'NYC027' => '41.7652|-73.7428|Dutchess||',
 'NYC029' => '42.7621|-78.7308|Erie||',
 'NYC031' => '44.1172|-73.7727|Essex||',
 'NYC033' => '44.5929|-74.3038|Franklin||',
 'NYC035' => '43.1139|-74.4222|Fulton||',
 'NYC037' => '43.0010|-78.1936|Genesee||',
 'NYC039' => '42.2766|-74.1227|Greene||',
 'NYC041' => '43.6611|-74.4974|Hamilton||',
 'NYC043' => '43.4196|-74.9626|Herkimer||',
 'NYC045' => '44.0409|-75.9102|Jefferson||',
 'NYC047' => '40.6447|-73.9472|Kings||',
 'NYC049' => '43.7847|-75.4488|Lewis||',
 'NYC051' => '42.7280|-77.7754|Livingston||',
 'NYC053' => '42.9129|-75.6697|Madison||',
 'NYC055' => '43.1464|-77.6958|Monroe||',
 'NYC057' => '42.9023|-74.4397|Montgomery||',
 'NYC059' => '40.7411|-73.5885|Nassau||',
 'NYC061' => '40.7786|-73.9671|New York (Manhattan)||',
 'NYC063' => '43.2011|-78.7427|Niagara||',
 'NYC065' => '43.2418|-75.4359|Oneida||',
 'NYC067' => '43.0058|-76.1946|Onondaga||',
 'NYC069' => '42.8529|-77.2998|Ontario||',
 'NYC071' => '41.4022|-74.3056|Orange||',
 'NYC073' => '43.2522|-78.2312|Orleans||',
 'NYC075' => '43.4261|-76.1412|Oswego||',
 'NYC077' => '42.6338|-75.0326|Otsego||',
 'NYC079' => '41.4267|-73.7495|Putnam||',
 'NYC081' => '40.7104|-73.8191|Queens||',
 'NYC083' => '42.7111|-73.5097|Rensselaer||',
 'NYC085' => '40.5811|-74.1554|Richmond||',
 'NYC087' => '41.1529|-74.0241|Rockland||',
 'NYC089' => '44.4921|-75.0625|St. Lawrence||',
 'NYC091' => '43.1074|-73.8639|Saratoga||',
 'NYC093' => '42.8182|-74.0585|Schenectady||',
 'NYC095' => '42.5882|-74.4421|Schoharie||',
 'NYC097' => '42.3938|-76.8752|Schuyler||',
 'NYC099' => '42.7810|-76.8237|Seneca||',
 'NYC101' => '42.2678|-77.3838|Steuben||',
 'NYC103' => '40.8780|-72.8573|Suffolk||',
 'NYC105' => '41.7164|-74.7681|Sullivan||',
 'NYC107' => '42.1703|-76.3063|Tioga||',
 'NYC109' => '42.4520|-76.4737|Tompkins||',
 'NYC111' => '41.8881|-74.2585|Ulster||',
 'NYC113' => '43.5610|-73.8460|Warren||',
 'NYC115' => '43.3137|-73.4307|Washington||',
 'NYC117' => '43.1566|-77.0292|Wayne||',
 'NYC119' => '41.1631|-73.7561|Westchester||',
 'NYC121' => '42.7023|-78.2245|Wyoming||',
 'NYC123' => '42.6335|-77.1055|Yates||',
 'NYZ001' => '43.2011|-78.7425|Niagara|Niagara|36063',
 'NYZ002' => '43.2522|-78.2312|Orleans|Orleans|36073',
 'NYZ003' => '43.1464|-77.6959|Monroe|Monroe|36055',
 'NYZ004' => '43.1566|-77.0292|Wayne|Wayne|36117',
 'NYZ005' => '43.1775|-76.6084|Northern Cayuga|Cayuga|36011',
 'NYZ006' => '43.426|-76.1412|Oswego|Oswego|36075',
 'NYZ007' => '44.0409|-75.9102|Jefferson|Jefferson|36045',
 'NYZ008' => '43.7847|-75.4488|Lewis|Lewis|36049',
 'NYZ009' => '43.3813|-75.4692|Northern Oneida|Oneida|36065',
 'NYZ010' => '42.9375|-78.6923|Northern Erie|Erie|36029',
 'NYZ011' => '43.001|-78.1936|Genesee|Genesee|36037',
 'NYZ012' => '42.7023|-78.2245|Wyoming|Wyoming|36121',
 'NYZ013' => '42.7281|-77.7754|Livingston|Livingston|36051',
 'NYZ014' => '42.8529|-77.2998|Ontario|Ontario|36069',
 'NYZ015' => '42.6335|-77.1055|Yates|Yates|36123',
 'NYZ016' => '42.781|-76.8237|Seneca|Seneca|36099',
 'NYZ017' => '42.8012|-76.5302|Southern Cayuga|Cayuga|36011',
 'NYZ018' => '43.0058|-76.1946|Onondaga|Onondaga|36067',
 'NYZ019' => '42.2282|-79.3664|Chautauqua|Chautauqua|36013',
 'NYZ020' => '42.2486|-78.6789|Cattaraugus|Cattaraugus|36009',
 'NYZ021' => '42.2574|-78.0276|Allegany|Allegany|36003',
 'NYZ022' => '42.2678|-77.3838|Steuben|Steuben|36101',
 'NYZ023' => '42.3938|-76.8752|Schuyler|Schuyler|36097',
 'NYZ024' => '42.1413|-76.76|Chemung|Chemung|36015',
 'NYZ025' => '42.452|-76.4737|Tompkins|Tompkins|36109',
 'NYZ026' => '44.8467|-74.9154|Northern St. Lawrence|St. Lawrence|36089',
 'NYZ027' => '44.9016|-74.4258|Northern Franklin|Franklin|36033',
 'NYZ028' => '44.8026|-73.5131|Eastern Clinton|Clinton|36019',
 'NYZ029' => '44.3207|-74.8555|Southeastern St. Lawrence|St. Lawrence|36089',
 'NYZ030' => '44.5162|-74.2734|Southern Franklin|Franklin|36033',
 'NYZ031' => '44.7069|-73.7931|Western Clinton|Clinton|36019',
 'NYZ032' => '43.7111|-74.9693|Northern Herkimer|Herkimer|36043',
 'NYZ033' => '43.6611|-74.4973|Hamilton|Hamilton|36041',
 'NYZ034' => '44.0851|-73.8551|Western Essex|Essex|36031',
 'NYZ035' => '44.2489|-73.4345|Eastern Essex|Essex|36031',
 'NYZ036' => '42.9129|-75.6697|Madison|Madison|36053',
 'NYZ037' => '43.12|-75.4068|Southern Oneida|Oneida|36065',
 'NYZ038' => '43.0923|-74.9549|Southern Herkimer|Herkimer|36043',
 'NYZ039' => '43.0404|-74.4213|Southern Fulton|Fulton|36035',
 'NYZ040' => '42.9023|-74.4397|Montgomery|Montgomery|36057',
 'NYZ041' => '43.1808|-73.8582|Northern Saratoga|Saratoga|36091',
 'NYZ042' => '43.5976|-73.8646|Northern Warren|Warren|36113',
 'NYZ043' => '43.5196|-73.4239|Northern Washington|Washington|36115',
 'NYZ044' => '42.595|-76.0702|Cortland|Cortland|36023',
 'NYZ045' => '42.4936|-75.6115|Chenango|Chenango|36017',
 'NYZ046' => '42.6338|-75.0326|Otsego|Otsego|36077',
 'NYZ047' => '42.5882|-74.4421|Schoharie|Schoharie|36095',
 'NYZ048' => '42.79|-74.1561|Western Schenectady|Schenectady|36093',
 'NYZ049' => '42.8421|-73.9758|Eastern Schenectady|Schenectady|36093',
 'NYZ050' => '42.9413|-73.8768|Southern Saratoga|Saratoga|36091',
 'NYZ051' => '42.5646|-74.125|Western Albany|Albany|36001',
 'NYZ052' => '42.6223|-73.8796|Eastern Albany|Albany|36001',
 'NYZ053' => '42.7053|-73.6159|Western Rensselaer|Rensselaer|36083',
 'NYZ054' => '42.7167|-73.4058|Eastern Rensselaer|Rensselaer|36083',
 'NYZ055' => '42.1703|-76.3063|Tioga|Tioga|36107',
 'NYZ056' => '42.1602|-75.8196|Broome|Broome|36007',
 'NYZ057' => '42.1982|-74.9665|Delaware|Delaware|36025',
 'NYZ058' => '42.257|-74.2376|Western Greene|Greene|36039',
 'NYZ059' => '42.312|-73.9147|Eastern Greene|Greene|36039',
 'NYZ060' => '42.2451|-73.733|Western Columbia|Columbia|36021',
 'NYZ061' => '42.2548|-73.536|Eastern Columbia|Columbia|36021',
 'NYZ062' => '41.7164|-74.7681|Sullivan|Sullivan|36105',
 'NYZ063' => '41.9216|-74.3795|Western Ulster|Ulster|36111',
 'NYZ064' => '41.8336|-74.0616|Eastern Ulster|Ulster|36111',
 'NYZ065' => '41.7716|-73.8457|Western Dutchess|Dutchess|36027',
 'NYZ066' => '41.7574|-73.6193|Eastern Dutchess|Dutchess|36027',
 'NYZ067' => '41.4022|-74.3056|Orange|Orange|36071',
 'NYZ068' => '41.4267|-73.7495|Putnam|Putnam|36079',
 'NYZ069' => '41.1529|-74.0241|Rockland|Rockland|36087',
 'NYZ070' => '41.2221|-73.7474|Northern Westchester|Westchester|36119',
 'NYZ071' => '40.9833|-73.7799|Southern Westchester|Westchester|36119',
 'NYZ072' => '40.7786|-73.9665|New York (Manhattan)|New York|36061',
 'NYZ073' => '40.8526|-73.8669|Bronx|Bronx|36005',
 'NYZ074' => '40.5802|-74.1557|Richmond (Staten Is.)|Richmond|36085',
 'NYZ075' => '40.6428|-73.9426|Kings (Brooklyn)|Kings|36047',
 'NYZ078' => '40.8778|-73.1715|Northwest Suffolk|Suffolk|36103',
 'NYZ079' => '40.9921|-72.5807|Northeast Suffolk|Suffolk|36103',
 'NYZ080' => '40.7503|-73.1828|Southwest Suffolk|Suffolk|36103',
 'NYZ081' => '40.9109|-72.4592|Southeast Suffolk|Suffolk|36103',
 'NYZ082' => '43.1615|-74.4228|Northern Fulton|Fulton|36035',
 'NYZ083' => '43.3468|-73.7376|Southeast Warren|Warren|36113',
 'NYZ084' => '43.1564|-73.436|Southern Washington|Washington|36115',
 'NYZ085' => '42.6247|-78.7608|Southern Erie|Erie|36029',
 'NYZ087' => '44.5173|-75.3061|Southwestern St. Lawrence|St. Lawrence|36089',
 'NYZ176' => '40.748|-73.8438|Northern Queens|Queens|36081',
 'NYZ177' => '40.8335|-73.5976|Northern Nassau|Nassau|36059',
 'NYZ178' => '40.6648|-73.792|Southern Queens|Queens|36081',
 'NYZ179' => '40.6903|-73.5836|Southern Nassau|Nassau|36059',
 'OHC001' => '38.8457|-83.4720|Adams||',
 'OHC003' => '40.7715|-84.1057|Allen||',
 'OHC005' => '40.8460|-82.2707|Ashland||',
 'OHC007' => '41.7074|-80.7485|Ashtabula||',
 'OHC009' => '39.3337|-82.0452|Athens||',
 'OHC011' => '40.5609|-84.2217|Auglaize||',
 'OHC013' => '40.0158|-80.9885|Belmont||',
 'OHC015' => '38.9344|-83.8680|Brown||',
 'OHC017' => '39.4386|-84.5755|Butler||',
 'OHC019' => '40.5796|-81.0897|Carroll||',
 'OHC021' => '40.1377|-83.7696|Champaign||',
 'OHC023' => '39.9168|-83.7835|Clark||',
 'OHC025' => '39.0476|-84.1522|Clermont||',
 'OHC027' => '39.4150|-83.8084|Clinton||',
 'OHC029' => '40.7686|-80.7775|Columbiana||',
 'OHC031' => '40.3017|-81.9200|Coshocton||',
 'OHC033' => '40.8509|-82.9197|Crawford||',
 'OHC035' => '41.4243|-81.6587|Cuyahoga||',
 'OHC037' => '40.1333|-84.6193|Darke||',
 'OHC039' => '41.3239|-84.4906|Defiance||',
 'OHC041' => '40.2785|-83.0052|Delaware||',
 'OHC043' => '41.3635|-82.6178|Erie||',
 'OHC045' => '39.7516|-82.6305|Fairfield||',
 'OHC047' => '39.5599|-83.4561|Fayette||',
 'OHC049' => '39.9696|-83.0093|Franklin||',
 'OHC051' => '41.6018|-84.1301|Fulton||',
 'OHC053' => '38.8247|-82.3169|Gallia||',
 'OHC055' => '41.4995|-81.1786|Geauga||',
 'OHC057' => '39.6915|-83.8898|Greene||',
 'OHC059' => '40.0521|-81.4942|Guernsey||',
 'OHC061' => '39.1954|-84.5426|Hamilton||',
 'OHC063' => '41.0019|-83.6665|Hancock||',
 'OHC065' => '40.6615|-83.6594|Hardin||',
 'OHC067' => '40.2938|-81.0911|Harrison||',
 'OHC069' => '41.3339|-84.0682|Henry||',
 'OHC071' => '39.1848|-83.6009|Highland||',
 'OHC073' => '39.4970|-82.4792|Hocking||',
 'OHC075' => '40.5612|-81.9294|Holmes||',
 'OHC077' => '41.1462|-82.5984|Huron||',
 'OHC079' => '39.0197|-82.6184|Jackson||',
 'OHC081' => '40.3850|-80.7610|Jefferson||',
 'OHC083' => '40.3988|-82.4216|Knox||',
 'OHC085' => '41.6968|-81.2370|Lake||',
 'OHC087' => '38.5985|-82.5368|Lawrence||',
 'OHC089' => '40.0918|-82.4835|Licking||',
 'OHC091' => '40.3885|-83.7658|Logan||',
 'OHC093' => '41.2955|-82.1512|Lorain||',
 'OHC095' => '41.6200|-83.6586|Lucas||',
 'OHC097' => '39.8941|-83.3999|Madison||',
 'OHC099' => '41.0146|-80.7753|Mahoning||',
 'OHC101' => '40.5873|-83.1609|Marion||',
 'OHC103' => '41.1176|-81.8997|Medina||',
 'OHC105' => '39.0821|-82.0229|Meigs||',
 'OHC107' => '40.5400|-84.6293|Mercer||',
 'OHC109' => '40.0534|-84.2289|Miami||',
 'OHC111' => '39.7274|-81.0829|Monroe||',
 'OHC113' => '39.7545|-84.2906|Montgomery||',
 'OHC115' => '39.6203|-81.8527|Morgan||',
 'OHC117' => '40.5240|-82.7941|Morrow||',
 'OHC119' => '39.9654|-81.9444|Muskingum||',
 'OHC121' => '39.7660|-81.4556|Noble||',
 'OHC123' => '41.5381|-83.1467|Ottawa||',
 'OHC125' => '41.1166|-84.5801|Paulding||',
 'OHC127' => '39.7371|-82.2361|Perry||',
 'OHC129' => '39.6420|-83.0243|Pickaway||',
 'OHC131' => '39.0774|-83.0668|Pike||',
 'OHC133' => '41.1676|-81.1962|Portage||',
 'OHC135' => '39.7416|-84.6481|Preble||',
 'OHC137' => '41.0221|-84.1317|Putnam||',
 'OHC139' => '40.7747|-82.5365|Richland||',
 'OHC141' => '39.3376|-83.0570|Ross||',
 'OHC143' => '41.3565|-83.1450|Sandusky||',
 'OHC145' => '38.8040|-82.9928|Scioto||',
 'OHC147' => '41.1239|-83.1277|Seneca||',
 'OHC149' => '40.3315|-84.2048|Shelby||',
 'OHC151' => '40.8138|-81.3659|Stark||',
 'OHC153' => '41.1259|-81.5321|Summit||',
 'OHC155' => '41.3174|-80.7604|Trumbull||',
 'OHC157' => '40.4410|-81.4738|Tuscarawas||',
 'OHC159' => '40.2995|-83.3715|Union||',
 'OHC161' => '40.8554|-84.5861|Van Wert||',
 'OHC163' => '39.2510|-82.4854|Vinton||',
 'OHC165' => '39.4277|-84.1668|Warren||',
 'OHC167' => '39.4553|-81.4953|Washington||',
 'OHC169' => '40.8289|-81.8883|Wayne||',
 'OHC171' => '41.5603|-84.5882|Williams||',
 'OHC173' => '41.3617|-83.6230|Wood||',
 'OHC175' => '40.8424|-83.3044|Wyandot||',
 'OHZ001' => '41.5603|-84.5882|Williams|Williams|39171',
 'OHZ002' => '41.6018|-84.1301|Fulton|Fulton|39051',
 'OHZ003' => '41.62|-83.6586|Lucas|Lucas|39095',
 'OHZ004' => '41.324|-84.4906|Defiance|Defiance|39039',
 'OHZ005' => '41.3339|-84.0682|Henry|Henry|39069',
 'OHZ006' => '41.3617|-83.623|Wood|Wood|39173',
 'OHZ007' => '41.5381|-83.1467|Ottawa|Ottawa|39123',
 'OHZ008' => '41.3565|-83.145|Sandusky|Sandusky|39143',
 'OHZ009' => '41.3635|-82.6178|Erie|Erie|39043',
 'OHZ010' => '41.2955|-82.1512|Lorain|Lorain|39093',
 'OHZ011' => '41.4243|-81.6587|Cuyahoga|Cuyahoga|39035',
 'OHZ012' => '41.6968|-81.237|Lake|Lake|39085',
 'OHZ013' => '41.4995|-81.1786|Geauga|Geauga|39055',
 'OHZ014' => '41.6796|-80.743|Ashtabula Inland|Ashtabula|39007',
 'OHZ015' => '41.1166|-84.5801|Paulding|Paulding|39125',
 'OHZ016' => '41.0221|-84.1317|Putnam|Putnam|39137',
 'OHZ017' => '41.0019|-83.6665|Hancock|Hancock|39063',
 'OHZ018' => '41.1239|-83.1277|Seneca|Seneca|39147',
 'OHZ019' => '41.1462|-82.5984|Huron|Huron|39077',
 'OHZ020' => '41.1176|-81.8997|Medina|Medina|39103',
 'OHZ021' => '41.1259|-81.5321|Summit|Summit|39153',
 'OHZ022' => '41.1676|-81.1962|Portage|Portage|39133',
 'OHZ023' => '41.3174|-80.7604|Trumbull|Trumbull|39155',
 'OHZ024' => '40.8554|-84.5861|Van Wert|Van Wert|39161',
 'OHZ025' => '40.7715|-84.1057|Allen|Allen|39003',
 'OHZ026' => '40.6615|-83.6594|Hardin|Hardin|39065',
 'OHZ027' => '40.8424|-83.3044|Wyandot|Wyandot|39175',
 'OHZ028' => '40.8509|-82.9197|Crawford|Crawford|39033',
 'OHZ029' => '40.7747|-82.5365|Richland|Richland|39139',
 'OHZ030' => '40.8461|-82.2707|Ashland|Ashland|39005',
 'OHZ031' => '40.8289|-81.8883|Wayne|Wayne|39169',
 'OHZ032' => '40.8138|-81.3659|Stark|Stark|39151',
 'OHZ033' => '41.0146|-80.7753|Mahoning|Mahoning|39099',
 'OHZ034' => '40.54|-84.6293|Mercer|Mercer|39107',
 'OHZ035' => '40.5609|-84.2217|Auglaize|Auglaize|39011',
 'OHZ036' => '40.5873|-83.1609|Marion|Marion|39101',
 'OHZ037' => '40.524|-82.7941|Morrow|Morrow|39117',
 'OHZ038' => '40.5612|-81.9294|Holmes|Holmes|39075',
 'OHZ039' => '40.441|-81.4738|Tuscarawas|Tuscarawas|39157',
 'OHZ040' => '40.5796|-81.0897|Carroll|Carroll|39019',
 'OHZ041' => '40.7686|-80.7775|Columbiana|Columbiana|39029',
 'OHZ042' => '40.1333|-84.6193|Darke|Darke|39037',
 'OHZ043' => '40.3316|-84.2048|Shelby|Shelby|39149',
 'OHZ044' => '40.3885|-83.7658|Logan|Logan|39091',
 'OHZ045' => '40.2995|-83.3715|Union|Union|39159',
 'OHZ046' => '40.2785|-83.0052|Delaware|Delaware|39041',
 'OHZ047' => '40.3988|-82.4216|Knox|Knox|39083',
 'OHZ048' => '40.3016|-81.92|Coshocton|Coshocton|39031',
 'OHZ049' => '40.2938|-81.0911|Harrison|Harrison|39067',
 'OHZ050' => '40.385|-80.761|Jefferson|Jefferson|39081',
 'OHZ051' => '40.0534|-84.2289|Miami|Miami|39109',
 'OHZ052' => '40.1378|-83.7696|Champaign|Champaign|39021',
 'OHZ053' => '39.9168|-83.7835|Clark|Clark|39023',
 'OHZ054' => '39.8942|-83.3999|Madison|Madison|39097',
 'OHZ055' => '39.9696|-83.0093|Franklin|Franklin|39049',
 'OHZ056' => '40.0918|-82.4835|Licking|Licking|39089',
 'OHZ057' => '39.9654|-81.9444|Muskingum|Muskingum|39119',
 'OHZ058' => '40.0521|-81.4942|Guernsey|Guernsey|39059',
 'OHZ059' => '40.0158|-80.9885|Belmont|Belmont|39013',
 'OHZ060' => '39.7416|-84.6481|Preble|Preble|39135',
 'OHZ061' => '39.7545|-84.2906|Montgomery|Montgomery|39113',
 'OHZ062' => '39.6915|-83.8898|Greene|Greene|39057',
 'OHZ063' => '39.5599|-83.4561|Fayette|Fayette|39047',
 'OHZ064' => '39.642|-83.0243|Pickaway|Pickaway|39129',
 'OHZ065' => '39.7516|-82.6305|Fairfield|Fairfield|39045',
 'OHZ066' => '39.7371|-82.2361|Perry|Perry|39127',
 'OHZ067' => '39.6203|-81.8527|Morgan|Morgan|39115',
 'OHZ068' => '39.766|-81.4555|Noble|Noble|39121',
 'OHZ069' => '39.7274|-81.0829|Monroe|Monroe|39111',
 'OHZ070' => '39.4386|-84.5755|Butler|Butler|39017',
 'OHZ071' => '39.4277|-84.1668|Warren|Warren|39165',
 'OHZ072' => '39.415|-83.8084|Clinton|Clinton|39027',
 'OHZ073' => '39.3376|-83.057|Ross|Ross|39141',
 'OHZ074' => '39.497|-82.4791|Hocking|Hocking|39073',
 'OHZ075' => '39.3337|-82.0452|Athens|Athens|39009',
 'OHZ076' => '39.4553|-81.4953|Washington|Washington|39167',
 'OHZ077' => '39.1954|-84.5426|Hamilton|Hamilton|39061',
 'OHZ078' => '39.0476|-84.1522|Clermont|Clermont|39025',
 'OHZ079' => '38.9344|-83.868|Brown|Brown|39015',
 'OHZ080' => '39.1848|-83.6009|Highland|Highland|39071',
 'OHZ081' => '38.8457|-83.472|Adams|Adams|39001',
 'OHZ082' => '39.0774|-83.0668|Pike|Pike|39131',
 'OHZ083' => '39.0197|-82.6184|Jackson|Jackson|39079',
 'OHZ084' => '39.251|-82.4854|Vinton|Vinton|39163',
 'OHZ085' => '39.0821|-82.0229|Meigs|Meigs|39105',
 'OHZ086' => '38.8248|-82.3169|Gallia|Gallia|39053',
 'OHZ087' => '38.5985|-82.5368|Lawrence|Lawrence|39087',
 'OHZ088' => '38.804|-82.9928|Scioto|Scioto|39145',
 'OHZ089' => '41.8761|-80.7817|Ashtabula Lakeshore|Ashtabula|39007',
 'OKC001' => '35.8839|-94.6587|Adair||',
 'OKC003' => '36.7310|-98.3240|Alfalfa||',
 'OKC005' => '34.3737|-96.0378|Atoka||',
 'OKC007' => '36.7497|-100.4767|Beaver||',
 'OKC009' => '35.2687|-99.6820|Beckham||',
 'OKC011' => '35.8752|-98.4335|Blaine||',
 'OKC013' => '33.9623|-96.2600|Bryan||',
 'OKC015' => '35.1744|-98.3751|Caddo||',
 'OKC017' => '35.5425|-97.9825|Canadian||',
 'OKC019' => '34.2509|-97.2858|Carter||',
 'OKC021' => '35.9066|-94.9997|Cherokee||',
 'OKC023' => '34.0265|-95.5521|Choctaw||',
 'OKC025' => '36.7483|-102.5178|Cimarron||',
 'OKC027' => '35.2036|-97.3271|Cleveland||',
 'OKC029' => '34.5882|-96.2979|Coal||',
 'OKC031' => '34.6621|-98.4717|Comanche||',
 'OKC033' => '34.2902|-98.3721|Cotton||',
 'OKC035' => '36.7617|-95.2086|Craig||',
 'OKC037' => '35.9027|-96.3709|Creek||',
 'OKC039' => '35.6389|-99.0015|Custer||',
 'OKC041' => '36.4082|-94.8027|Delaware||',
 'OKC043' => '35.9877|-99.0080|Dewey||',
 'OKC045' => '36.2184|-99.7546|Ellis||',
 'OKC047' => '36.3790|-97.7828|Garfield||',
 'OKC049' => '34.7045|-97.3093|Garvin||',
 'OKC051' => '35.0170|-97.8840|Grady||',
 'OKC053' => '36.7961|-97.7861|Grant||',
 'OKC055' => '34.9357|-99.5609|Greer||',
 'OKC057' => '34.7441|-99.8463|Harmon||',
 'OKC059' => '36.7887|-99.6673|Harper||',
 'OKC061' => '35.2248|-95.1166|Haskell||',
 'OKC063' => '35.0484|-96.2502|Hughes||',
 'OKC065' => '34.5880|-99.4148|Jackson||',
 'OKC067' => '34.1111|-97.8359|Jefferson||',
 'OKC069' => '34.3165|-96.6606|Johnston||',
 'OKC071' => '36.8180|-97.1439|Kay||',
 'OKC073' => '35.9454|-97.9421|Kingfisher||',
 'OKC075' => '34.9163|-98.9808|Kiowa||',
 'OKC077' => '34.8761|-95.2504|Latimer||',
 'OKC079' => '34.9001|-94.7035|Le Flore||',
 'OKC081' => '35.7030|-96.8809|Lincoln||',
 'OKC083' => '35.9194|-97.4434|Logan||',
 'OKC085' => '33.9499|-97.2442|Love||',
 'OKC087' => '35.0087|-97.4436|McClain||',
 'OKC089' => '34.1150|-94.7712|McCurtain||',
 'OKC091' => '35.3737|-95.6668|McIntosh||',
 'OKC093' => '36.3116|-98.5360|Major||',
 'OKC095' => '34.0245|-96.7690|Marshall||',
 'OKC097' => '36.3018|-95.2309|Mayes||',
 'OKC099' => '34.4823|-97.0679|Murray||',
 'OKC101' => '35.6161|-95.3794|Muskogee||',
 'OKC103' => '36.3886|-97.2306|Noble||',
 'OKC105' => '36.7985|-95.6174|Nowata||',
 'OKC107' => '35.4655|-96.3228|Okfuskee||',
 'OKC109' => '35.5515|-97.4072|Oklahoma||',
 'OKC111' => '35.6467|-95.9643|Okmulgee||',
 'OKC113' => '36.6292|-96.3984|Osage||',
 'OKC115' => '36.8355|-94.8105|Ottawa||',
 'OKC117' => '36.3169|-96.6993|Pawnee||',
 'OKC119' => '36.0773|-96.9757|Payne||',
 'OKC121' => '34.9239|-95.7484|Pittsburg||',
 'OKC123' => '34.7281|-96.6844|Pontotoc||',
 'OKC125' => '35.2068|-96.9483|Pottawatomie||',
 'OKC127' => '34.4162|-95.3758|Pushmataha||',
 'OKC129' => '35.6883|-99.6957|Roger Mills||',
 'OKC131' => '36.3716|-95.6044|Rogers||',
 'OKC133' => '35.1674|-96.6156|Seminole||',
 'OKC135' => '35.4953|-94.7549|Sequoyah||',
 'OKC137' => '34.4856|-97.8514|Stephens||',
 'OKC139' => '36.7479|-101.4900|Texas||',
 'OKC141' => '34.3728|-98.9242|Tillman||',
 'OKC143' => '36.1211|-95.9414|Tulsa||',
 'OKC145' => '35.9609|-95.5212|Wagoner||',
 'OKC147' => '36.7152|-95.9044|Washington||',
 'OKC149' => '35.2904|-98.9923|Washita||',
 'OKC151' => '36.7669|-98.8651|Woods||',
 'OKC153' => '36.4227|-99.2650|Woodward||',
 'OKZ001' => '36.7483|-102.5178|Cimarron|Cimarron|40025',
 'OKZ002' => '36.7479|-101.49|Texas|Texas|40139',
 'OKZ003' => '36.7497|-100.4767|Beaver|Beaver|40007',
 'OKZ004' => '36.7887|-99.6673|Harper|Harper|40059',
 'OKZ005' => '36.7669|-98.8651|Woods|Woods|40151',
 'OKZ006' => '36.731|-98.324|Alfalfa|Alfalfa|40003',
 'OKZ007' => '36.7962|-97.7861|Grant|Grant|40053',
 'OKZ008' => '36.818|-97.1439|Kay|Kay|40071',
 'OKZ009' => '36.2183|-99.7546|Ellis|Ellis|40045',
 'OKZ010' => '36.4227|-99.265|Woodward|Woodward|40153',
 'OKZ011' => '36.3116|-98.536|Major|Major|40093',
 'OKZ012' => '36.379|-97.7828|Garfield|Garfield|40047',
 'OKZ013' => '36.3886|-97.2306|Noble|Noble|40103',
 'OKZ014' => '35.6883|-99.6957|Roger Mills|Roger Mills|40129',
 'OKZ015' => '35.9877|-99.008|Dewey|Dewey|40043',
 'OKZ016' => '35.6389|-99.0015|Custer|Custer|40039',
 'OKZ017' => '35.8752|-98.4335|Blaine|Blaine|40011',
 'OKZ018' => '35.9454|-97.9421|Kingfisher|Kingfisher|40073',
 'OKZ019' => '35.9194|-97.4433|Logan|Logan|40083',
 'OKZ020' => '36.0773|-96.9757|Payne|Payne|40119',
 'OKZ021' => '35.2687|-99.682|Beckham|Beckham|40009',
 'OKZ022' => '35.2904|-98.9923|Washita|Washita|40149',
 'OKZ023' => '35.1744|-98.3751|Caddo|Caddo|40015',
 'OKZ024' => '35.5425|-97.9825|Canadian|Canadian|40017',
 'OKZ025' => '35.5515|-97.4072|Oklahoma|Oklahoma|40109',
 'OKZ026' => '35.703|-96.8809|Lincoln|Lincoln|40081',
 'OKZ027' => '35.017|-97.8841|Grady|Grady|40051',
 'OKZ028' => '35.0087|-97.4436|McClain|McClain|40087',
 'OKZ029' => '35.2036|-97.3271|Cleveland|Cleveland|40027',
 'OKZ030' => '35.2068|-96.9483|Pottawatomie|Pottawatomie|40125',
 'OKZ031' => '35.1675|-96.6156|Seminole|Seminole|40133',
 'OKZ032' => '35.0484|-96.2502|Hughes|Hughes|40063',
 'OKZ033' => '34.7441|-99.8463|Harmon|Harmon|40057',
 'OKZ034' => '34.9357|-99.5609|Greer|Greer|40055',
 'OKZ035' => '34.9163|-98.9808|Kiowa|Kiowa|40075',
 'OKZ036' => '34.588|-99.4147|Jackson|Jackson|40065',
 'OKZ037' => '34.3728|-98.9242|Tillman|Tillman|40141',
 'OKZ038' => '34.6621|-98.4717|Comanche|Comanche|40031',
 'OKZ039' => '34.4856|-97.8514|Stephens|Stephens|40137',
 'OKZ040' => '34.7045|-97.3093|Garvin|Garvin|40049',
 'OKZ041' => '34.4823|-97.0679|Murray|Murray|40099',
 'OKZ042' => '34.7281|-96.6844|Pontotoc|Pontotoc|40123',
 'OKZ043' => '34.5882|-96.2979|Coal|Coal|40029',
 'OKZ044' => '34.2902|-98.3721|Cotton|Cotton|40033',
 'OKZ045' => '34.1111|-97.8358|Jefferson|Jefferson|40067',
 'OKZ046' => '34.2509|-97.2858|Carter|Carter|40019',
 'OKZ047' => '34.3165|-96.6606|Johnston|Johnston|40069',
 'OKZ048' => '34.3737|-96.0378|Atoka|Atoka|40005',
 'OKZ049' => '34.4162|-95.3758|Pushmataha|Pushmataha|40127',
 'OKZ050' => '33.9499|-97.2442|Love|Love|40085',
 'OKZ051' => '34.0245|-96.7691|Marshall|Marshall|40095',
 'OKZ052' => '33.9623|-96.26|Bryan|Bryan|40013',
 'OKZ053' => '34.0265|-95.5521|Choctaw|Choctaw|40023',
 'OKZ054' => '36.6292|-96.3984|Osage|Osage|40113',
 'OKZ055' => '36.7152|-95.9044|Washington|Washington|40147',
 'OKZ056' => '36.7985|-95.6175|Nowata|Nowata|40105',
 'OKZ057' => '36.7617|-95.2085|Craig|Craig|40035',
 'OKZ058' => '36.8355|-94.8105|Ottawa|Ottawa|40115',
 'OKZ059' => '36.3169|-96.6993|Pawnee|Pawnee|40117',
 'OKZ060' => '36.1211|-95.9415|Tulsa|Tulsa|40143',
 'OKZ061' => '36.3716|-95.6044|Rogers|Rogers|40131',
 'OKZ062' => '36.3018|-95.2309|Mayes|Mayes|40097',
 'OKZ063' => '36.4082|-94.8027|Delaware|Delaware|40041',
 'OKZ064' => '35.9027|-96.3709|Creek|Creek|40037',
 'OKZ065' => '35.4655|-96.3228|Okfuskee|Okfuskee|40107',
 'OKZ066' => '35.6467|-95.9643|Okmulgee|Okmulgee|40111',
 'OKZ067' => '35.9609|-95.5212|Wagoner|Wagoner|40145',
 'OKZ068' => '35.9066|-94.9997|Cherokee|Cherokee|40021',
 'OKZ069' => '35.8839|-94.6587|Adair|Adair|40001',
 'OKZ070' => '35.6161|-95.3794|Muskogee|Muskogee|40101',
 'OKZ071' => '35.3737|-95.6668|McIntosh|McIntosh|40091',
 'OKZ072' => '35.4953|-94.7549|Sequoyah|Sequoyah|40135',
 'OKZ073' => '34.9239|-95.7484|Pittsburg|Pittsburg|40121',
 'OKZ074' => '35.2248|-95.1166|Haskell|Haskell|40061',
 'OKZ075' => '34.8761|-95.2504|Latimer|Latimer|40077',
 'OKZ076' => '34.9001|-94.7035|Le Flore|Le Flore|40079',
 'OKZ077' => '34.1151|-94.7712|McCurtain|McCurtain|40089',
 'ORC001' => '44.7092|-117.6753|Baker||',
 'ORC003' => '44.4922|-123.4292|Benton||',
 'ORC005' => '45.1887|-122.2214|Clackamas||',
 'ORC007' => '45.9895|-123.6547|Clatsop||',
 'ORC009' => '45.9439|-123.0881|Columbia||',
 'ORC011' => '43.1739|-124.0594|Coos||',
 'ORC013' => '44.1422|-120.3566|Crook||',
 'ORC015' => '42.4578|-124.1567|Curry||',
 'ORC017' => '43.9149|-121.2279|Deschutes||',
 'ORC019' => '43.2796|-123.1662|Douglas||',
 'ORC021' => '45.3780|-120.2109|Gilliam||',
 'ORC023' => '44.4912|-119.0074|Grant||',
 'ORC025' => '43.0640|-118.9679|Harney||',
 'ORC027' => '45.5190|-121.6512|Hood River||',
 'ORC029' => '42.4321|-122.7284|Jackson||',
 'ORC031' => '44.6294|-121.1754|Jefferson||',
 'ORC033' => '42.3654|-123.5555|Josephine||',
 'ORC035' => '42.6863|-121.6501|Klamath||',
 'ORC037' => '42.7934|-120.3874|Lake||',
 'ORC039' => '43.9386|-122.8470|Lane||',
 'ORC041' => '44.6421|-123.8668|Lincoln||',
 'ORC043' => '44.4886|-122.5342|Linn||',
 'ORC045' => '43.1934|-117.6231|Malheur||',
 'ORC047' => '44.9035|-122.5826|Marion||',
 'ORC049' => '45.4188|-119.5843|Morrow||',
 'ORC051' => '45.5469|-122.4157|Multnomah||',
 'ORC053' => '44.9034|-123.4134|Polk||',
 'ORC055' => '45.4052|-120.6894|Sherman||',
 'ORC057' => '45.4630|-123.7086|Tillamook||',
 'ORC059' => '45.5919|-118.7369|Umatilla||',
 'ORC061' => '45.3104|-118.0090|Union||',
 'ORC063' => '45.5798|-117.1811|Wallowa||',
 'ORC065' => '45.1600|-121.1682|Wasco||',
 'ORC067' => '45.5601|-123.0985|Washington||',
 'ORC069' => '44.7261|-120.0275|Wheeler||',
 'ORC071' => '45.2326|-123.3081|Yamhill||',
 'ORZ015' => '45.5872|-122.0526|Western Columbia River Gorge|Hood River|41027	45.5872|-122.0526|Western Columbia River Gorge|Multnomah|41051',
 'ORZ016' => '45.6845|-121.6091|Central Columbia River Gorge|Hood River|41031',
 'ORZ021' => '43.181|-124.1567|South Central Oregon Coast|Coos|41011	43.181|-124.1567|South Central Oregon Coast|Curry|41015	43.181|-124.1567|South Central Oregon Coast|Douglas|41019',
 'ORZ022' => '42.342|-124.301|Curry County Coast|Curry|41015',
 'ORZ023' => '43.2603|-123.4502|Central Douglas County|Coos|41011	43.2603|-123.4502|Central Douglas County|Douglas|41019',
 'ORZ024' => '42.3902|-123.7443|Eastern Curry County and Josephine County|Curry|41015	42.3902|-123.7443|Eastern Curry County and Josephine County|Josephine|41033',
 'ORZ025' => '43.2384|-122.709|Eastern Douglas County Foothills|Douglas|41019',
 'ORZ026' => '42.4652|-122.8457|Jackson County|Jackson|41029',
 'ORZ027' => '43.1875|-122.1568|South Central Oregon Cascades|Douglas|41019	43.1875|-122.1568|South Central Oregon Cascades|Jackson|41029	43.1875|-122.1568|South Central Oregon Cascades|Klamath|41035',
 'ORZ028' => '42.3339|-122.4507|Siskiyou Mountains and Southern Oregon Cascades|Jackson|41029	42.3339|-122.4507|Siskiyou Mountains and Southern Oregon Cascades|Josephine|41033	42.3339|-122.4507|Siskiyou Mountains and Southern Oregon Cascades|Klamath|41035',
 'ORZ029' => '42.3505|-121.7222|Klamath Basin|Klamath|41035',
 'ORZ030' => '42.7799|-121.2476|Northern and Eastern Klamath County and Western Lake County|Klamath|41035	42.7799|-121.2476|Northern and Eastern Klamath County and Western Lake County|Lake|41037',
 'ORZ031' => '42.8105|-120.2507|Central and Eastern Lake County|Lake|41037',
 'ORZ041' => '45.646|-120.5512|East Columbia River Gorge|Gilliam|41021	45.646|-120.5512|East Columbia River Gorge|Sherman|41055	45.646|-120.5512|East Columbia River Gorge|Wasco|41065',
 'ORZ044' => '45.7453|-119.4683|Lower Columbia Basin of Oregon|Morrow|41049	45.7453|-119.4683|Lower Columbia Basin of Oregon|Umatilla|41059',
 'ORZ049' => '45.3737|-117.9515|Grande Ronde Valley|Union|41061',
 'ORZ050' => '45.4827|-117.1835|Wallowa County|Union|41061	45.4827|-117.1835|Wallowa County|Wallowa|41063',
 'ORZ061' => '43.064|-118.9679|Harney County|Harney|41025',
 'ORZ062' => '44.7092|-117.6753|Baker County|Baker|41001',
 'ORZ063' => '43.123|-117.6604|Malheur County|Malheur|41045',
 'ORZ064' => '44.0233|-117.1835|Oregon Lower Treasure Valley|Malheur|41045',
 'ORZ103' => '44.5185|-124.0171|Central Coast of Oregon|Lane|41039',
 'ORZ104' => '45.7917|-123.4834|North Oregon Coast Range Lowlands|Clatsop|41007	45.7917|-123.4834|North Oregon Coast Range Lowlands|Lincoln|41041	45.7917|-123.4834|North Oregon Coast Range Lowlands|Washington|41067	45.7917|-123.4834|North Oregon Coast Range Lowlands|Yamhill|41071',
 'ORZ105' => '44.3784|-123.7351|Central Oregon Coast Range Lowlands|Lincoln|41041	44.3784|-123.7351|Central Oregon Coast Range Lowlands|Benton|41003	44.3784|-123.7351|Central Oregon Coast Range Lowlands|Polk|41053',
 'ORZ106' => '45.6454|-123.4735|North Oregon Coast Range|Clatsop|41007	45.6454|-123.4735|North Oregon Coast Range|Lincoln|41041	45.6454|-123.4735|North Oregon Coast Range|Washington|41067	45.6454|-123.4735|North Oregon Coast Range|Yamhill|41071',
 'ORZ107' => '44.4253|-123.6254|Central Oregon Coast Range|Lincoln|41041	44.4253|-123.6254|Central Oregon Coast Range|Benton|41003	44.4253|-123.6254|Central Oregon Coast Range|Polk|41053',
 'ORZ109' => '45.5144|-123.0010|Tualatin Valley|Multnomah|41051	45.5144|-123.0010|Tualatin Valley|Clackamas|41005',
 'ORZ110' => '45.4599|-122.9062|West Hills and Chehalem Mountains|Multnomah|41051',
 'ORZ111' => '45.4718|-122.6157|Inner Portland Metro|Clackamas|41005',
 'ORZ113' => '45.3705|-122.3697|Outer Southeast Portland Metro|Clackamas|41005',
 'ORZ114' => '45.0867|-123.2391|West Central Willamette Valley|Polk|41053',
 'ORZ115' => '45.0421|-122.8253|East Central Willamette Valley|Clackamas|41005',
 'ORZ119' => '45.5420|-122.0850|West Columbia River Gorge of Oregon above 500 ft|Hood River|41027',
 'ORZ120' => '45.6063|-122.0573|West Columbia River Gorge I-84 Corridor|Hood River|41027',
 'ORZ124' => '44.5450|-122.5773|Cascade Foothills of Marion and Linn Counties|Linn|41043',
 'ORZ126' => '45.2324|-121.9183|North Oregon Cascades|Hood River|41027	45.2324|-121.9183|North Oregon Cascades|Multnomah|41051',
 'ORZ127' => '44.5856|-122.1211|Cascades of Marion and Linn Counties|Linn|41043',
 'ORZ502' => '45.6952|-118.0041|Northern Blue Mountains of Oregon|Umatilla|41059	45.6952|-118.0041|Northern Blue Mountains of Oregon|Union|41061	45.6952|-118.0041|Northern Blue Mountains of Oregon|Wallowa|41063',
 'ORZ503' => '44.9813|-118.9718|Southern Blue Mountains of Oregon|Gilliam|41021	44.9813|-118.9718|Southern Blue Mountains of Oregon|Grant|41023	44.9813|-118.9718|Southern Blue Mountains of Oregon|Morrow|41049	44.9813|-118.9718|Southern Blue Mountains of Oregon|Umatilla|41059	44.9813|-118.9718|Southern Blue Mountains of Oregon|Union|41061	44.9813|-118.9718|Southern Blue Mountains of Oregon|Wheeler|41069',
 'ORZ505' => '44.7315|-119.7825|John Day Basin|Grant|41023	44.7315|-119.7825|John Day Basin|Jefferson|41031	44.7315|-119.7825|John Day Basin|Morrow|41049	44.7315|-119.7825|John Day Basin|Wasco|41065	44.7315|-119.7825|John Day Basin|Wheeler|41069',
 'ORZ506' => '44.1652|-120.0086|Ochoco-John Day Highlands|Crook|41013	44.1652|-120.0086|Ochoco-John Day Highlands|Deschutes|41017	44.1652|-120.0086|Ochoco-John Day Highlands|Grant|41023	44.1652|-120.0086|Ochoco-John Day Highlands|Jefferson|41031	44.1652|-120.0086|Ochoco-John Day Highlands|Wheeler|41069',
 'ORZ507' => '45.7238|-118.7135|Foothills of the Northern Blue Mountains of Oregon|Umatilla|41059',
 'ORZ508' => '45.3442|-120.0029|Foothills of the Southern Blue Mountains of Oregon|Gilliam|41021	45.3442|-120.0029|Foothills of the Southern Blue Mountains of Oregon|Morrow|41049	45.3442|-120.0029|Foothills of the Southern Blue Mountains of Oregon|Wheeler|41069',
 'ORZ509' => '44.2627|-121.5516|East Slopes of the Oregon Cascades|Deschutes|41017	44.2627|-121.5516|East Slopes of the Oregon Cascades|Jefferson|41031	44.2627|-121.5516|East Slopes of the Oregon Cascades|Wasco|41065',
 'ORZ510' => '45.221|-121.0222|North Central Oregon|Sherman|41055	45.221|-121.0222|North Central Oregon|Wasco|41065',
 'ORZ511' => '44.4439|-121.1488|Central Oregon|Crook|41013	44.4439|-121.1488|Central Oregon|Deschutes|41017	44.4439|-121.1488|Central Oregon|Jefferson|41031',
 'PAC001' => '39.8715|-77.2179|Adams||',
 'PAC003' => '40.4688|-79.9812|Allegheny||',
 'PAC005' => '40.8125|-79.4645|Armstrong||',
 'PAC007' => '40.6823|-80.3493|Beaver||',
 'PAC009' => '40.0066|-78.4902|Bedford||',
 'PAC011' => '40.4164|-75.9260|Berks||',
 'PAC013' => '40.4813|-78.3486|Blair||',
 'PAC015' => '41.7886|-76.5157|Bradford||',
 'PAC017' => '40.3370|-75.1067|Bucks||',
 'PAC019' => '40.9117|-79.9130|Butler||',
 'PAC021' => '40.4954|-78.7136|Cambria||',
 'PAC023' => '41.4368|-78.2038|Cameron||',
 'PAC025' => '40.9183|-75.7088|Carbon||',
 'PAC027' => '40.9190|-77.8196|Centre||',
 'PAC029' => '39.9733|-75.7483|Chester||',
 'PAC031' => '41.1925|-79.4210|Clarion||',
 'PAC033' => '41.0002|-78.4741|Clearfield||',
 'PAC035' => '41.2341|-77.6385|Clinton||',
 'PAC037' => '41.0486|-76.4052|Columbia||',
 'PAC039' => '41.6848|-80.1063|Crawford||',
 'PAC041' => '40.1637|-77.2651|Cumberland||',
 'PAC043' => '40.4155|-76.7793|Dauphin||',
 'PAC045' => '39.9166|-75.3991|Delaware||',
 'PAC047' => '41.4252|-78.6492|Elk||',
 'PAC049' => '41.9917|-80.0322|Erie||',
 'PAC051' => '39.9198|-79.6474|Fayette||',
 'PAC053' => '41.5132|-79.2361|Forest||',
 'PAC055' => '39.9275|-77.7212|Franklin||',
 'PAC057' => '39.9255|-78.1124|Fulton||',
 'PAC059' => '39.8538|-80.2229|Greene||',
 'PAC061' => '40.4170|-77.9812|Huntingdon||',
 'PAC063' => '40.6521|-79.0875|Indiana||',
 'PAC065' => '41.1281|-78.9995|Jefferson||',
 'PAC067' => '40.5311|-77.4020|Juniata||',
 'PAC069' => '41.4370|-75.6092|Lackawanna||',
 'PAC071' => '40.0424|-76.2477|Lancaster||',
 'PAC073' => '40.9912|-80.3342|Lawrence||',
 'PAC075' => '40.3672|-76.4577|Lebanon||',
 'PAC077' => '40.6129|-75.5924|Lehigh||',
 'PAC079' => '41.1771|-75.9889|Luzerne||',
 'PAC081' => '41.3433|-77.0645|Lycoming||',
 'PAC083' => '41.8078|-78.5690|McKean||',
 'PAC085' => '41.3022|-80.2577|Mercer||',
 'PAC087' => '40.6104|-77.6171|Mifflin||',
 'PAC089' => '41.0582|-75.3394|Monroe||',
 'PAC091' => '40.2109|-75.3672|Montgomery||',
 'PAC093' => '41.0280|-76.6586|Montour||',
 'PAC095' => '40.7543|-75.3074|Northampton||',
 'PAC097' => '40.8520|-76.7091|Northumberland||',
 'PAC099' => '40.3984|-77.2622|Perry||',
 'PAC101' => '40.0076|-75.1338|Philadelphia||',
 'PAC103' => '41.3321|-75.0338|Pike||',
 'PAC105' => '41.7450|-77.8958|Potter||',
 'PAC107' => '40.7059|-76.2160|Schuylkill||',
 'PAC109' => '40.7700|-77.0701|Snyder||',
 'PAC111' => '39.9725|-79.0283|Somerset||',
 'PAC113' => '41.4460|-76.5119|Sullivan||',
 'PAC115' => '41.8214|-75.8008|Susquehanna||',
 'PAC117' => '41.7721|-77.2543|Tioga||',
 'PAC119' => '40.9630|-77.0621|Union||',
 'PAC121' => '41.4010|-79.7580|Venango||',
 'PAC123' => '41.8147|-79.2741|Warren||',
 'PAC125' => '40.1894|-80.2482|Washington||',
 'PAC127' => '41.6487|-75.3033|Wayne||',
 'PAC129' => '40.3107|-79.4668|Westmoreland||',
 'PAC131' => '41.5184|-76.0165|Wyoming||',
 'PAC133' => '39.9199|-76.7265|York||',
 'PAZ001' => '42.1018|-80.1245|Northern Erie|Erie|42049',
 'PAZ002' => '41.97|-80.014|Southern Erie|Erie|42049',
 'PAZ003' => '41.6848|-80.1063|Crawford|Crawford|42039',
 'PAZ004' => '41.8147|-79.2741|Warren|Warren|42123',
 'PAZ005' => '41.8078|-78.569|McKean|McKean|42083',
 'PAZ006' => '41.745|-77.8958|Potter|Potter|42105',
 'PAZ007' => '41.3022|-80.2577|Mercer|Mercer|42085',
 'PAZ008' => '41.401|-79.758|Venango|Venango|42121',
 'PAZ009' => '41.5132|-79.2361|Forest|Forest|42053',
 'PAZ010' => '41.4253|-78.6492|Elk|Elk|42047',
 'PAZ011' => '41.4368|-78.2038|Cameron|Cameron|42023',
 'PAZ012' => '41.2914|-77.7332|Northern Clinton|Clinton|42035',
 'PAZ013' => '40.9912|-80.3342|Lawrence|Lawrence|42073',
 'PAZ014' => '40.9117|-79.913|Butler|Butler|42019',
 'PAZ015' => '41.1925|-79.421|Clarion|Clarion|42031',
 'PAZ016' => '41.1281|-78.9995|Jefferson|Jefferson|42065',
 'PAZ017' => '41.0002|-78.4741|Clearfield|Clearfield|42033',
 'PAZ018' => '40.9895|-78.0032|Northern Centre|Centre|42027',
 'PAZ019' => '40.8739|-77.7022|Southern Centre|Centre|42027',
 'PAZ020' => '40.6823|-80.3493|Beaver|Beaver|42007',
 'PAZ021' => '40.4688|-79.9812|Allegheny|Allegheny|42003',
 'PAZ022' => '40.8125|-79.4645|Armstrong|Armstrong|42005',
 'PAZ024' => '40.4954|-78.7136|Cambria|Cambria|42021',
 'PAZ025' => '40.4813|-78.3486|Blair|Blair|42013',
 'PAZ026' => '40.417|-77.9812|Huntingdon|Huntingdon|42061',
 'PAZ027' => '40.6104|-77.6171|Mifflin|Mifflin|42087',
 'PAZ028' => '40.5311|-77.402|Juniata|Juniata|42067',
 'PAZ029' => '40.1894|-80.2482|Washington|Washington|42125',
 'PAZ031' => '39.8538|-80.2229|Greene|Greene|42059',
 'PAZ033' => '39.9725|-79.0283|Somerset|Somerset|42111',
 'PAZ034' => '40.0066|-78.4902|Bedford|Bedford|42009',
 'PAZ035' => '39.9255|-78.1124|Fulton|Fulton|42057',
 'PAZ036' => '39.9275|-77.7212|Franklin|Franklin|42055',
 'PAZ037' => '41.7721|-77.2543|Tioga|Tioga|42117',
 'PAZ038' => '41.7886|-76.5157|Bradford|Bradford|42015',
 'PAZ039' => '41.8214|-75.8008|Susquehanna|Susquehanna|42115',
 'PAZ040' => '41.7773|-75.2898|Northern Wayne|Wayne|42127',
 'PAZ041' => '41.4265|-77.1724|Northern Lycoming|Lycoming|42081',
 'PAZ042' => '41.446|-76.5119|Sullivan|Sullivan|42113',
 'PAZ043' => '41.5184|-76.0165|Wyoming|Wyoming|42131',
 'PAZ044' => '41.437|-75.6092|Lackawanna|Lackawanna|42069',
 'PAZ045' => '41.0789|-77.3821|Southern Clinton|Clinton|42035',
 'PAZ046' => '41.2287|-76.9158|Southern Lycoming|Lycoming|42081',
 'PAZ047' => '41.1772|-75.9889|Luzerne|Luzerne|42079',
 'PAZ048' => '41.3321|-75.0337|Pike|Pike|42103',
 'PAZ049' => '40.963|-77.0621|Union|Union|42119',
 'PAZ050' => '40.77|-77.0701|Snyder|Snyder|42109',
 'PAZ051' => '41.028|-76.6586|Montour|Montour|42093',
 'PAZ052' => '40.852|-76.7091|Northumberland|Northumberland|42097',
 'PAZ053' => '41.0486|-76.4052|Columbia|Columbia|42037',
 'PAZ054' => '40.9183|-75.7088|Carbon|Carbon|42025',
 'PAZ055' => '41.0582|-75.3394|Monroe|Monroe|42089',
 'PAZ056' => '40.3984|-77.2622|Perry|Perry|42099',
 'PAZ057' => '40.4155|-76.7792|Dauphin|Dauphin|42043',
 'PAZ058' => '40.7059|-76.216|Schuylkill|Schuylkill|42107',
 'PAZ059' => '40.3672|-76.4577|Lebanon|Lebanon|42075',
 'PAZ060' => '40.4164|-75.926|Berks|Berks|42011',
 'PAZ061' => '40.6129|-75.5924|Lehigh|Lehigh|42077',
 'PAZ062' => '40.7543|-75.3074|Northampton|Northampton|42095',
 'PAZ063' => '40.1637|-77.2651|Cumberland|Cumberland|42041',
 'PAZ064' => '39.8715|-77.2179|Adams|Adams|42001',
 'PAZ065' => '39.9199|-76.7265|York|York|42133',
 'PAZ066' => '40.0424|-76.2477|Lancaster|Lancaster|42071',
 'PAZ070' => '39.9167|-75.399|Delaware|Delaware|42045',
 'PAZ071' => '40.0076|-75.1338|Philadelphia|Philadelphia|42101',
 'PAZ072' => '41.4763|-75.3213|Southern Wayne|Wayne|42127',
 'PAZ073' => '40.3446|-79.5748|Westmoreland|Westmoreland|42129',
 'PAZ074' => '40.2371|-79.2326|Westmoreland Ridges|Westmoreland|42129',
 'PAZ075' => '39.9485|-79.7718|Fayette|Fayette|42051',
 'PAZ076' => '39.8896|-79.5165|Fayette Ridges|Fayette|42051',
 'PAZ077' => '40.6974|-79.1167|Indiana|Indiana|42063',
 'PAZ078' => '40.5318|-79.0103|Higher Elevations of Indiana|Indiana|42063',
 'PAZ101' => '39.9733|-75.7483|Western Chester|Chester|42029',
 'PAZ102' => '39.9733|-75.7483|Eastern Chester|Chester|42029',
 'PAZ103' => '40.2109|-75.3672|Western Montgomery|Montgomery|42091',
 'PAZ104' => '40.2109|-75.3672|Eastern Montgomery|Montgomery|42091',
 'PAZ105' => '40.337|-75.1067|Bucks|Upper Bucks|42017',
 'PAZ106' => '40.337|-75.1067|Bucks|Lower Bucks|42017',
 'PRC001' => '18.1798|-66.7542|Adjuntas||',
 'PRC003' => '18.3603|-67.1748|Aguada||',
 'PRC005' => '18.4597|-67.1207|Aguadilla||',
 'PRC007' => '18.2517|-66.1268|Aguas Buenas||',
 'PRC009' => '18.1311|-66.2644|Aibonito||',
 'PRC011' => '18.2870|-67.1221|Anasco||',
 'PRC013' => '18.4068|-66.6752|Arecibo||',
 'PRC015' => '17.9982|-66.0563|Arroyo||',
 'PRC017' => '18.4454|-66.5605|Barceloneta||',
 'PRC019' => '18.2017|-66.3099|Barranquitas||',
 'PRC021' => '18.3497|-66.1684|Bayamon||',
 'PRC023' => '18.0415|-67.1537|Cabo Rojo||',
 'PRC025' => '18.2119|-66.0508|Caguas||',
 'PRC027' => '18.4188|-66.8602|Camuy||',
 'PRC029' => '18.3288|-65.8879|Canovanas||',
 'PRC031' => '18.3742|-65.9567|Carolina||',
 'PRC033' => '18.4374|-66.1440|Catano||',
 'PRC035' => '18.1029|-66.1495|Cayey||',
 'PRC037' => '18.2526|-65.6678|Ceiba||',
 'PRC039' => '18.2889|-66.5164|Ciales||',
 'PRC041' => '18.1737|-66.1611|Cidra||',
 'PRC043' => '18.0972|-66.3601|Coamo||',
 'PRC045' => '18.2248|-66.2219|Comerio||',
 'PRC047' => '18.3043|-66.3279|Corozal||',
 'PRC049' => '18.3159|-65.2877|Culebra||',
 'PRC051' => '18.4365|-66.2787|Dorado||',
 'PRC053' => '18.3176|-65.6686|Fajardo||',
 'PRC054' => '18.3735|-66.5601|Florida||',
 'PRC055' => '17.9827|-66.9198|Guanica||',
 'PRC057' => '18.0077|-66.1336|Guayama||',
 'PRC059' => '18.0406|-66.7916|Guayanilla||',
 'PRC061' => '18.3442|-66.1145|Guaynabo||',
 'PRC063' => '18.2663|-65.9791|Gurabo||',
 'PRC065' => '18.4106|-66.7964|Hatillo||',
 'PRC067' => '18.1341|-67.1140|Hormigueros||',
 'PRC069' => '18.1452|-65.8105|Humacao||',
 'PRC071' => '18.4499|-67.0052|Isabela||',
 'PRC073' => '18.2106|-66.5885|Jayuya||',
 'PRC075' => '18.0507|-66.4951|Juana Diaz||',
 'PRC077' => '18.2236|-65.9089|Juncos||',
 'PRC079' => '18.0123|-67.0404|Lajas||',
 'PRC081' => '18.2689|-66.8669|Lares||',
 'PRC083' => '18.2371|-66.9835|Las Marias||',
 'PRC085' => '18.1876|-65.8693|Las Piedras||',
 'PRC087' => '18.4340|-65.9247|Loiza||',
 'PRC089' => '18.3422|-65.7249|Luquillo||',
 'PRC091' => '18.4204|-66.4902|Manati||',
 'PRC093' => '18.1721|-66.9424|Maricao||',
 'PRC095' => '18.0180|-65.9219|Maunabo||',
 'PRC097' => '18.1716|-67.3370|Mayaguez||',
 'PRC099' => '18.3779|-67.0808|Moca||',
 'PRC101' => '18.3171|-66.4202|Morovis||',
 'PRC103' => '18.2306|-65.7542|Naguabo||',
 'PRC105' => '18.2884|-66.2526|Naranjito||',
 'PRC107' => '18.2149|-66.4339|Orocovis||',
 'PRC109' => '18.0317|-66.0122|Patillas||',
 'PRC111' => '18.0608|-66.7211|Penuelas||',
 'PRC113' => '18.0597|-66.6141|Ponce||',
 'PRC115' => '18.4397|-66.9260|Quebradillas||',
 'PRC117' => '18.3374|-67.2414|Rincon||',
 'PRC119' => '18.3553|-65.8202|Rio Grande||',
 'PRC121' => '18.0830|-66.9435|Sabana Grande||',
 'PRC123' => '18.0115|-66.2564|Salinas||',
 'PRC125' => '18.1111|-67.0385|San German||',
 'PRC127' => '18.3864|-66.0607|San Juan||',
 'PRC129' => '18.1480|-65.9764|San Lorenzo||',
 'PRC131' => '18.3288|-66.9712|San Sebastian||',
 'PRC133' => '17.9950|-66.3889|Santa Isabel||',
 'PRC135' => '18.3626|-66.2464|Toa Alta||',
 'PRC137' => '18.4312|-66.2144|Toa Baja||',
 'PRC139' => '18.3362|-65.9992|Trujillo Alto||',
 'PRC141' => '18.2710|-66.7024|Utuado||',
 'PRC143' => '18.4093|-66.3372|Vega Alta||',
 'PRC145' => '18.4284|-66.3980|Vega Baja||',
 'PRC147' => '18.1231|-65.4414|Vieques||',
 'PRC149' => '18.1280|-66.4729|Villalba||',
 'PRC151' => '18.0706|-65.8965|Yabucoa||',
 'PRC153' => '18.0801|-66.8586|Yauco||',
 'PRZ001' => '18.371|-66.0981|San Juan and Vicinity|Bayamon|72021	18.371|-66.0981|San Juan and Vicinity|Carolina|72031	18.371|-66.0981|San Juan and Vicinity|Catano|72033	18.371|-66.0981|San Juan and Vicinity|Guaynabo|72061	18.371|-66.0981|San Juan and Vicinity|San Juan|72127	18.371|-66.0981|San Juan and Vicinity|Toa Alta|72135	18.371|-66.0981|San Juan and Vicinity|Toa Baja|72137	18.371|-66.0981|San Juan and Vicinity|Trujillo Alto|72139',
 'PRZ002' => '18.2861|-65.7796|Northeast|Canovanas|72029	18.2861|-65.7796|Northeast|Ceiba|72037	18.2861|-65.7796|Northeast|Fajardo|72053	18.2861|-65.7796|Northeast|Humacao|72069	18.2861|-65.7796|Northeast|Loiza|72087	18.2861|-65.7796|Northeast|Luquillo|72089	18.2861|-65.7796|Northeast|Naguabo|72103	18.2861|-65.7796|Northeast|Rio Grande|72119',
 'PRZ003' => '18.0258|-66.0756|Southeast|Arroyo|72015	18.0258|-66.0756|Southeast|Guayama|72057	18.0258|-66.0756|Southeast|Maunabo|72095	18.0258|-66.0756|Southeast|Patillas|72109	18.0258|-66.0756|Southeast|Salinas|72123	18.0258|-66.0756|Southeast|Yabucoa|72151',
 'PRZ004' => '18.1894|-66.052|Eastern Interior|Aguas Buenas|72007	18.1894|-66.052|Eastern Interior|Caguas|72025	18.1894|-66.052|Eastern Interior|Cayey|72035	18.1894|-66.052|Eastern Interior|Cidra|72041	18.1894|-66.052|Eastern Interior|Comerio|72045	18.1894|-66.052|Eastern Interior|Gurabo|72063	18.1894|-66.052|Eastern Interior|Juncos|72077	18.1894|-66.052|Eastern Interior|Las Piedras|72085	18.1894|-66.052|Eastern Interior|San Lorenzo|72129',
 'PRZ005' => '18.4154|-66.5309|North Central|Arecibo|72013	18.4154|-66.5309|North Central|Barceloneta|72017	18.4154|-66.5309|North Central|Dorado|72051	18.4154|-66.5309|North Central|Florida|72054	18.4154|-66.5309|North Central|Manati|72091	18.4154|-66.5309|North Central|Vega Alta|72143	18.4154|-66.5309|North Central|Vega Baja|72145',
 'PRZ006' => '18.213|-66.4092|Central Interior|Aibonito|72009	18.213|-66.4092|Central Interior|Barranquitas|72019	18.213|-66.4092|Central Interior|Ciales|72039	18.213|-66.4092|Central Interior|Coamo|72043	18.213|-66.4092|Central Interior|Corozal|72047	18.213|-66.4092|Central Interior|Jayuya|72073	18.213|-66.4092|Central Interior|Morovis|72101	18.213|-66.4092|Central Interior|Naranjito|72105	18.213|-66.4092|Central Interior|Orocovis|72107	18.213|-66.4092|Central Interior|Villalba|72149',
 'PRZ007' => '18.0539|-66.6527|Ponce and Vicinity|Guayanilla|72059	18.0539|-66.6527|Ponce and Vicinity|Juana Diaz|72075	18.0539|-66.6527|Ponce and Vicinity|Penuelas|72111	18.0539|-66.6527|Ponce and Vicinity|Ponce|72113	18.0539|-66.6527|Ponce and Vicinity|Santa Isabel|72133	18.0539|-66.6527|Ponce and Vicinity|Yauco|72153',
 'PRZ008' => '18.4353|-66.941|Northwest|Aguadilla|72005	18.4353|-66.941|Northwest|Camuy|72027	18.4353|-66.941|Northwest|Hatillo|72065	18.4353|-66.941|Northwest|Isabela|72071	18.4353|-66.941|Northwest|Quebradillas|72115',
 'PRZ009' => '18.2385|-66.8482|Western Interior|Adjuntas|72001	18.2385|-66.8482|Western Interior|Lares|72081	18.2385|-66.8482|Western Interior|Las Marias|72083	18.2385|-66.8482|Western Interior|Maricao|72093	18.2385|-66.8482|Western Interior|Sabana Grande|72121	18.2385|-66.8482|Western Interior|San Sebastian|72131	18.2385|-66.8482|Western Interior|Utuado|72141',
 'PRZ010' => '18.2425|-67.1683|Mayaguez and Vicinity|Aguada|72003	18.2425|-67.1683|Mayaguez and Vicinity|Anasco|72011	18.2425|-67.1683|Mayaguez and Vicinity|Hormigueros|72067	18.2425|-67.1683|Mayaguez and Vicinity|Mayaguez|72097	18.2425|-67.1683|Mayaguez and Vicinity|Moca|72099	18.2425|-67.1683|Mayaguez and Vicinity|Rincon|72117	18.2425|-67.1683|Mayaguez and Vicinity|San German|72125',
 'PRZ011' => '18.018|-67.0614|Southwest|Cabo Rojo|72023	18.018|-67.0614|Southwest|Guanica|72055	18.018|-67.0614|Southwest|Lajas|72079',
 'PRZ012' => '18.3159|-65.2877|Culebra|Culebra|72049',
 'PRZ013' => '18.1231|-65.4415|Vieques|Vieques|72147',
 'PWC004' => '7.4279|134.5428|Airai||',
 'PWC010' => '6.9074|134.1372|Angaur||',
 'PWC050' => '3.0055|131.1563|Tobi||',
 'PWC100' => '8.0745|134.7146|Kayangel||',
 'PWC150' => '7.2464|134.3979|Koror||',
 'PWC212' => '7.5623|134.5852|Melekeok||',
 'PWC350' => '7.0153|134.2477|Peleliu||',
 'PWC370' => '5.0286|132.0991|Sonsorol||',
 'PWZ001' => '8.0745|134.7146|Kayangel|Kayangel|70100',
 'PWZ002' => '7.5623|134.5852|Melekeok|Melekeok|70212',
 'PWZ003' => '7.4279|134.5428|Airai|Airai|70004',
 'PWZ004' => '7.2464|134.3979|Koror|Koror|70150',
 'PWZ005' => '7.0153|134.2477|Peleliu|Peleliu|70350',
 'PWZ006' => '6.9074|134.1372|Angaur|Angaur|70010',
 'PWZ007' => '5.0286|132.0991|Sonsorol|Sonsorol|70370',
 'PWZ008' => '3.0055|131.1563|Tobi|Tobi|70050',
 'RIC001' => '41.7161|-71.2842|Bristol||',
 'RIC003' => '41.6719|-71.5943|Kent||',
 'RIC005' => '41.5560|-71.2366|Newport||',
 'RIC007' => '41.8724|-71.5811|Providence||',
 'RIC009' => '41.4687|-71.6234|Washington||',
 'RIZ001' => '41.8908|-71.6203|Northwest Providence|Providence|44007',
 'RIZ002' => '41.8121|-71.4526|Southeast Providence|Providence|44007',
 'RIZ003' => '41.6644|-71.6637|Western Kent|Kent|44003',
 'RIZ004' => '41.6861|-71.4647|Eastern Kent|Kent|44003',
 'RIZ005' => '41.7161|-71.2842|Bristol|Bristol|44001',
 'RIZ006' => '41.478|-71.6248|Washington|Washington|44009',
 'RIZ007' => '41.556|-71.2366|Newport|Newport|44005',
 'RIZ008' => '41.178|-71.5785|Block Island|Washington|44009',
 'SCC001' => '34.2226|-82.4587|Abbeville||',
 'SCC003' => '33.5444|-81.6348|Aiken||',
 'SCC005' => '32.9881|-81.3581|Allendale||',
 'SCC007' => '34.5191|-82.6379|Anderson||',
 'SCC009' => '33.2147|-81.0542|Bamberg||',
 'SCC011' => '33.2661|-81.4350|Barnwell||',
 'SCC013' => '32.3568|-80.6934|Beaufort||	32.3873|-80.7372|Beaufort||',
 'SCC015' => '33.1978|-79.9508|Berkeley||',
 'SCC017' => '33.6749|-80.7802|Calhoun||',
 'SCC019' => '32.6714|-80.1831|Charleston||	32.8411|-79.9439|Charleston||',
 'SCC021' => '35.0482|-81.6204|Cherokee||',
 'SCC023' => '34.6921|-81.1595|Chester||',
 'SCC025' => '34.6398|-80.1586|Chesterfield||',
 'SCC027' => '33.6658|-80.2164|Clarendon||',
 'SCC029' => '32.8655|-80.6680|Colleton||',
 'SCC031' => '34.3323|-79.9577|Darlington||',
 'SCC033' => '34.3915|-79.3789|Dillon||',
 'SCC035' => '33.0795|-80.4052|Dorchester||',
 'SCC037' => '33.7723|-81.9666|Edgefield||',
 'SCC039' => '34.3951|-81.1212|Fairfield||',
 'SCC041' => '34.0245|-79.7028|Florence||',
 'SCC043' => '33.2834|-79.2353|Georgetown||	33.4408|-79.3367|Georgetown||',
 'SCC045' => '34.8944|-82.3708|Greenville||',
 'SCC047' => '34.1538|-82.1259|Greenwood||',
 'SCC049' => '32.7763|-81.1406|Hampton||',
 'SCC051' => '33.9215|-78.9966|Horry||',
 'SCC053' => '32.4371|-81.0321|Jasper||	32.4045|-80.8545|Jasper||',
 'SCC055' => '34.3388|-80.5903|Kershaw||',
 'SCC057' => '34.6867|-80.7054|Lancaster||',
 'SCC059' => '34.4836|-82.0060|Laurens||',
 'SCC061' => '34.1633|-80.2545|Lee||',
 'SCC063' => '33.9022|-81.2722|Lexington||',
 'SCC065' => '33.8996|-82.3099|McCormick||',
 'SCC067' => '34.0801|-79.3625|Marion||',
 'SCC069' => '34.6020|-79.6786|Marlboro||',
 'SCC071' => '34.2898|-81.6001|Newberry||',
 'SCC073' => '34.7535|-83.0659|Oconee||',
 'SCC075' => '33.4390|-80.8003|Orangeburg||',
 'SCC077' => '34.8875|-82.7254|Pickens||',
 'SCC079' => '34.0218|-80.9031|Richland||',
 'SCC081' => '34.0061|-81.7269|Saluda||',
 'SCC083' => '34.9313|-81.9907|Spartanburg||',
 'SCC085' => '33.9162|-80.3823|Sumter||',
 'SCC087' => '34.6892|-81.6194|Union||',
 'SCC089' => '33.6199|-79.7277|Williamsburg||',
 'SCC091' => '34.9747|-81.1845|York||',
 'SCZ008' => '35.0482|-81.6204|Cherokee|Cherokee|45021',
 'SCZ009' => '34.9747|-81.1845|York|York|45091',
 'SCZ010' => '34.5191|-82.6379|Anderson|Anderson|45007',
 'SCZ011' => '34.2226|-82.4587|Abbeville|Abbeville|45001',
 'SCZ012' => '34.4836|-82.006|Laurens|Laurens|45059',
 'SCZ013' => '34.6892|-81.6194|Union|Union|45087',
 'SCZ014' => '34.6921|-81.1595|Chester|Chester|45023',
 'SCZ016' => '34.6397|-80.1586|Chesterfield|Chesterfield|45025',
 'SCZ017' => '34.602|-79.6786|Marlboro|Marlboro|45069',
 'SCZ018' => '33.8996|-82.3099|McCormick|McCormick|45065',
 'SCZ019' => '34.1538|-82.1259|Greenwood|Greenwood|45047',
 'SCZ020' => '34.2898|-81.6001|Newberry|Newberry|45071',
 'SCZ021' => '34.3951|-81.1212|Fairfield|Fairfield|45039',
 'SCZ022' => '34.3388|-80.5903|Kershaw|Kershaw|45055',
 'SCZ023' => '34.3324|-79.9577|Darlington|Darlington|45031',
 'SCZ024' => '34.3915|-79.3789|Dillon|Dillon|45033',
 'SCZ025' => '33.7723|-81.9666|Edgefield|Edgefield|45037',
 'SCZ026' => '34.0061|-81.7269|Saluda|Saluda|45081',
 'SCZ027' => '33.9022|-81.2722|Lexington|Lexington|45063',
 'SCZ028' => '34.0218|-80.9031|Richland|Richland|45079',
 'SCZ029' => '34.1633|-80.2545|Lee|Lee|45061',
 'SCZ030' => '33.5444|-81.6348|Aiken|Aiken|45003',
 'SCZ031' => '33.9162|-80.3823|Sumter|Sumter|45085',
 'SCZ032' => '34.0245|-79.7028|Florence|Florence|45041',
 'SCZ033' => '34.0801|-79.3625|Marion|Marion|45067',
 'SCZ035' => '33.2661|-81.435|Barnwell|Barnwell|45011',
 'SCZ037' => '33.6749|-80.7802|Calhoun|Calhoun|45017',
 'SCZ038' => '33.6658|-80.2164|Clarendon|Clarendon|45027',
 'SCZ039' => '33.6199|-79.7277|Williamsburg|Williamsburg|45089',
 'SCZ040' => '32.9881|-81.3581|Allendale|Allendale|45005',
 'SCZ041' => '33.2147|-81.0542|Bamberg|Bamberg|45009',
 'SCZ042' => '32.7763|-81.1406|Hampton|Hampton|45049',
 'SCZ043' => '32.9179|-80.7029|Inland Colleton|Colleton|45029',
 'SCZ044' => '33.0795|-80.4052|Dorchester|Dorchester|45035',
 'SCZ045' => '33.222|-79.9542|Inland Berkeley|Berkeley|45015',
 'SCZ047' => '32.4763|-81.0517|Inland Jasper|Jasper|45053',
 'SCZ048' => '32.3568|-80.6933|Beaufort|Beaufort|45013	32.3874|-80.7373|Beaufort|Beaufort|45013',
 'SCZ049' => '32.6103|-80.498|Coastal Colleton|Colleton|45029',
 'SCZ050' => '32.8411|-79.9437|Charleston|Charleston|45019',
 'SCZ051' => '32.2423|-80.9561|Coastal Jasper|Jasper|45053',
 'SCZ052' => '32.9612|-79.9183|Tidal Berkeley|Berkeley|45015',
 'SCZ054' => '33.7383|-78.8597|Coastal Horry|Horry|45051',
 'SCZ055' => '33.4918|-79.3913|Inland Georgetown|Georgetown|45043',
 'SCZ056' => '33.3522|-79.2437|Coastal Georgetown|Georgetown|45043',
 'SCZ058' => '33.8439|-79.0138|Central Horry|Horry|45051',
 'SCZ059' => '34.0737|-79.0299|Northern Horry|Horry|45051',
 'SCZ101' => '34.8778|-83.1175|Oconee Mountains|Oconee|45073',
 'SCZ102' => '35.0173|-82.8101|Pickens Mountains|Pickens|45077',
 'SCZ103' => '35.13|-82.4629|Greenville Mountains|Greenville|45045',
 'SCZ104' => '34.6875|-83.0385|Greater Oconee|Oconee|45073',
 'SCZ105' => '34.8593|-82.7069|Greater Pickens|Pickens|45077',
 'SCZ106' => '34.9673|-82.3782|Central Greenville|Greenville|45045',
 'SCZ107' => '34.6832|-82.3139|Southern Greenville|Greenville|45045',
 'SCZ108' => '35.0656|-82.0536|Northern Spartanburg|Spartanburg|45083',
 'SCZ109' => '34.8324|-81.9443|Southern Spartanburg|Spartanburg|45083',
 'SCZ115' => '34.9326|-80.842|Northern Lancaster |Lancaster|45057',
 'SCZ116' => '34.6577|-80.6893|Southern Lancaster |Lancaster|45057',
 'SCZ135' => '33.5756|-81.1333|Northwestern Orangeburg|Orangeburg|45075',
 'SCZ136' => '33.4489|-80.9111|Central Orangeburg|Orangeburg|45075',
 'SCZ137' => '33.3649|-80.5375|Southeastern Orangeburg|Orangeburg|45075',
 'SDC003' => '43.7182|-98.5616|Aurora||',
 'SDC005' => '44.4145|-98.2782|Beadle||',
 'SDC007' => '43.1949|-101.6639|Bennett||',
 'SDC009' => '42.9884|-97.8847|Bon Homme||',
 'SDC011' => '44.3697|-96.7905|Brookings||',
 'SDC013' => '45.5898|-98.3516|Brown||',
 'SDC015' => '43.7181|-99.0810|Brule||',
 'SDC017' => '44.0763|-99.2050|Buffalo||',
 'SDC019' => '44.9058|-103.5081|Butte||',
 'SDC021' => '45.7711|-100.0517|Campbell||',
 'SDC023' => '43.2079|-98.5879|Charles Mix||',
 'SDC025' => '44.8582|-97.7295|Clark||',
 'SDC027' => '42.9146|-96.9757|Clay||',
 'SDC029' => '44.9778|-97.1887|Codington||',
 'SDC031' => '45.7087|-101.1969|Corson||',
 'SDC033' => '43.6776|-103.4515|Custer||',
 'SDC035' => '43.6750|-98.1461|Davison||',
 'SDC037' => '45.3672|-97.6075|Day||',
 'SDC039' => '44.7600|-96.6680|Deuel||',
 'SDC041' => '45.1566|-100.8719|Dewey||',
 'SDC043' => '43.3871|-98.3662|Douglas||',
 'SDC045' => '45.4188|-99.2155|Edmunds||',
 'SDC047' => '43.2394|-103.5276|Fall River||',
 'SDC049' => '45.0711|-99.1453|Faulk||',
 'SDC051' => '45.1720|-96.7677|Grant||',
 'SDC053' => '43.1924|-99.1856|Gregory||',
 'SDC055' => '44.2944|-101.5400|Haakon||',
 'SDC057' => '44.6737|-97.1883|Hamlin||',
 'SDC059' => '44.5478|-99.0050|Hand||',
 'SDC061' => '43.6748|-97.7874|Hanson||',
 'SDC063' => '45.5804|-103.4959|Harding||',
 'SDC065' => '44.3890|-99.9961|Hughes||',
 'SDC067' => '43.3348|-97.7546|Hutchinson||',
 'SDC069' => '44.5474|-99.4871|Hyde||',
 'SDC071' => '43.6943|-101.6281|Jackson||',
 'SDC073' => '44.0664|-98.6298|Jerauld||',
 'SDC075' => '43.9604|-100.6896|Jones||',
 'SDC077' => '44.3696|-97.4915|Kingsbury||',
 'SDC079' => '44.0220|-97.1294|Lake||',
 'SDC081' => '44.3586|-103.7922|Lawrence||',
 'SDC083' => '43.2789|-96.7219|Lincoln||',
 'SDC085' => '43.8959|-99.8474|Lyman||',
 'SDC087' => '43.6743|-97.3684|McCook||',
 'SDC089' => '45.7664|-99.2215|McPherson||',
 'SDC091' => '45.7586|-97.5986|Marshall||',
 'SDC093' => '44.5668|-102.7168|Meade||',
 'SDC095' => '43.5811|-100.7600|Mellette||',
 'SDC097' => '44.0220|-97.6102|Miner||',
 'SDC099' => '43.6742|-96.7914|Minnehaha||',
 'SDC101' => '44.0221|-96.6710|Moody||',
 'SDC102' => '43.3356|-102.5516|Oglala Lakota||',
 'SDC103' => '44.0037|-102.8238|Pennington||',
 'SDC105' => '45.4904|-102.4759|Perkins||',
 'SDC107' => '45.0645|-99.9573|Potter||',
 'SDC109' => '45.6296|-96.9461|Roberts||',
 'SDC111' => '44.0235|-98.0914|Sanborn||',
 'SDC115' => '44.9381|-98.3463|Spink||',
 'SDC117' => '44.4123|-100.7359|Stanley||',
 'SDC119' => '44.7155|-100.1322|Sully||',
 'SDC121' => '43.1934|-100.7184|Todd||',
 'SDC123' => '43.3459|-99.8840|Tripp||',
 'SDC125' => '43.3108|-97.1488|Turner||',
 'SDC127' => '42.8324|-96.6561|Union||',
 'SDC129' => '45.4299|-100.0316|Walworth||',
 'SDC135' => '43.0090|-97.3947|Yankton||',
 'SDC137' => '44.9806|-101.6660|Ziebach||',
 'SDZ001' => '45.5804|-103.4959|Harding|Harding|46063',
 'SDZ002' => '45.7373|-102.4735|Northern Perkins |Perkins|46105',
 'SDZ003' => '45.7087|-101.1969|Corson|Corson|46031',
 'SDZ004' => '45.7711|-100.0517|Campbell|Campbell|46021',
 'SDZ005' => '45.7664|-99.2215|McPherson|McPherson|46089',
 'SDZ006' => '45.5898|-98.3516|Brown|Brown|46013',
 'SDZ007' => '45.7586|-97.5986|Marshall|Marshall|46091',
 'SDZ008' => '45.6296|-96.9461|Roberts|Roberts|46109',
 'SDZ009' => '45.4299|-100.0316|Walworth|Walworth|46129',
 'SDZ010' => '45.4188|-99.2156|Edmunds|Edmunds|46045',
 'SDZ011' => '45.3672|-97.6075|Day|Day|46037',
 'SDZ012' => '44.9058|-103.5081|Butte|Butte|46019',
 'SDZ013' => '44.8215|-102.48|Northern Meade Co Plains|Meade|46093',
 'SDZ014' => '44.9806|-101.666|Ziebach|Ziebach|46137',
 'SDZ015' => '45.1566|-100.8719|Dewey|Dewey|46041',
 'SDZ016' => '45.0645|-99.9573|Potter|Potter|46107',
 'SDZ017' => '45.0711|-99.1453|Faulk|Faulk|46049',
 'SDZ018' => '44.9381|-98.3463|Spink|Spink|46115',
 'SDZ019' => '44.8582|-97.7295|Clark|Clark|46025',
 'SDZ020' => '44.9778|-97.1886|Codington|Codington|46029',
 'SDZ021' => '45.172|-96.7678|Grant|Grant|46051',
 'SDZ022' => '44.6737|-97.1883|Hamlin|Hamlin|46057',
 'SDZ023' => '44.76|-96.668|Deuel|Deuel|46039',
 'SDZ024' => '44.1987|-103.7924|Northern Black Hills |Lawrence|46081	44.1987|-103.7924|Northern Black Hills |Meade|46093	44.1987|-103.7924|Northern Black Hills |Pennington|46103',
 'SDZ025' => '44.5217|-103.7849|Northern Foothills |Lawrence|46081',
 'SDZ026' => '44.0007|-103.223|Rapid City|Pennington|46103',
 'SDZ027' => '43.3817|-103.6039|Southern Foothills |Fall River|46047',
 'SDZ028' => '43.8684|-103.6043|Central Black Hills |Pennington|46103	43.8684|-103.6043|Central Black Hills |Custer|46033',
 'SDZ029' => '43.6072|-103.7517|Southern Black Hills |Custer|46033',
 'SDZ030' => '43.6988|-102.9762|Custer Co Plains|Custer|46033',
 'SDZ031' => '44.007|-102.4422|Pennington Co Plains|Pennington|46103',
 'SDZ032' => '44.2944|-101.5399|Haakon|Haakon|46055',
 'SDZ033' => '44.4123|-100.7359|Stanley|Stanley|46117',
 'SDZ034' => '44.7155|-100.1322|Sully|Sully|46119',
 'SDZ035' => '44.389|-99.9961|Hughes|Hughes|46065',
 'SDZ036' => '44.5474|-99.4871|Hyde|Hyde|46069',
 'SDZ037' => '44.5478|-99.005|Hand|Hand|46059',
 'SDZ038' => '44.4145|-98.2782|Beadle|Beadle|46005',
 'SDZ039' => '44.3696|-97.4915|Kingsbury|Kingsbury|46077',
 'SDZ040' => '44.3697|-96.7905|Brookings|Brookings|46011',
 'SDZ041' => '43.171|-103.8148|Western Fall River |Fall River|46047',
 'SDZ042' => '43.5307|-102.5558|Northern Oglala Lakota |Oglala Lakota|46102',
 'SDZ043' => '43.8677|-101.5949|Northern Jackson |Jackson|46071',
 'SDZ044' => '43.1949|-101.6639|Bennett|Bennett|46007',
 'SDZ045' => '43.9604|-100.6896|Jones|Jones|46075',
 'SDZ046' => '43.5811|-100.7601|Mellette|Mellette|46095',
 'SDZ047' => '43.1934|-100.7184|Todd|Todd|46121',
 'SDZ048' => '43.8958|-99.8474|Lyman|Lyman|46085',
 'SDZ049' => '43.3459|-99.884|Tripp|Tripp|46123',
 'SDZ050' => '43.1924|-99.1856|Gregory|Gregory|46053',
 'SDZ051' => '44.0763|-99.205|Buffalo|Buffalo|46017',
 'SDZ052' => '44.0664|-98.6298|Jerauld|Jerauld|46073',
 'SDZ053' => '44.0235|-98.0914|Sanborn|Sanborn|46111',
 'SDZ054' => '44.022|-97.6102|Miner|Miner|46097',
 'SDZ055' => '44.022|-97.1294|Lake|Lake|46079',
 'SDZ056' => '44.0221|-96.671|Moody|Moody|46101',
 'SDZ057' => '43.7181|-99.081|Brule|Brule|46015',
 'SDZ058' => '43.7182|-98.5616|Aurora|Aurora|46003',
 'SDZ059' => '43.675|-98.1461|Davison|Davison|46035',
 'SDZ060' => '43.6748|-97.7874|Hanson|Hanson|46061',
 'SDZ061' => '43.6742|-97.3684|McCook|McCook|46087',
 'SDZ062' => '43.6742|-96.7914|Minnehaha|Minnehaha|46099',
 'SDZ063' => '43.2079|-98.5879|Charles Mix|Charles Mix|46023',
 'SDZ064' => '43.3871|-98.3662|Douglas|Douglas|46043',
 'SDZ065' => '43.3348|-97.7546|Hutchinson|Hutchinson|46067',
 'SDZ066' => '43.3108|-97.1488|Turner|Turner|46125',
 'SDZ067' => '43.2789|-96.7219|Lincoln|Lincoln|46083',
 'SDZ068' => '42.9884|-97.8847|Bon Homme|Bon Homme|46009',
 'SDZ069' => '43.009|-97.3947|Yankton|Yankton|46135',
 'SDZ070' => '42.9146|-96.9757|Clay|Clay|46027',
 'SDZ071' => '42.8324|-96.6561|Union|Union|46127',
 'SDZ072' => '44.3268|-103.3829|Sturgis-Piedmont Foothills |Meade|46093',
 'SDZ073' => '44.4055|-102.7678|Southern Meade Co Plains|Meade|46093',
 'SDZ074' => '43.6677|-103.2509|Hermosa Foot Hills|Custer|46033',
 'SDZ075' => '43.2078|-103.2197|Eastern Fall River |Fall River|46047',
 'SDZ076' => '43.1901|-102.5485|Southern Oglala Lakota |Oglala Lakota|46102',
 'SDZ077' => '43.5628|-101.6533|Southern Jackson |Jackson|46071',
 'SDZ078' => '45.2845|-102.4779|Southern Perkins |Perkins|46105',
 'TNC001' => '36.1184|-84.1985|Anderson||',
 'TNC003' => '35.5138|-86.4589|Bedford||',
 'TNC005' => '36.0698|-88.0683|Benton||',
 'TNC007' => '35.5964|-85.2051|Bledsoe||',
 'TNC009' => '35.6873|-83.9255|Blount||',
 'TNC011' => '35.1541|-84.8596|Bradley||',
 'TNC013' => '36.4036|-84.1493|Campbell||',
 'TNC015' => '35.8087|-86.0617|Cannon||',
 'TNC017' => '35.9731|-88.4503|Carroll||',
 'TNC019' => '36.2927|-82.1274|Carter||',
 'TNC021' => '36.2612|-87.0868|Cheatham||',
 'TNC023' => '35.4211|-88.6128|Chester||',
 'TNC025' => '36.4859|-83.6603|Claiborne||',
 'TNC027' => '36.5511|-85.5438|Clay||',
 'TNC029' => '35.9254|-83.1211|Cocke||',
 'TNC031' => '35.4906|-86.0748|Coffee||',
 'TNC033' => '35.8135|-89.1395|Crockett||',
 'TNC035' => '35.9504|-84.9983|Cumberland||',
 'TNC037' => '36.1694|-86.7848|Davidson||',
 'TNC039' => '35.6030|-88.1088|Decatur||',
 'TNC041' => '35.9798|-85.8328|De Kalb||',
 'TNC043' => '36.1491|-87.3567|Dickson||',
 'TNC045' => '36.0590|-89.4138|Dyer||',
 'TNC047' => '35.1971|-89.4144|Fayette||',
 'TNC049' => '36.3805|-84.9324|Fentress||',
 'TNC051' => '35.1549|-86.0922|Franklin||',
 'TNC053' => '35.9966|-88.9326|Gibson||',
 'TNC055' => '35.2022|-87.0348|Giles||',
 'TNC057' => '36.2762|-83.5096|Grainger||',
 'TNC059' => '36.1754|-82.8458|Greene||',
 'TNC061' => '35.3884|-85.7226|Grundy||',
 'TNC063' => '36.2172|-83.2666|Hamblen||',
 'TNC065' => '35.1809|-85.1648|Hamilton||',
 'TNC067' => '36.5236|-83.2219|Hancock||',
 'TNC069' => '35.2069|-88.9931|Hardeman||',
 'TNC071' => '35.1987|-88.1845|Hardin||',
 'TNC073' => '36.4412|-82.9447|Hawkins||',
 'TNC075' => '35.5832|-89.2838|Haywood||',
 'TNC077' => '35.6543|-88.3880|Henderson||',
 'TNC079' => '36.3317|-88.3013|Henry||',
 'TNC081' => '35.8033|-87.4733|Hickman||',
 'TNC083' => '36.2860|-87.7171|Houston||',
 'TNC085' => '36.0408|-87.7757|Humphreys||',
 'TNC087' => '36.3592|-85.6732|Jackson||',
 'TNC089' => '36.0510|-83.4463|Jefferson||',
 'TNC091' => '36.4549|-81.8518|Johnson||',
 'TNC093' => '35.9932|-83.9371|Knox||',
 'TNC095' => '36.3352|-89.4935|Lake||',
 'TNC097' => '35.7609|-89.6314|Lauderdale||',
 'TNC099' => '35.2173|-87.3956|Lawrence||',
 'TNC101' => '35.5273|-87.4931|Lewis||',
 'TNC103' => '35.1405|-86.5889|Lincoln||',
 'TNC105' => '35.7350|-84.3116|Loudon||',
 'TNC107' => '35.4248|-84.6175|McMinn||',
 'TNC109' => '35.1746|-88.5637|McNairy||',
 'TNC111' => '36.5320|-86.0072|Macon||',
 'TNC113' => '35.6082|-88.8385|Madison||',
 'TNC115' => '35.1294|-85.6220|Marion||',
 'TNC117' => '35.4689|-86.7650|Marshall||',
 'TNC119' => '35.6170|-87.0770|Maury||',
 'TNC121' => '35.5127|-84.8135|Meigs||',
 'TNC123' => '35.4428|-84.2528|Monroe||',
 'TNC125' => '36.4969|-87.3828|Montgomery||',
 'TNC127' => '35.2847|-86.3588|Moore||',
 'TNC129' => '36.1350|-84.6491|Morgan||',
 'TNC131' => '36.3582|-89.1488|Obion||',
 'TNC133' => '36.3450|-85.2881|Overton||',
 'TNC135' => '35.6426|-87.8590|Perry||',
 'TNC137' => '36.5585|-85.0748|Pickett||',
 'TNC139' => '35.1199|-84.5233|Polk||',
 'TNC141' => '36.1408|-85.4951|Putnam||',
 'TNC143' => '35.6087|-84.9244|Rhea||',
 'TNC145' => '35.8478|-84.5233|Roane||',
 'TNC147' => '36.5254|-86.8705|Robertson||',
 'TNC149' => '35.8427|-86.4167|Rutherford||',
 'TNC151' => '36.4286|-84.5035|Scott||',
 'TNC153' => '35.3712|-85.4106|Sequatchie||',
 'TNC155' => '35.7847|-83.5242|Sevier||',
 'TNC157' => '35.1837|-89.8956|Shelby||',
 'TNC159' => '36.2505|-85.9567|Smith||',
 'TNC161' => '36.5012|-87.8385|Stewart||',
 'TNC163' => '36.5129|-82.3042|Sullivan||',
 'TNC165' => '36.4694|-86.4603|Sumner||',
 'TNC167' => '35.4966|-89.7594|Tipton||',
 'TNC169' => '36.3921|-86.1567|Trousdale||',
 'TNC171' => '36.1108|-82.4322|Unicoi||',
 'TNC173' => '36.2879|-83.8375|Union||',
 'TNC175' => '35.6960|-85.4525|Van Buren||',
 'TNC177' => '35.6787|-85.7785|Warren||',
 'TNC179' => '36.2933|-82.4974|Washington||',
 'TNC181' => '35.2399|-87.7880|Wayne||',
 'TNC183' => '36.2983|-88.7178|Weakley||',
 'TNC185' => '35.9264|-85.4553|White||',
 'TNC187' => '35.8938|-86.8986|Williamson||',
 'TNC189' => '36.1549|-86.2976|Wilson||',
 'TNZ001' => '36.3352|-89.4935|Lake|Lake|47095',
 'TNZ002' => '36.3582|-89.1488|Obion|Obion|47131',
 'TNZ003' => '36.2983|-88.7178|Weakley|Weakley|47183',
 'TNZ004' => '36.3317|-88.3013|Henry|Henry|47079',
 'TNZ005' => '36.5012|-87.8385|Stewart|Stewart|47161',
 'TNZ006' => '36.4969|-87.3829|Montgomery|Montgomery|47125',
 'TNZ007' => '36.5254|-86.8705|Robertson|Robertson|47147',
 'TNZ008' => '36.4694|-86.4603|Sumner|Sumner|47165',
 'TNZ009' => '36.532|-86.0072|Macon|Macon|47111',
 'TNZ010' => '36.5511|-85.5438|Clay|Clay|47027',
 'TNZ011' => '36.5585|-85.0748|Pickett|Pickett|47137',
 'TNZ012' => '36.4286|-84.5035|Scott|Scott|47151',
 'TNZ013' => '36.4036|-84.1493|Campbell|Campbell|47013',
 'TNZ014' => '36.4859|-83.6604|Claiborne|Claiborne|47025',
 'TNZ015' => '36.5236|-83.2219|Hancock|Hancock|47067',
 'TNZ016' => '36.4412|-82.9447|Hawkins|Hawkins|47073',
 'TNZ017' => '36.5129|-82.3042|Sullivan|Sullivan|47163',
 'TNZ018' => '36.4549|-81.8518|Johnson|Johnson|47091',
 'TNZ019' => '36.059|-89.4138|Dyer|Dyer|47045',
 'TNZ020' => '35.9966|-88.9326|Gibson|Gibson|47053',
 'TNZ021' => '35.9731|-88.4502|Carroll|Carroll|47017',
 'TNZ022' => '36.0698|-88.0683|Benton|Benton|47005',
 'TNZ023' => '36.286|-87.7171|Houston|Houston|47083',
 'TNZ024' => '36.0408|-87.7757|Humphreys|Humphreys|47085',
 'TNZ025' => '36.1491|-87.3567|Dickson|Dickson|47043',
 'TNZ026' => '36.2612|-87.0868|Cheatham|Cheatham|47021',
 'TNZ027' => '36.1694|-86.7848|Davidson|Davidson|47037',
 'TNZ028' => '36.1549|-86.2976|Wilson|Wilson|47189',
 'TNZ029' => '36.3921|-86.1567|Trousdale|Trousdale|47169',
 'TNZ030' => '36.2505|-85.9567|Smith|Smith|47159',
 'TNZ031' => '36.3592|-85.6732|Jackson|Jackson|47087',
 'TNZ032' => '36.1408|-85.4951|Putnam|Putnam|47141',
 'TNZ033' => '36.345|-85.2881|Overton|Overton|47133',
 'TNZ034' => '36.3805|-84.9324|Fentress|Fentress|47049',
 'TNZ035' => '36.135|-84.6491|Morgan|Morgan|47129',
 'TNZ036' => '36.1184|-84.1985|Anderson|Anderson|47001',
 'TNZ037' => '36.2879|-83.8375|Union|Union|47173',
 'TNZ038' => '36.2762|-83.5096|Grainger|Grainger|47057',
 'TNZ039' => '36.2172|-83.2666|Hamblen|Hamblen|47063',
 'TNZ040' => '35.9835|-83.1536|Northwest Cocke|Cocke|47029',
 'TNZ041' => '35.8417|-83.0743|Cocke Smoky Mountains|Cocke|47029',
 'TNZ042' => '36.2009|-82.8533|Northwest Greene|Greene|47059',
 'TNZ043' => '36.0126|-82.798|Southeast Greene|Greene|47059',
 'TNZ044' => '36.2933|-82.4974|Washington|Washington|47179',
 'TNZ045' => '36.1108|-82.4323|Unicoi|Unicoi|47171',
 'TNZ046' => '36.3716|-82.1633|Northwest Carter|Carter|47019',
 'TNZ047' => '36.2304|-82.099|Southeast Carter|Carter|47019',
 'TNZ048' => '35.7609|-89.6314|Lauderdale|Lauderdale|47097',
 'TNZ049' => '35.4966|-89.7594|Tipton|Tipton|47167',
 'TNZ050' => '35.5833|-89.2838|Haywood|Haywood|47075',
 'TNZ051' => '35.8135|-89.1395|Crockett|Crockett|47033',
 'TNZ052' => '35.6082|-88.8385|Madison|Madison|47113',
 'TNZ053' => '35.4211|-88.6128|Chester|Chester|47023',
 'TNZ054' => '35.6543|-88.388|Henderson|Henderson|47077',
 'TNZ055' => '35.603|-88.1088|Decatur|Decatur|47039',
 'TNZ056' => '35.6426|-87.859|Perry|Perry|47135',
 'TNZ057' => '35.8033|-87.4733|Hickman|Hickman|47081',
 'TNZ058' => '35.5273|-87.4931|Lewis|Lewis|47101',
 'TNZ059' => '35.8938|-86.8987|Williamson|Williamson|47187',
 'TNZ060' => '35.617|-87.077|Maury|Maury|47119',
 'TNZ061' => '35.4689|-86.7651|Marshall|Marshall|47117',
 'TNZ062' => '35.8427|-86.4167|Rutherford|Rutherford|47149',
 'TNZ063' => '35.8087|-86.0617|Cannon|Cannon|47015',
 'TNZ064' => '35.9798|-85.8328|De Kalb|De Kalb|47041',
 'TNZ065' => '35.9264|-85.4553|White|White|47185',
 'TNZ066' => '35.9504|-84.9983|Cumberland|Cumberland|47035',
 'TNZ067' => '35.8478|-84.5233|Roane|Roane|47145',
 'TNZ068' => '35.735|-84.3116|Loudon|Loudon|47105',
 'TNZ069' => '35.9932|-83.9371|Knox|Knox|47093',
 'TNZ070' => '36.051|-83.4463|Jefferson|Jefferson|47089',
 'TNZ071' => '35.7251|-83.9604|NW Blount|Blount|47009',
 'TNZ072' => '35.5851|-83.8315|Blount Smoky Mountains|Blount|47009',
 'TNZ073' => '35.8471|-83.5572|North Sevier|Sevier|47155',
 'TNZ074' => '35.6746|-83.4659|Sevier Smoky Mountains|Sevier|47155',
 'TNZ075' => '35.5138|-86.4589|Bedford|Bedford|47003',
 'TNZ076' => '35.2847|-86.3588|Moore|Moore|47127',
 'TNZ077' => '35.4906|-86.0748|Coffee|Coffee|47031',
 'TNZ078' => '35.6787|-85.7785|Warren|Warren|47177',
 'TNZ079' => '35.3884|-85.7226|Grundy|Grundy|47061',
 'TNZ080' => '35.696|-85.4525|Van Buren|Van Buren|47175',
 'TNZ081' => '35.3712|-85.4106|Sequatchie|Sequatchie|47153',
 'TNZ082' => '35.5964|-85.2051|Bledsoe|Bledsoe|47007',
 'TNZ083' => '35.6087|-84.9244|Rhea|Rhea|47143',
 'TNZ084' => '35.5127|-84.8135|Meigs|Meigs|47121',
 'TNZ085' => '35.4248|-84.6175|McMinn|McMinn|47107',
 'TNZ086' => '35.4861|-84.3095|Northwest Monroe|Monroe|47123',
 'TNZ087' => '35.353|-84.1353|Southeast Monroe|Monroe|47123',
 'TNZ088' => '35.1837|-89.8956|Shelby|Shelby|47157',
 'TNZ089' => '35.1971|-89.4144|Fayette|Fayette|47047',
 'TNZ090' => '35.2069|-88.9931|Hardeman|Hardeman|47069',
 'TNZ091' => '35.1746|-88.5637|McNairy|McNairy|47109',
 'TNZ092' => '35.1987|-88.1845|Hardin|Hardin|47071',
 'TNZ093' => '35.24|-87.788|Wayne|Wayne|47181',
 'TNZ094' => '35.2173|-87.3956|Lawrence|Lawrence|47099',
 'TNZ095' => '35.2022|-87.0348|Giles|Giles|47055',
 'TNZ096' => '35.1405|-86.5889|Lincoln|Lincoln|47103',
 'TNZ097' => '35.1549|-86.0922|Franklin|Franklin|47051',
 'TNZ098' => '35.1294|-85.622|Marion|Marion|47115',
 'TNZ099' => '35.1809|-85.1648|Hamilton|Hamilton|47065',
 'TNZ100' => '35.1541|-84.8596|Bradley|Bradley|47011',
 'TNZ101' => '35.1416|-84.5937|West Polk|Polk|47139',
 'TNZ102' => '35.0855|-84.4113|East Polk|Polk|47139',
 'TXC001' => '31.8134|-95.6525|Anderson||',
 'TXC003' => '32.3050|-102.6378|Andrews||',
 'TXC005' => '31.2548|-94.6118|Angelina||',
 'TXC007' => '28.1358|-96.9975|Aransas||',
 'TXC009' => '33.6153|-98.6877|Archer||',
 'TXC011' => '34.9649|-101.3574|Armstrong||',
 'TXC013' => '28.8907|-98.5279|Atascosa||',
 'TXC015' => '29.8870|-96.2780|Austin||',
 'TXC017' => '34.0685|-102.8298|Bailey||',
 'TXC019' => '29.7472|-99.2462|Bandera||',
 'TXC021' => '30.1036|-97.3121|Bastrop||',
 'TXC023' => '33.6165|-99.2135|Baylor||',
 'TXC025' => '28.4174|-97.7412|Bee||',
 'TXC027' => '31.0377|-97.4782|Bell||',
 'TXC029' => '29.4491|-98.5199|Bexar||',
 'TXC031' => '30.2664|-98.3998|Blanco||',
 'TXC033' => '32.7437|-101.4317|Borden||',
 'TXC035' => '31.9004|-97.6343|Bosque||',
 'TXC037' => '33.4454|-94.4229|Bowie||',
 'TXC039' => '29.1913|-95.4551|Brazoria||',
 'TXC041' => '30.6611|-96.3023|Brazos||',
 'TXC043' => '29.8119|-103.2517|Brewster||',
 'TXC045' => '34.5303|-101.2086|Briscoe||',
 'TXC047' => '27.0316|-98.2187|Brooks||',
 'TXC049' => '31.7743|-98.9998|Brown||',
 'TXC051' => '30.4924|-96.6210|Burleson||',
 'TXC053' => '30.7883|-98.1824|Burnet||',
 'TXC055' => '29.8372|-97.6200|Caldwell||',
 'TXC057' => '28.4909|-96.6495|Calhoun||',
 'TXC059' => '32.2977|-99.3735|Callahan||',
 'TXC061' => '26.1293|-97.5292|Cameron||',
 'TXC063' => '32.9732|-94.9785|Camp||',
 'TXC065' => '35.4035|-101.3542|Carson||',
 'TXC067' => '33.0775|-94.3436|Cass||',
 'TXC069' => '34.5300|-102.2617|Castro||',
 'TXC071' => '29.7390|-94.6073|Chambers||',
 'TXC073' => '31.8370|-95.1652|Cherokee||',
 'TXC075' => '34.5292|-100.2076|Childress||',
 'TXC077' => '33.7854|-98.2084|Clay||',
 'TXC079' => '33.6041|-102.8285|Cochran||',
 'TXC081' => '31.8885|-100.5299|Coke||',
 'TXC083' => '31.7732|-99.4536|Coleman||',
 'TXC085' => '33.1878|-96.5724|Collin||',
 'TXC087' => '34.9649|-100.2701|Collingsworth||',
 'TXC089' => '29.6208|-96.5263|Colorado||',
 'TXC091' => '29.8082|-98.2781|Comal||',
 'TXC093' => '31.9480|-98.5583|Comanche||',
 'TXC095' => '31.3265|-99.8639|Concho||',
 'TXC097' => '33.6393|-97.2126|Cooke||',
 'TXC099' => '31.3909|-97.7992|Coryell||',
 'TXC101' => '34.0777|-100.2787|Cottle||',
 'TXC103' => '31.4285|-102.5155|Crane||',
 'TXC105' => '30.7230|-101.4121|Crockett||',
 'TXC107' => '33.6146|-101.3000|Crosby||',
 'TXC109' => '31.4472|-104.5173|Culberson||',
 'TXC111' => '36.2779|-102.6022|Dallam||',
 'TXC113' => '32.7666|-96.7779|Dallas||',
 'TXC115' => '32.7425|-101.9477|Dawson||',
 'TXC117' => '34.9660|-102.6049|Deaf Smith||',
 'TXC119' => '33.3863|-95.6723|Delta||',
 'TXC121' => '33.2043|-97.1171|Denton||',
 'TXC123' => '29.0821|-97.3568|DeWitt||',
 'TXC125' => '33.6166|-100.7789|Dickens||',
 'TXC127' => '28.4225|-99.7567|Dimmit||',
 'TXC129' => '34.9654|-100.8140|Donley||',
 'TXC131' => '27.6813|-98.5089|Duval||',
 'TXC133' => '32.3271|-98.8323|Eastland||',
 'TXC135' => '31.8692|-102.5428|Ector||',
 'TXC137' => '29.9826|-100.3047|Edwards||',
 'TXC139' => '32.3484|-96.7945|Ellis||',
 'TXC141' => '31.7686|-106.2348|El Paso||',
 'TXC143' => '32.2363|-98.2180|Erath||',
 'TXC145' => '31.2533|-96.9358|Falls||',
 'TXC147' => '33.5939|-96.1066|Fannin||',
 'TXC149' => '29.8768|-96.9198|Fayette||',
 'TXC151' => '32.7428|-100.4022|Fisher||',
 'TXC153' => '34.0724|-101.3032|Floyd||',
 'TXC155' => '33.9746|-99.7780|Foard||',
 'TXC157' => '29.5274|-95.7707|Fort Bend||',
 'TXC159' => '33.1756|-95.2184|Franklin||',
 'TXC161' => '31.7049|-96.1490|Freestone||',
 'TXC163' => '28.8678|-99.1083|Frio||',
 'TXC165' => '32.7407|-102.6352|Gaines||',
 'TXC167' => '29.3941|-94.9650|Galveston||',
 'TXC169' => '33.1799|-101.2984|Garza||',
 'TXC171' => '30.3181|-98.9464|Gillespie||',
 'TXC173' => '31.8694|-101.5208|Glasscock||',
 'TXC175' => '28.6571|-97.4264|Goliad||',
 'TXC177' => '29.4567|-97.4925|Gonzales||',
 'TXC179' => '35.4012|-100.8126|Gray||',
 'TXC181' => '33.6268|-96.6776|Grayson||',
 'TXC183' => '32.4803|-94.8172|Gregg||',
 'TXC185' => '30.5436|-95.9855|Grimes||',
 'TXC187' => '29.5831|-97.9484|Guadalupe||',
 'TXC189' => '34.0705|-101.8269|Hale||',
 'TXC191' => '34.5308|-100.6811|Hall||',
 'TXC193' => '31.7048|-98.1107|Hamilton||',
 'TXC195' => '36.2775|-101.3545|Hansford||',
 'TXC197' => '34.2903|-99.7457|Hardeman||',
 'TXC199' => '30.3324|-94.3902|Hardin||',
 'TXC201' => '29.8588|-95.3963|Harris||	29.7371|-95.1819|Harris||',
 'TXC203' => '32.5482|-94.3713|Harrison||',
 'TXC205' => '35.8400|-102.6029|Hartley||',
 'TXC207' => '33.1782|-99.7303|Haskell||',
 'TXC209' => '30.0582|-98.0311|Hays||',
 'TXC211' => '35.8376|-100.2705|Hemphill||',
 'TXC213' => '32.2121|-95.8538|Henderson||',
 'TXC215' => '26.3968|-98.1811|Hidalgo||',
 'TXC217' => '31.9907|-97.1324|Hill||',
 'TXC219' => '33.6076|-102.3432|Hockley||',
 'TXC221' => '32.4299|-97.8323|Hood||',
 'TXC223' => '33.1495|-95.5640|Hopkins||',
 'TXC225' => '31.3178|-95.4227|Houston||',
 'TXC227' => '32.3062|-101.4355|Howard||',
 'TXC229' => '31.4562|-105.3865|Hudspeth||',
 'TXC231' => '33.1236|-96.0854|Hunt||',
 'TXC233' => '35.8400|-101.3547|Hutchinson||',
 'TXC235' => '31.3039|-100.9824|Irion||',
 'TXC237' => '33.2335|-98.1725|Jack||',
 'TXC239' => '28.9557|-96.5787|Jackson||',
 'TXC241' => '30.7440|-94.0250|Jasper||',
 'TXC243' => '30.7154|-104.1400|Jeff Davis||',
 'TXC245' => '29.8838|-94.1722|Jefferson||',
 'TXC247' => '27.0434|-98.6973|Jim Hogg||',
 'TXC249' => '27.7311|-98.0902|Jim Wells||',
 'TXC251' => '32.3790|-97.3663|Johnson||',
 'TXC253' => '32.7399|-99.8787|Jones||',
 'TXC255' => '28.9057|-97.8594|Karnes||',
 'TXC257' => '32.5996|-96.2879|Kaufman||',
 'TXC259' => '29.9447|-98.7116|Kendall||',
 'TXC261' => '26.9281|-97.7174|Kenedy||',
 'TXC263' => '33.1814|-100.7776|Kent||',
 'TXC265' => '30.0615|-99.3501|Kerr||',
 'TXC267' => '30.4868|-99.7487|Kimble||',
 'TXC269' => '33.6165|-100.2558|King||',
 'TXC271' => '29.3502|-100.4180|Kinney||',
 'TXC273' => '27.4338|-97.7344|Kleberg||',
 'TXC275' => '33.6061|-99.7414|Knox||',
 'TXC277' => '33.6671|-95.5711|Lamar||',
 'TXC279' => '34.0686|-102.3517|Lamb||',
 'TXC281' => '31.1962|-98.2414|Lampasas||',
 'TXC283' => '28.3451|-99.0997|La Salle||',
 'TXC285' => '29.3843|-96.9301|Lavaca||',
 'TXC287' => '30.3107|-96.9657|Lee||',
 'TXC289' => '31.2965|-95.9957|Leon||',
 'TXC291' => '30.1516|-94.8122|Liberty||',
 'TXC293' => '31.5455|-96.5805|Limestone||',
 'TXC295' => '36.2777|-100.2731|Lipscomb||',
 'TXC297' => '28.3514|-98.1248|Live Oak||',
 'TXC299' => '30.7056|-98.6840|Llano||',
 'TXC301' => '31.8492|-103.5800|Loving||',
 'TXC303' => '33.6102|-101.8205|Lubbock||',
 'TXC305' => '33.1768|-101.8161|Lynn||',
 'TXC307' => '31.1989|-99.3474|McCulloch||',
 'TXC309' => '31.5524|-97.2018|McLennan||',
 'TXC311' => '28.3491|-98.5674|McMullen||',
 'TXC313' => '30.9656|-95.9284|Madison||',
 'TXC315' => '32.7980|-94.3572|Marion||',
 'TXC317' => '32.3060|-101.9512|Martin||',
 'TXC319' => '30.7177|-99.2261|Mason||',
 'TXC321' => '28.8661|-95.9853|Matagorda||',
 'TXC323' => '28.7426|-100.3145|Maverick||',
 'TXC325' => '29.3557|-99.1101|Medina||',
 'TXC327' => '30.8898|-99.8206|Menard||',
 'TXC329' => '31.8692|-102.0316|Midland||',
 'TXC331' => '30.7863|-96.9769|Milam||',
 'TXC333' => '31.4952|-98.5955|Mills||',
 'TXC335' => '32.3062|-100.9212|Mitchell||',
 'TXC337' => '33.6757|-97.7246|Montague||',
 'TXC339' => '30.3002|-95.5030|Montgomery||',
 'TXC341' => '35.8377|-101.8929|Moore||',
 'TXC343' => '33.1135|-94.7326|Morris||',
 'TXC345' => '34.0741|-100.7798|Motley||',
 'TXC347' => '31.6160|-94.6158|Nacogdoches||',
 'TXC349' => '32.0470|-96.4724|Navarro||',
 'TXC351' => '30.7863|-93.7448|Newton||',
 'TXC353' => '32.3035|-100.4060|Nolan||',
 'TXC355' => '27.7232|-97.6289|Nueces||',
 'TXC357' => '36.2784|-100.8156|Ochiltree||',
 'TXC359' => '35.4050|-102.6029|Oldham||',
 'TXC361' => '30.1281|-93.8965|Orange||',
 'TXC363' => '32.7532|-98.3130|Palo Pinto||',
 'TXC365' => '32.1624|-94.3056|Panola||',
 'TXC367' => '32.7777|-97.8051|Parker||',
 'TXC369' => '34.5301|-102.7845|Parmer||',
 'TXC371' => '30.7811|-102.7236|Pecos||',
 'TXC373' => '30.7928|-94.8300|Polk||',
 'TXC375' => '35.4013|-101.8940|Potter||',
 'TXC377' => '29.9998|-104.2405|Presidio||',
 'TXC379' => '32.8703|-95.7934|Rains||',
 'TXC381' => '34.9659|-101.8969|Randall||',
 'TXC383' => '31.3662|-101.5230|Reagan||',
 'TXC385' => '29.8318|-99.8221|Real||',
 'TXC387' => '33.6207|-95.0504|Red River||',
 'TXC389' => '31.3230|-103.6931|Reeves||',
 'TXC391' => '28.3269|-97.1655|Refugio||',
 'TXC393' => '35.8385|-100.8135|Roberts||',
 'TXC395' => '31.0270|-96.5128|Robertson||',
 'TXC397' => '32.8978|-96.4077|Rockwall||',
 'TXC399' => '31.8311|-99.9762|Runnels||',
 'TXC401' => '32.1078|-94.7618|Rusk||',
 'TXC403' => '31.3432|-93.8518|Sabine||',
 'TXC405' => '31.3943|-94.1682|San Augustine||',
 'TXC407' => '30.5796|-95.1669|San Jacinto||',
 'TXC409' => '28.0095|-97.5188|San Patricio||',
 'TXC411' => '31.1552|-98.8176|San Saba||',
 'TXC413' => '30.8975|-100.5385|Schleicher||',
 'TXC415' => '32.7463|-100.9164|Scurry||',
 'TXC417' => '32.7360|-99.3541|Shackelford||',
 'TXC419' => '31.7924|-94.1450|Shelby||',
 'TXC421' => '36.2777|-101.8935|Sherman||',
 'TXC423' => '32.3750|-95.2692|Smith||',
 'TXC425' => '32.2223|-97.7744|Somervell||',
 'TXC427' => '26.5621|-98.7384|Starr||',
 'TXC429' => '32.7359|-98.8362|Stephens||',
 'TXC431' => '31.8279|-101.0500|Sterling||',
 'TXC433' => '33.1791|-100.2533|Stonewall||',
 'TXC435' => '30.4983|-100.5382|Sutton||',
 'TXC437' => '34.5304|-101.7350|Swisher||',
 'TXC439' => '32.7704|-97.2919|Tarrant||',
 'TXC441' => '32.3015|-99.8901|Taylor||',
 'TXC443' => '30.2250|-102.0765|Terrell||',
 'TXC445' => '33.1738|-102.3352|Terry||',
 'TXC447' => '33.1775|-99.2124|Throckmorton||',
 'TXC449' => '33.2166|-94.9657|Titus||',
 'TXC451' => '31.4044|-100.4621|Tom Green||',
 'TXC453' => '30.3347|-97.7819|Travis||',
 'TXC455' => '31.0889|-95.1355|Trinity||',
 'TXC457' => '30.7713|-94.3765|Tyler||',
 'TXC459' => '32.7363|-94.9414|Upshur||',
 'TXC461' => '31.3688|-102.0431|Upton||',
 'TXC463' => '29.3574|-99.7622|Uvalde||',
 'TXC465' => '29.8930|-101.1517|Val Verde||',
 'TXC467' => '32.5637|-95.8365|Van Zandt||',
 'TXC469' => '28.7964|-96.9715|Victoria||',
 'TXC471' => '30.7390|-95.5722|Walker||',
 'TXC473' => '30.0110|-95.9877|Waller||',
 'TXC475' => '31.5095|-103.1024|Ward||',
 'TXC477' => '30.2145|-96.4036|Washington||',
 'TXC479' => '27.7611|-99.3316|Webb||',
 'TXC481' => '29.2779|-96.2221|Wharton||',
 'TXC483' => '35.4013|-100.2697|Wheeler||',
 'TXC485' => '33.9880|-98.7032|Wichita||',
 'TXC487' => '34.0807|-99.2410|Wilbarger||',
 'TXC489' => '26.4706|-97.6732|Willacy||',
 'TXC491' => '30.6481|-97.6008|Williamson||',
 'TXC493' => '29.1741|-98.0866|Wilson||',
 'TXC495' => '31.8500|-103.0482|Winkler||',
 'TXC497' => '33.2159|-97.6544|Wise||',
 'TXC499' => '32.7864|-95.3821|Wood||',
 'TXC501' => '33.1729|-102.8278|Yoakum||',
 'TXC503' => '33.1767|-98.6878|Young||',
 'TXC505' => '27.0007|-99.1686|Zapata||',
 'TXC507' => '28.8662|-99.7606|Zavala||',
 'TXZ001' => '36.2779|-102.6022|Dallam|Dallam|48111',
 'TXZ002' => '36.2777|-101.8935|Sherman|Sherman|48421',
 'TXZ003' => '36.2775|-101.3545|Hansford|Hansford|48195',
 'TXZ004' => '36.2784|-100.8156|Ochiltree|Ochiltree|48357',
 'TXZ005' => '36.2777|-100.2731|Lipscomb|Lipscomb|48295',
 'TXZ006' => '35.84|-102.6029|Hartley|Hartley|48205',
 'TXZ007' => '35.8377|-101.8929|Moore|Moore|48341',
 'TXZ008' => '35.84|-101.3547|Hutchinson|Hutchinson|48233',
 'TXZ009' => '35.8385|-100.8134|Roberts|Roberts|48393',
 'TXZ010' => '35.8376|-100.2705|Hemphill|Hemphill|48211',
 'TXZ011' => '35.405|-102.6029|Oldham|Oldham|48359',
 'TXZ012' => '35.4013|-101.894|Potter|Potter|48375',
 'TXZ013' => '35.4035|-101.3542|Carson|Carson|48065',
 'TXZ014' => '35.4012|-100.8126|Gray|Gray|48179',
 'TXZ015' => '35.4013|-100.2697|Wheeler|Wheeler|48483',
 'TXZ016' => '34.966|-102.6049|Deaf Smith|Deaf Smith|48117',
 'TXZ017' => '34.9669|-101.9073|Randall|Randall|48381',
 'TXZ018' => '34.9649|-101.3574|Armstrong|Armstrong|48011',
 'TXZ019' => '34.9654|-100.814|Donley|Donley|48129',
 'TXZ020' => '34.9649|-100.2701|Collingsworth|Collingsworth|48087',
 'TXZ021' => '34.5301|-102.7845|Parmer|Parmer|48369',
 'TXZ022' => '34.53|-102.2617|Castro|Castro|48069',
 'TXZ023' => '34.5304|-101.735|Swisher|Swisher|48437',
 'TXZ024' => '34.5303|-101.2086|Briscoe|Briscoe|48045',
 'TXZ025' => '34.5308|-100.6811|Hall|Hall|48191',
 'TXZ026' => '34.5292|-100.2076|Childress|Childress|48075',
 'TXZ027' => '34.0685|-102.8298|Bailey|Bailey|48017',
 'TXZ028' => '34.0686|-102.3517|Lamb|Lamb|48279',
 'TXZ029' => '34.0705|-101.8269|Hale|Hale|48189',
 'TXZ030' => '34.0724|-101.3032|Floyd|Floyd|48153',
 'TXZ031' => '34.0741|-100.7798|Motley|Motley|48345',
 'TXZ032' => '34.0776|-100.2788|Cottle|Cottle|48101',
 'TXZ033' => '33.6041|-102.8285|Cochran|Cochran|48079',
 'TXZ034' => '33.6076|-102.3432|Hockley|Hockley|48219',
 'TXZ035' => '33.6102|-101.8205|Lubbock|Lubbock|48303',
 'TXZ036' => '33.6146|-101.3|Crosby|Crosby|48107',
 'TXZ037' => '33.6166|-100.7789|Dickens|Dickens|48125',
 'TXZ038' => '33.6165|-100.2558|King|King|48269',
 'TXZ039' => '33.173|-102.8278|Yoakum|Yoakum|48501',
 'TXZ040' => '33.1738|-102.3352|Terry|Terry|48445',
 'TXZ041' => '33.1768|-101.8161|Lynn|Lynn|48305',
 'TXZ042' => '33.1799|-101.2984|Garza|Garza|48169',
 'TXZ043' => '33.1814|-100.7776|Kent|Kent|48263',
 'TXZ044' => '33.1791|-100.2533|Stonewall|Stonewall|48433',
 'TXZ045' => '32.7407|-102.6352|Gaines|Gaines|48165',
 'TXZ046' => '32.7425|-101.9477|Dawson|Dawson|48115',
 'TXZ047' => '32.7437|-101.4317|Borden|Borden|48033',
 'TXZ048' => '32.7463|-100.9164|Scurry|Scurry|48415',
 'TXZ049' => '32.7428|-100.4022|Fisher|Fisher|48151',
 'TXZ050' => '32.305|-102.6378|Andrews|Andrews|48003',
 'TXZ051' => '32.3061|-101.9512|Martin|Martin|48317',
 'TXZ052' => '32.3062|-101.4355|Howard|Howard|48227',
 'TXZ053' => '32.3062|-100.9212|Mitchell|Mitchell|48335',
 'TXZ054' => '32.3035|-100.4061|Nolan|Nolan|48353',
 'TXZ059' => '31.8492|-103.58|Loving|Loving|48301',
 'TXZ060' => '31.85|-103.0482|Winkler|Winkler|48495',
 'TXZ061' => '31.8692|-102.5428|Ector|Ector|48135',
 'TXZ062' => '31.8692|-102.0316|Midland|Midland|48329',
 'TXZ063' => '31.8695|-101.5208|Glasscock|Glasscock|48173',
 'TXZ064' => '31.8279|-101.05|Sterling|Sterling|48431',
 'TXZ065' => '31.8885|-100.5299|Coke|Coke|48081',
 'TXZ066' => '31.8311|-99.9762|Runnels|Runnels|48399',
 'TXZ067' => '31.5095|-103.1024|Ward|Ward|48475',
 'TXZ068' => '31.4285|-102.5155|Crane|Crane|48103',
 'TXZ069' => '31.3688|-102.043|Upton|Upton|48461',
 'TXZ070' => '31.3662|-101.523|Reagan|Reagan|48383',
 'TXZ071' => '31.3039|-100.9824|Irion|Irion|48235',
 'TXZ072' => '31.4044|-100.4621|Tom Green|Tom Green|48451',
 'TXZ073' => '31.3265|-99.864|Concho|Concho|48095',
 'TXZ075' => '30.7811|-102.7236|Pecos|Pecos|48371',
 'TXZ076' => '30.723|-101.4121|Crockett|Crockett|48105',
 'TXZ077' => '30.8975|-100.5385|Schleicher|Schleicher|48413',
 'TXZ078' => '30.4983|-100.5382|Sutton|Sutton|48435',
 'TXZ082' => '30.225|-102.0765|Terrell|Terrell|48443',
 'TXZ083' => '34.2903|-99.7457|Hardeman|Hardeman|48197',
 'TXZ084' => '33.9746|-99.778|Foard|Foard|48155',
 'TXZ085' => '34.0807|-99.241|Wilbarger|Wilbarger|48487',
 'TXZ086' => '33.988|-98.7032|Wichita|Wichita|48485',
 'TXZ087' => '33.6061|-99.7414|Knox|Knox|48275',
 'TXZ088' => '33.6165|-99.2135|Baylor|Baylor|48023',
 'TXZ089' => '33.6153|-98.6877|Archer|Archer|48009',
 'TXZ090' => '33.7854|-98.2084|Clay|Clay|48077',
 'TXZ091' => '33.6757|-97.7246|Montague|Montague|48337',
 'TXZ092' => '33.6393|-97.2126|Cooke|Cooke|48097',
 'TXZ093' => '33.6268|-96.6776|Grayson|Grayson|48181',
 'TXZ094' => '33.5939|-96.1066|Fannin|Fannin|48147',
 'TXZ095' => '33.6671|-95.5711|Lamar|Lamar|48277',
 'TXZ096' => '33.6207|-95.0504|Red River|Red River|48387',
 'TXZ097' => '33.4454|-94.4229|Bowie|Bowie|48037',
 'TXZ098' => '33.1782|-99.7303|Haskell|Haskell|48207',
 'TXZ099' => '33.1775|-99.2124|Throckmorton|Throckmorton|48447',
 'TXZ100' => '33.1767|-98.6878|Young|Young|48503',
 'TXZ101' => '33.2335|-98.1725|Jack|Jack|48237',
 'TXZ102' => '33.2159|-97.6544|Wise|Wise|48497',
 'TXZ103' => '33.2043|-97.1171|Denton|Denton|48121',
 'TXZ104' => '33.1878|-96.5724|Collin|Collin|48085',
 'TXZ105' => '33.1236|-96.0854|Hunt|Hunt|48231',
 'TXZ106' => '33.3863|-95.6723|Delta|Delta|48119',
 'TXZ107' => '33.1495|-95.564|Hopkins|Hopkins|48223',
 'TXZ108' => '33.1756|-95.2184|Franklin|Franklin|48159',
 'TXZ109' => '33.2166|-94.9657|Titus|Titus|48449',
 'TXZ110' => '32.9732|-94.9785|Camp|Camp|48063',
 'TXZ111' => '33.1135|-94.7326|Morris|Morris|48343',
 'TXZ112' => '33.0775|-94.3436|Cass|Cass|48067',
 'TXZ113' => '32.7399|-99.8787|Jones|Jones|48253',
 'TXZ114' => '32.736|-99.3541|Shackelford|Shackelford|48417',
 'TXZ115' => '32.7359|-98.8362|Stephens|Stephens|48429',
 'TXZ116' => '32.7532|-98.313|Palo Pinto|Palo Pinto|48363',
 'TXZ117' => '32.7776|-97.8051|Parker|Parker|48367',
 'TXZ118' => '32.7704|-97.2919|Tarrant|Tarrant|48439',
 'TXZ119' => '32.7666|-96.7779|Dallas|Dallas|48113',
 'TXZ120' => '32.8978|-96.4077|Rockwall|Rockwall|48397',
 'TXZ121' => '32.5996|-96.2879|Kaufman|Kaufman|48257',
 'TXZ122' => '32.5637|-95.8365|Van Zandt|Van Zandt|48467',
 'TXZ123' => '32.8703|-95.7934|Rains|Rains|48379',
 'TXZ124' => '32.7864|-95.3821|Wood|Wood|48499',
 'TXZ125' => '32.7363|-94.9414|Upshur|Upshur|48459',
 'TXZ126' => '32.798|-94.3572|Marion|Marion|48315',
 'TXZ127' => '32.3015|-99.8901|Taylor|Taylor|48441',
 'TXZ128' => '32.2977|-99.3735|Callahan|Callahan|48059',
 'TXZ129' => '32.3271|-98.8323|Eastland|Eastland|48133',
 'TXZ130' => '32.2363|-98.218|Erath|Erath|48143',
 'TXZ131' => '32.4299|-97.8323|Hood|Hood|48221',
 'TXZ132' => '32.2223|-97.7744|Somervell|Somervell|48425',
 'TXZ133' => '32.379|-97.3663|Johnson|Johnson|48251',
 'TXZ134' => '32.3484|-96.7945|Ellis|Ellis|48139',
 'TXZ135' => '32.2121|-95.8538|Henderson|Henderson|48213',
 'TXZ136' => '32.375|-95.2692|Smith|Smith|48423',
 'TXZ137' => '32.4803|-94.8172|Gregg|Gregg|48183',
 'TXZ138' => '32.5483|-94.3713|Harrison|Harrison|48203',
 'TXZ139' => '31.7732|-99.4536|Coleman|Coleman|48083',
 'TXZ140' => '31.7743|-98.9998|Brown|Brown|48049',
 'TXZ141' => '31.948|-98.5582|Comanche|Comanche|48093',
 'TXZ142' => '31.4952|-98.5955|Mills|Mills|48333',
 'TXZ143' => '31.7048|-98.1107|Hamilton|Hamilton|48193',
 'TXZ144' => '31.9004|-97.6343|Bosque|Bosque|48035',
 'TXZ145' => '31.9907|-97.1324|Hill|Hill|48217',
 'TXZ146' => '32.047|-96.4724|Navarro|Navarro|48349',
 'TXZ147' => '31.7049|-96.149|Freestone|Freestone|48161',
 'TXZ148' => '31.8134|-95.6525|Anderson|Anderson|48001',
 'TXZ149' => '31.837|-95.1652|Cherokee|Cherokee|48073',
 'TXZ150' => '32.1077|-94.7618|Rusk|Rusk|48401',
 'TXZ151' => '32.1624|-94.3056|Panola|Panola|48365',
 'TXZ152' => '31.616|-94.6158|Nacogdoches|Nacogdoches|48347',
 'TXZ153' => '31.7924|-94.145|Shelby|Shelby|48419',
 'TXZ154' => '31.1989|-99.3475|McCulloch|McCulloch|48307',
 'TXZ155' => '31.1552|-98.8176|San Saba|San Saba|48411',
 'TXZ156' => '31.1962|-98.2414|Lampasas|Lampasas|48281',
 'TXZ157' => '31.3909|-97.7992|Coryell|Coryell|48099',
 'TXZ158' => '31.0377|-97.4782|Bell|Bell|48027',
 'TXZ159' => '31.5524|-97.2018|McLennan|McLennan|48309',
 'TXZ160' => '31.2533|-96.9358|Falls|Falls|48145',
 'TXZ161' => '31.5455|-96.5805|Limestone|Limestone|48293',
 'TXZ162' => '31.2965|-95.9957|Leon|Leon|48289',
 'TXZ163' => '31.3178|-95.4227|Houston|Houston|48225',
 'TXZ164' => '31.0888|-95.1355|Trinity|Trinity|48455',
 'TXZ165' => '31.2548|-94.6118|Angelina|Angelina|48005',
 'TXZ166' => '31.3942|-94.1682|San Augustine|San Augustine|48405',
 'TXZ167' => '31.3432|-93.8518|Sabine|Sabine|48403',
 'TXZ168' => '30.8898|-99.8206|Menard|Menard|48327',
 'TXZ169' => '30.4868|-99.7487|Kimble|Kimble|48267',
 'TXZ170' => '30.7177|-99.2261|Mason|Mason|48319',
 'TXZ171' => '30.7056|-98.684|Llano|Llano|48299',
 'TXZ172' => '30.7883|-98.1824|Burnet|Burnet|48053',
 'TXZ173' => '30.6481|-97.6008|Williamson|Williamson|48491',
 'TXZ174' => '30.7863|-96.9769|Milam|Milam|48331',
 'TXZ175' => '31.027|-96.5128|Robertson|Robertson|48395',
 'TXZ176' => '30.9656|-95.9284|Madison|Madison|48313',
 'TXZ177' => '30.739|-95.5722|Walker|Walker|48471',
 'TXZ178' => '30.5796|-95.1669|San Jancinto|San Jacinto|48407',
 'TXZ179' => '30.7928|-94.83|Polk|Polk|48373',
 'TXZ180' => '30.7712|-94.3765|Tyler|Tyler|48457',
 'TXZ183' => '29.893|-101.1517|Val Verde|Val Verde|48465',
 'TXZ184' => '29.9826|-100.3047|Edwards|Edwards|48137',
 'TXZ185' => '29.8318|-99.8221|Real|Real|48385',
 'TXZ186' => '30.0615|-99.3501|Kerr|Kerr|48265',
 'TXZ187' => '29.7472|-99.2463|Bandera|Bandera|48019',
 'TXZ188' => '30.3181|-98.9464|Gillespie|Gillespie|48171',
 'TXZ189' => '29.9447|-98.7116|Kendall|Kendall|48259',
 'TXZ190' => '30.2664|-98.3998|Blanco|Blanco|48031',
 'TXZ191' => '30.0582|-98.0311|Hays|Hays|48209',
 'TXZ192' => '30.3347|-97.7819|Travis|Travis|48453',
 'TXZ193' => '30.1036|-97.3121|Bastrop|Bastrop|48021',
 'TXZ194' => '30.3107|-96.9657|Lee|Lee|48287',
 'TXZ195' => '30.4924|-96.621|Burleson|Burleson|48051',
 'TXZ196' => '30.6611|-96.3023|Brazos|Brazos|48041',
 'TXZ197' => '30.2145|-96.4036|Washington|Washington|48477',
 'TXZ198' => '30.5436|-95.9855|Grimes|Grimes|48185',
 'TXZ199' => '30.3002|-95.503|Montgomery|Montgomery|48339',
 'TXZ200' => '30.2284|-94.8693|Northern Liberty|Liberty|48291',
 'TXZ201' => '30.3324|-94.3903|Hardin|Hardin|48199',
 'TXZ202' => '29.3502|-100.418|Kinney|Kinney|48271',
 'TXZ203' => '29.3573|-99.7622|Uvalde|Uvalde|48463',
 'TXZ204' => '29.3557|-99.1101|Medina|Medina|48325',
 'TXZ205' => '29.4491|-98.5199|Bexar|Bexar|48029',
 'TXZ206' => '29.8082|-98.2782|Comal|Comal|48091',
 'TXZ207' => '29.5831|-97.9484|Guadalupe|Guadalupe|48187',
 'TXZ208' => '29.8372|-97.62|Caldwell|Caldwell|48055',
 'TXZ209' => '29.8768|-96.9198|Fayette|Fayette|48149',
 'TXZ210' => '29.6208|-96.5263|Colorado|Colorado|48089',
 'TXZ211' => '29.887|-96.278|Austin|Austin|48015',
 'TXZ212' => '30.0111|-95.9877|Waller|Waller|48473',
 'TXZ213' => '29.8829|-95.459|Inland Harris|Harris|48201',
 'TXZ214' => '29.7388|-94.608|Chambers|Chambers|48071',
 'TXZ217' => '28.7426|-100.3145|Maverick|Maverick|48323',
 'TXZ218' => '28.8662|-99.7606|Zavala|Zavala|48507',
 'TXZ219' => '28.8678|-99.1083|Frio|Frio|48163',
 'TXZ220' => '28.8907|-98.5279|Atascosa|Atascosa|48013',
 'TXZ221' => '29.1741|-98.0866|Wilson|Wilson|48493',
 'TXZ222' => '28.9057|-97.8594|Karnes|Karnes|48255',
 'TXZ223' => '29.4567|-97.4925|Gonzales|Gonzales|48177',
 'TXZ224' => '29.0821|-97.3568|De Witt|DeWitt|48123',
 'TXZ225' => '29.3843|-96.9302|Lavaca|Lavaca|48285',
 'TXZ226' => '29.2779|-96.2221|Wharton|Wharton|48481',
 'TXZ227' => '29.5274|-95.7707|Fort Bend|Fort Bend|48157',
 'TXZ228' => '28.4225|-99.7567|Dimmit|Dimmit|48127',
 'TXZ229' => '28.3451|-99.0997|La Salle|La Salle|48283',
 'TXZ230' => '28.3491|-98.5675|McMullen|McMullen|48311',
 'TXZ231' => '28.3514|-98.1248|Live Oak|Live Oak|48297',
 'TXZ232' => '28.4174|-97.7412|Bee|Bee|48025',
 'TXZ233' => '28.6571|-97.4264|Goliad|Goliad|48175',
 'TXZ234' => '28.7964|-96.9714|Victoria|Victoria|48469',
 'TXZ235' => '29.0039|-96.6044|Inland Jackson|Jackson|48239',
 'TXZ236' => '28.9561|-96.0201|Inland Matagorda|Matagorda|48321',
 'TXZ237' => '29.269|-95.5128|Inland Brazoria|Brazoria|48039',
 'TXZ238' => '29.4207|-95.132|Inland Galveston|Galveston|48167',
 'TXZ239' => '27.7611|-99.3316|Webb|Webb|48479',
 'TXZ240' => '27.6813|-98.5089|Duval|Duval|48131',
 'TXZ241' => '27.731|-98.0902|Jim Wells|Jim Wells|48249',
 'TXZ242' => '27.4319|-97.8503|Inland Kleberg|Kleberg|48273',
 'TXZ243' => '27.7423|-97.7226|Inland Nueces|Nueces|48355',
 'TXZ244' => '28.0275|-97.5879|Inland San Patricio|San Patricio|48409',
 'TXZ245' => '28.1558|-97.0065|Aransas|Aransas|48007',
 'TXZ246' => '28.3407|-97.208|Inland Refugio|Refugio|48391',
 'TXZ247' => '28.5677|-96.7923|Inland Calhoun|Calhoun|48057',
 'TXZ248' => '27.0008|-99.1686|Zapata|Zapata|48505',
 'TXZ249' => '27.0434|-98.6973|Jim Hogg|Jim Hogg|48247',
 'TXZ250' => '27.0316|-98.2187|Brooks|Brooks|48047',
 'TXZ251' => '26.9205|-97.7793|Inland Kenedy|Kenedy|48261',
 'TXZ252' => '26.5621|-98.7384|Starr|Starr|48427',
 'TXZ253' => '26.2769|-98.1789|Southern Hidalgo|Hidalgo|48215',
 'TXZ254' => '26.4665|-97.7187|Inland Willacy|Willacy|48489',
 'TXZ255' => '26.1202|-97.5793|Inland Cameron|Cameron|48061',
 'TXZ259' => '30.8641|-94.0341|Northern Jasper|Jasper|48241',
 'TXZ260' => '30.8876|-93.7287|Northern Newton|Newton|48351',
 'TXZ261' => '30.3824|-93.9977|Southern Jasper|Jasper|48241',
 'TXZ262' => '30.383|-93.8089|Southern Newton|Newton|48351',
 'TXZ270' => '31.9461|-104.8425|Guadalupe Mountains Above 7000 Feet |Culberson|48109',
 'TXZ271' => '31.7378|-104.7322|Guadalupe and Delaware Mountains |Culberson|48109',
 'TXZ272' => '31.2123|-104.7304|Van Horn and Highway 54 Corridor |Culberson|48109',
 'TXZ273' => '31.6552|-104.3586|Eastern Culberson County |Culberson|48109',
 'TXZ274' => '31.3331|-103.68|Reeves County Plains |Reeves|48389',
 'TXZ275' => '30.0939|-104.3962|Chinati Mountains |Presidio|48377',
 'TXZ276' => '30.179|-104.2468|Marfa Plateau |Jeff Davis|48243	30.179|-104.2468|Marfa Plateau |Presidio|48377',
 'TXZ277' => '30.5275|-103.985|Davis Mountains |Brewster|48043	30.5275|-103.985|Davis Mountains |Jeff Davis|48243	30.5275|-103.985|Davis Mountains |Presidio|48377',
 'TXZ278' => '30.7538|-103.787|Davis Mountains Foothills |Brewster|48043	30.7538|-103.787|Davis Mountains Foothills |Culberson|48109	30.7538|-103.787|Davis Mountains Foothills |Jeff Davis|48243	30.7538|-103.787|Davis Mountains Foothills |Reeves|48389',
 'TXZ279' => '29.8383|-103.3132|Central Brewster County |Brewster|48043',
 'TXZ280' => '29.2508|-103.2892|Chisos Basin |Brewster|48043',
 'TXZ281' => '29.8815|-104.3805|Presidio Valley |Culberson|48109	29.8815|-104.3805|Presidio Valley |Jeff Davis|48243	29.8815|-104.3805|Presidio Valley |Presidio|48377',
 'TXZ282' => '29.5252|-103.0214|Lower Brewster County |Brewster|48043',
 'TXZ300' => '29.9703|-94.6771|Southern Liberty|Liberty|48291',
 'TXZ313' => '29.7281|-95.0568|Coastal Harris|Harris|48201',
 'TXZ317' => '34.9436|-101.6778|Palo Duro Canyon|Randall|48381',
 'TXZ335' => '28.7655|-96.4773|Coastal Jackson|Jackson|48239',
 'TXZ336' => '28.7695|-95.9366|Coastal Matagorda|Matagorda|48321',
 'TXZ337' => '29.0676|-95.3623|Coastal Brazoria|Brazoria|48039',
 'TXZ338' => '29.3887|-95.0028|Coastal Galveston|Galveston|48167',
 'TXZ342' => '27.4408|-97.4768|Coastal Kleberg|Kleberg|48273',
 'TXZ343' => '27.6637|-97.4107|Coastal Nueces|Nueces|48355',
 'TXZ344' => '27.9431|-97.2647|Coastal San Patricio|San Patricio|48409',
 'TXZ345' => '28.0051|-96.9391|Aransas County Islands|Aransas|48007',
 'TXZ346' => '28.2777|-97.0145|Coastal Refugio|Refugio|48391',
 'TXZ347' => '28.5117|-96.5835|Coastal Calhoun|Calhoun|48057',
 'TXZ351' => '26.9556|-97.4956|Coastal Kenedy|Kenedy|48261',
 'TXZ353' => '26.6133|-98.1849|Northern Hidalgo |Hidalgo|48215',
 'TXZ354' => '26.4868|-97.4673|Coastal Willacy|Willacy|48489',
 'TXZ355' => '26.17|-97.3264|Coastal Cameron|Cameron|48061',
 'TXZ418' => '31.8933|-106.5545|Western El Paso County|El Paso|48141',
 'TXZ419' => '31.8096|-106.2948|Eastern/Central El Paso County|El Paso|48141',
 'TXZ420' => '31.7056|-105.7878|Northern Hudspeth Highlands/Hueco Mountains|El Paso|48141	31.7056|-105.7878|Northern Hudspeth Highlands/Hueco Mountains|Hudspeth|48229',
 'TXZ421' => '31.7396|-105.2179|Salt Basin|Hudspeth|48229',
 'TXZ422' => '31.1872|-105.1931|Southern Hudspeth Highlands|Hudspeth|48229',
 'TXZ423' => '31.3635|-105.8909|Rio Grande Valley of Eastern El Paso/Western Hudspeth Counties|El Paso|48141	31.3635|-105.8909|Rio Grande Valley of Eastern El Paso/Western Hudspeth Counties|Hudspeth|48229',
 'TXZ424' => '30.8825|-105.2707|Rio Grande Valley of Eastern Hudspeth County|Hudspeth|48229',
 'TXZ436' => '28.6248|-95.9674|Matagorda Islands|Matagorda|48321',
 'TXZ437' => '28.9671|-95.3005|Brazoria Islands|Brazoria|48039',
 'TXZ438' => '29.2456|-94.8973|Galveston Island|Galveston|48167',
 'TXZ439' => '29.4886|-94.5711|Bolivar Peninsula|Galveston|48167',
 'TXZ442' => '27.4267|-97.3101|Kleberg County Island|Kleberg|48273',
 'TXZ443' => '27.7078|-97.1651|Nueces County Islands|Nueces|48355',
 'TXZ447' => '28.2324|-96.6387|Calhoun County Island|Calhoun|48057',
 'TXZ451' => '26.9012|-97.3609|Kenedy Island|Kenedy|48261',
 'TXZ454' => '26.5229|-97.2769|Willacy Island|Willacy|48489',
 'TXZ455' => '26.1485|-97.1763|Cameron Island|Cameron|48061',
 'TXZ515' => '30.037|-94.2917|Upper Jefferson|Jefferson|48245',
 'TXZ516' => '30.1826|-93.907|Northern Orange|Orange|48361',
 'TXZ615' => '29.8231|-94.1248|Lower Jefferson|Jefferson|48245',
 'TXZ616' => '30.0641|-93.8842|Southern Orange|Orange|48361',
 'UTC001' => '38.3577|-113.2358|Beaver||',
 'UTC003' => '41.5210|-113.0821|Box Elder||',
 'UTC005' => '41.7224|-111.7435|Cache||',
 'UTC007' => '39.6482|-110.5889|Carbon||',
 'UTC009' => '40.8865|-109.5059|Daggett||',
 'UTC011' => '40.9907|-112.1114|Davis||',
 'UTC013' => '40.2975|-110.4247|Duchesne||',
 'UTC015' => '38.9968|-110.7007|Emery||',
 'UTC017' => '37.8548|-111.4447|Garfield||',
 'UTC019' => '38.9818|-109.5697|Grand||',
 'UTC021' => '37.8592|-113.2893|Iron||',
 'UTC023' => '39.7026|-112.7848|Juab||',
 'UTC025' => '37.2851|-111.8878|Kane||',
 'UTC027' => '39.0738|-113.1004|Millard||',
 'UTC029' => '41.0893|-111.5731|Morgan||',
 'UTC031' => '38.3365|-112.1269|Piute||',
 'UTC033' => '41.6323|-111.2444|Rich||',
 'UTC035' => '40.6676|-111.9239|Salt Lake||',
 'UTC037' => '37.6263|-109.8048|San Juan||',
 'UTC039' => '39.3740|-111.5764|Sanpete||',
 'UTC041' => '38.7476|-111.8046|Sevier||',
 'UTC043' => '40.8682|-110.9554|Summit||',
 'UTC045' => '40.4488|-113.1311|Tooele||',
 'UTC047' => '40.1247|-109.5186|Uintah||',
 'UTC049' => '40.1196|-111.6706|Utah||',
 'UTC051' => '40.3304|-111.1694|Wasatch||',
 'UTC053' => '37.2804|-113.5049|Washington||',
 'UTC055' => '38.3244|-110.9036|Wayne||',
 'UTC057' => '41.2699|-111.9133|Weber||',
 'UTZ022' => '37.2729|-109.6517|Southeast Utah|San Juan|49037',
 'UTZ023' => '40.7677|-109.5041|Eastern Unita Mountains|Daggett|49009	40.7677|-109.5041|Eastern Unita Mountains|Uintah|49047',
 'UTZ024' => '40.2152|-109.538|Eastern Uinta Basin|Uintah|49047',
 'UTZ025' => '39.4851|-109.5696|Tavaputs Plateau|Grand|49019	39.4851|-109.5696|Tavaputs Plateau|Uintah|49047',
 'UTZ027' => '38.8582|-109.5593|Arches/Grand Flat|Grand|49019',
 'UTZ028' => '38.047|-109.3836|La Sal and Abajo Mountains|Grand|49019	38.047|-109.3836|La Sal and Abajo Mountains|San Juan|49037',
 'UTZ029' => '37.8442|-110.0067|Canyonlands/Natural Bridges|San Juan|49037',
 'UTZ101' => '40.9292|-113.2347|Great Salt Lake Desert and Mountains|Box Elder|49003	40.9292|-113.2347|Great Salt Lake Desert and Mountains|Salt Lake|49035	40.9292|-113.2347|Great Salt Lake Desert and Mountains|Tooele|49045	40.9292|-113.2347|Great Salt Lake Desert and Mountains|Utah|49049',
 'UTZ102' => '40.3692|-112.3841|Tooele and Rush Valleys|Tooele|49045',
 'UTZ103' => '41.71|-112.322|Eastern Box Elder County|Box Elder|49003',
 'UTZ104' => '41.0742|-112.1496|Northern Wasatch Front|Davis|49011	41.0742|-112.1496|Northern Wasatch Front|Weber|49057',
 'UTZ105' => '40.6778|-111.9881|Salt Lake Valley|Salt Lake|49035',
 'UTZ106' => '40.1571|-111.9|Utah Valley|Utah|49049',
 'UTZ107' => '41.809|-111.9092|Cache Valley/Utah Portion|Cache|49005',
 'UTZ108' => '40.8141|-111.5267|Wasatch Back|Morgan|49029	40.8141|-111.5267|Wasatch Back|Summit|49043	40.8141|-111.5267|Wasatch Back|Wasatch|49051	40.8141|-111.5267|Wasatch Back|Weber|49057',
 'UTZ109' => '41.6797|-111.1912|Bear Lake and Bear River Valley|Rich|49033',
 'UTZ110' => '41.4128|-111.546|Wasatch Mountains I-80 North|Box Elder|49003	41.4128|-111.546|Wasatch Mountains I-80 North|Cache|49005	41.4128|-111.546|Wasatch Mountains I-80 North|Davis|49011	41.4128|-111.546|Wasatch Mountains I-80 North|Morgan|49029	41.4128|-111.546|Wasatch Mountains I-80 North|Rich|49033	41.4128|-111.546|Wasatch Mountains I-80 North|Salt Lake|49035	41.4128|-111.546|Wasatch Mountains I-80 North|Summit|49043	41.4128|-111.546|Wasatch Mountains I-80 North|Weber|49057',
 'UTZ111' => '40.2682|-111.62|Wasatch Mountains South of I-80|Juab|49023	40.2682|-111.62|Wasatch Mountains South of I-80|Salt Lake|49035	40.2682|-111.62|Wasatch Mountains South of I-80|Summit|49043	40.2682|-111.62|Wasatch Mountains South of I-80|Utah|49049	40.2682|-111.62|Wasatch Mountains South of I-80|Wasatch|49051',
 'UTZ112' => '40.6923|-110.7334|Western Uinta Mountains|Duchesne|49013	40.6923|-110.7334|Western Uinta Mountains|Summit|49043	40.6923|-110.7334|Western Uinta Mountains|Wasatch|49051',
 'UTZ113' => '39.8071|-110.767|Wasatch Plateau/Book Cliffs|Carbon|49007	39.8071|-110.767|Wasatch Plateau/Book Cliffs|Duchesne|49013	39.8071|-110.767|Wasatch Plateau/Book Cliffs|Emery|49015	39.8071|-110.767|Wasatch Plateau/Book Cliffs|Sanpete|49039	39.8071|-110.767|Wasatch Plateau/Book Cliffs|Utah|49049	39.8071|-110.767|Wasatch Plateau/Book Cliffs|Wasatch|49051',
 'UTZ114' => '40.246|-110.3145|Western Uinta Basin|Duchesne|49013',
 'UTZ115' => '39.307|-113.1813|Western Millard and Juab Counties|Juab|49023	39.307|-113.1813|Western Millard and Juab Counties|Millard|49027',
 'UTZ116' => '39.2286|-112.2213|Eastern Juab/Millard Counties|Juab|49023	39.2286|-112.2213|Eastern Juab/Millard Counties|Millard|49027',
 'UTZ117' => '39.0084|-111.7827|Central Mountains|Emery|49015	39.0084|-111.7827|Central Mountains|Juab|49023	39.0084|-111.7827|Central Mountains|Millard|49027	39.0084|-111.7827|Central Mountains|Sanpete|49039	39.0084|-111.7827|Central Mountains|Sevier|49041',
 'UTZ118' => '39.3723|-111.6668|Sanpete Valley|Sanpete|49039',
 'UTZ119' => '38.7785|-112.039|Sevier Valley|Sevier|49041',
 'UTZ120' => '39.3174|-110.8905|Castle Country|Carbon|49007	39.3174|-110.8905|Castle Country|Emery|49015	39.3174|-110.8905|Castle Country|Sevier|49041',
 'UTZ121' => '38.8704|-110.632|San Rafael Swell|Emery|49015	38.8704|-110.632|San Rafael Swell|Sevier|49041',
 'UTZ122' => '38.1051|-113.4513|Southwest Utah|Beaver|49001	38.1051|-113.4513|Southwest Utah|Iron|49021	38.1051|-113.4513|Southwest Utah|Washington|49053',
 'UTZ123' => '37.1632|-113.6488|Lower Washington County|Washington|49053',
 'UTZ124' => '37.2808|-113.0793|Zion National Park|Iron|49021	37.2808|-113.0793|Zion National Park|Kane|49025	37.2808|-113.0793|Zion National Park|Washington|49053',
 'UTZ125' => '37.8671|-112.4662|Southern Mountains|Beaver|49001	37.8671|-112.4662|Southern Mountains|Garfield|49017	37.8671|-112.4662|Southern Mountains|Iron|49021	37.8671|-112.4662|Southern Mountains|Kane|49025	37.8671|-112.4662|Southern Mountains|Piute|49031	37.8671|-112.4662|Southern Mountains|Washington|49053	37.8671|-112.4662|Southern Mountains|Wayne|49055',
 'UTZ126' => '38.1842|-112.1917|Upper Sevier River Valleys|Garfield|49017	38.1842|-112.1917|Upper Sevier River Valleys|Piute|49031	38.1842|-112.1917|Upper Sevier River Valleys|Sevier|49041',
 'UTZ127' => '37.738|-112.1542|Bryce Canyon Country|Garfield|49017	37.738|-112.1542|Bryce Canyon Country|Kane|49025',
 'UTZ128' => '37.3759|-111.8128|South Central Utah|Garfield|49017	37.3759|-111.8128|South Central Utah|Kane|49025	37.3759|-111.8128|South Central Utah|Washington|49053',
 'UTZ129' => '38.2218|-111.2634|Capitol Reef National Park and Vicinity|Emery|49015	38.2218|-111.2634|Capitol Reef National Park and Vicinity|Garfield|49017	38.2218|-111.2634|Capitol Reef National Park and Vicinity|Sevier|49041	38.2218|-111.2634|Capitol Reef National Park and Vicinity|Wayne|49055',
 'UTZ130' => '38.1697|-110.5783|Western Canyonlands|Garfield|49017	38.1697|-110.5783|Western Canyonlands|Wayne|49055',
 'UTZ131' => '37.3615|-110.7898|Glen Canyon Recreation Area/Lake Powell|Garfield|49017	37.3615|-110.7898|Glen Canyon Recreation Area/Lake Powell|Kane|49025	37.3615|-110.7898|Glen Canyon Recreation Area/Lake Powell|San Juan|49037',
 'VAC001' => '37.7660|-75.6472|Accomack||',
 'VAC003' => '38.0229|-78.5565|Albemarle||',
 'VAC005' => '37.7876|-80.0070|Alleghany||',
 'VAC007' => '37.3360|-77.9760|Amelia||',
 'VAC009' => '37.6048|-79.1451|Amherst||',
 'VAC011' => '37.3722|-78.8121|Appomattox||',
 'VAC013' => '38.8788|-77.1008|Arlington||',
 'VAC015' => '38.1646|-79.1338|Augusta||',
 'VAC017' => '38.0587|-79.7411|Bath||',
 'VAC019' => '37.3152|-79.5242|Bedford||',
 'VAC021' => '37.1340|-81.1302|Bland||',
 'VAC023' => '37.5571|-79.8123|Botetourt||',
 'VAC025' => '36.7648|-77.8590|Brunswick||',
 'VAC027' => '37.2666|-82.0360|Buchanan||',
 'VAC029' => '37.5722|-78.5287|Buckingham||',
 'VAC031' => '37.2056|-79.0963|Campbell||',
 'VAC033' => '38.0272|-77.3475|Caroline||',
 'VAC035' => '36.7316|-80.7339|Carroll||',
 'VAC036' => '37.3565|-77.0613|Charles City||	37.2385|-76.9028|Charles City||',
 'VAC037' => '37.0116|-78.6616|Charlotte||',
 'VAC041' => '37.3785|-77.5868|Chesterfield||',
 'VAC043' => '39.1122|-77.9966|Clarke||',
 'VAC045' => '37.4813|-80.2123|Craig||',
 'VAC047' => '38.4861|-77.9559|Culpeper||',
 'VAC049' => '37.5120|-78.2450|Cumberland||',
 'VAC051' => '37.1258|-82.3503|Dickenson||',
 'VAC053' => '37.0759|-77.6323|Dinwiddie||',
 'VAC057' => '37.9426|-76.9518|Essex||	37.8958|-76.8079|Essex||',
 'VAC059' => '38.8385|-77.2788|Fairfax||	38.6971|-77.1788|Fairfax||',
 'VAC061' => '38.7386|-77.8094|Fauquier||',
 'VAC063' => '36.9315|-80.3626|Floyd||',
 'VAC065' => '37.8418|-78.2774|Fluvanna||',
 'VAC067' => '36.9919|-79.8810|Franklin||',
 'VAC069' => '39.2046|-78.2626|Frederick||',
 'VAC071' => '37.3141|-80.7037|Giles||',
 'VAC073' => '37.3643|-76.4883|Gloucester||	37.4257|-76.5431|Gloucester||',
 'VAC075' => '37.7220|-77.9164|Goochland||',
 'VAC077' => '36.6566|-81.2250|Grayson||',
 'VAC079' => '38.2977|-78.4669|Greene||',
 'VAC081' => '36.6759|-77.5596|Greensville||',
 'VAC083' => '36.7670|-78.9367|Halifax||',
 'VAC085' => '37.7601|-77.4909|Hanover||',
 'VAC087' => '37.5380|-77.4058|Henrico||',
 'VAC089' => '36.6828|-79.8739|Henry||',
 'VAC091' => '38.3623|-79.5685|Highland||',
 'VAC093' => '36.8908|-76.7269|Isle of Wight||',
 'VAC095' => '37.3296|-76.7782|James City||	37.2297|-76.8324|James City||',
 'VAC097' => '37.7182|-76.8949|King and Queen||',
 'VAC099' => '38.2729|-77.1572|King George||	38.3151|-77.0516|King George||',
 'VAC101' => '37.7067|-77.0884|King William||',
 'VAC103' => '37.7367|-76.4640|Lancaster||	37.7189|-76.5300|Lancaster||',
 'VAC105' => '36.7055|-83.1285|Lee||',
 'VAC107' => '39.0907|-77.6357|Loudoun||',
 'VAC109' => '37.9782|-77.9630|Louisa||',
 'VAC111' => '36.9462|-78.2405|Lunenburg||',
 'VAC113' => '38.4137|-78.2792|Madison||',
 'VAC115' => '37.4368|-76.3444|Mathews||	37.4632|-76.3392|Mathews||',
 'VAC117' => '36.6804|-78.3627|Mecklenburg||',
 'VAC119' => '37.6353|-76.5769|Middlesex||	37.6424|-76.5151|Middlesex||',
 'VAC121' => '37.1740|-80.3869|Montgomery||',
 'VAC125' => '37.7874|-78.8867|Nelson||',
 'VAC127' => '37.5052|-76.9972|New Kent||',
 'VAC131' => '37.3566|-75.8995|Northampton||',
 'VAC133' => '37.8875|-76.4233|Northumberland||	37.9686|-76.4378|Northumberland||',
 'VAC135' => '37.1431|-78.0513|Nottoway||',
 'VAC137' => '38.2463|-78.0134|Orange||',
 'VAC139' => '38.6200|-78.4841|Page||',
 'VAC141' => '36.6784|-80.2843|Patrick||',
 'VAC143' => '36.8213|-79.3971|Pittsylvania||',
 'VAC145' => '37.5502|-77.9151|Powhatan||',
 'VAC147' => '37.2243|-78.4411|Prince Edward||',
 'VAC149' => '37.1866|-77.2241|Prince George||',
 'VAC153' => '38.7037|-77.4821|Prince William||	38.5711|-77.2826|Prince William||',
 'VAC155' => '37.0636|-80.7143|Pulaski||',
 'VAC157' => '38.6845|-78.1593|Rappahannock||',
 'VAC159' => '37.9429|-76.7249|Richmond||	37.8881|-76.7671|Richmond||',
 'VAC161' => '37.2693|-80.0679|Roanoke||',
 'VAC163' => '37.8146|-79.4475|Rockbridge||',
 'VAC165' => '38.5122|-78.8758|Rockingham||',
 'VAC167' => '36.9338|-82.0956|Russell||',
 'VAC169' => '36.7142|-82.6030|Scott||',
 'VAC171' => '38.8585|-78.5704|Shenandoah||',
 'VAC173' => '36.8439|-81.5370|Smyth||',
 'VAC175' => '36.7201|-77.1066|Southampton||',
 'VAC177' => '38.1854|-77.6567|Spotsylvania||',
 'VAC179' => '38.4213|-77.4603|Stafford||	38.3825|-77.3287|Stafford||',
 'VAC181' => '37.1089|-76.9009|Surry||	37.2113|-76.8566|Surry||',
 'VAC183' => '36.9218|-77.2618|Sussex||',
 'VAC185' => '37.1250|-81.5606|Tazewell||',
 'VAC187' => '38.9087|-78.2072|Warren||',
 'VAC191' => '36.7245|-81.9596|Washington||',
 'VAC193' => '38.1366|-76.7252|Westmoreland||	38.1108|-76.8052|Westmoreland||',
 'VAC195' => '36.9752|-82.6212|Wise||',
 'VAC197' => '36.9171|-81.0786|Wythe||',
 'VAC199' => '37.2045|-76.4684|York||	37.2371|-76.5637|York||',
 'VAC510' => '38.8185|-77.0861|City of Alexandria||',
 'VAC520' => '36.6181|-82.1606|City of Bristol||',
 'VAC530' => '37.7317|-79.3567|City of Buena Vista||',
 'VAC540' => '38.0373|-78.4858|City of Charlottesville||',
 'VAC550' => '36.6778|-76.3024|City of Chesapeake||',
 'VAC570' => '37.2647|-77.3968|City of Colonial Heights||',
 'VAC580' => '37.7786|-79.9867|City of Covington||',
 'VAC590' => '36.5831|-79.4087|City of Danville||',
 'VAC595' => '36.6952|-77.5356|City of Emporia||',
 'VAC600' => '38.8533|-77.3003|City of Fairfax||',
 'VAC610' => '38.8843|-77.1743|City of Falls Church||',
 'VAC620' => '36.6827|-76.9384|City of Franklin||',
 'VAC630' => '38.2992|-77.4870|City of Fredericksburg||',
 'VAC640' => '36.6663|-80.9173|City of Galax||',
 'VAC650' => '37.0958|-76.3307|City of Hampton||	37.0533|-76.3674|City of Hampton||',
 'VAC660' => '38.4362|-78.8735|City of Harrisonburg||',
 'VAC670' => '37.2914|-77.2986|City of Hopewell||',
 'VAC678' => '37.7823|-79.4445|City of Lexington||',
 'VAC680' => '37.4005|-79.1910|City of Lynchburg||',
 'VAC683' => '38.7482|-77.4837|City of Manassas||',
 'VAC685' => '38.7714|-77.4445|City of Manassas Park||',
 'VAC690' => '36.6826|-79.8636|City of Martinsville||',
 'VAC700' => '37.1051|-76.5189|City of Newport News||',
 'VAC710' => '36.8313|-76.2711|City of Norfolk||	36.8966|-76.2552|City of Norfolk||	36.8889|-76.3096|City of Norfolk||',
 'VAC720' => '36.9317|-82.6259|City of Norton||',
 'VAC730' => '37.2042|-77.3915|City of Petersburg||',
 'VAC735' => '37.1508|-76.3693|City of Poquoson||	37.1323|-76.3578|City of Poquoson||',
 'VAC740' => '36.8449|-76.3548|City of Portsmouth||	36.8698|-76.3466|City of Portsmouth||',
 'VAC750' => '37.1231|-80.5583|City of Radford||',
 'VAC760' => '37.5293|-77.4754|City of Richmond||',
 'VAC770' => '37.2781|-79.9581|City of Roanoke||',
 'VAC775' => '37.2864|-80.0556|City of Salem||',
 'VAC790' => '38.1587|-79.0616|City of Staunton||',
 'VAC800' => '36.6926|-76.6417|City of Suffolk||	36.8717|-76.5046|City of Suffolk||',
 'VAC810' => '36.7494|-76.0571|City of Virginia Beach||',
 'VAC820' => '38.0673|-78.9013|City of Waynesboro||',
 'VAC830' => '37.2691|-76.7074|City of Williamsburg||',
 'VAC840' => '39.1733|-78.1744|City of Winchester||',
 'VAZ001' => '36.7055|-83.1285|Lee|Lee|51105',
 'VAZ002' => '36.9745|-82.6213|Wise|Wise|51195	36.9745|-82.6213|Wise|City of Norton|51720',
 'VAZ003' => '37.1258|-82.3503|Dickenson|Dickenson|51051',
 'VAZ004' => '37.2666|-82.036|Buchanan|Buchanan|51027',
 'VAZ005' => '36.7142|-82.603|Scott|Scott|51169',
 'VAZ006' => '36.9338|-82.0956|Russell|Russell|51167',
 'VAZ007' => '37.125|-81.5606|Tazewell|Tazewell|51185',
 'VAZ008' => '36.7221|-81.9642|Washington|Washington|51191	36.7221|-81.9642|Washington|City of Bristol|51520',
 'VAZ009' => '36.8439|-81.537|Smyth|Smyth|51173',
 'VAZ010' => '37.134|-81.1302|Bland|Bland|51021',
 'VAZ011' => '37.3141|-80.7037|Giles|Giles|51071',
 'VAZ012' => '36.9171|-81.0786|Wythe|Wythe|51197',
 'VAZ013' => '37.0654|-80.7096|Pulaski|Pulaski|51155	37.0654|-80.7096|Pulaski|City of Radford|51750',
 'VAZ014' => '37.174|-80.3869|Montgomery|Montgomery|51121',
 'VAZ015' => '36.6566|-81.225|Grayson|Grayson|51077',
 'VAZ016' => '36.7304|-80.737|Carroll|Carroll|51035	36.7304|-80.737|Carroll|City of Galax|51640',
 'VAZ017' => '36.9315|-80.3626|Floyd|Floyd|51063',
 'VAZ018' => '37.4813|-80.2123|Craig|Craig|51045',
 'VAZ019' => '37.7875|-80.0067|Alleghany|Alleghany|51005	37.7875|-80.0067|Alleghany|City of Covington|51580',
 'VAZ020' => '38.0587|-79.7411|Bath|Bath|51017',
 'VAZ022' => '37.2714|-80.052|Roanoke|Roanoke|51161	37.2714|-80.052|Roanoke|City of Roanoke|51770	37.2714|-80.052|Roanoke|City of Salem|51775',
 'VAZ023' => '37.5571|-79.8123|Botetourt|Botetourt|51023',
 'VAZ024' => '37.8136|-79.4465|Rockbridge|Rockbridge|51163	37.8136|-79.4465|Rockbridge|City of Buena Vista|51530	37.8136|-79.4465|Rockbridge|City of Lexington|51678',
 'VAZ025' => '38.163|-79.1289|Augusta|City of Staunton|51790	38.163|-79.1289|Augusta|City of Waynesboro|51820',
 'VAZ026' => '38.5106|-78.8757|Rockingham|Rockingham|51165	38.5106|-78.8757|Rockingham|City of Harrisonburg|51660',
 'VAZ027' => '38.8585|-78.5704|Shenandoah|Shenandoah|51171',
 'VAZ028' => '39.2039|-78.2606|Frederick|Frederick|51069	39.2039|-78.2606|Frederick|City of Winchester|51840',
 'VAZ029' => '38.62|-78.4841|Page|Page|51139',
 'VAZ030' => '38.9087|-78.2072|Warren|Warren|51187',
 'VAZ031' => '39.1122|-77.9966|Clarke|Clarke|51043',
 'VAZ032' => '36.6784|-80.2843|Patrick|Patrick|51141',
 'VAZ033' => '36.992|-79.881|Franklin|Franklin|51067',
 'VAZ034' => '37.3152|-79.5242|Bedford|Bedford|51019',
 'VAZ035' => '37.6048|-79.1451|Amherst|Amherst|51009',
 'VAZ036' => '37.7874|-78.8867|Nelson|Nelson|51125',
 'VAZ037' => '38.0231|-78.5555|Albemarle|City of Charlottesville|51540',
 'VAZ038' => '38.2977|-78.4669|Greene|Greene|51079',
 'VAZ039' => '38.4137|-78.2792|Madison|Madison|51113',
 'VAZ040' => '38.6845|-78.1593|Rappahannock|Rappahannock|51157',
 'VAZ043' => '36.6828|-79.8736|Henry|Henry|51089	36.6828|-79.8736|Henry|City of Martinsville|51690',
 'VAZ044' => '36.8111|-79.3976|Pittsylvania|Pittsylvania|51143	36.8111|-79.3976|Pittsylvania|City of Danville|51590',
 'VAZ045' => '37.2231|-79.1048|Campbell|Campbell|51031	37.2231|-79.1048|Campbell|City of Lynchburg|51680',
 'VAZ046' => '37.3722|-78.8121|Appomattox|Appomattox|51011',
 'VAZ047' => '37.5722|-78.5287|Buckingham|Buckingham|51029',
 'VAZ048' => '37.8419|-78.2774|Fluvanna|Fluvanna|51065',
 'VAZ050' => '38.2463|-78.0134|Orange|Orange|51137',
 'VAZ051' => '38.4861|-77.9559|Culpeper|Culpeper|51047',
 'VAZ053' => '38.8387|-77.2791|Fairfax|Fairfax|51059	38.8387|-77.2791|Fairfax|City of Fairfax|51600',
 'VAZ054' => '38.8577|-77.0989|Arlington/Falls Church/Alexandria|Arlington|51013	38.8577|-77.0989|Arlington/Falls Church/Alexandria|City of Alexandria|51510	38.8577|-77.0989|Arlington/Falls Church/Alexandria|City of Falls Church|51610',
 'VAZ055' => '38.4213|-77.4603|Stafford|Stafford|51179',
 'VAZ056' => '38.1882|-77.6525|Spotsylvania|Spotsylvania|51177	38.1882|-77.6525|Spotsylvania|City of Fredericksburg|51630',
 'VAZ057' => '38.2729|-77.1572|King George|King George|51099',
 'VAZ058' => '36.767|-78.9367|Halifax|Halifax|51083',
 'VAZ059' => '37.0116|-78.6616|Charlotte|Charlotte|51037',
 'VAZ060' => '37.2243|-78.4411|Prince Edward|Prince Edward|51147',
 'VAZ061' => '37.512|-78.245|Cumberland|Cumberland|51049',
 'VAZ062' => '37.722|-77.9164|Goochland|Goochland|51075',
 'VAZ064' => '38.0272|-77.3475|Caroline|Caroline|51033',
 'VAZ065' => '36.6804|-78.3627|Mecklenburg|Mecklenburg|51117',
 'VAZ066' => '36.9462|-78.2406|Lunenburg|Lunenburg|51111',
 'VAZ067' => '37.1431|-78.0512|Nottoway|Nottoway|51135',
 'VAZ068' => '37.336|-77.9761|Amelia|Amelia|51007',
 'VAZ069' => '37.5502|-77.9152|Powhatan|Powhatan|51145',
 'VAZ075' => '38.1108|-76.8052|Westmoreland|Westmoreland|51193	38.1366|-76.7253|Westmoreland|Westmoreland|51193',
 'VAZ076' => '37.8881|-76.7671|Richmond|Richmond|51159	37.9429|-76.7249|Richmond|Richmond|51159',
 'VAZ077' => '37.8863|-76.4228|Northumberland|Northumberland|51133',
 'VAZ078' => '37.6779|-76.4808|Lancaster|Lancaster|51103	37.7371|-76.465|Lancaster|Lancaster|51103',
 'VAZ079' => '36.7648|-77.859|Brunswick|Brunswick|51025',
 'VAZ080' => '37.0759|-77.6323|Dinwiddie|Dinwiddie|51053',
 'VAZ081' => '37.1915|-77.2389|Prince George|Prince George|51149	37.1915|-77.2389|Prince George|City of Hopewell|51670	37.1915|-77.2389|Prince George|City of Petersburg|51730',
 'VAZ082' => '37.2385|-76.9027|Charles City|Charles City|51036	37.3565|-77.0613|Charles City|Charles City|51036',
 'VAZ083' => '37.5052|-76.9972|New Kent|New Kent|51127',
 'VAZ084' => '37.3249|-76.5063|Gloucester|Gloucester|51073	37.4257|-76.5431|Gloucester|Gloucester|51073',
 'VAZ085' => '37.6258|-76.4816|Middlesex|Middlesex|51119	37.6353|-76.5769|Middlesex|Middlesex|51119',
 'VAZ086' => '37.4368|-76.3444|Mathews|Mathews|51115	37.4577|-76.3416|Mathews|Mathews|51115',
 'VAZ087' => '36.6763|-77.559|Greensville|Greensville|51081	36.6763|-77.559|Greensville|City of Emporia|51595',
 'VAZ088' => '36.9218|-77.2618|Sussex|Sussex|51183',
 'VAZ089' => '37.1169|-76.8883|Surry|Surry|51181',
 'VAZ090' => '37.2088|-76.7412|James City|James City|51095	37.3264|-76.7745|James City|James City|51095	37.3264|-76.7745|James City|City of Williamsburg|51830',
 'VAZ092' => '36.7199|-77.1038|Southampton|Southampton|51175	36.7199|-77.1038|Southampton|City of Franklin|51620',
 'VAZ093' => '36.9067|-76.7091|Isle of Wight|Isle of Wight|51093',
 'VAZ095' => '36.8752|-76.2937|Norfolk/Portsmouth|City of Norfolk|51710	36.8959|-76.3428|Norfolk/Portsmouth|City of Norfolk|51710	36.8752|-76.2937|Norfolk/Portsmouth|City of Portsmouth|51740	36.8959|-76.3428|Norfolk/Portsmouth|City of Portsmouth|51740',
 'VAZ096' => '36.6926|-76.6417|Suffolk|City of Suffolk|51800	36.8935|-76.4749|Suffolk|City of Suffolk|51800',
 'VAZ097' => '36.6778|-76.3024|Chesapeake|City of Chesapeake|51550',
 'VAZ098' => '36.7494|-76.0571|Virginia Beach|City of Virginia Beach|51810',
 'VAZ099' => '37.7659|-75.6472|Accomack|Accomack|51001',
 'VAZ100' => '37.3566|-75.8995|Northampton|Northampton|51131',
 'VAZ501' => '38.854|-77.8851|Northern Fauquier|Fauquier|51061',
 'VAZ502' => '38.5953|-77.7154|Southern Fauquier|Fauquier|51061',
 'VAZ503' => '38.4256|-79.6618|Western Highland|Highland|51091',
 'VAZ504' => '38.3315|-79.523|Eastern Highland|Highland|51091',
 'VAZ505' => '39.1337|-77.6963|Western Loudoun|Loudoun|51107',
 'VAZ506' => '39.0052|-77.5151|Eastern Loudoun|Loudoun|51107',
 'VAZ507' => '38.5272|-78.4323|Northern Virginia Blue Ridge|Greene|51079	38.5272|-78.4323|Northern Virginia Blue Ridge|Madison|51113	38.5272|-78.4323|Northern Virginia Blue Ridge|Page|51139	38.5272|-78.4323|Northern Virginia Blue Ridge|Rappahannock|51157	38.5272|-78.4323|Northern Virginia Blue Ridge|Rockingham|51165	38.5272|-78.4323|Northern Virginia Blue Ridge|Warren|51187',
 'VAZ508' => '37.9889|-78.9469|Central Virginia Blue Ridge|Albemarle|51003	37.9889|-78.9469|Central Virginia Blue Ridge|Augusta|51015	37.9889|-78.9469|Central Virginia Blue Ridge|Amherst|51009	37.9889|-78.9469|Central Virginia Blue Ridge|Nelson|51125	37.9889|-78.9469|Central Virginia Blue Ridge|Rockbridge|51163',
 'VAZ509' => '38.0408|-78.1061|Western Louisa|Louisa|51109',
 'VAZ510' => '37.9335|-77.8608|Eastern Louisa|Louisa|51109',
 'VAZ511' => '37.809|-77.5823|Western Hanover|Hanover|51085',
 'VAZ512' => '37.4671|-77.2793|Eastern Hanover|Hanover|51085',
 'VAZ513' => '37.3765|-77.5835|Western Chesterfield|Chesterfield|51041',
 'VAZ514' => '37.3765|-77.5835|Eastern Chesterfield (Including Col. Heights)|City of Colonial Heights|51570',
 'VAZ515' => '37.5362|-77.42|Western Henrico (Including the City of Richmond)|Henrico|51087	37.5293|-77.4754|Western Henrico (Including the City of Richmond)|City of Richmond|51760',
 'VAZ516' => '37.5362|-77.42|Eastern Henrico|Henrico|51087',
 'VAZ517' => '37.7067|-77.0884|Western King William|King William|51101',
 'VAZ518' => '37.7067|-77.0884|Eastern King William|King William|51101',
 'VAZ519' => '37.7179|-76.8946|Western King and Queen|King and Queen|51097',
 'VAZ520' => '37.7179|-76.8946|Eastern King and Queen|King and Queen|51097',
 'VAZ521' => '37.8958|-76.808|Western Essex|Essex|51057',
 'VAZ522' => '37.9426|-76.9518|Eastern Essex|Essex|51057',
 'VAZ523' => '37.2242|-76.5383|York|York|51199	37.256|-76.5124|York|York|51199	37.2242|-76.5383|York|City of Poquoson|51735',
 'VAZ524' => '37.077|-76.5058|Newport News/Hampton|City of Newport News|51700',
 'VAZ525' => '37.0534|-76.3673|Hampton/Poquoson|City of Hampton|51650',
 'VAZ526' => '38.8549|-77.6332|Northwest Prince William|Prince William|51153',
 'VAZ527' => '38.6727|-77.4488|Central and Southeast Prince William/Manassas/Manassas Park|Prince William|51153	38.6727|-77.4488|Central and Southeast Prince William/Manassas/Manassas Park|City of Manassas|51683	38.6727|-77.4488|Central and Southeast Prince William/Manassas/Manassas Park|City of Manassas Park|51685',
 'VIC010' => '17.7333|-64.7677|Saint Croix||',
 'VIC020' => '18.3390|-64.7385|Saint John||',
 'VIC030' => '18.3453|-64.9302|Saint Thomas||',
 'VIZ001' => '18.3429|-64.8564|St.Thomas...St. John.. and Adjacent Islands|Saint John|78020	18.3429|-64.8564|St.Thomas...St. John.. and Adjacent Islands|Saint Thomas|78030',
 'VIZ002' => '17.7333|-64.7677|St Croix|Saint Croix|78010',
 'VTC001' => '44.0306|-73.1407|Addison||',
 'VTC003' => '43.0355|-73.0929|Bennington||',
 'VTC005' => '44.4647|-72.1022|Caledonia||',
 'VTC007' => '44.4609|-73.0809|Chittenden||',
 'VTC009' => '44.7281|-71.7364|Essex||',
 'VTC011' => '44.8574|-72.9120|Franklin||',
 'VTC013' => '44.7968|-73.2948|Grand Isle||',
 'VTC015' => '44.6057|-72.6414|Lamoille||',
 'VTC017' => '44.0056|-72.3769|Orange||',
 'VTC019' => '44.8288|-72.2438|Orleans||',
 'VTC021' => '43.5801|-73.0366|Rutland||',
 'VTC023' => '44.2734|-72.6149|Washington||',
 'VTC025' => '42.9906|-72.7138|Windham||',
 'VTC027' => '43.5798|-72.5855|Windsor||',
 'VTZ001' => '44.7968|-73.2948|Grand Isle|Grand Isle|50013',
 'VTZ002' => '44.8517|-73.034|Western Franklin|Franklin|50011',
 'VTZ003' => '44.8288|-72.2438|Orleans|Orleans|50019',
 'VTZ004' => '44.7281|-71.7364|Essex|Essex|50009',
 'VTZ005' => '44.4793|-73.1562|Western Chittenden|Chittenden|50007',
 'VTZ006' => '44.6057|-72.6414|Lamoille|Lamoille|50015',
 'VTZ007' => '44.4647|-72.1022|Caledonia|Caledonia|50005',
 'VTZ008' => '44.2734|-72.6149|Washington|Washington|50023',
 'VTZ009' => '44.0215|-73.2394|Western Addison|Addison|50001',
 'VTZ010' => '44.0056|-72.3769|Orange|Orange|50017',
 'VTZ011' => '43.5856|-73.1398|Western Rutland|Rutland|50021',
 'VTZ013' => '43.0355|-73.0929|Bennington|Bennington|50003',
 'VTZ014' => '43.0015|-72.7867|Western Windham|Windham|50025',
 'VTZ015' => '42.9675|-72.5583|Eastern Windham|Windham|50025',
 'VTZ016' => '44.8662|-72.7255|Eastern Franklin|Franklin|50011',
 'VTZ017' => '44.4237|-72.9287|Eastern Chittenden|Chittenden|50007',
 'VTZ018' => '44.0466|-72.9674|Eastern Addison|Addison|50001',
 'VTZ019' => '43.5713|-72.8735|Eastern Rutland|Rutland|50021',
 'VTZ020' => '43.6473|-72.7043|Western Windsor|Windsor|50027',
 'VTZ021' => '43.5254|-72.4895|Eastern Windsor|Windsor|50027',
 'WAC001' => '46.9834|-118.5605|Adams||',
 'WAC003' => '46.1919|-117.2031|Asotin||',
 'WAC005' => '46.2398|-119.5112|Benton||',
 'WAC007' => '47.8691|-120.6188|Chelan||',
 'WAC009' => '48.0491|-123.9316|Clallam||',
 'WAC011' => '45.7793|-122.4826|Clark||',
 'WAC013' => '46.2976|-117.9079|Columbia||',
 'WAC015' => '46.1933|-122.6808|Cowlitz||',
 'WAC017' => '47.7361|-119.6917|Douglas||',
 'WAC019' => '48.4700|-118.5165|Ferry||',
 'WAC021' => '46.5348|-118.8989|Franklin||',
 'WAC023' => '46.4316|-117.5452|Garfield||',
 'WAC025' => '47.2056|-119.4518|Grant||',
 'WAC027' => '47.1508|-123.7726|Grays Harbor||',
 'WAC029' => '48.1629|-122.5486|Island||',
 'WAC031' => '47.7478|-123.6002|Jefferson||',
 'WAC033' => '47.4902|-121.8048|King||',
 'WAC035' => '47.6110|-122.6767|Kitsap||',
 'WAC037' => '47.1242|-120.6797|Kittitas||',
 'WAC039' => '45.8738|-120.7893|Klickitat||',
 'WAC041' => '46.5777|-122.3924|Lewis||',
 'WAC043' => '47.5762|-118.4188|Lincoln||',
 'WAC045' => '47.3537|-123.2058|Mason||',
 'WAC047' => '48.5487|-119.7408|Okanogan||',
 'WAC049' => '46.5549|-123.6982|Pacific||',
 'WAC051' => '48.5323|-117.2740|Pend Oreille||',
 'WAC053' => '47.0230|-122.1020|Pierce||',
 'WAC055' => '48.5786|-122.9627|San Juan||',
 'WAC057' => '48.4794|-121.7285|Skagit||',
 'WAC059' => '46.0227|-121.9151|Skamania||',
 'WAC061' => '48.0473|-121.6966|Snohomish||',
 'WAC063' => '47.6206|-117.4040|Spokane||',
 'WAC065' => '48.3990|-117.8551|Stevens||',
 'WAC067' => '46.9282|-122.8314|Thurston||',
 'WAC069' => '46.2998|-123.4248|Wahkiakum||',
 'WAC071' => '46.2298|-118.4784|Walla Walla||',
 'WAC073' => '48.8256|-121.7175|Whatcom||',
 'WAC075' => '46.9012|-117.5230|Whitman||',
 'WAC077' => '46.4569|-120.7387|Yakima||',
 'WAZ001' => '48.5786|-122.9627|San Juan County|San Juan|53055',
 'WAZ024' => '45.7233|-120.8763|Eastern Columbia River Gorge of Washington|Klickitat|53039',
 'WAZ026' => '46.9429|-120.314|Kittitas Valley|Kittitas|53037	46.9429|-120.314|Kittitas Valley|Yakima|53077',
 'WAZ027' => '46.4331|-120.312|Yakima Valley|Yakima|53077',
 'WAZ028' => '46.3373|-119.1824|Lower Columbia Basin of Washington|Benton|53005	46.3373|-119.1824|Lower Columbia Basin of Washington|Franklin|53021	46.3373|-119.1824|Lower Columbia Basin of Washington|Klickitat|53039	46.3373|-119.1824|Lower Columbia Basin of Washington|Walla Walla|53071',
 'WAZ029' => '46.3118|-118.2123|Foothills of the Blue Mountains of Washington|Columbia|53013	46.3118|-118.2123|Foothills of the Blue Mountains of Washington|Walla Walla|53071',
 'WAZ030' => '46.1508|-117.8128|Northwest Blue Mountains|Columbia|53013	46.1508|-117.8128|Northwest Blue Mountains|Walla Walla|53071',
 'WAZ031' => '46.1967|-117.3899|Northeast Blue Mountains|Asotin|53003	46.1967|-117.3899|Northeast Blue Mountains|Garfield|53023',
 'WAZ032' => '46.422|-117.3795|Lower Garfield and Asotin Counties|Asotin|53003	46.422|-117.3795|Lower Garfield and Asotin Counties|Garfield|53023',
 'WAZ033' => '46.9272|-117.5068|Washington Palouse|Spokane|53063	46.9272|-117.5068|Washington Palouse|Whitman|53075',
 'WAZ034' => '47.0108|-119.4918|Moses Lake Area|Adams|53001	47.0108|-119.4918|Moses Lake Area|Grant|53025',
 'WAZ035' => '47.3555|-118.6116|Upper Columbia Basin|Adams|53001	47.3555|-118.6116|Upper Columbia Basin|Douglas|53017	47.3555|-118.6116|Upper Columbia Basin|Grant|53025	47.3555|-118.6116|Upper Columbia Basin|Lincoln|53043	47.3555|-118.6116|Upper Columbia Basin|Okanogan|53047',
 'WAZ036' => '47.6181|-117.613|Spokane Area|Lincoln|53043	47.6181|-117.613|Spokane Area|Spokane|53063',
 'WAZ037' => '48.4082|-117.6152|Northeast Mountains|Pend Oreille|53051	48.4082|-117.6152|Northeast Mountains|Spokane|53063	48.4082|-117.6152|Northeast Mountains|Stevens|53065',
 'WAZ038' => '48.5329|-118.6987|Okanogan Highlands|Ferry|53019	48.5329|-118.6987|Okanogan Highlands|Okanogan|53047',
 'WAZ041' => '47.6296|-120.2222|Wenatchee Area|Chelan|53007	47.6296|-120.2222|Wenatchee Area|Douglas|53017',
 'WAZ043' => '48.3496|-119.4519|Okanogan Valley|Douglas|53017	48.3496|-119.4519|Okanogan Valley|Okanogan|53047',
 'WAZ044' => '47.6675|-119.6829|Waterville Plateau|Douglas|53017	47.6675|-119.6829|Waterville Plateau|Grant|53025',
 'WAZ047' => '47.8063|-120.5252|Central Chelan County|Chelan|53007',
 'WAZ048' => '48.0304|-120.869|Western Chelan County|Chelan|53007',
 'WAZ049' => '48.5981|-120.1638|Western Okanogan County|Okanogan|53047',
 'WAZ101' => '46.0848|-123.8453|Clatsop County Coast|Clatsop|41007',
 'WAZ102' => '45.3813|-123.8935|Tillamook County Coast|Tillamook|41057',
 'WAZ103' => '44.5185|-124.0171|Central Coast of Oregon|Lincoln|41041',
 'WAZ104' => '45.7917|-123.4834|North Oregon Coast Range Lowlands|Tillamook|41057',
 'WAZ105' => '44.3784|-123.7351|Central Oregon Coast Range Lowlands|Lane|41039',
 'WAZ106' => '45.6454|-123.4735|North Oregon Coast Range|Tillamook|41057',
 'WAZ107' => '44.4253|-123.6254|Central Oregon Coast Range|Lane|41039',
 'WAZ108' => '45.9591|-122.9767|Lower Columbia River|Columbia|41009',
 'WAZ109' => '45.5144|-123.0010|Tualatin Valley|Washington|41067',
 'WAZ110' => '45.4599|-122.9062|West Hills and Chehalem Mountains|Washington|41067',
 'WAZ111' => '45.4718|-122.6157|Inner Portland Metro|Multnomah|41051',
 'WAZ112' => '45.5186|-122.4069|East Portland Metro|Multnomah|41051',
 'WAZ113' => '45.3705|-122.3697|Outer Southeast Portland Metro|Multnomah|41051',
 'WAZ114' => '45.0867|-123.2391|West Central Willamette Valley|Yamhill|41071',
 'WAZ115' => '45.0421|-122.8253|East Central Willamette Valley|Marion|41047',
 'WAZ116' => '44.4987|-123.3084|Benton County Lowlands|Benton|41003',
 'WAZ117' => '44.5207|-122.9602|Linn County Lowlands|Linn|41043',
 'WAZ118' => '44.0605|-123.1621|Lane County Lowlands|Lane|41039',
 'WAZ119' => '45.5420|-122.0850|West Columbia River Gorge of Oregon above 500 ft|Multnomah|41051',
 'WAZ120' => '45.6063|-122.0573|West Columbia River Gorge I-84 Corridor|Multnomah|41051',
 'WAZ121' => '45.6055|-121.5868|Upper Hood River Valley|Hood River|41027',
 'WAZ122' => '45.7005|-121.6071|Central Columbia River Gorge I-84 Corridor|Hood River|41027',
 'WAZ123' => '45.2088|-122.2583|Clackamas County Cascade Foothills|Clackamas|41005',
 'WAZ124' => '44.5450|-122.5773|Cascade Foothills of Marion and Linn Counties|Marion|41047',
 'WAZ125' => '43.9499|-122.7232|Lane County Cascade Foothills|Lane|41039',
 'WAZ126' => '45.2324|-121.9183|North Oregon Cascades|Clackamas|41005',
 'WAZ127' => '44.5856|-122.1211|Cascades of Marion and Linn Counties|Marion|41047',
 'WAZ128' => '43.8198|-122.2756|Cascades of Lane County|Lane|41039',
 'WAZ201' => '46.5078|-123.9011|South Washington Coast|Pacific|53049',
 'WAZ202' => '46.4823|-123.5766|Willapa and Wahkiakum Lowlands|Pacific|53049	46.4823|-123.5766|Willapa and Wahkiakum Lowlands|Wahkiakum|53069',
 'WAZ203' => '46.4636|-123.4406|Willapa Hills|Pacific|53049	46.4636|-123.4406|Willapa Hills|Wahkiakum|53069	46.4636|-123.4406|Willapa Hills|Cowlitz|53015',
 'WAZ204' => '46.1895|-122.9135|Cowlitz County Lowlands|Cowlitz|53015',
 'WAZ205' => '45.7787|-122.6057|North Clark County Lowlands|Clark|53011',
 'WAZ206' => '45.6678|-122.6462|Inner Vancouver Metro|Clark|53011',
 'WAZ207' => '45.6042|-122.3953|East Clark County Lowlands|Clark|53011',
 'WAZ208' => '46.0337|-122.5546|South Washington Cascade Foothills|Clark|53011	46.0337|-122.5546|South Washington Cascade Foothills|Cowlitz|53015	46.0337|-122.5546|South Washington Cascade Foothills|Skamania|53059',
 'WAZ209' => '45.6379|-122.0056|West Columbia River Gorge - SR 14|Skamania|53059',
 'WAZ210' => '45.7152|-121.7109|Central Columbia River Gorge - SR 14|Skamania|53059',
 'WAZ211' => '46.0559|-122.0135|South Washington Cascades|Skamania|53059	46.0559|-122.0135|South Washington Cascades|Cowlitz|53015	46.0559|-122.0135|South Washington Cascades|Clark|53011',
 'WAZ503' => '48.8588|-122.4772|Western Whatcom County|Whatcom|53073',
 'WAZ504' => '46.7206|-122.8973|Southwest Interior|Lewis|53041	46.7206|-122.8973|Southwest Interior|Thurston|53067',
 'WAZ506' => '48.4646|-122.3668|Western Skagit County|Skagit|53057',
 'WAZ507' => '48.0549|-122.2545|Everett and Vicinity|Kitsap|53035	48.0549|-122.2545|Everett and Vicinity|Snohomish|53061',
 'WAZ509' => '47.1703|-122.5041|Tacoma Area|Pierce|53053',
 'WAZ510' => '48.1131|-122.6404|Admiralty Inlet Area|Island|53029	48.1131|-122.6404|Admiralty Inlet Area|Jefferson|53031',
 'WAZ511' => '47.4978|-122.967|Hood Canal Area|Jefferson|53031	47.4978|-122.967|Hood Canal Area|Kitsap|53035	47.4978|-122.967|Hood Canal Area|Mason|53045',
 'WAZ512' => '47.0579|-123.5111|Lower Chehalis Valley Area|Grays Harbor|53027	47.0579|-123.5111|Lower Chehalis Valley Area|Mason|53045',
 'WAZ513' => '47.7525|-123.599|Olympics|Clallam|53009	47.7525|-123.599|Olympics|Grays Harbor|53027	47.7525|-123.599|Olympics|Jefferson|53031	47.7525|-123.599|Olympics|Mason|53045',
 'WAZ514' => '48.076|-123.2615|Eastern Strait of Juan de Fuca|Clallam|53009',
 'WAZ515' => '48.1845|-124.1477|Western Strait of Juan De Fuca|Clallam|53009',
 'WAZ516' => '47.9309|-124.4066|North Coast|Clallam|53009	47.9309|-124.4066|North Coast|Jefferson|53031',
 'WAZ517' => '47.1902|-124.0272|Central Coast|Grays Harbor|53027',
 'WAZ521' => '45.9735|-120.6525|Simcoe Highlands|Klickitat|53039	45.9735|-120.6525|Simcoe Highlands|Yakima|53077',
 'WAZ522' => '46.9379|-121.2667|Upper Slopes of the Eastern Washington Cascades Crest|Kittitas|53037	46.9379|-121.2667|Upper Slopes of the Eastern Washington Cascades Crest|Yakima|53077',
 'WAZ523' => '46.4569|-120.7387|Lower Slopes of the Eastern Washington Cascades Crest|Kittitas|53037	46.4569|-120.7387|Lower Slopes of the Eastern Washington Cascades Crest|Klickitat|53039	46.4569|-120.7387|Lower Slopes of the Eastern Washington Cascades Crest|Yakima|53077',
 'WAZ555' => '47.562|-122.0265|East Puget Sound Lowlands|King|53033	47.562|-122.0265|East Puget Sound Lowlands|Pierce|53053	48.0549|-122.2545|East Puget Sound Lowlands|Snohomish|53061',
 'WAZ556' => '47.521|-122.4499|Bellevue and Vicinity|King|53033	47.562|-122.0265|Bellevue and Vicinity|Snohomish|53061',
 'WAZ558' => '47.521|-122.4499|Seattle and Vicinity|King|53033',
 'WAZ559' => '47.4978|-122.967|Bremerton and Vicinity|Kitsap|53035',
 'WAZ567' => '48.4646|-122.3668|West Slopes North Cascades and Passes|Skagit|53057	48.8588|-122.4772|West Slopes North Cascades and Passes|Whatcom|53073',
 'WAZ568' => '47.562|-122.0265|West Slopes North Central Cascdes|King|53033	48.0549|-122.2545|West Slopes North Central Cascdes|Snohomish|53061',
 'WAZ569' => '46.7206|-122.8973|West Slopes South Central Cascades and Passes|Lewis|53041	47.562|-122.0265|West Slopes South Central Cascades and Passes|Pierce|53053',
 'WIC001' => '43.9696|-89.7706|Adams||',
 'WIC003' => '46.3148|-90.6781|Ashland||',
 'WIC005' => '45.4238|-91.8484|Barron||',
 'WIC007' => '46.5241|-91.2006|Bayfield||',
 'WIC009' => '44.4537|-88.0032|Brown||',
 'WIC011' => '44.3799|-91.7545|Buffalo||',
 'WIC013' => '45.8627|-92.3675|Burnett||',
 'WIC015' => '44.0817|-88.2180|Calumet||',
 'WIC017' => '45.0694|-91.2799|Chippewa||',
 'WIC019' => '44.7347|-90.6121|Clark||',
 'WIC021' => '43.4665|-89.3338|Columbia||',
 'WIC023' => '43.2395|-90.9310|Crawford||',
 'WIC025' => '43.0674|-89.4183|Dane||',
 'WIC027' => '43.4164|-88.7075|Dodge||',
 'WIC029' => '44.9436|-87.3173|Door||',
 'WIC031' => '46.4309|-91.9147|Douglas||',
 'WIC033' => '44.9466|-91.8964|Dunn||',
 'WIC035' => '44.7268|-91.2861|Eau Claire||',
 'WIC037' => '45.8484|-88.3982|Florence||',
 'WIC039' => '43.7536|-88.4883|Fond du Lac||',
 'WIC041' => '45.6673|-88.7704|Forest||',
 'WIC043' => '42.8675|-90.7062|Grant||',
 'WIC045' => '42.6799|-89.6022|Green||',
 'WIC047' => '43.8003|-89.0450|Green Lake||',
 'WIC049' => '43.0005|-90.1354|Iowa||',
 'WIC051' => '46.2623|-90.2420|Iron||',
 'WIC053' => '44.3191|-90.8052|Jackson||',
 'WIC055' => '43.0209|-88.7759|Jefferson||',
 'WIC057' => '43.9245|-90.1140|Juneau||',
 'WIC059' => '42.5767|-88.0418|Kenosha||',
 'WIC061' => '44.5161|-87.6154|Kewaunee||',
 'WIC063' => '43.9065|-91.1152|La Crosse||',
 'WIC065' => '42.6605|-90.1317|Lafayette||',
 'WIC067' => '45.2624|-89.0719|Langlade||',
 'WIC069' => '45.3375|-89.7346|Lincoln||',
 'WIC071' => '44.1198|-87.8096|Manitowoc||',
 'WIC073' => '44.8983|-89.7590|Marathon||',
 'WIC075' => '45.3830|-88.0344|Marinette||',
 'WIC077' => '43.8196|-89.3988|Marquette||',
 'WIC078' => '45.0044|-88.7100|Menominee||',
 'WIC079' => '43.0071|-87.9667|Milwaukee||',
 'WIC081' => '43.9457|-90.6179|Monroe||',
 'WIC083' => '45.0255|-88.2676|Oconto||',
 'WIC085' => '45.7056|-89.5217|Oneida||',
 'WIC087' => '44.4161|-88.4649|Outagamie||',
 'WIC089' => '43.3838|-87.9515|Ozaukee||',
 'WIC091' => '44.5829|-92.0017|Pepin||',
 'WIC093' => '44.7196|-92.4225|Pierce||',
 'WIC095' => '45.4614|-92.4414|Polk||',
 'WIC097' => '44.4760|-89.5015|Portage||',
 'WIC099' => '45.6804|-90.3614|Price||',
 'WIC101' => '42.7477|-88.0551|Racine||',
 'WIC103' => '43.3756|-90.4295|Richland||',
 'WIC105' => '42.6712|-89.0716|Rock||',
 'WIC107' => '45.4751|-91.1331|Rusk||',
 'WIC109' => '45.0340|-92.4528|St. Croix||',
 'WIC111' => '43.4268|-89.9484|Sauk||',
 'WIC113' => '45.8800|-91.1447|Sawyer||',
 'WIC115' => '44.7892|-88.7656|Shawano||',
 'WIC117' => '43.7212|-87.9454|Sheboygan||',
 'WIC119' => '45.2115|-90.5012|Taylor||',
 'WIC121' => '44.3040|-91.3585|Trempealeau||',
 'WIC123' => '43.5939|-90.8344|Vernon||',
 'WIC125' => '46.0529|-89.5148|Vilas||',
 'WIC127' => '42.6685|-88.5419|Walworth||',
 'WIC129' => '45.8993|-91.7912|Washburn||',
 'WIC131' => '43.3684|-88.2308|Washington||',
 'WIC133' => '43.0181|-88.3045|Waukesha||',
 'WIC135' => '44.4704|-88.9648|Waupaca||',
 'WIC137' => '44.1131|-89.2429|Waushara||',
 'WIC139' => '44.0689|-88.6446|Winnebago||',
 'WIC141' => '44.4553|-90.0416|Wood||',
 'WIZ001' => '46.4309|-91.9147|Douglas|Douglas|55031',
 'WIZ002' => '46.5241|-91.2006|Bayfield|Bayfield|55007',
 'WIZ003' => '46.3148|-90.6781|Ashland|Ashland|55003',
 'WIZ004' => '46.2623|-90.242|Iron|Iron|55051',
 'WIZ005' => '46.0529|-89.5148|Vilas|Vilas|55125',
 'WIZ006' => '45.8627|-92.3676|Burnett|Burnett|55013',
 'WIZ007' => '45.8993|-91.7912|Washburn|Washburn|55129',
 'WIZ008' => '45.88|-91.1447|Sawyer|Sawyer|55113',
 'WIZ009' => '45.6804|-90.3614|Price|Price|55099',
 'WIZ010' => '45.7056|-89.5217|Oneida|Oneida|55085',
 'WIZ011' => '45.6673|-88.7704|Forest|Forest|55041',
 'WIZ012' => '45.8484|-88.3982|Florence|Florence|55037',
 'WIZ013' => '45.5511|-88.109|Northern Marinette County|Marinette|55075',
 'WIZ014' => '45.4614|-92.4414|Polk|Polk|55095',
 'WIZ015' => '45.4238|-91.8484|Barron|Barron|55005',
 'WIZ016' => '45.4751|-91.1331|Rusk|Rusk|55107',
 'WIZ017' => '45.2115|-90.5012|Taylor|Taylor|55119',
 'WIZ018' => '45.3375|-89.7346|Lincoln|Lincoln|55069',
 'WIZ019' => '45.2624|-89.0719|Langlade|Langlade|55067',
 'WIZ020' => '45.0044|-88.71|Menominee|Menominee|55078',
 'WIZ021' => '45.2006|-88.4257|Northern Oconto County|Oconto|55083',
 'WIZ022' => '44.9435|-87.3173|Door|Door|55029',
 'WIZ023' => '45.034|-92.4528|St. Croix|St. Croix|55109',
 'WIZ024' => '44.7196|-92.4224|Pierce|Pierce|55093',
 'WIZ025' => '44.9466|-91.8964|Dunn|Dunn|55033',
 'WIZ026' => '44.5829|-92.0016|Pepin|Pepin|55091',
 'WIZ027' => '45.0694|-91.2799|Chippewa|Chippewa|55017',
 'WIZ028' => '44.7268|-91.286|Eau Claire|Eau Claire|55035',
 'WIZ029' => '44.7347|-90.6121|Clark|Clark|55019',
 'WIZ030' => '44.8983|-89.759|Marathon|Marathon|55073',
 'WIZ031' => '44.7892|-88.7656|Shawano|Shawano|55115',
 'WIZ032' => '44.3799|-91.7545|Buffalo|Buffalo|55011',
 'WIZ033' => '44.304|-91.3585|Trempealeau|Trempealeau|55121',
 'WIZ034' => '44.3191|-90.8052|Jackson|Jackson|55053',
 'WIZ035' => '44.4553|-90.0416|Wood|Wood|55141',
 'WIZ036' => '44.476|-89.5015|Portage|Portage|55097',
 'WIZ037' => '44.4704|-88.9648|Waupaca|Waupaca|55135',
 'WIZ038' => '44.4161|-88.4649|Outagamie|Outagamie|55087',
 'WIZ039' => '44.4537|-88.0032|Brown|Brown|55009',
 'WIZ040' => '44.5161|-87.6154|Kewaunee|Kewaunee|55061',
 'WIZ041' => '43.9065|-91.1152|La Crosse|La Crosse|55063',
 'WIZ042' => '43.9457|-90.6179|Monroe|Monroe|55081',
 'WIZ043' => '43.9245|-90.114|Juneau|Juneau|55057',
 'WIZ044' => '43.9696|-89.7706|Adams|Adams|55001',
 'WIZ045' => '44.1131|-89.2429|Waushara|Waushara|55137',
 'WIZ046' => '43.8196|-89.3988|Marquette|Marquette|55077',
 'WIZ047' => '43.8003|-89.045|Green Lake|Green Lake|55047',
 'WIZ048' => '44.0689|-88.6446|Winnebago|Winnebago|55139',
 'WIZ049' => '44.0817|-88.218|Calumet|Calumet|55015',
 'WIZ050' => '44.1198|-87.8096|Manitowoc|Manitowoc|55071',
 'WIZ051' => '43.7536|-88.4882|Fond Du Lac|Fond du Lac|55039',
 'WIZ052' => '43.7212|-87.9454|Sheboygan|Sheboygan|55117',
 'WIZ053' => '43.5939|-90.8344|Vernon|Vernon|55123',
 'WIZ054' => '43.2395|-90.931|Crawford|Crawford|55023',
 'WIZ055' => '43.3756|-90.4295|Richland|Richland|55103',
 'WIZ056' => '43.4268|-89.9484|Sauk|Sauk|55111',
 'WIZ057' => '43.4665|-89.3338|Columbia|Columbia|55021',
 'WIZ058' => '43.4164|-88.7075|Dodge|Dodge|55027',
 'WIZ059' => '43.3684|-88.2308|Washington|Washington|55131',
 'WIZ060' => '43.3838|-87.9515|Ozaukee|Ozaukee|55089',
 'WIZ061' => '42.8675|-90.7062|Grant|Grant|55043',
 'WIZ062' => '43.0005|-90.1354|Iowa|Iowa|55049',
 'WIZ063' => '43.0674|-89.4183|Dane|Dane|55025',
 'WIZ064' => '43.0209|-88.7759|Jefferson|Jefferson|55055',
 'WIZ065' => '43.0181|-88.3045|Waukesha|Waukesha|55133',
 'WIZ066' => '43.0071|-87.9667|Milwaukee|Milwaukee|55079',
 'WIZ067' => '42.6605|-90.1317|Lafayette|Lafayette|55065',
 'WIZ068' => '42.68|-89.6022|Green|Green|55045',
 'WIZ069' => '42.6712|-89.0716|Rock|Rock|55105',
 'WIZ070' => '42.6685|-88.5419|Walworth|Walworth|55127',
 'WIZ071' => '42.7477|-88.0551|Racine|Racine|55101',
 'WIZ072' => '42.5767|-88.0418|Kenosha|Kenosha|55059',
 'WIZ073' => '45.1874|-87.9475|Southern Marinette County|Marinette|55075',
 'WIZ074' => '44.8829|-88.139|Southern Oconto County|Oconto|55083',
 'WVC001' => '39.1329|-80.0030|Barbour||',
 'WVC003' => '39.4641|-78.0275|Berkeley||',
 'WVC005' => '38.0231|-81.7113|Boone||',
 'WVC007' => '38.6998|-80.7193|Braxton||',
 'WVC009' => '40.2733|-80.5765|Brooke||',
 'WVC011' => '38.4203|-82.2417|Cabell||',
 'WVC013' => '38.8445|-81.1175|Calhoun||',
 'WVC015' => '38.4626|-81.0751|Clay||',
 'WVC017' => '39.2692|-80.7069|Doddridge||',
 'WVC019' => '38.0288|-81.0811|Fayette||',
 'WVC021' => '38.9241|-80.8571|Gilmer||',
 'WVC023' => '39.1051|-79.1955|Grant||',
 'WVC025' => '37.9469|-80.4529|Greenbrier||',
 'WVC027' => '39.3171|-78.6142|Hampshire||',
 'WVC029' => '40.5213|-80.5739|Hancock||',
 'WVC031' => '39.0075|-78.8579|Hardy||',
 'WVC033' => '39.2835|-80.3798|Harrison||',
 'WVC035' => '38.8344|-81.6748|Jackson||',
 'WVC037' => '39.3076|-77.8628|Jefferson||',
 'WVC039' => '38.3365|-81.5281|Kanawha||',
 'WVC041' => '38.9958|-80.5022|Lewis||',
 'WVC043' => '38.1753|-82.0705|Lincoln||',
 'WVC045' => '37.8316|-81.9353|Logan||',
 'WVC047' => '37.3785|-81.6536|McDowell||',
 'WVC049' => '39.5100|-80.2434|Marion||',
 'WVC051' => '39.8606|-80.6634|Marshall||',
 'WVC053' => '38.7697|-82.0265|Mason||',
 'WVC055' => '37.4055|-81.1114|Mercer||',
 'WVC057' => '39.4147|-78.9438|Mineral||',
 'WVC059' => '37.7264|-82.1346|Mingo||',
 'WVC061' => '39.6303|-80.0465|Monongalia||',
 'WVC063' => '37.5604|-80.5505|Monroe||',
 'WVC065' => '39.5604|-78.2578|Morgan||',
 'WVC067' => '38.2917|-80.7993|Nicholas||',
 'WVC069' => '40.0969|-80.6189|Ohio||',
 'WVC071' => '38.6808|-79.3509|Pendleton||',
 'WVC073' => '39.3709|-81.1606|Pleasants||',
 'WVC075' => '38.3318|-80.0077|Pocahontas||',
 'WVC077' => '39.4693|-79.6681|Preston||',
 'WVC079' => '38.5086|-81.9090|Putnam||',
 'WVC081' => '37.7714|-81.2486|Raleigh||',
 'WVC083' => '38.7748|-79.8758|Randolph||',
 'WVC085' => '39.1783|-81.0629|Ritchie||',
 'WVC087' => '38.7140|-81.3483|Roane||',
 'WVC089' => '37.6559|-80.8586|Summers||',
 'WVC091' => '39.3360|-80.0461|Taylor||',
 'WVC093' => '39.1136|-79.5650|Tucker||',
 'WVC095' => '39.4653|-80.8849|Tyler||',
 'WVC097' => '38.8978|-80.2334|Upshur||',
 'WVC099' => '38.1461|-82.4270|Wayne||',
 'WVC101' => '38.4947|-80.4219|Webster||',
 'WVC103' => '39.6053|-80.6391|Wetzel||',
 'WVC105' => '39.0224|-81.3786|Wirt||',
 'WVC107' => '39.2111|-81.5150|Wood||',
 'WVC109' => '37.6096|-81.5491|Wyoming||',
 'WVZ001' => '40.5213|-80.5739|Hancock|Hancock|54029',
 'WVZ002' => '40.2733|-80.5765|Brooke|Brooke|54009',
 'WVZ003' => '40.0969|-80.6189|Ohio|Ohio|54069',
 'WVZ004' => '39.8606|-80.6634|Marshall|Marshall|54051',
 'WVZ005' => '38.1461|-82.427|Wayne|Wayne|54099',
 'WVZ006' => '38.4203|-82.2417|Cabell|Cabell|54011',
 'WVZ007' => '38.7698|-82.0265|Mason|Mason|54053',
 'WVZ008' => '38.8344|-81.6748|Jackson|Jackson|54035',
 'WVZ009' => '39.2111|-81.515|Wood|Wood|54107',
 'WVZ010' => '39.3709|-81.1606|Pleasants|Pleasants|54073',
 'WVZ011' => '39.4653|-80.8849|Tyler|Tyler|54095',
 'WVZ012' => '39.6053|-80.6391|Wetzel|Wetzel|54103',
 'WVZ013' => '38.1753|-82.0705|Lincoln|Lincoln|54043',
 'WVZ014' => '38.5086|-81.909|Putnam|Putnam|54079',
 'WVZ015' => '38.3365|-81.5281|Kanawha|Kanawha|54039',
 'WVZ016' => '38.714|-81.3483|Roane|Roane|54087',
 'WVZ017' => '39.0224|-81.3786|Wirt|Wirt|54105',
 'WVZ018' => '38.8445|-81.1175|Calhoun|Calhoun|54013',
 'WVZ019' => '39.1783|-81.0629|Ritchie|Ritchie|54085',
 'WVZ020' => '39.2692|-80.707|Doddridge|Doddridge|54017',
 'WVZ021' => '39.51|-80.2434|Marion|Marion|54049',
 'WVZ024' => '37.7264|-82.1346|Mingo|Mingo|54059',
 'WVZ025' => '37.8316|-81.9353|Logan|Logan|54045',
 'WVZ026' => '38.0231|-81.7113|Boone|Boone|54005',
 'WVZ027' => '38.4626|-81.075|Clay|Clay|54015',
 'WVZ028' => '38.6998|-80.7193|Braxton|Braxton|54007',
 'WVZ029' => '38.9241|-80.8571|Gilmer|Gilmer|54021',
 'WVZ030' => '38.9958|-80.5022|Lewis|Lewis|54041',
 'WVZ031' => '39.2835|-80.3798|Harrison|Harrison|54033',
 'WVZ032' => '39.336|-80.0461|Taylor|Taylor|54091',
 'WVZ033' => '37.3785|-81.6536|McDowell|McDowell|54047',
 'WVZ034' => '37.6096|-81.5491|Wyoming|Wyoming|54109',
 'WVZ039' => '38.8978|-80.2334|Upshur|Upshur|54097',
 'WVZ040' => '39.1329|-80.003|Barbour|Barbour|54001',
 'WVZ042' => '37.4055|-81.1114|Mercer|Mercer|54055',
 'WVZ043' => '37.6559|-80.8586|Summers|Summers|54089',
 'WVZ044' => '37.5604|-80.5505|Monroe|Monroe|54063',
 'WVZ050' => '39.3171|-78.6142|Hampshire|Hampshire|54027',
 'WVZ051' => '39.5604|-78.2578|Morgan|Morgan|54065',
 'WVZ052' => '39.4641|-78.0275|Berkeley|Berkeley|54003',
 'WVZ053' => '39.3076|-77.8628|Jefferson|Jefferson|54037',
 'WVZ055' => '39.0075|-78.8579|Hardy|Hardy|54031',
 'WVZ501' => '39.2245|-79.2815|Western Grant|Grant|54023',
 'WVZ502' => '39.0552|-79.1596|Eastern Grant|Grant|54023',
 'WVZ503' => '39.3868|-79.1158|Western Mineral|Mineral|54057',
 'WVZ504' => '39.4239|-78.8872|Eastern Mineral|Mineral|54057',
 'WVZ505' => '38.7534|-79.4656|Western Pendleton|Pendleton|54071',
 'WVZ506' => '38.6434|-79.2919|Eastern Pendleton|Pendleton|54071',
 'WVZ507' => '38.6434|-79.2919|Eastern Greenbrier|Greenbrier|54025',
 'WVZ508' => '37.9469|-80.4529|Western Greenbrier|Greenbrier|54025',
 'WVZ509' => '39.6303|-80.0465|Monongalia|Monongalia|54061',
 'WVZ510' => '39.6303|-80.0465|Ridges of Eastern Monongalia and Northwestern Preston|Monongalia|54061',
 'WVZ511' => '39.4693|-79.6681|Preston|Preston|54077',
 'WVZ512' => '39.4693|-79.6681|Eastern Preston|Preston|54077',
 'WVZ513' => '39.1136|-79.565|Western Tucker|Tucker|54093',
 'WVZ514' => '39.1136|-79.565|Eastern Tucker|Tucker|54093',
 'WVZ515' => '37.8161|-81.3664|Northwest Raleigh|Raleigh|54081',
 'WVZ516' => '37.7176|-81.1069|Southeast Raleigh|Raleigh|54081',
 'WVZ517' => '38.0705|-81.1522|Northwest Fayette|Fayette|54019',
 'WVZ518' => '37.9361|-80.9236|Southeast Fayette|Fayette|54019',
 'WVZ519' => '38.3224|-80.8474|Northwest Nicholas|Nicholas|54067',
 'WVZ520' => '38.1937|-80.6455|Southeast Nicholas|Nicholas|54067',
 'WVZ521' => '38.5398|-80.4692|Northwest Webster|Webster|54101',
 'WVZ522' => '38.4185|-80.3419|Southeast Webster|Webster|54101',
 'WVZ523' => '38.429|-79.9797|Northwest Pocahontas|Pocahontas|54075',
 'WVZ524' => '38.2241|-80.0388|Southeast Pocahontas|Pocahontas|54075',
 'WVZ525' => '38.8495|-79.9622|Northwest Randolph|Randolph|54083',
 'WVZ526' => '38.7298|-79.8239|Southeast Randolph|Randolph|54083',
 'WYC001' => '41.6545|-105.7239|Albany||',
 'WYC003' => '44.5268|-107.9952|Big Horn||',
 'WYC005' => '44.2476|-105.5488|Campbell||',
 'WYC007' => '41.6946|-106.9306|Carbon||',
 'WYC009' => '42.9723|-105.5071|Converse||',
 'WYC011' => '44.5891|-104.5708|Crook||',
 'WYC013' => '43.0405|-108.6304|Fremont||',
 'WYC015' => '42.0880|-104.3533|Goshen||',
 'WYC017' => '43.7189|-108.4420|Hot Springs||',
 'WYC019' => '44.0388|-106.5846|Johnson||',
 'WYC021' => '41.3071|-104.6896|Laramie||',
 'WYC023' => '42.2624|-110.6556|Lincoln||',
 'WYC025' => '42.9622|-106.7985|Natrona||',
 'WYC027' => '43.0565|-104.4754|Niobrara||',
 'WYC029' => '44.5206|-109.5886|Park||',
 'WYC031' => '42.1331|-104.9658|Platte||',
 'WYC033' => '44.7900|-106.8795|Sheridan||',
 'WYC035' => '42.7669|-109.9147|Sublette||',
 'WYC037' => '41.6595|-108.8794|Sweetwater||',
 'WYC039' => '43.9337|-110.5901|Teton||',
 'WYC041' => '41.2876|-110.5476|Uinta||',
 'WYC043' => '43.9050|-107.6829|Washakie||',
 'WYC045' => '43.8404|-104.5679|Weston||',
 'WYZ001' => '44.5976|-110.5469|Yellowstone National Park|Fremont|16043	44.5976|-110.5469|Yellowstone National Park|Park|56029	44.5976|-110.5469|Yellowstone National Park|Teton|56039	44.5976|-110.5469|Yellowstone National Park|Gallatin|30031',
 'WYZ002' => '44.2172|-109.5521|Absaroka Mountains|Fremont|56013	44.2172|-109.5521|Absaroka Mountains|Hot Springs|56017	44.2172|-109.5521|Absaroka Mountains|Park|56029',
 'WYZ003' => '44.4594|-109.0463|Cody Foothills|Park|56029',
 'WYZ004' => '44.5447|-108.3008|North Big Horn Basin|Big Horn|56003	44.5447|-108.3008|North Big Horn Basin|Park|56029',
 'WYZ005' => '43.7774|-108.2779|Southwest Big Horn Basin|Hot Springs|56017',
 'WYZ006' => '43.9423|-107.8197|Southeast Big Horn Basin|Washakie|56043',
 'WYZ007' => '43.573|-108.2336|Owl Creek and Bridger Mountains|Fremont|56013	43.573|-108.2336|Owl Creek and Bridger Mountains|Hot Springs|56017	43.573|-108.2336|Owl Creek and Bridger Mountains|Natrona|56025',
 'WYZ008' => '44.2518|-107.4682|Bighorn Mountains West|Big Horn|56003	44.2518|-107.4682|Bighorn Mountains West|Fremont|56013	44.2518|-107.4682|Bighorn Mountains West|Johnson|56019	44.2518|-107.4682|Bighorn Mountains West|Natrona|56025	44.2518|-107.4682|Bighorn Mountains West|Washakie|56043',
 'WYZ009' => '43.9099|-107.0263|Bighorn Mountains Southeast|Johnson|56019	43.9099|-107.0263|Bighorn Mountains Southeast|Natrona|56025	43.9099|-107.0263|Bighorn Mountains Southeast|Washakie|56043',
 'WYZ010' => '44.368|-106.4299|Northeast Johnson County|Johnson|56019',
 'WYZ011' => '43.8206|-106.4368|Southeast Johnson County|Johnson|56019',
 'WYZ012' => '43.6883|-110.5055|Teton and Gros Ventre Mountains|Fremont|56013	43.6883|-110.5055|Teton and Gros Ventre Mountains|Lincoln|56023	43.6883|-110.5055|Teton and Gros Ventre Mountains|Sublette|56035	43.6883|-110.5055|Teton and Gros Ventre Mountains|Teton|56039',
 'WYZ013' => '43.6458|-110.6864|Jackson Hole|Lincoln|56023	43.6458|-110.6864|Jackson Hole|Teton|56039',
 'WYZ014' => '42.9092|-109.4923|Wind River Mountains West|Fremont|56013	42.9092|-109.4923|Wind River Mountains West|Sublette|56035',
 'WYZ015' => '43.0496|-109.2855|Wind River Mountains East|Fremont|56013	43.0496|-109.2855|Wind River Mountains East|Sublette|56035',
 'WYZ016' => '43.4505|-109.339|Upper Wind River Basin|Fremont|56013',
 'WYZ017' => '43.1357|-108.2754|Wind River Basin|Fremont|56013',
 'WYZ018' => '42.797|-108.6388|Lander Foothills|Fremont|56013',
 'WYZ019' => '42.4379|-107.9137|Green Mountains and Rattlesnake Range|Fremont|56013	42.4379|-107.9137|Green Mountains and Rattlesnake Range|Natrona|56025	42.4379|-107.9137|Green Mountains and Rattlesnake Range|Sweetwater|56037',
 'WYZ020' => '43.066|-106.6783|Natrona County Lower Elevations|Natrona|56025',
 'WYZ021' => '41.2876|-110.5476|Southwest Wyoming|Uinta|56041',
 'WYZ022' => '42.6061|-106.2637|Casper Mountain|Natrona|56025',
 'WYZ023' => '42.8634|-110.982|Star Valley|Lincoln|56023',
 'WYZ024' => '42.5626|-110.6654|Salt River and Wyoming Ranges|Lincoln|56023	42.5626|-110.6654|Salt River and Wyoming Ranges|Sublette|56035',
 'WYZ025' => '42.9803|-110.0392|Upper Green River Basin Foothills|Sublette|56035',
 'WYZ026' => '42.3437|-109.7743|Upper Green River Basin|Fremont|56013	42.3437|-109.7743|Upper Green River Basin|Lincoln|56023	42.3437|-109.7743|Upper Green River Basin|Sublette|56035	42.3437|-109.7743|Upper Green River Basin|Sweetwater|56037',
 'WYZ027' => '41.8212|-110.5572|South Lincoln County|Lincoln|56023',
 'WYZ028' => '41.5579|-109.6723|Rock Springs and Green River|Sweetwater|56037',
 'WYZ029' => '41.2424|-109.4375|Flaming Gorge|Sweetwater|56037',
 'WYZ030' => '41.5802|-108.4192|East Sweetwater County|Sweetwater|56037',
 'WYZ054' => '44.596|-105.5497|Northern Cambell|Campbell|56005',
 'WYZ055' => '43.8436|-105.5478|Southern Campbell|Campbell|56005',
 'WYZ056' => '44.6273|-104.8077|Western Crook |Crook|56011',
 'WYZ057' => '44.3823|-104.3495|Wyoming Black Hills |Crook|56011	44.3823|-104.3495|Wyoming Black Hills |Weston|56045',
 'WYZ058' => '43.8072|-104.6212|Weston|Weston|56045	43.8674|-104.7853|Weston County Plains |Weston|56045',
 'WYZ059' => '43.7191|-104.3166|Newcastle |Weston|56045',
 'WYZ060' => '44.7865|-104.1802|Northeastern Crook |Crook|56011',
 'WYZ071' => '44.8506|-104.1767|Northeastern Crook|Crook|56011',
 'WYZ101' => '43.074|-105.4593|Converse County Lower Elevations|Converse|56009',
 'WYZ102' => '43.0565|-104.4754|Niobrara County|Niobrara|56027',
 'WYZ103' => '42.3535|-105.6241|North Laramie Range|Albany|56001	42.3535|-105.6241|North Laramie Range|Converse|56009	42.3535|-105.6241|North Laramie Range|Platte|56031',
 'WYZ104' => '42.2707|-106.878|Ferris/Seminoe/Shirley Mountains|Carbon|56007',
 'WYZ105' => '42.134|-106.0943|Shirley Basin|Albany|56001	42.134|-106.0943|Shirley Basin|Carbon|56007',
 'WYZ106' => '41.8778|-105.2243|Central Laramie Range and Southwest Platte County|Albany|56001	41.8778|-105.2243|Central Laramie Range and Southwest Platte County|Laramie|56021	41.8778|-105.2243|Central Laramie Range and Southwest Platte County|Platte|56031',
 'WYZ107' => '42.2373|-104.8821|East Platte County|Platte|56031',
 'WYZ108' => '42.088|-104.3533|Goshen County|Goshen|56015',
 'WYZ109' => '41.8204|-107.103|Central Carbon County|Carbon|56007',
 'WYZ110' => '41.6904|-106.259|North Snowy Range Foothills|Albany|56001	41.6904|-106.259|North Snowy Range Foothills|Carbon|56007',
 'WYZ111' => '41.2862|-107.7097|Southwest Carbon County|Carbon|56007',
 'WYZ112' => '41.1695|-107.099|Sierra Madre Range|Carbon|56007',
 'WYZ113' => '41.3867|-106.7713|Upper North Platte River Basin|Carbon|56007',
 'WYZ114' => '41.3101|-106.3148|Snowy Range|Albany|56001	41.3101|-106.3148|Snowy Range|Carbon|56007',
 'WYZ115' => '41.4005|-105.7614|Laramie Valley|Albany|56001',
 'WYZ116' => '41.2851|-105.3769|South Laramie Range|Albany|56001	41.2851|-105.3769|South Laramie Range|Laramie|56021',
 'WYZ117' => '41.3136|-105.0324|South Laramie Range Foothills|Albany|56001	41.3136|-105.0324|South Laramie Range Foothills|Laramie|56021',
 'WYZ118' => '41.3277|-104.6546|Central Laramie County|Laramie|56021',
 'WYZ119' => '41.2851|-104.2337|East Laramie County|Laramie|56021',
 'WYZ198' => '44.7706|-107.492|Northeast Big Horn Mountains|Sheridan|56033',
 'WYZ199' => '44.7977|-106.6544|Sheridan Foothills|Sheridan|56033',
);
